
MobiScout.Tab.App.init = function () {
	//MobiScout.Tab.App.topVehicleListCoordinate;
	MobiScout.Tab.App.PageTransistionsAlwaysNone = false;
	MobiScout.Tab.App.LastPageID;
	MobiScout.Tab.App.canbusChart;
	MobiScout.Tab.App.GaugesInitialized = false;
	MobiScout.Tab.App.CurrentMsgSN = 0;
	MobiScout.Tab.App.CurrentDriverID = 0;
	MobiScout.Tab.App.CurrentVehicleID = 0;
    MobiScout.Tab.App.refreshDataID;
    //MobiScout.Tab.App.messageReminderID;
    MobiScout.Tab.App.ReminderActive = false;
    MobiScout.Tab.App.playingSound = false;
    MobiScout.Tab.App.DefaultRefreshInterval = 60000; // 60 seconds
    MobiScout.Tab.App.allowUserCancel = true;
    MobiScout.Tab.App.MapCentered = false;
    MobiScout.Tab.App.isAppPaused = false;
    MobiScout.Tab.App.LastSelectedVehicleID = 0;
    MobiScout.Tab.App.CurrentMessageStopSN = 0;
    MobiScout.Tab.App.LastVehicleInMessageDialog = 0;
    MobiScout.Tab.App.LastVehicleInTripStop = 0;
    MobiScout.Tab.App.selectedAlertSN = 0;
    MobiScout.Tab.App.LastSelectedTripSN = 0;
    MobiScout.Tab.App.CurrentPlanner = new Planner();
    MobiScout.Tab.App.TrackAndTraceList = new Array();
    MobiScout.Tab.App.TrackAndTraceDriverList = new Array();
    MobiScout.Tab.App.EmployeeCharts = new Array();
    MobiScout.Tab.App.VehicleList = new Array();
    MobiScout.Tab.App.DriverList = new Array();
    MobiScout.Tab.App.UserList = new Array();
    MobiScout.Tab.App.TrailerList = new Array();
    MobiScout.Tab.App.Messages = new Array();
    MobiScout.Tab.App.MessageDialog = new Array();
    MobiScout.Tab.App.Trips = new Array();
    MobiScout.Tab.App.Stops = new Array();
    MobiScout.Tab.App.TempActions = new Array();
    MobiScout.Tab.App.TempGoods = new Array();
    MobiScout.Tab.App.AlertList = new Array();
    MobiScout.Tab.App.Geofences = new Array();
    MobiScout.Tab.App.LogonRetries = 5;
    MobiScout.Tab.App.ActionFromDateSelection = 0;
    MobiScout.Tab.App.PlotRouteAfterPageChange = false;
    MobiScout.Tab.App.CenterMapOnVehicle = false;
    MobiScout.Tab.App.CenterMapOnVehiclePosition;
    MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.UNREADMESSAGES;
    MobiScout.Tab.App.NavigatingToMap = false;
    //MobiScout.Tab.App.TxMessages = new Array();
    MobiScout.Tab.App.MediaPlayer;
    MobiScout.Tab.App.VehicleIconTableWidth = 100;
    MobiScout.Tab.App.VehicleMenuItemCount = 8;
    
    MobiScout.Tab.App.numberOfVehicleMenuTransitions = 0;
    MobiScout.Tab.App.vehicleMenuTimerID;
    MobiScout.Tab.App.vehicleMenuInfoIndex = 0;
	MobiScout.Tab.App.maxVehicleMenuInfoIndex = 0;
	MobiScout.Tab.App.isVehicleMenuCircular = false;

	if (MobiScout.Tab.Data.LoadLocalData("SecureConnection") == 'true' || MobiScout.Tab.Data.LoadLocalData("SecureConnection") == true) {
		SecureConnection = true;
	}

	

    if (MobiScout.Tab.Data.LoadLocalData("ServiceURL")) {
            var strURL = MobiScout.Tab.Data.LoadLocalData("ServiceURL");
            if (strURL != "") {
                if (startsWith(strURL, "http")) {
                    if (!endsWith(strURL, "/")) {
                        strURL += "/";
                    }
                    WebServiceURL = strURL;
                }
                else {
                	if(SecureConnection == true){
                		WebServiceURL = "https://" + strURL + "/";
                	}
                	else{
                    	WebServiceURL = "http://" + strURL + "/";
                    }
                }
            }
        }
    
    MobiScout.Tab.App.BindShims = function(){
    	if (!window.requestAnimationFrame) {
    		MobiScout.Tab.App.PageTransistionsAlwaysNone = true;
		    window.requestAnimationFrame = (function() {
		        return window.webkitRequestAnimationFrame ||
		            window.mozRequestAnimationFrame || // comment out if FF4 is slow (it caps framerate at ~30fps: https://bugzilla.mozilla.org/show_bug.cgi?id=630127)
		        window.oRequestAnimationFrame ||
		            window.msRequestAnimationFrame ||
		            function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element) {
		
		                window.setTimeout(callback, 1000 / 60);
		
		        };
		
		    })();
		
		}
    }
    
    
    MobiScout.Tab.App.directUrlToExternalBrowser = function (urlPattern){
    	var pattern = "a[href^='"+urlPattern+"']";      // detect all urls starting with urlPattern
    	$(document).on('click', pattern, function(e){
	        e.preventDefault();
	        MobiScout.Tab.PlayTick();
	        var ref = window.open($(this).attr("href"), '_system', '');      // '_system' will open the system web browser, '_blank' will open the InAppBrowser
    	});
	}
    
    MobiScout.Tab.App.ClearData = function(){
    	MobiScout.Tab.App.CurrentPlanner = new Planner();
    	MobiScout.Tab.App.TrackAndTraceList.splice(0, MobiScout.Tab.App.TrackAndTraceList.length);
    	MobiScout.Tab.App.TrackAndTraceDriverList.splice(0, MobiScout.Tab.App.TrackAndTraceDriverList.length);
    	MobiScout.Tab.App.DriverList.splice(0, MobiScout.Tab.App.DriverList.length);
    	MobiScout.Tab.App.VehicleList.splice(0, MobiScout.Tab.App.VehicleList.length);
    	MobiScout.Tab.App.TrailerList.splice(0, MobiScout.Tab.App.TrailerList.length);
    	MobiScout.Tab.App.Messages.splice(0, MobiScout.Tab.App.Messages.length);
    	MobiScout.Tab.App.MessageDialog.splice(0, MobiScout.Tab.App.MessageDialog.length);
    	MobiScout.Tab.App.Trips.splice(0, MobiScout.Tab.App.Trips.length);
    	MobiScout.Tab.App.Stops.splice(0, MobiScout.Tab.App.Stops.length);
    	MobiScout.Tab.App.AlertList.splice(0, MobiScout.Tab.App.AlertList.length);
    	MobiScout.Tab.App.Geofences.splice(0, MobiScout.Tab.App.Geofences.length);
    	MobiScout.Tab.App.MessageDialog.splice(0, MobiScout.Tab.App.MessageDialog.length);
    	MobiScout.Tab.Mapping.ClearMap();
    	MobiScout.Tab.App.LogonRetries = 5;
    	MobiScout.Tab.App.CurrentMsgSN = 0;
    	MobiScout.Tab.App.LastSelectedVehicleID = 0;
    	MobiScout.Tab.App.LastVehicleInMessageDialog = 0;
    	MobiScout.Tab.App.LastVehicleInTripStop = 0;
    	MobiScout.Tab.App.selectedAlertSN = 0;
    	MobiScout.Tab.App.LastSelectedTripSN = 0;
    	MobiScout.Tab.App.LastSelectedStopSN = 0;
	    MobiScout.Tab.App.ActionFromDateSelection = 0;
	    MobiScout.Tab.App.PlotRouteAfterPageChange = false;
	    MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.UNREADMESSAGES;
	    MobiScout.Tab.App.NavigatingToMap = false;    	
	    MobiScout.Tab.Mapping.ClearMap();
	    MobiScout.Tab.Mapping.clearMarkers(); 
	    MobiScout.Tab.Mapping.SetClusterer();
	    // clear lists
	    $("#TrackAndTraceList").empty();
	    $("#TrackAndTraceDriverList").empty();
	    $("#MessagesList").empty();
	    $("#AlertList").empty();
	    $("#MessageDialogList").empty();
	    $("#TripsList").empty();
	    $("#StopsList").empty();
	    
    }
    
    MobiScout.Tab.App.SendNewMessage = function(vehicleid){
		// bekijk van welke pagina we komen
		if(vehicleid != undefined) MobiScout.Tab.App.LastSelectedVehicleID = vehicleid;

   		MobiScout.Tab.App.VehicleToSendTo = MobiScout.Tab.App.LastSelectedVehicleID;
    	if(MobiScout.Tab.App.VehicleToSendTo > 0){
			$("#lblNewTextMsg").text(MobiScout.Tab.Translations.NaarVoertuig + " " + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.VehicleToSendTo) + " [" + MobiScout.Tab.App.VehicleToSendTo + "]");
			MobiScout.Tab.SelectVehicleInList(MobiScout.Tab.App.VehicleToSendTo);
		}
    	if ($('.ui-page-active').attr('id') == 'home') {
    		MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.HOMESCREEN;
    		
    	}
    	else if ($('.ui-page-active').attr('id') == 'messages') {
    		MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.UNREADMESSAGES;
    	}
    	else if ($('.ui-page-active').attr('id') == 'messagedialog') {
    		MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.MESSAGEDIALOG;
    	}
    	else if ($('.ui-page-active').attr('id') == 'map') {
    		MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.MAP;
    	}
    	else if ($('.ui-page-active').attr('id') == 'settings') {
    		MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.HOMESCREEN;
    	}
    	else if ($('.ui-page-active').attr('id') == 'messagedetail') {
    		MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.HOMESCREEN;
    	}
    	else if ($('.ui-page-active').attr('id') == 'newmessage') {
    		MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.HOMESCREEN;
    	}
    	
    	MobiScout.Tab.ChangePage("newmessage");    
    }
    
    MobiScout.Tab.App.AddNewGeofence = function (description, latitude, longitude, radiusenter, radiusleave, type, once, dateTimeEnd, fixed, geoactive, isnavdest, poiid) {
        var newFence = new Geofence();
        //MobiScout.Tab.LogToConsole("Add geofence descr: " + description + " latitude: " + latitude + " longitude: " + longitude + " poiid: " + poiid);
        latitude=latitude.replace(",",".");
        longitude=longitude.replace(",",".");
        
        // als er al een voor de opgegeven POIID bestaat, dan weggooien
        for (var i = 0; i < this.Geofences.length; i++) {
        	if(MobiScout.Tab.App.Geofences[i].PoiID == poiid && poiid >= 0){
        		MobiScout.Tab.App.Geofences.splice(i, 1); 
        	}
        }

        newFence.GeofenceID = 0;
        newFence.DateTimeDelete = dateTimeEnd;
        newFence.DateTimeDeletedMS = dateTimeEnd.getTime();
        newFence.Description = description;
        newFence.RadiusEnter = parseInt(radiusenter, 10);
        newFence.RadiusLeave = parseInt(radiusleave, 10);
        if(newFence.RadiusEnter == newFence.RadiusLeave) newFence.RadiusLeave = newFence.RadiusEnter + 100;  
        newFence.Latitude = parseFloat(latitude);
        newFence.Longitude = parseFloat(longitude);
        newFence.FireOnEnter = false;
        newFence.FireOnLeave = false;
        newFence.FireOnlyOnce = false;
        newFence.InGeofence = false;
        newFence.isFixed = fixed;
        if(fixed == false){
        	// dan is het altijd een geofence die na een bepaalde tijd vervalt
        	newFence.DeactivateAfterDate = true;
        }
        // 1 = kan gelden als geofence
        // 2 = geldt altijd als geofence
        if(geoactive > 1) newFence.isActive = true;
        else newFence.isActive = false;
        if(isnavdest == 1) newFence.isNavDest = true;
        else newFence.isNavDest = false;
        newFence.PoiID = poiid;
        if(type == 1) newFence.FireOnEnter = true;
        if(type == 2) newFence.FireOnLeave = true;
        if(type == 3) {
        	newFence.FireOnEnter = true;
        	newFence.FireOnLeave = true;
        }
        if(once == 1) newFence.FireOnlyOnce = true;
        MobiScout.Tab.App.Geofences.push(newFence);
    };
    
	MobiScout.Tab.App.removeUnreadMessage = function(msgsn){
	 	for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
            if (MobiScout.Tab.App.Messages[i].MsgSN == msgsn) {
            	MobiScout.Tab.App.Messages.splice(i, 1); // Removes 1 element from index 1
            	break;
            }
        }
		
	};
	
	MobiScout.Tab.App.UnreadMessageCountForVehicle = function(vehicleid){
		var retval = 0;
	 	for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
	 		if(MobiScout.Tab.App.Messages[i].VehicleID == vehicleid){
            	retval ++;
            }
        }
        return retval;
	};
	
	MobiScout.Tab.App.GetNumberUnreadMessages = function(excludeMsgSN){
		var retval = 0;
	 	for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
	 		if(MobiScout.Tab.App.Messages[i].MsgSN != excludeMsgSN){
            	retval ++;
            }
        }
        return retval;
	};

	MobiScout.Tab.App.SetMessageReminderInterval = function(){
		// clear the timer
		/*if(MobiScout.Tab.App.messageReminderID) clearInterval(MobiScout.Tab.App.messageReminderID);
		if(messageReminderInterval > 0){
			MobiScout.Tab.App.messageReminderID = setInterval("MobiScout.Tab.App.RemindUnreadMessages()", messageReminderInterval * 60 * 1000);
		}*/
	};
	
	MobiScout.Tab.App.RemindUnreadMessages = function(){
		if(MobiScout.Tab.App.ReminderActive == true){
			MobiScout.Tab.PlayNotification(false);
		}
	};

	MobiScout.Tab.App.ClearMessageDialog = function(){
		// wis de dialoog!
		MobiScout.Tab.App.MessageDialog.splice(0, MobiScout.Tab.App.MessageDialog.length);
	};

	MobiScout.Tab.App.ClearStops = function(){
		MobiScout.Tab.App.Stops.splice(0, MobiScout.Tab.App.Stops.length);
		MobiScout.Tab.UI.Trip.ClearStopList();
	};

	MobiScout.Tab.App.ConvertToHyperlink = function(text){
		if(startsWith(text, "http") || startsWith(text, "www")){
			  var exp = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/i;
			  var filename = text.match(/.*\/(.*)$/)[1];
			  if(window.MobiScoutApp) return '<a onclick="MobiScout.Tab.App.DownloadDocument(\'' + encodeURI(text) + '\')">Bijlage: ' + filename + '</a>' ;
			  return text.replace(exp,"<a href='$1'>Bijlage: " + filename + "</a>");
		}
		return text;
	}
	
	MobiScout.Tab.App.DownloadDocument = function(url){
		if(isPhoneGap == true){
			if(window.MobiScoutApp){
				MobiScout.Tab.LogToConsole("DownloadDocument " + url);
				var filename = url.substring(url.lastIndexOf('/')+1);
				window.MobiScoutApp.DownloadAndShowDocument(url, filename);
			}
		}
	}
	
	MobiScout.Tab.App.FormatStopDetails = function(){
		var stopInfoDone = false;
		var dataToAppend = '';
		for (var i = 0; i < MobiScout.Tab.App.TempActions.length; i++) {
			if(Number(MobiScout.Tab.App.TempActions[i].stopsn) == Number(MobiScout.Tab.App.CurrentMessageStopSN)){
				if(stopInfoDone == false){
					dataToAppend += '<br><fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">' + MobiScout.Tab.Translations.ZendingDetails + '</legend>';
					dataToAppend += '<div style="margin:10px;line-height:0.85em;font-size:0.65em;white-space:normal;word-wrap:break-word;">';
					dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].addressName + '</p>';
					dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].addressAddress + '</p>';
					dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].addressPostcode + ' ' + MobiScout.Tab.App.TempActions[i].addressCity + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].addressPhone)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].addressPhone + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].addressContact)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].addressContact + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].addressEmail)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].addressEmail + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].stopRemark)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].stopRemark + '</p>';
					// dan een scheiding
					dataToAppend += '<hr>';
					dataToAppend += '<div id="shipment' + MobiScout.Tab.App.TempActions[i].shipmentSN + '">';
					dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionTypeDescr + '</p>';
					dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionTSStartPL + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionDescr)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionDescr + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionName)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionName + '</p>';
					if(MobiScout.Tab.App.TempActions[i].actionReasonID > 0){
						if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionRemarks)) dataToAppend += '<p style="color:red">' + MobiScout.Tab.App.TempActions[i].actionRemarks + '</p>';
					}
					else{
						if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionRemarks)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionRemarks + '</p>';
					}
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionExternalRef)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionExternalRef + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentDescr)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentDescr + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentOrderRef)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentOrderRef + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentTrackingCode)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentTrackingCode + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentClientName)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentClientName + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark1)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentRemark1 + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark2)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentRemark2 + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark3)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentRemark3 + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark4)) dataToAppend += '<p>' + MobiScout.Tab.App.ConvertToHyperlink(MobiScout.Tab.App.TempActions[i].shipmentRemark4) + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentPacktypeDescr)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentPacktypeDescr + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentCOD)) dataToAppend += '<p>&#x20AC; ' + MobiScout.Tab.App.TempActions[i].shipmentCOD + '</p>';
					dataToAppend += '</div>';
					stopInfoDone = true;
				}
				else{
					dataToAppend += '<hr>';
					dataToAppend += '<div id="shipment' + MobiScout.Tab.App.TempActions[i].shipmentSN + '">';
					dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionTypeDescr + '</p>';
					dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionTSStartPL + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionDescr)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionDescr + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionName)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionName + '</p>';
					if(MobiScout.Tab.App.TempActions[i].actionReasonID > 0){
						if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionRemarks)) dataToAppend += '<p style="color:red">' + MobiScout.Tab.App.TempActions[i].actionRemarks + '</p>';
					}
					else{
						if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionRemarks)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionRemarks + '</p>';
					}
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].actionExternalRef)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].actionExternalRef + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentDescr)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentDescr + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentOrderRef)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentOrderRef + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentTrackingCode)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentTrackingCode + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentClientName)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentClientName + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark1)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentRemark1 + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark2)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentRemark2 + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark3)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentRemark3 + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentRemark4)) dataToAppend += '<p>' + MobiScout.Tab.App.ConvertToHyperlink(MobiScout.Tab.App.TempActions[i].shipmentRemark4) + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentPacktypeDescr)) dataToAppend += '<p>' + MobiScout.Tab.App.TempActions[i].shipmentPacktypeDescr + '</p>';
					if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempActions[i].shipmentCOD)) dataToAppend += '&#x20AC; <p>' + MobiScout.Tab.App.TempActions[i].shipmentCOD + '</p>';
					dataToAppend += '</div>';
				}
			}
		}
		if(!isBlank(dataToAppend)){
					dataToAppend += '</div></fieldset>';
					dataToAppend += '<br>';
		}
		if(isBlank(dataToAppend)){
			dataToAppend += '<br><fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">' + MobiScout.Tab.Translations.ZendingDetails + '</legend>';
			dataToAppend += '<div style="margin:10px;line-height:0.85em;font-size:0.65em;white-space:normal;word-wrap:break-word;">';
			dataToAppend += '<p>Geen gegevens beschikbaar</p>';
			dataToAppend += '</div></fieldset>';
			dataToAppend += '<br>';
		}
		return 	dataToAppend;
	}

	MobiScout.Tab.App.ContainsData = function(object){
		if(object == undefined) return false;
		if(isBlank(object)) return false;
		if(object == 0) return false;
		return true; 
	}

	MobiScout.Tab.App.AppendGoodsInfoToCurrentScreen = function(){
		
		// goederen aan de juiste zendingen knopen aub
		for (var i = 0; i < MobiScout.Tab.App.TempGoods.length; i++) {
 			var goodsInfo = '<p><b><i>Goederen informatie</i></b></p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].orderref)) goodsInfo += '<p>' + MobiScout.Tab.App.TempGoods[i].orderref + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].descr)) goodsInfo += '<p>' + MobiScout.Tab.App.TempGoods[i].descr + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].goodsref)) goodsInfo += '<p>' + MobiScout.Tab.App.TempGoods[i].goodsref + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].packcount)) goodsInfo += '<p>aantal: ' + MobiScout.Tab.App.TempGoods[i].packcount + ' ' + MobiScout.Tab.App.TempGoods[i].packtypedescr +'</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].palletplaatsen)) goodsInfo += '<p>palletplaatsen: ' + MobiScout.Tab.App.TempGoods[i].palletplaatsen + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].laadmeter)) goodsInfo += '<p>laadmeter: ' + MobiScout.Tab.App.TempGoods[i].laadmeter + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].weight)) goodsInfo += '<p>gewicht: ' + MobiScout.Tab.App.TempGoods[i].weight + ' ' + MobiScout.Tab.App.TempGoods[i].weighttypedescr +'</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].volume)) goodsInfo += '<p>volume: ' + MobiScout.Tab.App.TempGoods[i].volume + ' ' + MobiScout.Tab.App.TempGoods[i].volumetypedescr +'</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].dim1)) goodsInfo += '<p>afmetingen: ' + MobiScout.Tab.App.TempGoods[i].dim1 + ' x ' + MobiScout.Tab.App.TempGoods[i].dim2 + ' x ' + MobiScout.Tab.App.TempGoods[i].dim3 + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].remark1)) goodsInfo += '<p>' + MobiScout.Tab.App.TempGoods[i].remark1 + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].remark2)) goodsInfo += '<p>' + MobiScout.Tab.App.TempGoods[i].remark2 + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].remark3)) goodsInfo += '<p>' + MobiScout.Tab.App.TempGoods[i].remark3 + '</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].remark4)) goodsInfo += '<p>' + MobiScout.Tab.App.TempGoods[i].remark4 + '</p>';
			//goodsInfo += '<hr>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].packcountex)) goodsInfo += '<p>uitgevoerd aantal: ' + MobiScout.Tab.App.TempGoods[i].packcountex + ' ' + MobiScout.Tab.App.TempGoods[i].packtypedescr +'</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].weightex)) goodsInfo += '<p>uitgevoerd gewicht: ' + MobiScout.Tab.App.TempGoods[i].weightex + ' ' + MobiScout.Tab.App.TempGoods[i].weighttypedescr +'</p>';
			if(MobiScout.Tab.App.ContainsData(MobiScout.Tab.App.TempGoods[i].volumeex)) goodsInfo += '<p>uitgevoerd volume: ' + MobiScout.Tab.App.TempGoods[i].volumeex + ' ' + MobiScout.Tab.App.TempGoods[i].volumetypedescr +'</p>';
			
			$('#shipment' + MobiScout.Tab.App.TempGoods[i].shipmentsn).append(goodsInfo);
		}
	}

	MobiScout.Tab.App.AppendActionInfoToCurrentScreen = function(){
		try{
			//console.log("active page: " + $('.ui-page-active').attr('id'));
			if ($('.ui-page-active').attr('id') == 'messagedetail' || $('.ui-page-active').attr('id') == 'messagedialog') {
				// dan bericht details aanvullen indien het de juiste stop betreft
				var dataToAppend = MobiScout.Tab.App.FormatStopDetails();
				if(!isBlank(dataToAppend)){
					$("#divMsgDetails").append(dataToAppend);
				}
			}
			else if ($('.ui-page-active').attr('id') == 'trips' || $('.ui-page-active').attr('id') == 'tripstops' || $('.ui-page-active').attr('id') == 'stopdetails') {
				//console.log("update info from stop!"); 
				var dataToAppend = MobiScout.Tab.App.FormatStopDetails();
				if(!isBlank(dataToAppend)){
					$("#divStopDetails").append(dataToAppend);
				}
			}
			else if ($('.ui-page-active').attr('id') == 'realtimeHours'){
				// toevoegen aan het zendingen / info div
				var dataToAppend = MobiScout.Tab.App.FormatStopDetails();
				if(!isBlank(dataToAppend)){
					$("#rtinfo").append(dataToAppend);
				}
			}
			else if ($('.ui-page-active').attr('id') == 'periodView'){
				// toevoegen aan het zendingen / info div
				var dataToAppend = MobiScout.Tab.App.FormatStopDetails();
				if(!isBlank(dataToAppend)){
					$("#hoursinfo").append(dataToAppend);
				}
			}
		}
		catch(Err)
		{
			MobiScout.Tab.LogToConsole("Failed to append stop/action data to message: " + Err);
		}
		
	}
	MobiScout.Tab.App.AddTemporaryGood = function(goodssn, shipmentsn, orderref, descr, packcount, weight, packtypedescr, volume, weighttypedescr, volumetypedescr, remark1, packcountex, dim1, dim2, dim3, weightex, volumeex, remark2, remark3, remark4, goodsref, palletplaatsen, laadmeter){
		try{
			  
			var tempGood = new TabTempGood();
			tempGood.goodssn = goodssn;
			tempGood.shipmentsn = shipmentsn;
			tempGood.orderref = orderref;
			tempGood.descr = descr;
			tempGood.packcount = packcount;
			tempGood.weight = weight;
			tempGood.packtypedescr = packtypedescr;
			tempGood.volume = volume;
			tempGood.weighttypedescr = weighttypedescr;
			tempGood.volumetypedescr = volumetypedescr;
			tempGood.remark1 = remark1;
			tempGood.packcountex = packcountex;
			tempGood.dim1 = dim1;
			tempGood.dim2 = dim2;
			tempGood.dim3 = dim3;
			tempGood.weightex = weightex;
			tempGood.volumeex = volumeex;
			tempGood.remark2 = remark2;
			tempGood.remark3 = remark3;
			tempGood.remark4 = remark4;
			tempGood.goodsref = goodsref;
			tempGood.palletplaatsen = palletplaatsen;
			tempGood.laadmeter = laadmeter;
			MobiScout.Tab.App.TempGoods.push(tempGood);
			
		}
		catch(Err){
			console.log(Err);
		}
	}

	MobiScout.Tab.App.AddTemporaryAction = function (stopsn, actionsn, actionDescr, actionStatus, actionTSStartPL, actionName, actionRemarks, actionTSStartEX, actionTSStopEX, actionExternalRef, actionReasonID, shipmentDescr, shipmentOrderRef, shipmentTrackingCode, shipmentClientName, shipmentRemark1, shipmentRemark2, shipmentRemark3, shipmentRemark4,shipmentPackcount, shipmentWeight, shipmentPacktypeDescr, shipmentCOD, actionTypeDescr, stopRemark, addressName, addressAddress, addressPostcode, addressCity, addressPhone, addressContact, addressEmail, shipmentSN){
		try{
			var tempAction = new TabTempAction();
			tempAction.stopsn = stopsn;
			tempAction.actionsn = actionsn;
			tempAction.actionDescr = actionDescr;
			tempAction.actionStatus = actionStatus;
			tempAction.actionTSStartPL = actionTSStartPL;
			tempAction.actionName = actionName;
			tempAction.actionRemarks = actionRemarks;
			tempAction.actionTSStartEX = actionTSStartEX;
			tempAction.actionTSStopEX = actionTSStopEX;
			tempAction.actionExternalRef = actionExternalRef;
			tempAction.actionReasonID = actionReasonID;
			tempAction.shipmentDescr = shipmentDescr;
			tempAction.shipmentOrderRef = shipmentOrderRef;
			tempAction.shipmentTrackingCode = shipmentTrackingCode;
			tempAction.shipmentClientName = shipmentClientName;
			tempAction.shipmentRemark1 = shipmentRemark1;
			tempAction.shipmentRemark2 = shipmentRemark2;
			tempAction.shipmentRemark3 = shipmentRemark3;
			tempAction.shipmentRemark4 = shipmentRemark4;
			tempAction.shipmentPackcount = shipmentPackcount;
			tempAction.shipmentWeight = shipmentWeight;
			tempAction.shipmentPacktypeDescr = shipmentPacktypeDescr;
			tempAction.shipmentCOD = shipmentCOD;
			tempAction.actionTypeDescr = actionTypeDescr;
			tempAction.stopRemark = stopRemark;
			tempAction.addressName = addressName;
			tempAction.addressAddress = addressAddress;
			tempAction.addressPostcode = addressPostcode;
			tempAction.addressCity = addressCity;
			tempAction.addressPhone = addressPhone;
			tempAction.addressContact = addressContact;
			tempAction.addressEmail = addressEmail;
			tempAction.shipmentSN = shipmentSN;
			MobiScout.Tab.App.TempActions.push(tempAction);
		}
		catch(Err){
		}
	};

	MobiScout.Tab.App.AddStop = function(stopsn, tsstartpl, tsstoppl, statusid, addressname, addressaddress, addressno, addresspostcode, addresscity, externalref, actiondescr, actiontypeid, afwijkingen){
		try{
			var stop = new TabStop();
			stop.StopSN = stopsn;
			stop.StatusID = statusid;
			stop.TSStartPlanned = tsstartpl;
			stop.TSStopPlanned = tsstoppl;
			stop.CustomerName = addressname;
			stop.Address = addressaddress;
			stop.AddressNo = addressno;
			stop.Postcode = addresspostcode;
			stop.City = addresscity;
			stop.ExternalRef = externalref;
			stop.Action = actiondescr;
			stop.ActionTypeID = actiontypeid;
			stop.Afwijkingen = afwijkingen;
			MobiScout.Tab.App.Stops.push(stop);
		}
		catch(Err){
		}
	};
	
	MobiScout.Tab.App.GetStatusColor = function (statusid){
		if(statusid == 20) return "#0000FF";
		if(statusid == 21) return "#2E2EFE";
		if(statusid == 25) return "#04B45F";
		if(statusid == 27) return "#7401DF";
		if(statusid == 30) return "#886A08";
		if(statusid == 35) return "#886A08";
		if(statusid == 40) return "#01DF3A";
		if(statusid == 99) return "#0A0A2A";
		return "#000000";
	}
	
	MobiScout.Tab.App.TranslateStatus = function(statusid){
		if(statusid == 20) return MobiScout.Tab.Translations.Gepland;
		if(statusid == 21) return MobiScout.Tab.Translations.OpnieuwGepland;
		if(statusid == 25) return MobiScout.Tab.Translations.Verzonden;
		if(statusid == 27) return MobiScout.Tab.Translations.Afgeleverd;
		if(statusid == 30) return MobiScout.Tab.Translations.InUitvoering;
		if(statusid == 35) return MobiScout.Tab.Translations.GedeeltelijkUitgevoerd;
		if(statusid == 40) return MobiScout.Tab.Translations.Uitgevoerd;
		if(statusid == 99) return MobiScout.Tab.Translations.Verwijderd;
		return String(statusid);
	}

	MobiScout.Tab.App.AddMessageToDialog = function(msgsn, vehicleid, driverid, tsstatus, content, activityid, statusid, msgtypeid, tsread, plate, name, latitude, longitude, location, prio){
		try{
			var found = false;
        	for (var i = 0; i < MobiScout.Tab.App.MessageDialog.length; i++) {
            	if (MobiScout.Tab.App.MessageDialog[i].MsgSN == msgsn) {
                	// update the values
                	found = true;
                	MobiScout.Tab.App.MessageDialog[i].FoundInList = true;
                	break;
            	}
        	}
        	if (found == false) {
				var msg = new TabMessage();
				msg.MsgSN = msgsn;
				msg.VehicleID = vehicleid;
				msg.DriverID = driverid;
				msg.TSStatus = tsstatus;
				msg.MsgContent = content;
				msg.ActivityID = activityid;
				msg.StatusID = statusid;
				msg.MsgTypeID = msgtypeid;
				msg.ActivityDescr = MobiScout.Tab.App.getActivityDescription(activityid);
				msg.Color = MobiScout.Tab.App.getActivityColor(activityid);
				msg.Plate = plate;//MobiScout.Tab.App.GetVehiclePlate(vehicleid);
				msg.DriverName = name;
				msg.TSRead = tsread;
				if(latitude) msg.Latitude = latitude;
				if(longitude) msg.Longitude = longitude;
				msg.Location = location;
				msg.Prio = prio;
				MobiScout.Tab.App.DecodeMessage(msg);
				
				MobiScout.Tab.App.MessageDialog.push(msg);
				return true;
			}
			return false;
		}
		catch(Err){
		}
		
	};
	
	MobiScout.Tab.App.DecodeMessage = function(msg){
		try{
			if(msg.MsgTypeID == 7){
				// status bericht
				if (startsWith(msg.MsgContent,"$STAT1") || startsWith(msg.MsgContent,"$STAT2")){
					var items = msg.MsgContent.split(',');
					msg.Odometer = parseFloat(items[2]);
					msg.Reason = Number(items[3]);
					if(items[9][0] == '1') msg.IO1 = true;
					if(items[9][1] == '1') msg.IO2 = true;
					if(items[9][2] == '1') msg.IO3 = true;
					msg.VehicleState = Number(items[10]);
					msg.TrailerID = Number(items[12]);
					msg.Temperature1 = parseFloat(items[13]);
					msg.Temperature2 = parseFloat(items[14]);
					msg.Temperature3 = parseFloat(items[15]);
					msg.Temperature4 = parseFloat(items[16]);
					msg.Temperature5 = parseFloat(items[17]);
					msg.Temperature6 = parseFloat(items[18]);
					msg.Temperature7 = parseFloat(items[19]);
					msg.Temperature8 = parseFloat(items[20]);
					msg.StopSN = Number(items[23]);
					msg.TripSN = Number(items[24]);
					msg.Speed = Number(items[30]);
					msg.Heading = Number(items[31]);
					//msg.TrailerID = Number(items[25]);
				}
				else if (startsWith(msg.MsgContent,"$STAT4")){
					var items = msg.MsgContent.split(',');
					msg.Odometer = parseFloat(items[2]);
					msg.Reason = Number(items[3]);
					if(items[9][0] == '1') msg.IO1 = true;
					if(items[9][1] == '1') msg.IO2 = true;
					if(items[9][2] == '1') msg.IO3 = true;
					msg.VehicleState = Number(items[10]);
					msg.TrailerID = Number(items[12]);
					msg.Temperature1 = parseFloat(items[13]);
					msg.Temperature2 = parseFloat(items[14]);
					msg.Temperature3 = parseFloat(items[15]);
					msg.Temperature4 = parseFloat(items[16]);
					msg.Temperature5 = parseFloat(items[17]);
					msg.Temperature6 = parseFloat(items[18]);
					msg.Temperature7 = parseFloat(items[19]);
					msg.Temperature8 = parseFloat(items[20]);
					msg.StopSN = Number(items[23]);
					msg.TripSN = Number(items[24]);
					msg.Speed = Number(items[30]);
					msg.Heading = Number(items[31]);
					msg.TrailerID = Number(items[25]);
					msg.TrailerID2 = Number(items[26]);
				}
			}
			else if(msg.MsgTypeID == 18){
				if (startsWith(msg.MsgContent,"$TEMPREPORT")){
					// $TEMPREPORT,240113104412,0,22.16,21.57,--,--,--,--,--,--,003b
					//var items = msg.MsgContent.split(',');
					msg.TrailerID = Number(items[2]);
					msg.Temperature1 = parseFloat(items[3]);
					msg.Temperature2 = parseFloat(items[4]);
					msg.Temperature3 = parseFloat(items[5]);
					msg.Temperature4 = parseFloat(items[6]);
					msg.Temperature5 = parseFloat(items[7]);
					msg.Temperature6 = parseFloat(items[8]);
					msg.Temperature7 = parseFloat(items[9]);
	                msg.Temperature8 = parseFloat(items[10]);
				}
			}
			else if(msg.MsgTypeID == 19){
				if (startsWith(msg.MsgContent,"$TEMPALERT")){
					//$TEMPALERT,160114155729,0,420.09,--,--,--,--,--,--,--,20000000,100,0056;$GPAUX,24	     ,1457,A,5145.5581,N,00530.8245,E,000,305,1601,00000000,0000,0000,*00
					var items = msg.MsgContent.split(',');
					msg.TrailerID = Number(items[2]);
					if(items[12][0] == '1') msg.IO1 = true;
					if(items[12][1] == '1') msg.IO2 = true;
					if(items[12][1] == '1') msg.IO3 = true;
					msg.Temperature1 = parseFloat(items[3]);
					msg.Temperature2 = parseFloat(items[4]);
					msg.Temperature3 = parseFloat(items[5]);
					msg.Temperature4 = parseFloat(items[6]);
					msg.Temperature5 = parseFloat(items[7]);
					msg.Temperature6 = parseFloat(items[8]);
					msg.Temperature7 = parseFloat(items[9]);
                    msg.Temperature8 = parseFloat(items[10]);
				}
			
			}
			if(isNaN(msg.Temperature1)) msg.Temperature1 = -1000;
			if(isNaN(msg.Temperature2)) msg.Temperature2 = -1000;
			if(isNaN(msg.Temperature3)) msg.Temperature3 = -1000;
			if(isNaN(msg.Temperature4)) msg.Temperature4 = -1000;
			if(isNaN(msg.Temperature5)) msg.Temperature5 = -1000;
			if(isNaN(msg.Temperature6)) msg.Temperature6 = -1000;
			if(isNaN(msg.Temperature7)) msg.Temperature7 = -1000;
			if(isNaN(msg.Temperature8)) msg.Temperature8 = -1000;			
		}
		catch(ErrDec){
			MobiScout.Tab.LogToConsole("Failed to decode message type: " + msg.MsgTypeID + " content: " + msg.MsgContent + " err: " + ErrDec);
		}
		
		
	}
	
	
	MobiScout.Tab.App.MarkAllAlertsRead = function(){
		for (var i = 0; i < MobiScout.Tab.App.AlertList.length; i++) {
			MobiScout.Tab.Data.MarkAlertRead(MobiScout.Tab.App.AlertList[i].AlertSN);
		}
	};
	
	
	MobiScout.Tab.App.MarkAllMessagesRead = function(){
		for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
			MobiScout.Tab.Data.MarkMessageRead(MobiScout.Tab.App.Messages[i].MsgSN);
		}
	};
	
	MobiScout.Tab.App.MarkMessageRead = function(msgsn){
		for (var i = 0; i < MobiScout.Tab.App.MessageDialog.length; i++) {
			if(isBlank(MobiScout.Tab.App.MessageDialog[i].TSRead) == true && MobiScout.Tab.App.MessageDialog[i].MsgSN == msgsn){
				// markeer als gelezen!
				MobiScout.Tab.App.MessageDialog[i].TSRead = MobiScout.Tab.GetCurrentDate().format('YmdHis');
			}
		}
		MobiScout.Tab.Data.MarkMessageRead(msgsn);
	};

    MobiScout.Tab.App.clearTrackAndTraceList = function () {
        MobiScout.Tab.App.TrackAndTraceList.splice(0, MobiScout.Tab.App.TrackAndTraceList.length);
    };
    
    MobiScout.Tab.App.clearTrackAndTraceDriverList = function () {
        MobiScout.Tab.App.TrackAndTraceDriverList.splice(0, MobiScout.Tab.App.TrackAndTraceDriverList.length);
    };

	MobiScout.Tab.App.GetVehicleIDForTrip = function(tripsn){
		for (var i = 0; i < MobiScout.Tab.App.Trips.length; i++) {
            if (MobiScout.Tab.App.Trips[i].TripSN == tripsn) {
            	return MobiScout.Tab.App.Trips[i].VehicleID;
            }
       	}
       	return 0;
		
	};

	MobiScout.Tab.App.IsVehicleInGeofence = function(vehicle){
		for (var i = 0; i < this.Geofences.length; i++) {
			//FireOnEnter
			var distanceNow = 1000 * Distance(vehicle.Latitude, vehicle.Longitude, this.Geofences[i].Latitude, this.Geofences[i].Longitude, "K");
			if(distanceNow < this.Geofences[i].RadiusEnter){
				// dan zit de auto in de geofence
				return this.Geofences[i].Description;
			}
		}
		
	}
	
	MobiScout.Tab.App.IsMessageInGeofence = function(message){
		try{
			if(message.Latitude > 0 && message.Longitude > 0){
				for (var i = 0; i < this.Geofences.length; i++) {
					var distanceNow = 1000 * Distance(message.Latitude, message.Longitude, this.Geofences[i].Latitude, this.Geofences[i].Longitude, "K");
					if(distanceNow < this.Geofences[i].RadiusEnter){
						// dan zit de auto in de geofence
						return this.Geofences[i].Description;
					}
				}
			}
		}
		catch(Err){
		}
		
	}
	
	MobiScout.Tab.App.GetUserName = function(userid){
		for (var i = 0; i < MobiScout.Tab.App.UserList.length; i++) {
            if (MobiScout.Tab.App.UserList[i].UserID == userid) {
            	return MobiScout.Tab.App.UserList[i].Name;
            }
       	}
       	return "";
    };
    
    MobiScout.Tab.App.GetUserPassword = function(userid){
		for (var i = 0; i < MobiScout.Tab.App.UserList.length; i++) {
            if (MobiScout.Tab.App.UserList[i].UserID == userid) {
            	return MobiScout.Tab.App.UserList[i].Password;
            }
       	}
       	return "";
    };
    
	
	MobiScout.Tab.App.GetDriverName = function(driverid){
		for (var i = 0; i < MobiScout.Tab.App.DriverList.length; i++) {
            if (MobiScout.Tab.App.DriverList[i].ID == driverid) {
            	return MobiScout.Tab.App.DriverList[i].Name;
            }
       	}
       	return "";
    };
    
    MobiScout.Tab.App.GetDriverPassword = function(driverid){
		for (var i = 0; i < MobiScout.Tab.App.DriverList.length; i++) {
            if (MobiScout.Tab.App.DriverList[i].ID == driverid) {
            	return MobiScout.Tab.App.DriverList[i].Password;
            }
       	}
       	return "";
    };
    
    MobiScout.Tab.App.GetDriverUserID = function(driverid){
		for (var i = 0; i < MobiScout.Tab.App.DriverList.length; i++) {
            if (MobiScout.Tab.App.DriverList[i].ID == driverid) {
            	return MobiScout.Tab.App.DriverList[i].UserID;
            }
       	}
       	return "";
    };

	MobiScout.Tab.App.GetVehiclePassword = function(vehicleid){
		for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
            if (MobiScout.Tab.App.VehicleList[i].ID == vehicleid) {
            	if(!isBlank(MobiScout.Tab.App.VehicleList[i].Password)){
	           		return MobiScout.Tab.App.VehicleList[i].Password;
	           	}
	        }
	  	}
       	return "";
    };

	MobiScout.Tab.App.GetVehiclePlate = function(vehicleid){
		if(showVehiclePlate == true){
			/*for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
	            if (MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicleid) {
	            	return MobiScout.Tab.App.TrackAndTraceList[i].Plate;
	            }
	       	}*/
	       	for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
	            if (MobiScout.Tab.App.VehicleList[i].ID == vehicleid) {
	            	return MobiScout.Tab.App.VehicleList[i].Plate;
	            }
	       	}
	       	
       	}
       	return vehicleid;
    };

	MobiScout.Tab.App.GetVehiclePassword = function(vehicleid){
		for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
            if (MobiScout.Tab.App.VehicleList[i].ID == vehicleid) {
            	if(!isBlank(MobiScout.Tab.App.VehicleList[i].Password)){
	           		return MobiScout.Tab.App.VehicleList[i].Password;
	           	}
	        }
	  	}
       	return "";
    };

	MobiScout.Tab.App.GetVehicleProtocolID = function(vehicleid){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicleid) {
            	return MobiScout.Tab.App.TrackAndTraceList[i].ProtocolID;
            }
       	}
       	return 6;
    };

	MobiScout.Tab.App.GetVehicleTachoGraph = function(vehicleid){
		for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
            if (MobiScout.Tab.App.VehicleList[i].ID == vehicleid) {
            	if(MobiScout.Tab.App.VehicleList[i].HasTachograph > 0) return true;
            	else return false;
            }
       	}
       	return false;
    };


	MobiScout.Tab.App.CallPhoneNumber = function(number){
		if (isPhoneGap == true) {
			if(window.MobiScoutApp){
				window.MobiScoutApp.CallPhoneNumber(number);
			}
		}
	}

	MobiScout.Tab.App.GetDriverOnVehicle = function(vehicleid){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicleid) {
            	return MobiScout.Tab.App.TrackAndTraceList[i].DriverID;
            }
       	}
       	return 0;
	}
	
	MobiScout.Tab.App.GetEmployeeData = function(driverid){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceDriverList[i].ID == driverid) {
            	return MobiScout.Tab.App.TrackAndTraceDriverList[i];
            }
       	}
	}
	
	MobiScout.Tab.App.GetDriverPhonenumber = function(driverid){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceDriverList[i].ID == driverid) {
            	return MobiScout.Tab.App.TrackAndTraceDriverList[i].PhoneNumber;
            }
       	}
       	return "";
	}
	
	MobiScout.Tab.App.GetVehiclePhonenumber = function(vehicleid){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicleid) {
            	return MobiScout.Tab.App.TrackAndTraceList[i].PhoneNumber;
            }
       	}
       	return "";
	}
    
    MobiScout.Tab.App.GetDriverName = function(empid){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceDriverList[i].ID == empid) {
            	return MobiScout.Tab.App.TrackAndTraceDriverList[i].Name;
            }
       	}
       	return empid;
    };
    
	MobiScout.Tab.App.GetTrailerPlate = function(trailerid){
		if(showTrailerPlate == true){
			for (var i = 0; i < MobiScout.Tab.App.TrailerList.length; i++) {
	            if (MobiScout.Tab.App.TrailerList[i].ID == trailerid) {
	            	return MobiScout.Tab.App.TrailerList[i].Plate;
	            }
	       	}
       	}
       	return trailerid;
    };

	MobiScout.Tab.App.ClearAlerts = function(){
		MobiScout.Tab.App.AlertList.splice(0, MobiScout.Tab.App.AlertList.length);	
	};

	MobiScout.Tab.App.AddAlert = function(alertsn, tsalert, descr, alerttypeid, geofencetypeid, poiid, vehicleid, plate, alerttypedescr, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, geofencetypedescr){
		 var newAlert = new TabAlert();
         newAlert.AlertSN = alertsn;
         newAlert.TSAlert = tsalert;
         newAlert.Description = descr;
         newAlert.AlertTypeID = alerttypeid;
         newAlert.GeofenceTypeID = geofencetypeid;
         newAlert.VehicleID = vehicleid;
         newAlert.Plate = plate;
         newAlert.POIID = poiid;
         newAlert.AlertTypeDescription = alerttypedescr;
         
         newAlert.Temperature1 = temp1;
         newAlert.Temperature2 = temp2;
         newAlert.Temperature3 = temp3;
         newAlert.Temperature4 = temp4;
         newAlert.Temperature5 = temp5;
         newAlert.Temperature6 = temp6;
         newAlert.Temperature7 = temp7;
         newAlert.Temperature8 = temp8;
         
         newAlert.GeofenceTypeDescription = geofencetypedescr;
         MobiScout.Tab.App.AlertList.push(newAlert);
	};
	
	MobiScout.Tab.App.removeAlertMessage = function(alertsn){ 
		for (var i = 0; i < MobiScout.Tab.App.AlertList.length; i++) {
            if (MobiScout.Tab.App.AlertList[i].AlertSN == alertsn) {
            	MobiScout.Tab.App.DecreaseAlertCountForVehicle(MobiScout.Tab.App.AlertList[i].VehicleID);
            	MobiScout.Tab.App.AlertList.splice(i, 1); // Removes 1 element from index 1
            	
            	break;
            }
        }
	};
	
	MobiScout.Tab.App.DecreaseAlertCountForVehicle = function(vehicleid){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
			if(MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicleid){
				if(MobiScout.Tab.App.TrackAndTraceList[i].NumberOfAlerts > 0) MobiScout.Tab.App.TrackAndTraceList[i].NumberOfAlerts --;
			}
		}
	};
	
	MobiScout.Tab.App.DumpMemUsage = function(textToDisplay){
        //var memUsage = 0;
        if(window.MobiScoutApp && isDevelopmentDevice == true){
        	window.MobiScoutApp.getMemoryUsage(textToDisplay);
        	/*console.log("mem usage: " + memUsage);
        	if(window.performance){
	        	if(window.performance.memory){
					console.log("usedJSHeapSize: " + window.performance.memory.usedJSHeapSize);
					console.log("totalJSHeapSize: " + window.performance.memory.totalJSHeapSize);
					//jsHeapSizeLimit
						        	
	        	}
        	}*/
        }
	};

	MobiScout.Tab.App.GetTempDescr = function(type){
		if(type == '0') return 'ok @';
		if(type == '1') return MobiScout.Tab.Translations.TeKoud + ' @';
		if(type == '2') return MobiScout.Tab.Translations.TeWarm + ' @';
		return MobiScout.Tab.Translations.Onbekend + ' @';
	}

	MobiScout.Tab.App.addVehicleToTrackAndTraceListV2 = function (vehicle) {
		var found = false;
        for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicle.ID) {
            	if(vehicle.NumberOfAlerts > MobiScout.Tab.App.TrackAndTraceList[i].NumberOfAlerts){
                	// dan moeten we een notificatie doen lijkt me.
                	MobiScout.Tab.PlayNotification(true);
                }
                if(MobiScout.Tab.App.TrackAndTraceList[i].ActivityID != vehicle.ActivityID) {
                	MobiScout.Tab.App.TrackAndTraceList[i].ActivityChanged = true;
                	vehicle.ActivityChanged = true;
                }
                if(MobiScout.Tab.App.TrackAndTraceList[i].TSActivity != vehicle.TSActivity) {
                	MobiScout.Tab.App.TrackAndTraceList[i].TimestampChanged = true;
                	vehicle.TimestampChanged = true;
                }
               	MobiScout.Tab.App.TrackAndTraceList[i] = null; // eerst vrijgeven
            	MobiScout.Tab.App.TrackAndTraceList[i] = vehicle;
                found = true;
                break;
            }
        }
        if (found == false) {
        	MobiScout.Tab.App.TrackAndTraceList.push(vehicle);
            return true;
        }
        return false;
	}
	
	MobiScout.Tab.App.SetPhoneNumberInDriverList = function(empid, name, phonenumber){
		
        for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
        	if (MobiScout.Tab.App.TrackAndTraceDriverList[i].ID == empid) {
        		MobiScout.Tab.App.TrackAndTraceDriverList[i].PhoneNumber = phonenumber;
        		return;
        	}
        }
        var newTTD = new TabEmployee();
		newTTD.ID = empid;
		newTTD.Name = name;
		newTTD.PhoneNumber = phonenumber;
        MobiScout.Tab.App.TrackAndTraceDriverList.push(newTTD);
	}

	MobiScout.Tab.App.addEmployeeToTrackAndTraceDriverListV2 = function (employee) {
		var found = false;
        for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceDriverList[i].ID == employee.ID) {
                if(MobiScout.Tab.App.TrackAndTraceDriverList[i].ActivityID != employee.ActivityID) {
                	MobiScout.Tab.App.TrackAndTraceDriverList[i].ActivityChanged = true;
                	employee.ActivityChanged = true;
                }
                if(MobiScout.Tab.App.TrackAndTraceDriverList[i].TSActivity != employee.TSActivity) {
                	MobiScout.Tab.App.TrackAndTraceDriverList[i].TimestampChanged = true;
                	employee.TimestampChanged = true;
                }
                //console.log("overwrite entry " + employee.ID);
                MobiScout.Tab.App.TrackAndTraceDriverList[i] = null; // eerst vrijgeven
            	MobiScout.Tab.App.TrackAndTraceDriverList[i] = employee;
                found = true;
                break;
            }
        }
        if (found == false) {
        	//console.log("add new entry " + employee.ID);
        	MobiScout.Tab.App.TrackAndTraceDriverList.push(employee);
            return true;
        }
        return false;
	}

    MobiScout.Tab.App.addVehicleToTrackAndTraceList = function (vehicleid, plate, name, yref, xref, activityid, tsactivity, color, lastkeepalive, location, numberUnreadMessages, trailerid, speed, destination, numberAlerts, expectedduration, actualiteit, restminutes, subdrivinghours, totdrivinghours, waitminutes, workminutes,tenallowed, workweek, departmentid, TSLKA, TSACT, liters, distance, marchingspeed, consumption, vehiclephonenumber, protocolid, driverid, stopstotal, stopsdone, dtcostatus, dtcolastresult, dtcolastdownload, dtcolastsuccess, tslastdownload, tslastsuccess, tsactivitychange, tsactchange, sensor1, sensor2, sensor3, sensor4, sensor5, sensor6, sensor7, sensor8, sensor1alert, sensor2alert, sensor3alert, sensor4alert, sensor5alert, sensor6alert, sensor7alert, sensor8alert) {
        var found = false;
        var d;
        var d2;
        for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
            if (MobiScout.Tab.App.TrackAndTraceList[i].ID == vehicleid) {
                // update the values
                
                if(MobiScout.Tab.App.TrackAndTraceList[i].ActivityID != activityid) MobiScout.Tab.App.TrackAndTraceList[i].ActivityChanged = true;
                MobiScout.Tab.App.TrackAndTraceList[i].ActivityID = activityid;
                MobiScout.Tab.App.TrackAndTraceList[i].LastKeepAlive = lastkeepalive;
                if(MobiScout.Tab.App.TrackAndTraceList[i].TSActivity != tsactivity) MobiScout.Tab.App.TrackAndTraceList[i].TimestampChanged = true;
                MobiScout.Tab.App.TrackAndTraceList[i].TSActivity = tsactivity;
                MobiScout.Tab.App.TrackAndTraceList[i].TSActivityChange = tsactivitychange;
                MobiScout.Tab.App.TrackAndTraceList[i].ActivityDescription = MobiScout.Tab.App.getActivityDescription(activityid);
                MobiScout.Tab.App.TrackAndTraceList[i].Latitude = yref;
                MobiScout.Tab.App.TrackAndTraceList[i].Longitude = xref;
                MobiScout.Tab.App.TrackAndTraceList[i].Color = color;
                MobiScout.Tab.App.TrackAndTraceList[i].Name = name;
                MobiScout.Tab.App.TrackAndTraceList[i].Location = location;
                MobiScout.Tab.App.TrackAndTraceList[i].NumberOfUnreadMessages = numberUnreadMessages;
                MobiScout.Tab.App.TrackAndTraceList[i].TrailerID = trailerid;
                MobiScout.Tab.App.TrackAndTraceList[i].Speed = speed;
                MobiScout.Tab.App.TrackAndTraceList[i].Destination = destination;
                MobiScout.Tab.App.TrackAndTraceList[i].Updated = true;
                MobiScout.Tab.App.TrackAndTraceList[i].ExpectedDuration = expectedduration;
                MobiScout.Tab.App.TrackAndTraceList[i].Actualiteit = actualiteit;
                
                MobiScout.Tab.App.TrackAndTraceList[i].Restminutes = restminutes;
                MobiScout.Tab.App.TrackAndTraceList[i].Subdrivinghours = subdrivinghours;
                MobiScout.Tab.App.TrackAndTraceList[i].Totdrivinghours = totdrivinghours;
                MobiScout.Tab.App.TrackAndTraceList[i].Waitminutes = waitminutes;
                MobiScout.Tab.App.TrackAndTraceList[i].Workminutes = workminutes;
                MobiScout.Tab.App.TrackAndTraceList[i].Tenallowed = tenallowed;
                MobiScout.Tab.App.TrackAndTraceList[i].Workweek = workweek;
                MobiScout.Tab.App.TrackAndTraceList[i].DepartmentID = departmentid;
                
                
                try{
					d = new Date(TSLKA);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					MobiScout.Tab.App.TrackAndTraceList[i].TSLKA = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
		        try{
					d = new Date(TSACT);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					MobiScout.Tab.App.TrackAndTraceList[i].TSACT = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
				try{
					d = new Date(tsactchange);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					MobiScout.Tab.App.TrackAndTraceList[i].TSACTCHANGE = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
    			MobiScout.Tab.App.TrackAndTraceList[i].Liters = liters;
				MobiScout.Tab.App.TrackAndTraceList[i].Distance = distance;
				MobiScout.Tab.App.TrackAndTraceList[i].MarchingSpeed = marchingspeed;
				MobiScout.Tab.App.TrackAndTraceList[i].Consumption = consumption;
                MobiScout.Tab.App.TrackAndTraceList[i].PhoneNumber = vehiclephonenumber;
                MobiScout.Tab.App.TrackAndTraceList[i].ProtocolID = protocolid;
                MobiScout.Tab.App.TrackAndTraceList[i].DriverID = driverid;
                
                MobiScout.Tab.App.TrackAndTraceList[i].StopsTotal = stopstotal;
                MobiScout.Tab.App.TrackAndTraceList[i].StopsDone = stopsdone;
                
                MobiScout.Tab.App.TrackAndTraceList[i].DTCOStatus = dtcostatus;
                MobiScout.Tab.App.TrackAndTraceList[i].DTCOLastResult = dtcolastresult;
                MobiScout.Tab.App.TrackAndTraceList[i].DTCOLastDownload = dtcolastdownload;
                MobiScout.Tab.App.TrackAndTraceList[i].DTCOLastSuccess = dtcolastsuccess;
                
                try{
					d = new Date(tslastdownload);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					MobiScout.Tab.App.TrackAndTraceList[i].TSDTCOLastDownload = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
				try{
					d = new Date(tslastsuccess);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					MobiScout.Tab.App.TrackAndTraceList[i].TSDTCOLastSuccess = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
                
                
                if(numberAlerts > MobiScout.Tab.App.TrackAndTraceList[i].NumberOfAlerts){
                	// dan moeten we een notificatie doen lijkt me.
                	MobiScout.Tab.PlayNotification(true);
                }
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor1 = sensor1;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor2 = sensor2;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor3 = sensor3;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor4 = sensor4;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor5 = sensor5;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor6 = sensor6;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor7 = sensor7;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor8 = sensor8;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor1Alert = sensor1alert;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor2Alert = sensor2alert;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor3Alert = sensor3alert;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor4Alert = sensor4alert;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor5Alert = sensor5alert;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor6Alert = sensor6alert;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor7Alert = sensor7alert;
                MobiScout.Tab.App.TrackAndTraceList[i].Sensor8Alert = sensor8alert;
                
                MobiScout.Tab.App.TrackAndTraceList[i].NumberOfAlerts = numberAlerts;
                found = true;
                break;
            }
        }
        if (found == false) {
            var newTT = new TabVehicle();
            newTT.ID = vehicleid;
            newTT.ActivityID = activityid;
            newTT.LastKeepAlive = lastkeepalive;
            newTT.TSActivity = tsactivity;
            newTT.TSActivityChange = tsactivitychange;
            newTT.ActivityDescription = MobiScout.Tab.App.getActivityDescription(activityid);
            newTT.Latitude = yref;
            newTT.Longitude = xref;
            newTT.Color = color;
            newTT.Plate = plate;
            newTT.Name = name;
            newTT.Location = location;
            newTT.NumberOfUnreadMessages = numberUnreadMessages;
            newTT.TrailerID = trailerid;
            newTT.Speed = speed;
            newTT.Destination = destination;
            newTT.ExpectedDuration = expectedduration;
            newTT.Updated = true;
            newTT.NumberOfAlerts = numberAlerts;
            newTT.Actualiteit = actualiteit;
            
            newTT.Restminutes = restminutes;
            newTT.Subdrivinghours = subdrivinghours;
            newTT.Totdrivinghours = totdrivinghours;
            newTT.Waitminutes = waitminutes;
            newTT.Workminutes = workminutes;
            newTT.Tenallowed = tenallowed;
            newTT.Workweek = workweek;
            newTT.DepartmentID = departmentid;
            try{
				d = new Date(TSLKA);
				d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
				newTT.TSLKA = d2;
			}
			catch(Err)
			{
				console.log(Err);
			}
		    try{
				d = new Date(TSACT);
				d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
				newTT.TSACT = d2;
			}
			catch(Err)
			{
				console.log(Err);
			}
			try{
				d = new Date(tsactchange);
				d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
				newTT.TSACTCHANGE = d2;
			}
			catch(Err)
			{
				console.log(Err);
			}
            //newTT.TSLKA = TSLKA;
            //newTT.TSACT = TSACT; 
    		newTT.Liters = liters;
			newTT.Distance = distance;
			newTT.MarchingSpeed = marchingspeed;
			newTT.Consumption = consumption;
			newTT.PhoneNumber = vehiclephonenumber;
            newTT.ProtocolID = protocolid;
            newTT.DriverID = driverid;
			newTT.StopsTotal = stopstotal;
            newTT.StopsDone = stopsdone;
            
            newTT.DTCOStatus = dtcostatus;
            newTT.DTCOLastResult = dtcolastresult;
            newTT.DTCOLastDownload = dtcolastdownload;
            newTT.DTCOLastSuccess = dtcolastsuccess;
	           try{
					d = new Date(tslastdownload);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					newTT.TSDTCOLastDownload = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
				try{
					d = new Date(tslastsuccess);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					newTT.TSDTCOLastSuccess = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
            
            newTT.Sensor1 = sensor1;
            newTT.Sensor2 = sensor2;
            newTT.Sensor3 = sensor3;
            newTT.Sensor4 = sensor4;
            newTT.Sensor5 = sensor5;
            newTT.Sensor6 = sensor6;
            newTT.Sensor7 = sensor7;
            newTT.Sensor8 = sensor8;
            newTT.Sensor1Alert = sensor1alert;
            newTT.Sensor2Alert = sensor2alert;
            newTT.Sensor3Alert = sensor3alert;
            newTT.Sensor4Alert = sensor4alert;
            newTT.Sensor5Alert = sensor5alert;
            newTT.Sensor6Alert = sensor6alert;
            newTT.Sensor7Alert = sensor7alert;
            newTT.Sensor8Alert = sensor8alert;
            MobiScout.Tab.App.TrackAndTraceList.push(newTT);
            return true;
        }
        return false;
    };

    MobiScout.Tab.App.refreshData = function (isAutoRefresh) {
       // MobiScout.Tab.Data.getTrackAndTrace(isAutoRefresh, true);
    };

    MobiScout.Tab.App.LogoffPlanner = function () {
        MobiScout.Tab.App.CurrentPlanner.Logoff();
    }

    MobiScout.Tab.App.LogonPlanner = function () {
    	if(MobiScout.Tab.App.LogonRetries > 0){
    		MobiScout.Tab.App.CurrentPlanner.Logon();
    		MobiScout.Tab.App.LogonRetries --;
        }
    }

    MobiScout.Tab.App.startworkers = function () {
        //MobiScout.Tab.App.refreshData();
        //MobiScout.Tab.Data.getActivityTypeCollection();
        //MobiScout.Tab.App.refreshDataID = setInterval("MobiScout.Tab.App.refreshData(true)", MobiScout.Tab.App.DefaultRefreshInterval);
    };

    MobiScout.Tab.App.stopworkers = function () {
        if(MobiScout.Tab.App.refreshDataID) clearInterval(MobiScout.Tab.App.refreshDataID);
        //if(MobiScout.Tab.App.messageReminderID) clearInterval(MobiScout.Tab.App.messageReminderID);
    };

    MobiScout.Tab.App.toRGB = function (color) {
        var b = Number((color >> 16) & 0x0000FF);
        var g = Number((color >> 8) & 0x0000FF);
        var r = Number(color & 0x0000FF);
        return 'rgb(' + r + ',' + g + ',' + b + ')';
    };

    MobiScout.Tab.App.Activities = Array();

    MobiScout.Tab.App.ClearActivities = function () {
        MobiScout.Tab.App.Activities.splice(0, MobiScout.Tab.App.Activities.length);
    };
    
    MobiScout.Tab.App.CaoTypes = Array();
    
    MobiScout.Tab.App.ClearCaoTypes = function () {
        MobiScout.Tab.App.CaoTypes.splice(0, MobiScout.Tab.App.CaoTypes.length);
    };
    
    MobiScout.Tab.App.GetCaoIDForGroupName = function(description){
    	for(var i = 0; i < MobiScout.Tab.App.CaoTypes.length; i ++){
    		if(description.toUpperCase() ===  MobiScout.Tab.App.CaoTypes[i].Description.toUpperCase()) return MobiScout.Tab.App.CaoTypes[i].CaoID;
    	}
    	return 0;
    }
    
    MobiScout.Tab.App.AddCaoType = function (caoid, descr, paid) {
        var newCaoType = new CaoType();
        newCaoType.CaoID = caoid;
        newCaoType.Description = descr;
        newCaoType.Paid = paid;
        MobiScout.Tab.App.CaoTypes.push(newCaoType);
    };
    
    
    MobiScout.Tab.App.Departments = Array();

    MobiScout.Tab.App.ClearDepartments = function () {
        MobiScout.Tab.App.Departments.splice(0, MobiScout.Tab.App.Departments.length);
    };

	MobiScout.Tab.App.AddDepartment = function (id, descr) {
        var newDep = new Department();
        newDep.ID = id;
        newDep.Description = descr;
        MobiScout.Tab.App.Departments.push(newDep);
    };


	MobiScout.Tab.App.getVehicleCountForDepartment = function(id){
		var retval = 0;
		 for (var i = 0; i < this.TrackAndTraceList.length; i++) {
            if (this.TrackAndTraceList[i].DepartmentID == id) {
                retval ++;
            }
        }
        return retval;
	}

	MobiScout.Tab.App.getDepartment = function (id) {
        for (var i = 0; i < this.Departments.length; i++) {
            if (this.Departments[i].ID == id) {
                return this.Departments[i].Description;
            }
        }
        return MobiScout.Tab.Translations.GeenAfdeling;
    };
    
    MobiScout.Tab.App.getDepartmentForVehicle = function (id) {
        for (var i = 0; i < this.TrackAndTraceList.length; i++) {
            if (this.TrackAndTraceList[i].ID == id) {
                return this.TrackAndTraceList[i].DepartmentID;
            }
        }
        return 0;
    };

    MobiScout.Tab.App.AddActivity = function (id, color, descr, maxcolor, maxtime, atbtype) {
        var newAct = new Activity();
        newAct.ActID = id;
        newAct.Color = color;
        newAct.Description = descr;
        newAct.MaxColor = maxcolor;
        newAct.MaxTime = maxtime;
        newAct.AtbType = atbtype;
        MobiScout.Tab.App.Activities.push(newAct);
    };


    MobiScout.Tab.App.getActivityColor = function (actid) {
        for (var i = 0; i < this.Activities.length; i++) {
            if (this.Activities[i].ActID == actid) {
                return this.Activities[i].Color;
            }
        }
        return 0;
    };
    
    MobiScout.Tab.App.getActivityMaxColor = function (actid) {
        for (var i = 0; i < this.Activities.length; i++) {
            if (this.Activities[i].ActID == actid) {
                return this.Activities[i].MaxColor;
            }
        }
        return 0;
    };
    
    MobiScout.Tab.App.getActivityMaxTime = function (actid) {
        for (var i = 0; i < this.Activities.length; i++) {
            if (this.Activities[i].ActID == actid) {
                return this.Activities[i].MaxTime;
            }
        }
        return 0;
    };

    MobiScout.Tab.App.getActivityDescription = function (actid) {
        for (var i = 0; i < this.Activities.length; i++) {
            if (this.Activities[i].ActID == actid) {
                return this.Activities[i].Description;
            }
        }
        return "";
    };
    
    MobiScout.Tab.App.getActivityType = function (actid) {
    	
        if(actid == 960 || actid == 961 || actid == 60) return 3;
        for (var i = 0; i < this.Activities.length; i++) {
            if (this.Activities[i].ActID == actid) {
            	if(this.Activities[i].AtbType > 0) return this.Activities[i].AtbType;
            }
        }
        //<GS-20170511> default = werken aub 
        // was return 0;
        return 1;
    };

	MobiScout.Tab.App.sortTrackAndTraceList = function(){
		MobiScout.Tab.App.TrackAndTraceList.sort(function(a,b){
			if(UseDepartments == true){
				return b.DepartmentID - a.DepartmentID;
			}
			else{
				return a.ID - b.ID;
			}
		});
	};
	
	MobiScout.Tab.App.sortTrackAndTraceDriverList = function(){
		MobiScout.Tab.App.TrackAndTraceDriverList.sort(function(a,b){
			if(UseDepartments == true){
				return b.DepartmentID - a.DepartmentID;
			}
			else{
				return a.ID - b.ID;
			}
		});
	};
    
    MobiScout.Tab.App.markVehiclesNotUpdated = function(){
		 for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
		 	MobiScout.Tab.App.TrackAndTraceList[i].Updated = false;
		 }
	};
	
	 MobiScout.Tab.App.markEmployeesNotUpdated = function(){
		 for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
		 	MobiScout.Tab.App.TrackAndTraceDriverList[i].Updated = false;
		 }
	};

	MobiScout.Tab.App.clearTrackAndTraceList = function(){
		// remove all old entries 
		var deleting = true;
		var deletedEntries = false;
		while(deleting == true){
			deleting = false;
			for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
			 	if(MobiScout.Tab.App.TrackAndTraceList[i].Updated == false){
			 		MobiScout.Tab.Mapping.RemovePin(String(MobiScout.Tab.App.TrackAndTraceList[i].ID));
			 		MobiScout.Tab.App.TrackAndTraceList.splice(i, 1); 
			 		deleting = true;
			 		deletedEntries = true;
			 	}
			 }
		 }
		 return deletedEntries;
	};
	
	MobiScout.Tab.App.clearTrackAndTraceDriverList = function(){
		// remove all old entries 
		var deleting = true;
		var deletedEntries = false;
		while(deleting == true){
			deleting = false;
			for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
			 	if(MobiScout.Tab.App.TrackAndTraceDriverList[i].Updated == false){
			 		MobiScout.Tab.App.TrackAndTraceDriverList.splice(i, 1); 
			 		deleting = true;
			 		deletedEntries = true;
			 	}
			 }
		 }
		 return deletedEntries;
	};
    
    MobiScout.Tab.App.GetVehicleIDForMessageSN = function(msgsn){
      	for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
            if (MobiScout.Tab.App.Messages[i].MsgSN == msgsn) {
            	return MobiScout.Tab.App.Messages[i].VehicleID;
            }
      	}
      	// indien niet gevonden, kijk dan even in het berichten dialoog, daar kan die ook in staan
      	for (var i = 0; i < MobiScout.Tab.App.MessageDialog.length; i++) {
            if (MobiScout.Tab.App.MessageDialog[i].MsgSN == msgsn) {
            	return MobiScout.Tab.App.MessageDialog[i].VehicleID;
            }
      	}
      	return 0;
    }
    
    MobiScout.Tab.App.cleanUnreadMessageList = function(){
    	var deleting = true;
		var deletedEntries = false;
		while(deleting == true){
			deleting = false;
			for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
			 	if(MobiScout.Tab.App.Messages[i].FoundInList == false){
			 		MobiScout.Tab.App.Messages.splice(i, 1); 
			 		deleting = true;
			 		deletedEntries = true;
			 	}
			 }
		 }
		 return deletedEntries;
    };
    
    MobiScout.Tab.App.ClearFoundInListFlags = function(){
    	for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
    		MobiScout.Tab.App.Messages[i].FoundInList = false;
    	}
    };
    
    MobiScout.Tab.App.AddUnreadMessage = function(msgsn, vehicleid, driverid, tsstatus, content, plate, name, latitude, longitude, location){
   		var found = false;
        for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
            if (MobiScout.Tab.App.Messages[i].MsgSN == msgsn) {
                // update the values
                found = true;
                MobiScout.Tab.App.Messages[i].FoundInList = true;
                break;
            }
        }
        if (found == false) {
            var newTT = new TabMessage();
            newTT.VehicleID = vehicleid;
            newTT.DriverID = driverid;
            newTT.MsgSN = msgsn;
            newTT.TSStatus = tsstatus;
            newTT.MsgContent = content;
            newTT.Plate = plate;
            newTT.DriverName = name;
            newTT.StatusID = 40; // inkomend altijd
            newTT.MsgTypeID = 1; // altijd tekst
            newTT.FoundInList = true;
            if(latitude) newTT.Latitude = latitude;
            if(longitude) newTT.Longitude = longitude;
            newTT.Location = location;
            MobiScout.Tab.App.Messages.push(newTT);
            
            // for test only
            /*if(startsWith(content, "$PING")){ 
            	MobiScout.Tab.postNewTextMessage(vehicleid, "$PONG" );
            }
            if(startsWith(content, "$PONG")){ 
            	MobiScout.Tab.postNewTextMessage(vehicleid, "$PING" );
            }*/
            
            return true;
        }
        return false;
    };
    
	MobiScout.Tab.App.LoadTripsForVehicle = function(vehicleid){
		MobiScout.Tab.UpdateTrips(vehicleid);
		MobiScout.Tab.ChangePage("trips");
	};
	
	
	MobiScout.Tab.App.SetActivePageTransition = function(){
	 	$.mobile.defaultPageTransition = pageTransition;
	 	$.mobile.defaultDialogTransition = pageTransition;
        $.mobile.transitionFallbacks= 'none';
	}
    
    MobiScout.Tab.App.SendWhatsApp = function(text, url){
     	var message = encodeURIComponent(text) + " - " + encodeURIComponent(url); 
     	var whatsapp_url = "whatsapp://send?text=" + message; 
     	window.location.href = whatsapp_url; 
		
    }
    
    MobiScout.Tab.App.CheckAutorisationValid = function(){
    	if(authorisationForMap == true) return true;
    	if(authorisationForVehicles == true) return true;
    	if(authorisationForEmployees == true) return true;
    	if(authorisationForTrailers == true) return true;
    	if(authorisationForTrips == true) return true;
    	if(authorisationForHours == true) return true;
    	if(authorisationForMessages == true) return true;
    	if(authorisationForMessageDialog == true) return true;
    	if(authorisationForRoute == true) return true;
    	if(authorisationForPeriodView == true) return true;
    	if(authorisationForCAO == true) return true;
    	if(authorisationForRealtimeHours == true) return true;
    	if(authorisationForAlerts == true) return true;
    	if(authorisationForTemperature == true) return true;
    	if(authorisationForDrivingTimes == true) return true;
    	if(authorisationForCanbus == true) return true;
    	if(authorisationForFuelUsage == true) return true;
    	return false;
    }
    
    MobiScout.Tab.App.SetAuthorisation = function(){
    
    	// controleer eerst of we wel autorisaties ontvangen hebben
    	if(MobiScout.Tab.App.CheckAutorisationValid() == false){
    		MobiScout.Tab.LogToConsole("Autorisation not received, granting all permissions");
    		authorisationForMap = true; 
			authorisationForVehicles = true;
			authorisationForEmployees = true;
			authorisationForTrailers = true;
			authorisationForTrips = true;
			authorisationForHours = true;
			authorisationForMessages = true;
			authorisationForMessageDialog = true;
			authorisationForRoute = true;
			authorisationForPeriodView = true;
			authorisationForCAO = true;
			authorisationForRealtimeHours = true;
			authorisationForAlerts = true;
			authorisationForTemperature = true;
			authorisationForDrivingTimes = true;
			authorisationForCanbus = true;
			authorisationForFuelUsage = true;
			return;
    	}
    
    	if(authorisationForMap == false){
    		// disable UI for Map
    		$("#btnmenu_map").css( 'display', 'none' );
    		UseServerImages = false;
    		UseClustering = false;
    		UseTrafficInfo = false;
    		$('#toggleuseserverimages').val('off').slider('refresh');
    		$('#toggleuseserverimages').slider('disable');
    		$('#toggleuseclustering').val('off').slider('refresh');
    		$('#toggleuseclustering').slider('disable');
    		$('#toggleusetrafficinfo').val('off').slider('refresh');
    		$('#toggleusetrafficinfo').slider('disable');
    		MobiScout.Tab.Data.SaveLocalData("UseServerImages", UseServerImages);
    		MobiScout.Tab.Data.SaveLocalData("UseClustering", UseClustering);
    		MobiScout.Tab.Data.SaveLocalData("UseTrafficInfo", UseTrafficInfo);
    	}
    	else{
    		// enable UI for Map
    		$("#btnmenu_map").css( 'display', 'block' );
    		$('#toggleuseserverimages').slider('enable');
    		$('#toggleuseclustering').slider('enable');
    		$('#toggleusetrafficinfo').slider('enable');
    	}
    	if(authorisationForVehicles == false){
    		// disable UI for Vehicles ... strange
    	}
    	else{
    	}
    	if(authorisationForTrips == false){
    		// disable UI for trips
    		$("#btnmenu_trips").css( 'display', 'none' );
    		showTripInformation = false; // ook niet in het menu
    		$('#toggletrips').val('off').slider('refresh');
    		$('#toggletrips').slider('disable');
    		MobiScout.Tab.Data.SaveLocalData("showTripInformation", showTripInformation);
    	}
    	else{
    		$("#btnmenu_trips").css( 'display', 'block' );
    		$('#toggletrips').slider('enable');
    	}
    	if(authorisationForMessages == false){
    		// disable UI for messages
    	}
    	else{
    	}
    	if(authorisationForMessageDialog == false){
    		// disable UI for messagedialog
    		$("#btnmenu_dialog").css( 'display', 'none' ); 
    	}
    	else{
    		$("#btnmenu_dialog").css( 'display', 'block' ); 
    	}
    	if(authorisationForRoute == false){
    		// disable UI for routing
    	}
    	else{
    	}
    	if(authorisationForAlerts == false){
    		// disable UI for alerts
    		countAlertMessages = false; // geen alarm berichten tellen dus
    		$("#btnmenu_alerts").css( 'display', 'none' );
    		$('#togglecountalertmessages').val('off').slider('refresh');
    		$('#togglecountalertmessages').slider('disable');
    		MobiScout.Tab.Data.SaveLocalData("CountAlertMessages", countAlertMessages);
    	}
    	else{
    		$("#btnmenu_alerts").css( 'display', 'block' );
    		$('#togglecountalertmessages').slider('enable');
    	}
    	if(authorisationForEmployees == false){
    		// disable UI for employee list
    		showGraphsInEmployeeList = false;
    		$("#btnmenu_employees").css( 'display', 'none' );
    		$('#toggleshowgraphsinlist').val('off').slider('refresh');
    		$('#toggleshowgraphsinlist').slider('disable');
    		MobiScout.Tab.Data.SaveLocalData("showGraphsInEmployeeList", showGraphsInEmployeeList);
    	}
    	else{
    		$("#btnmenu_employees").css( 'display', 'block' );
    		$('#toggleshowgraphsinlist').slider('enable');
    	}
    	if(authorisationForTrailers == false){
    		// disable UI for trailer list
    	}
    	else{
    	}
    	if(authorisationForHours == false){
    		// disable UI for uren overzicht
    	}
    	else{
    	}
    	if(authorisationForPeriodView == false){
    		// disable UI for period view
    		$("#btnmenu_periodview").css( 'display', 'none' );
    	}
    	else{
    		$("#btnmenu_periodview").css( 'display', 'block' );
    	}
    	if(authorisationForCAO == false){
    		// disable UI for UO calculation
    	}
    	else{
    	}
    	if(authorisationForRealtimeHours == false){
    		// disable UI for realtime hours
    	}
    	else{
    	}
    	if(authorisationForTemperature == false){
    		// disable UI for temperature 
    		showTemperatureInformation = false;
    		$('#toggletemperature').val('off').slider('refresh');
    		$('#toggletemperature').slider('disable');
    		MobiScout.Tab.Data.SaveLocalData("showTemperatureInformation", showTemperatureInformation);
    	}
    	else{
    		$('#toggletemperature').slider('enable');
    	}
    	if(authorisationForDrivingTimes == false){
    		// disable UI for driving times 
    	}
    	else{
    	}
    	if(authorisationForCanbus == false){
    		// disable UI for canbus 
    		UseCanbus = false;
    		$('#togglecanbus').val('off').slider('refresh');
    		$('#togglecanbus').slider('disable');
    		MobiScout.Tab.Data.SaveLocalData("UseCanbus", UseCanbus);
    		
    		showGraphsInEmployeeList = false;
    		$('#toggleshowgraphsinlist').val('off').slider('refresh');
    		$('#toggleshowgraphsinlist').slider('disable');
    		MobiScout.Tab.Data.SaveLocalData("showGraphsInEmployeeList", showGraphsInEmployeeList);
    	}
    	else{
    		$('#togglecanbus').slider('enable');
    		if(authorisationForEmployees == true) $('#toggleshowgraphsinlist').slider('enable');
    	}
    	if(authorisationForFuelUsage == false){
    		// disable UI for fuel usage 
    	}
    	else{
    	}
    }
    
};

