var getConfigurationRunning = false;
var getTrackAndTraceRunning = false;
var getEmployeesRunning = false;
var getVehicleListRunning = false;
var getTrailerListRunning = false;
var checkSessionRunning = false;
var restoreSessionRunning = false;
var restoreRefreshCounter = 0;
var logonPlannerRunning = false;
var getDriverListRunning = false;

MobiScout.Tab.Data.LoadConfig = function () {
		MobiScout.Tab.Data.HandleOption("SecureConnection");
        MobiScout.Tab.Data.HandleOption("AvailableVersion");
        MobiScout.Tab.Data.HandleOption("AvailableURL");
        MobiScout.Tab.Data.HandleOption("CompanyName");
        MobiScout.Tab.Data.HandleOption("RefreshInterval");
        MobiScout.Tab.Data.HandleOption("VehicleSelectMethod");
        MobiScout.Tab.Data.HandleOption("DriverSelectMethod");
        MobiScout.Tab.Data.HandleOption("TranslatePositions");
        //MobiScout.Tab.Data.HandleOption("MessageReminderInterval");
        MobiScout.Tab.Data.HandleOption("NotificationSound");
        MobiScout.Tab.Data.HandleOption("ReminderMessages");
        MobiScout.Tab.Data.HandleOption("ConfirmMessages");
        MobiScout.Tab.Data.HandleOption("IsDevelopmentDevice");
        MobiScout.Tab.Data.HandleOption("CountAlertMessages");
        MobiScout.Tab.Data.HandleOption("LogLevel");
        MobiScout.Tab.Data.HandleOption("ConnectionTimeout");
        MobiScout.Tab.Data.HandleOption("UseServerImages");
        MobiScout.Tab.Data.HandleOption("UseServerImagesInList");
        MobiScout.Tab.Data.HandleOption("useLastActChange");
        MobiScout.Tab.Data.HandleOption("UseClustering");
        MobiScout.Tab.Data.HandleOption("UseTrafficInfo");
        MobiScout.Tab.Data.HandleOption("UseDepartments");
        MobiScout.Tab.Data.HandleOption("UseTickSound");
        MobiScout.Tab.Data.HandleOption("UseHapticFeedback");
        MobiScout.Tab.Data.HandleOption("UseCanbus");
        MobiScout.Tab.Data.HandleOption("showTripInformation");
        MobiScout.Tab.Data.HandleOption("showVehiclePlate");
        MobiScout.Tab.Data.HandleOption("showTrailerPlate");
        MobiScout.Tab.Data.HandleOption("showTemperatureInformation");
        MobiScout.Tab.Data.HandleOption("pageTransition");
        MobiScout.Tab.Data.HandleOption("showGraphsInEmployeeList");
        MobiScout.Tab.Data.HandleOption("LanguageID");
        
        if(UseTrafficInfo == true) MobiScout.Tab.Mapping.InitializeTraffic();
        if(UseClustering == true) MobiScout.Tab.Mapping.SetClusterer();
        
       	// autorisaties 
       	MobiScout.Tab.Data.HandleOption("1050");
        MobiScout.Tab.Data.HandleOption("1100");
        MobiScout.Tab.Data.HandleOption("1150");
        MobiScout.Tab.Data.HandleOption("1200");
        MobiScout.Tab.Data.HandleOption("1250");
        MobiScout.Tab.Data.HandleOption("1300");
        MobiScout.Tab.Data.HandleOption("1350");
        MobiScout.Tab.Data.HandleOption("1400");
        MobiScout.Tab.Data.HandleOption("1450");
        MobiScout.Tab.Data.HandleOption("1600");
        MobiScout.Tab.Data.HandleOption("1650");
        MobiScout.Tab.Data.HandleOption("1700");
        MobiScout.Tab.Data.HandleOption("1750");
        MobiScout.Tab.Data.HandleOption("1800");
        MobiScout.Tab.Data.HandleOption("1851");
        MobiScout.Tab.Data.HandleOption("1853");
        MobiScout.Tab.Data.HandleOption("1854");
        MobiScout.Tab.App.SetAuthorisation();
        MobiScout.Tab.UI.Vehicle.GenerateCircularMenu(true);
       try{
       	MobiScout.Tab.FillSettingsScreen();
       	$("#capSettingScreen").html(MobiScout.Tab.UI.GenerateVersionTable(applicationVersion, companyName));
       	 
       }
       catch(Err){
       }
        
};

MobiScout.Tab.Data.HandleOption = function (varOption) {
    try {
        if (MobiScout.Tab.Data.LoadLocalData(varOption)) {
            var varValue = MobiScout.Tab.Data.LoadLocalData(varOption);
            if (varOption == "AvailableVersion") {
                availableVersion = varValue;
            }
            else if (varOption == "AvailableURL") {
                availableURL = varValue;
            }
            
            else if (varOption == "CompanyName") {
                companyName = varValue;
            }
            else if(varOption == "SecureConnection"){
				if(varValue.toUpperCase() == "TRUE") {
			    	MobiScout.Tab.Data.SaveLocalData("SecureConnection", true);
			        SecureConnection = true;
			        try {
						$("#checkSecureConnection").attr("checked", true).checkboxradio('refresh');
			        }
			    	catch(Err){}
			      	}
			 	else{
			  		MobiScout.Tab.Data.SaveLocalData("SecureConnection", false);
			   		SecureConnection = false;
			   		try {
			   			$("#checkSecureConnection").attr("checked", false).checkboxradio('refresh');
			   		}
			   		catch(Err){}
			   	}
			}
            else if (varOption == "RefreshInterval") {
            	refreshInterval = Number(varValue);
            	// nu moeten we de alarmmanager opnieuw starten met een ander interval!
            	if(window.MobiScoutApp){
            		MobiScout.Tab.LogToConsoleWithLevel("refresh interval from config: " + refreshInterval, 5); 
            		window.MobiScoutApp.SetRefreshInterval(refreshInterval);
            	}
            }
            
            else if (varOption == "ConnectionTimeout") {
            	connectionTimeout = Number(varValue);
            	MobiScout.Tab.LogToConsole("ConnectionTimeout: " + connectionTimeout);
            }
            else if (varOption == "LogLevel") {
            	logLevel = Number(varValue);
            	MobiScout.Tab.LogToConsole("LogLevel: " + logLevel);
            }
            else if (varOption == "VehicleSelectMethod") {
            	vehicleSelectMethod = Number(varValue);
            }
            else if (varOption == "DriverSelectMethod") {
            	driverSelectMethod = Number(varValue);
            }
            else if (varOption == "LanguageID") {
            	LanguageID = Number(varValue);
            	if(LanguageID != 31) MobiScout.Tab.Translations.switchLanguage();
            }
            else if (varOption == "NotificationSound") {
            	notificationSound = Number(varValue);
            }
            else if (varOption == "TranslatePositions") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		translatePositions = true;
	        	}
	        	else{
	        		translatePositions = false;
	        	}
            }
            else if (varOption == "UseServerImages") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseServerImages = true;
	        	}
	        	else{
	        		UseServerImages = false;
	        	}
            }
            
            else if (varOption == "showGraphsInEmployeeList") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		showGraphsInEmployeeList = true;
	        	}
	        	else{
	        		showGraphsInEmployeeList = false;
	        	}
            }
            else if (varOption == "UseServerImagesInList") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseServerImagesInList = true;
	        	}
	        	else{
	        		UseServerImagesInList = false;
	        	}
            }
            else if (varOption == "useLastActChange") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		useLastActChange = true;
	        	}
	        	else{
	        		useLastActChange = false;
	        	}
            }
            else if (varOption == "UseDepartments") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseDepartments = true;
	        	}
	        	else{
	        		UseDepartments = false;
	        	}
            }
            
            else if (varOption == "UseClustering") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseClustering = true;
	        	}
	        	else{
	        		UseClustering = false;
	        	}
            }
            else if (varOption == "UseTrafficInfo") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseTrafficInfo = true;
	        	}
	        	else{
	        		UseTrafficInfo = false;
	        	}
            }
            
            else if (varOption == "ReminderMessages") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		reminderMessages = true;
	        	}
	        	else{
	        		reminderMessages = false;
	        	}
            }
 			else if (varOption == "ConfirmMessages") {
	        	if (varValue == true || varValue.toUpperCase() == "TRUE") {
	            	confirmMessages = true;
	            }
	            else {
	            	confirmMessages = false;
	          	}
	        }            
            else if (varOption == "IsDevelopmentDevice") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		isDevelopmentDevice = true;
	        		if(window.MobiScoutApp) window.MobiScoutApp.EnableDebugging();
	        		//$("#btnProgramNFCTag").css({"display": "block"});
	        		MobiScout.Tab.UI.BuildContextMenu($('.ui-page-active').attr('id'));
	        	}
	        	else{
	        		isDevelopmentDevice = false;
	        	}
	        	MobiScout.Tab.LogToConsole("IsDevelopmentDevice: " + isDevelopmentDevice);
	        	
            }
            else if (varOption == "CountAlertMessages") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		countAlertMessages = true;
	        		$('#btnmenu_alerts').css('display','block');
	        	}
	        	else{
	        		countAlertMessages = false;
	        		$('#btnmenu_alerts').css('display','none');
	        	}
            }
            else if (varOption == "pageTransition") {
            	pageTransition = varValue;
            	MobiScout.Tab.App.SetActivePageTransition();
            }
            else if (varOption == "UseHapticFeedback") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseHapticFeedback = true;
	        	}
	        	else{
	        		UseHapticFeedback = false;
	        	}
            }
            else if (varOption == "UseCanbus") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseCanbus = true;
	        	}
	        	else{
	        		UseCanbus = false;
	        	}
            }
            else if (varOption == "showTripInformation") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		showTripInformation = true;
	        		$('#btnmenu_trips').css('display','block');
	        	}
	        	else{
	        		showTripInformation = false;
	        		$('#btnmenu_trips').css('display','none');
	        	}
            }
            
            else if (varOption == "showVehiclePlate") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		showVehiclePlate = true;
	        	}
	        	else{
	        		showVehiclePlate = false;
	        	}
            }
            else if (varOption == "showTrailerPlate") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		showTrailerPlate = true;
	        	}
	        	else{
	        		showTrailerPlate = false;
	        	}
            }
            
            else if (varOption == "showTemperatureInformation") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		showTemperatureInformation = true;
	        	}
	        	else{
	        		showTemperatureInformation = false;
	        	}
            }
            else if (varOption == "UseTickSound") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		UseTickSound = true;
	        	}
	        	else{
	        		UseTickSound = false;
	        	}
            }
            else if (varOption == "1050") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForMap = true;
	        	}
	        	else{
	        		authorisationForMap = false;
	        	}
            }
            else if (varOption == "1100") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForVehicles = true;
	        	}
	        	else{
	        		authorisationForVehicles = false;
	        	}
            }
            else if (varOption == "1150") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForEmployees = true;
	        	}
	        	else{
	        		authorisationForEmployees = false;
	        	}
            }
            else if (varOption == "1250") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForTrips = true;
	        	}
	        	else{
	        		authorisationForTrips = false;
	        	}
            }
            else if (varOption == "1300") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForHours = true;
	        	}
	        	else{
	        		authorisationForHours = false;
	        	}
            }
            else if (varOption == "1350") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForMessages = true;
	        	}
	        	else{
	        		authorisationForMessages = false;
	        	}
            }
            else if (varOption == "1400") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForMessageDialog = true;
	        	}
	        	else{
	        		authorisationForMessageDialog = false;
	        	}
            }
            else if (varOption == "1450") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForRoute = true;
	        	}
	        	else{
	        		authorisationForRoute = false;
	        	}
            }
            else if (varOption == "1600") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForPeriodView = true;
	        	}
	        	else{
	        		authorisationForPeriodView = false;
	        	}
            }
            else if (varOption == "1650") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForCAO = true;
	        	}
	        	else{
	        		authorisationForCAO = false;
	        	}
            }
            else if (varOption == "1700") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForRealtimeHours = true;
	        	}
	        	else{
	        		authorisationForRealtimeHours = false;
	        	}
            }
            else if (varOption == "1750") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForAlerts = true;
	        	}
	        	else{
	        		authorisationForAlerts = false;
	        	}
            }
            else if (varOption == "1800") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForTemperature = true;
	        	}
	        	else{
	        		authorisationForTemperature = false;
	        	}
            }
            else if (varOption == "1851") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForDrivingTimes = true;
	        	}
	        	else{
	        		authorisationForDrivingTimes = false;
	        	}
            }
            else if (varOption == "1853") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForCanbus = true;
	        	}
	        	else{
	        		authorisationForCanbus = false;
	        	}
            }
            else if (varOption == "1854") {
            	if(varValue == true || varValue.toUpperCase() == "TRUE"){
	        		authorisationForFuelUsage = true;
	        	}
	        	else{
	        		authorisationForFuelUsage = false;
	        	}
            }
        }
    }
    catch(Err)
    {
    }
};


MobiScout.Tab.Data.getConfiguration = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getConfiguration", 5);
	if(MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getConfiguration: not logged on");
		return;
	}
	
    var varOption = "";
    var varValue = "";
    
    MobiScout.Tab.SetDataIconMenu('recycle'); // test <GS-20141201> busy icoon ook tonen bij opstarten
    
    MobiScout.Tab.Data.checkSession();
    if (getConfigurationRunning == true) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getConfiguration: already running");
    	return;
    }
    
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getPlannerConfiguration",
		crossDomain: true,
	    cache: false,
		headers: { "cache-control": "no-cache" },
		type: "POST",
		dataType: "xml",
		data: "",
		beforeSend: function (xhr, settings) {
			getConfigurationRunning = true;
	    },
		success: function (xml) {
			MobiScout.Tab.ClearAutorisations(); // prevent old autorisations to be a pest!
			getConfigurationRunning = false;
		    $(xml).find('row').each(function () {
		    	$(this).find('cell').each(function () {
		        	// overwrites the configuration options from the server!
		            var id = $(this).attr('column');
		            if (id == "ENTRY") varOption = $(this).text();
		            if (id == "VALUE") varValue = $(this).text();
		        });
		        try{
	            	MobiScout.Tab.Data.SaveLocalData(varOption, varValue);
	            }
	            catch(Err){
		           MobiScout.Tab.LogToConsole("Fout bij afhandelen optie: " + Err);
	            }
	        });
		        
		    
		    MobiScout.Tab.Data.LoadConfig(); // both data and ui
		    setTimeout("MobiScout.Tab.CheckUpdateAvailable()", 10000); // na 10 seconden pas melden
		    delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
	        getConfigurationRunning = false;
	    },
        complete: function(jqXHR, textStatus) {
        	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getConfiguration done");
        	if(textStatus != "success"){
        		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getConfiguration: " + textStatus + " status: " + jqXHR.status);
        		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getConfiguration text: " + jqXHR.responseText );
        		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getConfiguration xml: " + jqXHR.responseXML );
        		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getConfiguration hdr: " + jqXHR.getResponseHeader() );
        		
        		MobiScout.Tab.checkAlertForDevelopment();
        	}
           	MobiScout.Tab.Data.getActivityTypeCollection();
        	MobiScout.Tab.Data.getCaoTypes();
        	
        }
	});
};

MobiScout.Tab.Data.getCaoTypes = function(){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getCaoTypes", 5);
    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getCaoTypes: not logged on");
    	return;
    }
    var caoid;
    var descr;
    var paid;
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getCaoTypes",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "",
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        MobiScout.Tab.App.ClearCaoTypes();
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "CAO_ID") caoid = Number($(this).text());
	                else if (id == "DESCR") descr = $(this).text();
	                else if (id == "PAID") paid = Number($(this).text());
	            });
	            MobiScout.Tab.App.AddCaoType(caoid, descr, paid);

	        });
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
	    complete: function(jqXHR, textStatus) {
	       	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getCaoTypes done");
	    
	    	if(textStatus != "success"){
	    		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getCaoTypes: " + textStatus);
	    		MobiScout.Tab.checkAlertForDevelopment();
	    	}
	    }
	});
};


MobiScout.Tab.Data.getActivityTypeCollection = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getActivityTypeCollection", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getActivityTypeCollection: not logged on");
    	return;
    }
    var actid;
    var color;
    var maxcolor;
    var maxtime;
    var descr;
    var atbtype = 0;
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getActivityTypeCollection",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "",
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        MobiScout.Tab.App.ClearActivities();
	        $(xml).find('row').each(function () {
	        	atbtype = 0;
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "ACT_ID") actid = Number($(this).text());
	                else if (id == "MSSCOLOR") color = Number($(this).text());
	                else if (id == "MSSMAXCOLOR") maxcolor = Number($(this).text());
	                else if (id == "MSSMAXTIME") maxtime = Number($(this).text());
	                else if (id == "DESCR") descr = $(this).text();
	                else if (id == "ATB_TYPE") {
	                	try{
	                		atbtype = Number($(this).text());
	                	}catch(Err){}
	                }
	                
	                
	            });
	            // handle the row here
	            MobiScout.Tab.App.AddActivity(actid, color, descr, maxcolor, maxtime, atbtype);

	        });
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
	    complete: function(jqXHR, textStatus) {
	        MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getActivityTypeCollection done");
	    
	    	if(textStatus != "success"){
	    		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getActivityTypeCollection: " + textStatus);
	    		MobiScout.Tab.checkAlertForDevelopment();
	    	}
	      	if(UseDepartments == true){ 
	      		MobiScout.Tab.Data.getDepartments();
	      	}
	      	else{
	      		MobiScout.Tab.Data.getGeofences();
	      	}
	    }
	});
};


MobiScout.Tab.Data.getDepartments = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getDepartments", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getDepartments: not logged on");
    	return;
    }
    var departmentid;
    var descr;
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getDepartments",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "",
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	    	
	        MobiScout.Tab.App.ClearDepartments();
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "DEPARTMENTID") departmentid = Number($(this).text());
	                if (id == "DESCR") descr = $(this).text();
	            });
	            // handle the row here
	            MobiScout.Tab.App.AddDepartment(departmentid, descr);

	        });
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
	    		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getDepartments: " + textStatus);
	    		//MobiScout.Tab.checkAlertForDevelopment();
	    	}
	      	MobiScout.Tab.Data.getGeofences();
	    }
	});
};

MobiScout.Tab.Data.getAlertMessages = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getAlertMessages", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getAlertMessages: not logged on");
     	return;
    }
    var alertsn;
    var tsalert;
    var descr;
    var alerttypeid;
    var geofencetypeid;
    var poiid;
    var vehicleid;
    var plate;
    var alerttypedescr;
    var geofencetypedescr;
    var poidescr;
    var temp1;
    var temp2;
    var temp3;
    var temp4;
    var temp5;
    var temp6;
    var temp7;
    var temp8;
    MobiScout.Tab.UI.SetPlaceHolderForListView("AlertList", MobiScout.Tab.Translations.LadenAlarmBerichten);
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getAlerts",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "selectMethod=" + vehicleSelectMethod,
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	    	MobiScout.Tab.App.ClearAlerts();
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "MSSALERTS.ALERTSN") alertsn = Number($(this).text());
	                else if (id == "MSSALERTS.TSALERT") tsalert = $(this).text();
	                else if (id == "MSSALERTS.DESCR") descr = $(this).text();
	                else if (id == "MSSALERTS.ALERTTYPEID") alerttypeid = Number($(this).text());
	                else if (id == "ALERTTYPES.DESCR") alerttypedescr = $(this).text();
	                else if (id == "MSSALERTS.GEOFENCETYPEID") geofencetypeid = Number($(this).text());
	                else if (id == "MSSALERTS.POI_ID") poiid = Number($(this).text());
	                else if (id == "MSSALERTS.VEHICLEID") vehicleid = Number($(this).text());
	                else if (id == "VEHICLES.PLATE") plate = $(this).text();
	                else if (id == "MSSALERTS.TEMPERATURE1") temp1 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "MSSALERTS.TEMPERATURE2") temp2 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "MSSALERTS.TEMPERATURE3") temp3 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "MSSALERTS.TEMPERATURE4") temp4 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "MSSALERTS.TEMPERATURE5") temp5 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "MSSALERTS.TEMPERATURE6") temp6 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "MSSALERTS.TEMPERATURE7") temp7 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "MSSALERTS.TEMPERATURE8") temp8 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "POINTOFINTEREST.DESCR") poidescr = $(this).text();
	                // else if (id == "GEOFENCETYPES.DESCR") geofencetypedescr = $(this).text();
	                geofencetypedescr = MobiScout.Tab.TranslateGeofenceType(geofencetypeid);
	            });
	            if(descr.indexOf("GPAUX") > -1){
	            	descr = poidescr;
	            }
	            if(descr.trim() == "Geofence"){
	            	descr = poidescr;
	            }
	            MobiScout.Tab.App.AddAlert(alertsn, tsalert, descr, alerttypeid, geofencetypeid, poiid, vehicleid, plate, alerttypedescr, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, geofencetypedescr);
	        });
	        MobiScout.Tab.UI.Alert.BuildAlertList();
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
	    },
		complete: function(jqXHR, textStatus) {
	        MobiScout.Tab.UI.SetPlaceHolderForListView("AlertList", MobiScout.Tab.Translations.ZoekAlarmBerichten);
			if(textStatus != "success"){
		    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getAlertMessages: " + textStatus);
		    	MobiScout.Tab.checkAlertForDevelopment();
		    }
	    }
	});
};

MobiScout.Tab.Data.getScoreCard = function (ID, isDriver) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getScoreCard " + ID + " " + isDriver, 5);
    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getScoreCard: not logged on");
     	return;
    }
	
    
    var grade;
    var liters;
    var distance;
    var scoreVerbruik;
    var scoreCruise;
    var scoreRem;
    var scoreStationair;
    var scoreUitrol;
    var scoreHarshBrake;
    var scoreHarshAccel;
    var scoreOverspeed;
    var scoreOverrev;
    var scoreOverTPS;
    var avgSpeed;
    var consumption;
    var prevconsumption;
    var prevgrade;
    var prevavgspeed;
    var histconsumption;
    var histmarssnelheid;
    var globalconsumption;
    //console.log("Data: " + "ID=" + ID + "&isDriver" + isDriver);
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getScoreCard",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "ID=" + ID + "&isDriver=" + isDriver,
	    success: function (xml) {
	    	//console.log("MobiScout.Tab.Data.getScoreCard " + xml);
	        $(xml).find('row').each(function () {
	        
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "Grade") grade = parseFloat($(this).text().replace(",", "."));
	                else if (id == "RealLiters") liters = parseFloat($(this).text().replace(",", "."));
	                else if (id == "RealDistance") distance = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreVerbruik") scoreVerbruik = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreCruise") scoreCruise = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreRem") scoreRem = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreStationair") scoreStationair = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreUitrol") scoreUitrol = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreHarshBraking") scoreHarshBrake = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreHarshAccel") scoreHarshAccel = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreOverspeed") scoreOverspeed = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreOverrev") scoreOverrev = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ScoreOverTPS") scoreOverTPS = parseFloat($(this).text().replace(",", "."));
	                else if (id == "AvgSpeed") avgSpeed = parseFloat($(this).text().replace(",", "."));
	                else if (id == "ConsumptionL100KM") consumption = parseFloat($(this).text().replace(",", "."));
	                else if (id == "PrevConsumption") prevconsumption = parseFloat($(this).text().replace(",", "."));
	                else if (id == "PrevGrade") prevgrade = parseFloat($(this).text().replace(",", "."));
	                else if (id == "PrevAvgSpeed") prevavgspeed = parseFloat($(this).text().replace(",", "."));
	                else if (id == "Duration") duration = parseFloat($(this).text().replace(",", "."));
	                else if (id == "HISTORY_CONSUMPTION") histconsumption = $(this).text();
	                else if (id == "HISTORY_MARSSNELHEID") histmarssnelheid = $(this).text();
	                else if (id == "GLOBAL_CONSUMPTION") globalconsumption = $(this).text();
	                //PrevConsumption
	                //PrevGrade
	                //PrevAvgSpeed
	                
	                //AvgSpeed
	                //Idle_time
	                //Driving_time
	                //Idle_liters
	                //ConsumptionKML
	                //IdleTimePercentage
	                //CruisePerc
	            });
	        });
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getScoreCard: " + textStatus + " code " + jqXHR.status);
				MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.GeenGegevensBeschikbaar);
				if(MobiScout.Tab.App.CurrentDriverID > 0) {
					// dan was dit vanuit het chauffeursschherm gestart
					MobiScout.Tab.ChangePage("employees");
				}
				else if(MobiScout.Tab.App.CurrentVehicleID > 0){
					// dan was dit vanuit het voertuigenscherm gestart
					MobiScout.Tab.ChangePage("home");
				}
			}
			else{
				// set driver details in score card page
				MobiScout.Tab.UI.Scoring.SetScoreCard(ID, isDriver, grade, liters, distance, duration, scoreVerbruik, scoreCruise, scoreRem, scoreStationair, scoreUitrol, scoreHarshBrake, scoreHarshAccel, scoreOverspeed, scoreOverrev, scoreOverTPS, avgSpeed, consumption, prevconsumption, prevavgspeed, prevgrade);
				MobiScout.Tab.UI.Scoring.SetScoreCardChart(ID, isDriver, histconsumption, histmarssnelheid, globalconsumption);
			}
	    }
	});
}


MobiScout.Tab.Data.getUnreadMessages = function (isAutoUpdate) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getUnreadMessages", 5);
	
    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getUnreadMessages: not logged on");
     	return;
    }
    var msgsn;
    var tsstatus;
    var content;
    var driverid;
    var vehicleid;
    var plate;
    var name;
    var firstReceivedMessageContent;
    var totalReceivedMessageContent = "";
    
    var latitude;
    var longitude;
    var location;
    //MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getUnreadMessages",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "translatePositions=" + translatePositions + "&selectMethod=" + vehicleSelectMethod,
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	    	try{
		        var badgeCount = 0;
		        var newMessageReceived = false;
		        MobiScout.Tab.App.ClearFoundInListFlags();
		        $(xml).find('row').each(function () {
		            $(this).find('cell').each(function () {
		                var id = $(this).attr('column');
		                if (id == "MSSMESSAGES.MSGSN") msgsn = Number($(this).text());
		                if (id == "MSSMESSAGES.VEHICLEID") vehicleid = Number($(this).text());
		                if (id == "MSSMESSAGES.EMP_ID") driverid = Number($(this).text());
		                if (id == "MSSMESSAGES.MSGCONTENTS") {
		                	content = $(this).text();
		                	content = $('<p>' + content + '</p>').text(); // <GS-20170119> HTML formatted might cause breaking issues in UI
		                	if(isBlank(firstReceivedMessageContent)) firstReceivedMessageContent = content;
		                }
		                if (id == "MSSMESSAGES.TSSTATUS") tsstatus = $(this).text();
		                if (id == "VEHICLES.PLATE") plate = $(this).text();
		                if (id == "EMPLOYEES.NAME") name = $(this).text();
		                if (id == "MSSPOSITIONS.LATTITUDE") {
		                	try{
		                		latitude = parseFloat($(this).text().replace(",", "."));
		                	}catch(Err){
		                	}
		                }
		                if (id == "MSSPOSITIONS.LONGITUDE") 
		                {
		                	try{
		                		longitude = parseFloat($(this).text().replace(",", "."));
							}catch(Err){
		                	}
		                }
		                if (id == "Location") location = $(this).text();
		            });
		            if(MobiScout.Tab.App.AddUnreadMessage(msgsn, vehicleid, driverid, tsstatus, content, plate, name, latitude, longitude, location) == true){
		            	newMessageReceived = true;
		            	if(!isBlank(totalReceivedMessageContent)) totalReceivedMessageContent += "|";
		            	totalReceivedMessageContent += plate + ": " + content;
		            	
		            }
		            badgeCount ++;
		        });
		        var updateMessageList = newMessageReceived ;
		        if(MobiScout.Tab.App.cleanUnreadMessageList() == true) updateMessageList = true; 
		        MobiScout.Tab.UI.Message.BuildMessagesList(updateMessageList, badgeCount);
		        MobiScout.Tab.UpdateMessageBadgeCount(badgeCount);
		        if(badgeCount == 0) {
		        	MobiScout.Tab.ClearAndroidNotification();
		        }
		        
		        if(newMessageReceived == true){
		        	// als de app openstaat en we staan in het berichtenscherm, dan hoeft er geen notificatie te volgen?
		        	if(MobiScout.Tab.App.isAppPaused == false && $('.ui-page-active').attr('id') == 'messages'){
			        	MobiScout.Tab.PlayNotification(false);
		        	}
		        	else{
		        		var nieuweBerichten = MobiScout.Tab.App.Messages.length + " " + MobiScout.Tab.Translations.OngelezenBerichten;
		        		if(MobiScout.Tab.App.Messages.length == 1) nieuweBerichten = MobiScout.Tab.App.Messages.length + " ongelezen bericht";
			        	MobiScout.Tab.AndroidNotification(nieuweBerichten, totalReceivedMessageContent/* firstReceivedMessageContent*/, 1)
			        	MobiScout.Tab.App.ReminderActive = true;
			        	MobiScout.Tab.PlayNotification(true);
		        	}
		        }
		        else{
		        	if(reminderMessages == true && badgeCount > 0 && isAutoUpdate == true){
		        		MobiScout.Tab.App.RemindUnreadMessages();  // herinnering voor ongelezen berichten
		        	}
		        }
			}
			catch(e1){
				MobiScout.Tab.LogToConsole("Failed to update unread messages on success: " + e1);
			}
			delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getUnreadMessages: " + textStatus + " code " + jqXHR.status);
				MobiScout.Tab.checkAlertForDevelopment();
			}
			if(getTrackAndTraceRunning == false && MobiScout.Tab.App.playingSound == false){
	    		MobiScout.Tab.AllowSleep(); // direct doen
	    	}
	    	else{
	    		if(getTrackAndTraceRunning == true){
	    			MobiScout.Tab.LogToConsole("Keeping wakelock on because getTrackAndTraceRunning = true");
	    		}
	    		if(MobiScout.Tab.App.playingSound == true){
	    			MobiScout.Tab.LogToConsole("Keeping wakelock on because a notification sound is still playing");
	    		}
	    	}
	    	navigator.notification.activityStop();
	    }
	});
};

MobiScout.Tab.Data.getTrips = function (vehicleid) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getTrips", 5);

	if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrips: not logged on");
		return;
	}
	var tripsn;
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getTrips",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "vehicleID=" + vehicleid,
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "TRIPSN") tripsn = Number($(this).text());
	                
	            });
	            MobiScout.Tab.Data.getStops(tripsn);
	        });
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
			MobiScout.Tab.UI.Trip.BuildStopList();
	        MobiScout.Tab.App.LastVehicleInTripStop = vehicleid;
	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrips: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
	    }
	});
};

MobiScout.Tab.Data.getRouteForVehicleV2 = function(vehicleid, dateToPlot){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getRouteForVehicleV2", 5);
	if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getRouteForVehicleV2: not logged on");
	 	return;
	}
    var positionsn;
    var tsposition;
    var latitude;
    var longitude;
    if(!dateToPlot) dateToPlot = MobiScout.Tab.GetCurrentDate();
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getVehicleTrailV2",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "vehicleID=" + vehicleid + "&dtMessage=" + dateToPlot.format('YmdHis'),
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "MSSPOSITIONS.POSITIONSN") positionsn = Number($(this).text());
	                else if (id == "MSSPOSITIONS.TSPOSITION") tsposition = $(this).text();
	                else if (id == "MSSPOSITIONS.LATTITUDE") {
	                	try{
	                		latitude = parseFloat($(this).text().replace(",", "."));
	                	}catch(Err){
	                	}
	                }
	                else if (id == "MSSPOSITIONS.LONGITUDE") 
	                {
	                	try{
	                		longitude = parseFloat($(this).text().replace(",", "."));
						}catch(Err){
	                	}
	                }
	                else if (id == "MSSMESSAGES.ACTIVITYID") 
	                {
	                	try{
	                		activityID = Number($(this).text());
						}catch(Err){
	                	}
	                }
	            });
	            MobiScout.Tab.Mapping.AddPlotLocation(latitude, longitude, activityID);
	        });
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getRouteForVehicle: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
			MobiScout.Tab.Mapping.FinishPlotVehicleRouteOnMap(vehicleid);
	    }
	});
};

MobiScout.Tab.Data.getRouteForVehicle = function(vehicleid, dateToPlot){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getRouteForVehicle", 5);
	if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getRouteForVehicle: not logged on");
	 	return;
	}
    var positionsn;
    var tsposition;
    var latitude;
    var longitude;
    if(!dateToPlot) dateToPlot = MobiScout.Tab.GetCurrentDate();
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getVehicleTrail",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "vehicleID=" + vehicleid + "&dtMessage=" + dateToPlot.format('YmdHis'),
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "POSITIONSN") positionsn = Number($(this).text());
	                if (id == "TSPOSITION") tsposition = $(this).text();
	                if (id == "LATTITUDE") {
	                	try{
	                		latitude = parseFloat($(this).text().replace(",", "."));
	                	}catch(Err){
	                	}
	                }
	                if (id == "LONGITUDE") 
	                {
	                	try{
	                		longitude = parseFloat($(this).text().replace(",", "."));
						}catch(Err){
	                	}
	                }
	            });
	            MobiScout.Tab.Mapping.AddPlotLocation(latitude, longitude, 0);
	        });
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getRouteForVehicle: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
			MobiScout.Tab.Mapping.FinishPlotVehicleRouteOnMap(vehicleid);
	    }
	});
};

MobiScout.Tab.Data.getTripList = function(vehicleid){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getTripList", 5);
	MobiScout.Tab.App.Trips.splice(0, MobiScout.Tab.App.Trips.length);
    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTripList: not logged on");
     	return;
    }
    var trip = new TabTrip();
    MobiScout.Tab.Data.checkSession();
    MobiScout.Tab.UI.SetPlaceHolderForListView("TripsList", MobiScout.Tab.Translations.LadenRitten);
    $.support.cors = true;
    $.ajax
		({
		    url: WebServiceURL + webServicePage + "/getPlannerTripsList",
		    crossDomain: true,
		    cache: false,
		    headers: { "cache-control": "no-cache" },
		    type: "POST",
		    dataType: "xml",
		    data: "vehicleID=" + vehicleid + "&selectMethod=" + vehicleSelectMethod,
		    success: function (xml) {
		        $(xml).find('row').each(function () {
		            trip = new TabTrip();
		            try{
			            $(this).find('cell').each(function () {
			                var id = $(this).attr('column');
			                if (id == "MSSTRIPS.TRIPSN") trip.TripSN = $(this).text();
			                else if (id == "MSSTRIPS.STATUSID") trip.StatusID = Number($(this).text());
			                else if (id == "MSSTRIPS.EXTERNALREF") trip.ExternalRef = $(this).text();
			                else if (id == "MSSTRIPS.TSSTARTPL") trip.TSStartPlanned = $(this).text();
			                else if (id == "MSSTRIPS.TSSTOPPL") trip.TSStopPlanned = $(this).text();
			                else if (id == "MSSTRIPS.REMARKS") trip.Remarks = $(this).text();
			                else if (id == "MSSTRIPS.TRIPREF") trip.TripRef = $(this).text();
			                else if (id == "MSSTRIPS.DESCR") trip.Descr = $(this).text();
			                else if (id == "MSSTRIPS.TRAILERID") {
			                	try{
			                    	trip.TrailerID = Number($(this).text());
			                    }
			                    catch(Err){}
			                }
			                else if (id == "MSSTRIPS.LOCFROM") trip.LocFrom = $(this).text();
			                else if (id == "MSSTRIPS.LOCTO") trip.LocTo = $(this).text();
			                else if (id == "MSSTRIPS.STOPCOUNT") trip.StopCount = Number($(this).text());
			                
			                else if (id == "MSSTRIPS.STOPSDONE") trip.StopsDone = Number($(this).text());
			                else if (id == "MSSTRIPS.TOTALSTOPS") trip.StopsTotal = Number($(this).text());
			                
			                else if (id == "MSSTRIPS.VEHICLEID") trip.VehicleID = Number($(this).text());
			                else if (id == "MSSTRIPS.DRIVERID") trip.DriverID = Number($(this).text());
							else if (id == "VEHICLES.PLATE") trip.Plate = $(this).text();
							else if (id == "EMPLOYEES.NAME") trip.Name = $(this).text();
			            });
		            }
		            catch(ETrip)
		            {
		            	MobiScout.Tab.LogToConsole("Failed to parse trip: " + ETrip);
		            }
		            //console.log("MobiScout.Tab.Data.getTripList found trip: " + trip.TripSN);
		            MobiScout.Tab.App.Trips.push(trip);
		        });
		        delete xml;
		    },
			complete: function(jqXHR, textStatus) {
				if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTripList: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
				
		    	MobiScout.Tab.UI.Trip.BuildTripList();
		    	MobiScout.Tab.UI.SetPlaceHolderForListView("TripsList", MobiScout.Tab.Translations.ZoekRitten);
		    },		    
		    error: function (xhr, ajaxOptions, thrownError) {
		    }
		});



    /* }
    else {
    }*/
}


MobiScout.Tab.Data.GetDetailsForStop = function(stopSN){
	// herbruikbare functie voor weergeven stop/zendingdetails vanuit status berichten
	// en vanuit stop lijst
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetDetailsForStop", 3);

	if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){ 
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetDetailsForStop: not logged on");
		return;
	}
	if(stopSN <= 0) return; // dan doen we dat mooi niet
	var stopsn;
	var actionsn;
	var actionDescr;
	var actionStatus;
	var actionTSStartPL;
	var actionName;
	var actionRemarks;
	var actionTSStartEX;
	var actionTSStopEX;
	var actionExternalRef;
	var actionReasonID;
	var shipmentDescr;
	var shipmentOrderRef;
	var shipmentTrackingCode;
	var shipmentClientName;
	var shipmentRemark1;
	var shipmentRemark2;
	var shipmentRemark3;
	var shipmentRemark4;
	var shipmentPackcount;
	var shipmentWeight;
	var shipmentPacktypeDescr;
	var shipmentCOD;
	var actionTypeDescr;
	var stopRemark;
	var addressName;
	var addressAddress;
	var addressPostcode;
	var addressCity;
	var addressPhone;
	var addressContact;
	var addressEmail;
	var shipmentSN;
	
	$.ajax
	({
	    url: WebServiceURL + webServicePage + "/getDetailsForStop",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "stopSN=" + stopSN,
	    success: function (xml) {
	    	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetDetailsForStop success", 3);
	    	MobiScout.Tab.App.TempActions.splice(0, MobiScout.Tab.App.TempActions.length);
	    	
			$(xml).find('row').each(function () {
				shipmentCOD = 0;
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "MSSACTIONS.STOPSN") stopsn = Number($(this).text());
	                else if (id == "MSSACTIONS.ACTIONSN") actionsn = Number($(this).text());
	                else if (id == "MSSACTIONS.DESCR") actionDescr = $(this).text();	    
	                else if (id == "MSSACTIONS.STATUSID") actionStatus = $(this).text();	    
	                else if (id == "MSSACTIONS.TSSTARTPL") actionTSStartPL = $(this).text();	    
	                else if (id == "MSSACTIONS.NAME") actionName = $(this).text();	    
	                else if (id == "MSSACTIONS.REMARKS") actionRemarks = $(this).text();	    
	                else if (id == "MSSACTIONS.TSSTARTEX") actionTSStartEX = $(this).text();	    
	                else if (id == "MSSACTIONS.TSSTOPEX") actionTSStopEX = $(this).text();	    
	                else if (id == "MSSACTIONS.EXTERNALREF") actionExternalRef = $(this).text();	    
	                else if (id == "MSSACTIONS.REASONNE_ID") actionReasonID = $(this).text();
	                else if (id == "MSSSHIPMENTS.SHIPMENTSN") shipmentSN = Number($(this).text());	    
	                else if (id == "MSSSHIPMENTS.DESCR") shipmentDescr = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.ORDERREF") shipmentOrderRef = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.TRACKINGCODE") shipmentTrackingCode = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.CLIENTNAME") shipmentClientName = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.REMARK1") shipmentRemark1 = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.REMARK2") shipmentRemark2 = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.REMARK3") shipmentRemark3 = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.REMARK4") shipmentRemark4 = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.PACKCOUNT") shipmentPackcount = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.WEIGHT") shipmentWeight = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.PACKTYPEDESCR") shipmentPacktypeDescr = $(this).text();	    
	                else if (id == "MSSSHIPMENTS.COD"){
	                	try{ 
	                		shipmentCOD = parseFloat($(this).text().replace(",", "."));	    
	                	}
	                	catch(Err){}
	                }
	                else if (id == "MSSACTIONTYPES.DESCR") actionTypeDescr = $(this).text();	    
	                else if (id == "MSSSTOPS.REMARKS") stopRemark = $(this).text();	    
	                else if (id == "MSSADDRESSES.NAME") addressName = $(this).text();	    
	                else if (id == "MSSADDRESSES.ADDRESS") addressAddress = $(this).text();	    
	                else if (id == "MSSADDRESSES.POSTCODE") addressPostcode = $(this).text();	    
	                else if (id == "MSSADDRESSES.CITY") addressCity = $(this).text();	    
	                else if (id == "MSSADDRESSES.PHONE") addressPhone = $(this).text();	    
	                else if (id == "MSSADDRESSES.CONTACT") addressContact = $(this).text();	    
	                else if (id == "MSSADDRESSES.EMAIL") addressEmail = $(this).text();
				});
				// opslaan in tijdelijke opslag
				MobiScout.Tab.App.AddTemporaryAction(stopsn, actionsn, actionDescr, actionStatus, actionTSStartPL, actionName, actionRemarks, actionTSStartEX, actionTSStopEX, actionExternalRef, actionReasonID, shipmentDescr, shipmentOrderRef, shipmentTrackingCode, shipmentClientName, shipmentRemark1, shipmentRemark2, shipmentRemark3, shipmentRemark4,shipmentPackcount, shipmentWeight, shipmentPacktypeDescr, shipmentCOD, actionTypeDescr, stopRemark, addressName, addressAddress, addressPostcode, addressCity, addressPhone, addressContact, addressEmail, shipmentSN);       
	        });
	        delete xml;
	        
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetDetailsForStop: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
			else{
				// vul de betreffende pagina aan.. indien we in het stopscherm zitten, dan die weergeven
				// anders het berichten detail scherm aanvullen met de details
	    		MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetDetailsForStop complete", 3);
				MobiScout.Tab.App.AppendActionInfoToCurrentScreen();
				// haal nu ook de goederen op die bij deze zendingen horen
				MobiScout.Tab.Data.GetDetailsForTemporaryActions2();
			}
			//MobiScout.Tab.UI.Trip.BuildStopList();
	    }
	});
}

MobiScout.Tab.Data.removeLastComma = function(strng){        
    var n=strng.lastIndexOf(",");
    var a=strng.substring(0,n) 
    return a;
}

MobiScout.Tab.Data.GetGoodsForActionList = function (actionlist) {

	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetGoodsForActionList", 3);
	if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){ 
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetGoodsForActionList: not logged on");
		return;
	}
	
	var goodssn;
	var shipmentsn;
	var orderref;
	var descr;
	var packcount;
	var weight;
	var packtypedescr;
	var volume;
	var weighttypedescr;
	var volumetypedescr;
	var remark1;
	var packcountex;
	var dim1;
	var dim2;
	var dim3;
	var weightex;
	var volumeex;
	var remark2;
	var remark3;
	var remark4;
	var goodsref;
	var palletplaatsen;
	var laadmeter;
	
	$.ajax
	({
	    url: WebServiceURL + webServicePage + "/getGoodsForActions", // nieuwe functie voor maken in webservice!!
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "actionlist=" + actionlist,
	    success: function (xml) {
	    	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetGoodsForActionList success", 3);
	    	MobiScout.Tab.App.TempGoods.splice(0, MobiScout.Tab.App.TempGoods.length);
	    	
			$(xml).find('row').each(function () {
				orderref = '';
				descr = '';
				packtypedescr = '';
				remark1 = '';
				remark2 = '';
				remark3 = '';
				remark4 = '';
				dim1 = '';
				dim2 = '';
				dim3 = '';
				goodsref = '';
				
				
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "GOODSSN") goodssn = Number($(this).text());
	                else if (id == "SHIPMENTSN") shipmentsn = Number($(this).text());	    
	                else if (id == "ORDERREF") orderref = $(this).text();	    
	                else if (id == "DESCR") descr = $(this).text();	    
	                else if (id == "PACKCOUNT") packcount = Number($(this).text());	    
	                else if (id == "WEIGHT") weight = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "PACKTYPEDESCR") packtypedescr = $(this).text();	    
	                else if (id == "VOLUME") volume = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "WEIGHTTYPEDESCR") weighttypedescr = $(this).text();	    
	                else if (id == "VOLUMETYPEDESCR") volumetypedescr = $(this).text();
	                else if (id == "REMARK1") remark1 = $(this).text();	    
	                else if (id == "PACKCOUNTEX") packcountex = $(this).text();	    
	                else if (id == "DIM1") dim1 = $(this).text();	    
	                else if (id == "DIM2") dim2 = $(this).text();	    
	                else if (id == "DIM3") dim3 = $(this).text();	    
	                else if (id == "WEIGHTEX") weightex = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "VOLUMEEX") volumeex = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "REMARK2") remark2 = $(this).text();	    
	                else if (id == "REMARK3") remark3 = $(this).text();	    
	                else if (id == "REMARK4") remark3 = $(this).text();	    
	                else if (id == "GOODSREF") goodsref = $(this).text();	    
	                else if (id == "PALLETPLAATSEN") palletplaatsen = Number($(this).text());	    
	                else if (id == "LAADMETER"){
	                 	laadmeter = parseFloat($(this).text().replace(",", "."));	    
	                }
	                
				});
				if(weighttypedescr == undefined) weighttypedescr = "KG";
				else if(isBlank(weighttypedescr)) weighttypedescr = "KG";
				if(volumetypedescr == undefined) volumetypedescr = "M3";
				else if(isBlank(volumetypedescr)) volumetypedescr = "M3";
				MobiScout.Tab.App.AddTemporaryGood(goodssn, shipmentsn, orderref, descr, packcount, weight, packtypedescr, volume, weighttypedescr, volumetypedescr, remark1, packcountex, dim1, dim2, dim3, weightex, volumeex, remark2, remark3, remark4, goodsref, palletplaatsen, laadmeter);
	        });
	        delete xml;
	        
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetGoodsForActionList: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
			else{
	    		MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetGoodsForActionList complete", 3);
				MobiScout.Tab.App.AppendGoodsInfoToCurrentScreen();
			}
	    }
	});
}

MobiScout.Tab.Data.GetGoodsForShipmentList = function(shipmentlist){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetGoodsForShipmentList", 3);
	if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){ 
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetGoodsForShipmentList: not logged on");
		return;
	}
	
	var goodssn;
	var shipmentsn;
	var orderref;
	var descr;
	var packcount;
	var weight;
	var packtypedescr;
	var volume;
	var weighttypedescr;
	var volumetypedescr;
	var remark1;
	var packcountex;
	var dim1;
	var dim2;
	var dim3;
	var weightex;
	var volumeex;
	var remark2;
	var remark3;
	var remark4;
	var goodsref;
	var palletplaatsen;
	var laadmeter;
	
	//TODO: Vanaf hier afmaken!
	
	$.ajax
	({
	    url: WebServiceURL + webServicePage + "/getGoodsForShipments", // nieuwe functie voor maken in webservice!!
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "shipmentlist=" + shipmentlist,
	    success: function (xml) {
	    	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetGoodsForShipmentList success", 3);
	    	MobiScout.Tab.App.TempGoods.splice(0, MobiScout.Tab.App.TempGoods.length);
	    	
			$(xml).find('row').each(function () {
				orderref = '';
				descr = '';
				packtypedescr = '';
				remark1 = '';
				remark2 = '';
				remark3 = '';
				remark4 = '';
				dim1 = '';
				dim2 = '';
				dim3 = '';
				goodsref = '';
				
				
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "GOODSSN") goodssn = Number($(this).text());
	                else if (id == "SHIPMENTSN") shipmentsn = Number($(this).text());	    
	                else if (id == "ORDERREF") orderref = $(this).text();	    
	                else if (id == "DESCR") descr = $(this).text();	    
	                else if (id == "PACKCOUNT") packcount = Number($(this).text());	    
	                else if (id == "WEIGHT") weight = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "PACKTYPEDESCR") packtypedescr = $(this).text();	    
	                else if (id == "VOLUME") volume = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "WEIGHTTYPEDESCR") weighttypedescr = $(this).text();	    
	                else if (id == "VOLUMETYPEDESCR") volumetypedescr = $(this).text();
	                else if (id == "REMARK1") remark1 = $(this).text();	    
	                else if (id == "PACKCOUNTEX") packcountex = $(this).text();	    
	                else if (id == "DIM1") dim1 = $(this).text();	    
	                else if (id == "DIM2") dim2 = $(this).text();	    
	                else if (id == "DIM3") dim3 = $(this).text();	    
	                else if (id == "WEIGHTEX") weightex = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "VOLUMEEX") volumeex = parseFloat($(this).text().replace(",", "."));	    
	                else if (id == "REMARK2") remark2 = $(this).text();	    
	                else if (id == "REMARK3") remark3 = $(this).text();	    
	                else if (id == "REMARK4") remark3 = $(this).text();	    
	                else if (id == "GOODSREF") goodsref = $(this).text();	    
	                else if (id == "PALLETPLAATSEN") palletplaatsen = Number($(this).text());	    
	                else if (id == "LAADMETER"){
	                 	laadmeter = parseFloat($(this).text().replace(",", "."));	    
	                }
	                
				});
				if(weighttypedescr == undefined) weighttypedescr = "KG";
				else if(isBlank(weighttypedescr)) weighttypedescr = "KG";
				if(volumetypedescr == undefined) volumetypedescr = "M3";
				else if(isBlank(volumetypedescr)) volumetypedescr = "M3";
				MobiScout.Tab.App.AddTemporaryGood(goodssn, shipmentsn, orderref, descr, packcount, weight, packtypedescr, volume, weighttypedescr, volumetypedescr, remark1, packcountex, dim1, dim2, dim3, weightex, volumeex, remark2, remark3, remark4, goodsref, palletplaatsen, laadmeter);
	        });
	        delete xml;
	        
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetGoodsForShipmentList: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
			else{
	    		MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetGoodsForShipmentList complete", 3);
				MobiScout.Tab.App.AppendGoodsInfoToCurrentScreen();
			}
	    }
	});
}

MobiScout.Tab.Data.GetDetailsForTemporaryActions2 = function (stopSN) {

	var actionlist = "";
	try{
		for (var i = 0; i < MobiScout.Tab.App.TempActions.length; i++) {
			if(Number(MobiScout.Tab.App.TempActions[i].stopsn) == Number(MobiScout.Tab.App.CurrentMessageStopSN)){
				// haal goederen voor deze zendingen
				if(MobiScout.Tab.App.TempActions[i].actionsn){
					if(MobiScout.Tab.App.TempActions[i].actionsn > 0){
						actionlist += MobiScout.Tab.App.TempActions[i].actionsn + ",";
					}
				}
			}
		}
		actionlist = MobiScout.Tab.Data.removeLastComma(actionlist);
		if(!isBlank(actionlist)){
			MobiScout.Tab.Data.GetGoodsForActionList(actionlist);
		}
	}
	catch(Err)
	{
	}
}

MobiScout.Tab.Data.GetDetailsForTemporaryActions = function(){
	var shipmentlist = "";
	try{
		for (var i = 0; i < MobiScout.Tab.App.TempActions.length; i++) {
			if(Number(MobiScout.Tab.App.TempActions[i].stopsn) == Number(MobiScout.Tab.App.CurrentMessageStopSN)){
				// haal goederen voor deze zendingen
				if(MobiScout.Tab.App.TempActions[i].shipmentSN){
					if(MobiScout.Tab.App.TempActions[i].shipmentSN > 0){
						shipmentlist += MobiScout.Tab.App.TempActions[i].shipmentSN + ",";
					}
				}
			}
		}
		shipmentlist = MobiScout.Tab.Data.removeLastComma(shipmentlist);
		if(!isBlank(shipmentlist)){
			MobiScout.Tab.Data.GetGoodsForShipmentList(shipmentlist);
		}
	}
	catch(Err)
	{
	}

}

MobiScout.Tab.Data.getStops = function (tripsn) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getStops", 5);

	if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){ 
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getStops: not logged on");
		return;
	}
	var stopsn;
	var tsstartpl;
	var tsstoppl;
	var addressname;
    var statusid;
    var addressaddress;
    var addressno;
    var addresspostcode;
    var addresscity;
    var externalref;
    var actiondescr;
    var actiontypeid;
    var afwijkingen;
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getStopsForTripSN",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "tripSN=" + tripsn + "&getAllStops=true",
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	        	afwijkingen = 0;
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "MSSSTOPS.STOPSN") stopsn = Number($(this).text());
	                else if (id == "MSSSTOPS.TSSTARTPL") tsstartpl = $(this).text();
	                else if (id == "MSSSTOPS.TSSTOPPL") tsstoppl = $(this).text();
	                else if (id == "MSSADDRESSES.NAME") addressname = $(this).text();
	                else if (id == "MSSADDRESSES.ADDRESS") addressaddress = $(this).text();
	                else if (id == "MSSADDRESSES.ADDRESSNO") addressno = $(this).text();
	                else if (id == "MSSADDRESSES.POSTCODE") addresspostcode = $(this).text();
	                else if (id == "MSSADDRESSES.CITY") addresscity = $(this).text();
	                else if (id == "MSSSTOPS.EXTERNALREF") externalref = $(this).text();
	                else if (id == "MSSSTOPS.STATUSID") statusid = Number($(this).text());
	                else if (id == "MSSACTIONTYPES.DESCR") actiondescr = $(this).text();
	                else if (id == "MSSSTOPS.ACTIONTYPEID") {
	                	try{
	                		actiontypeid = Number($(this).text());
	                	}catch(Err){}
	                }
					else if(id == "AFW"){
						try{
							afwijkingen = Number($(this).text());
						}catch(Err){}
					}
	                
	            });
	            MobiScout.Tab.App.AddStop(stopsn, tsstartpl, tsstoppl, statusid, addressname, addressaddress, addressno, addresspostcode, addresscity, externalref, actiondescr, actiontypeid, afwijkingen);
	        });
	        delete xml;
	        
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getStops: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
			MobiScout.Tab.UI.Trip.BuildStopList();
	    }
	});
};

MobiScout.Tab.Data.getMessageDialog = function (vehicleid, datetimemessage, forceclear) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getMessageDialog", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getMessageDialog: not logged on");
    	return;
    }
    var msgsn;
    var tsstatus;
    var tsread;
    var content;
    var driverid;
    var vehicleid;
    var activityid;
    var statusid;
    var msgtypeid;
    var plate;
    var name;
    var latitude;
    var longitude;
    var location;
    var prio;
    if(datetimemessage == undefined) datetimemessage = MobiScout.Tab.GetCurrentDate();
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getMessageDialog",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "vehicleID=" + vehicleid + "&dtMessage=" + datetimemessage.format('YmdHis') + "&translatePositions=" + translatePositions + "&convertMessages=false",
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	    	MobiScout.Tab.UI.PeriodView.ActivityList.splice(0, MobiScout.Tab.UI.PeriodView.ActivityList.length);
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "MSSMESSAGES.MSGSN") msgsn = Number($(this).text());
	                else if (id == "MSSMESSAGES.VEHICLEID") vehicleid = Number($(this).text());
	                else if (id == "MSSMESSAGES.EMP_ID") driverid = Number($(this).text());
	                else if (id == "MSSMESSAGES.MSGCONTENTS") content = $(this).text();
	                else if (id == "MSSMESSAGES.TSSTATUS") tsstatus = $(this).text();
	                else if (id == "MSSMESSAGES.ACTIVITYID") activityid = Number($(this).text());
	                else if (id == "MSSMESSAGES.STATUSID") statusid = Number($(this).text());
	                else if (id == "MSSMESSAGES.MSGTYPEID") msgtypeid = Number($(this).text());
	                else if (id == "MSSMESSAGES.TSREAD") tsread = $(this).text();
	                else if (id == "MSSMESSAGES.PRIORITY") prio = $(this).text();
	                else if (id == "VEHICLES.PLATE") plate = $(this).text();
	                else if (id == "EMPLOYEES.NAME") name = $(this).text();
	                else if (id == "MSSPOSITIONS.LATTITUDE") {
	                	try{
	                		latitude = parseFloat($(this).text().replace(",", "."));
	                	}catch(Err){
	                	}
	                }
	                else if (id == "MSSPOSITIONS.LONGITUDE") 
	                {
	                	try{
	                		longitude = parseFloat($(this).text().replace(",", "."));
						}catch(Err){
	                	}
	                }
	                else if (id == "Location") location = $(this).text();
	            });
	            
	            content = $('<p>' + content + '</p>').text(); // <GS-20170119> HTML formatted might cause breaking issues in UI
	            
	            
	            MobiScout.Tab.App.AddMessageToDialog(msgsn, vehicleid, driverid, tsstatus, content, activityid, statusid, msgtypeid, tsread, plate, name, latitude, longitude, location, prio);
	        });
	        MobiScout.Tab.UI.Message.BuildMessagesDialogList(forceclear);
	        MobiScout.Tab.App.LastVehicleInMessageDialog = vehicleid;
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getMessageDialog: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
	    }
	});
};

//TODO: Afmaken... 
// hoe berekenen we alle chauffeurs achter elkaar zonder dat de gebruiker daar last van heeft?
// zal wel een achtergrond proces moeten worden met een voortgangs balkje?!
// maar dat moet in de webvariant ook gewoon werken ... how to?

MobiScout.Tab.Data.CalculateWeekForDriver = function(driverid, datetimemessage){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.CalculateWeekForDriver " + driverid + " " + datetimemessage, 5);
    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.CalculateWeekForDriver: not logged on");
    	return;
    }
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/CalculateWeek",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "emp_id=" + driverid + "&dtMessage=" + datetimemessage.format('YmdHis'),
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('boolean').each(function () {
	        	if ($(this).text() == "true") {
	        		// bereken volgende chauffeur? 
	        		MobiScout.Tab.UOCalculationManager.RemoveDriverFromCalculationList(driverid, datetimemessage);
	        		MobiScout.Tab.UOCalculationManager.Run(false);
	        	}
	        	else{
	        		MobiScout.Tab.UOCalculationManager.Stop();
	        	}
		    });
		    delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.CalculateWeekForDriver: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
				MobiScout.Tab.UOCalculationManager.Stop();
			}
	    }
	});
    
}

MobiScout.Tab.Data.GetTemperatures = function(vehicleid, date){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetTemperatures", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetTemperatures: not logged on");
    	return;
    }
    var sensorsn;
    var actsn;
    var vehicleid;
    var trailerid;
    var tsaction;
    var timestampaction;
    var sensor1;
    var sensor1alert;
    var sensor2;
    var sensor2alert;
    var sensor3;
    var sensor3alert;
    var sensor4;
    var sensor4alert;
    var sensor5;
    var sensor5alert;
    var sensor6;
    var sensor6alert;
    var sensor7;
    var sensor7alert;
    var sensor8;
    var sensor8alert;
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getTemperatures",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "vehicleID=" + vehicleid + "&dtMessage=" + date.format('YmdHis'),
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "SENSORSN") sensorsn = Number($(this).text());
	                else if (id == "VEHICLEID") vehicleid = Number($(this).text());
	                else if (id == "TRAILERID") trailerid = Number($(this).text());
	                else if (id == "TSACTION") tsaction = $(this).text();
	                else if (id == "TIMESTAMPACTION") timestampaction = Number($(this).text());
	                else if (id == "SENSOR1") sensor1 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR2") sensor2 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR3") sensor3 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR4") sensor4 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR5") sensor5 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR6") sensor6 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR7") sensor7 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR8") sensor8 = parseFloat($(this).text().replace(",", "."));
	                else if (id == "SENSOR1ALERT") sensor1alert = Number($(this).text());
	                else if (id == "SENSOR2ALERT") sensor2alert = Number($(this).text());
	                else if (id == "SENSOR3ALERT") sensor3alert = Number($(this).text());
	                else if (id == "SENSOR4ALERT") sensor4alert = Number($(this).text());
	                else if (id == "SENSOR5ALERT") sensor5alert = Number($(this).text());
	                else if (id == "SENSOR6ALERT") sensor6alert = Number($(this).text());
	                else if (id == "SENSOR7ALERT") sensor7alert = Number($(this).text());
	                else if (id == "SENSOR8ALERT") sensor8alert = Number($(this).text());
	                
	                
	            });
	            var temp = new TabTemperature();
				temp.SensorSN = sensorsn;
				temp.ActSN = actsn;
    			temp.VehicleID = vehicleid;
    			temp.TrailerID = trailerid;
    			temp.TSAction = tsaction;
    			temp.Sensor1 = sensor1;
    			temp.Sensor1Alert = sensor1alert;
    			temp.Sensor2 = sensor2;
    			temp.Sensor2Alert = sensor2alert;
    			temp.Sensor3 = sensor3;
    			temp.Sensor3Alert = sensor3alert;
    			temp.Sensor4 = sensor4;
    			temp.Sensor4Alert = sensor4alert;
    			temp.Sensor5 = sensor5;
    			temp.Sensor5Alert = sensor5alert;
    			temp.Sensor6 = sensor6;
    			temp.Sensor6Alert = sensor6alert;
    			temp.Sensor7 = sensor7;
    			temp.Sensor7Alert = sensor7alert;
    			temp.Sensor8 = sensor8;
    			temp.Sensor8Alert = sensor8alert;
    			
				try{
					var d = new Date(timestampaction);
					var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					temp.TimeStampAction = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
				MobiScout.Tab.UI.Temperature.AddSensorEntryToList(temp);
	        });
	        
			if (MobiScout.Tab.UI.Temperature.currentView == 1) MobiScout.Tab.UI.Temperature.ShowTable(); 
        	else MobiScout.Tab.UI.Temperature.ShowChart();
        	delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetTemperatures: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
	    }
	});
}

MobiScout.Tab.Data.GetActivitiesForDriver = function(driverid, datetimemessage, append){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetActivitiesForDriver", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetActivitiesForDriver: not logged on");
    	return;
    }
    var actsn;
    var tsstart;
    var tsstop;
    var driverid;
    var vehicleid;
    var activityid;
    var plate;
    var name;
    var caogroup;
    var caodescr;
    var timestampstart;
    var timestampstop;
    var location;
    var kmsstart;
    var kmsstop;
    var stopsn;
    var rem;
    var remarks;
    var activitiesAdded = false;
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getActivities",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "driverID=" + driverid + "&dtMessage=" + datetimemessage.format('YmdHis') + "&translatePositions=" + translatePositions + "&convertMessages=false",
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	        	caogroup = 0;
	        	caodescr = "";
	        	timestampstart = 0;
	        	timestampstop = 0;
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "ACTIVITIES.ACT_SN") actsn = Number($(this).text());
	                else if (id == "ACTIVITIES.VEH_ID") vehicleid = Number($(this).text());
	                else if (id == "ACTIVITIES.EMP_ID") driverid = Number($(this).text());
	                else if (id == "ACTIVITIES.STOPSN") stopsn = Number($(this).text());
	                else if (id == "ACTIVITIES.TS_START") tsstart = $(this).text();
	                else if (id == "ACTIVITIES.TS_STOP") tsstop = $(this).text();
	                else if (id == "ACTIVITIES.KMS_START") kmsstart = $(this).text();
	                else if (id == "ACTIVITIES.KMS_STOP") kmsstop = $(this).text();
	                else if (id == "ACTIVITIES.REM") rem = $(this).text();
	                else if (id == "ACTIVITIES.REMARKS") remarks = $(this).text();
	                else if (id == "TIMESTAMPSTART") timestampstart = Number($(this).text());
	                else if (id == "TIMESTAMPSTOP") timestampstop = Number($(this).text());
	                else if (id == "ACTIVITIES.ACT_ID") activityid = Number($(this).text());
	                else if (id == "VEHICLES.PLATE") plate = $(this).text();
	                else if (id == "EMPLOYEES.NAME") name = $(this).text();
	                else if (id == "Location") location = $(this).text();
	                else if (id == "ACT_TYPES.CAO_GROUP") {
	                	try{
	                		caogroup = Number($(this).text());
	                	}
	                	catch(Err){
	                	}
	                }
	                else if (id == "CAO_TYPES.DESCR") caodescr = $(this).text();
	                
	            });
	            var act = new TabActivity();
				act.ActSN = actsn;
				act.VehicleID = vehicleid;
				act.DriverID = driverid;
				act.TSStart = tsstart;
				act.TSStop = tsstop;
				act.ActivityID = activityid;
				act.ActivityDescr = MobiScout.Tab.App.getActivityDescription(activityid);
				act.Color = MobiScout.Tab.App.getActivityColor(activityid);
				act.Plate = plate;
				act.DriverName = name;
				act.CaoGroupID = caogroup;
    			act.CaoGroupDescr = caodescr;
    			act.Location = location;
    			act.KMSStart = kmsstart;
    			act.KMSStop = kmsstop;
    			act.StopSN = stopsn;
    			act.Rem = rem;
    			act.Remarks = remarks;
    			
				try{
					var d = new Date(timestampstart);
					var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					act.TimeStampStart = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
				try{
					var d = new Date(timestampstop);
					var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					act.TimeStampStop = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
				
				if(MobiScout.Tab.UI.PeriodView.AddActivityToList(act)){
					activitiesAdded = true;
				}
	        });
	        if(activitiesAdded == true && append == true){
	        	MobiScout.Tab.UI.PeriodView.RefreshActivityView();
	        }
	        else{
	        	MobiScout.Tab.UI.PeriodView.UpdateActivityView(true);
	        }
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetActivitiesForDriver: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
	    }
	});
}

MobiScout.Tab.Data.GetPeriodView = function(fromDate){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetPeriodView", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetPeriodView: not logged on");
    	return;
    }
    var date;
    var tsdate;
    var driverid;
    var tsnetto;
    var holiday;
    var name;
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getPeriodViewData",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "dtStart=" + fromDate.format('YmdHis') + "&selectMethod=" + driverSelectMethod,
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	        	
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "DATUM") date = $(this).text();
	                else if (id == "TSDATUM") tsdate = Number($(this).text());
	                else if (id == "EMP_ID") driverid = Number($(this).text());
	                else if (id == "TS_NETTO") tsnetto = $(this).text();
	                else if (id == "HOLIDAY") {
	                	try{
	                		holiday = Number($(this).text());
	                	}catch(Err){}
	                }
	                else if (id == "NAME") name = $(this).text();
	            });
	            
    			var d2;
				try{
					var d = new Date(tsdate);
					d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
				}
				catch(Err)
				{
					console.log(Err);
				}
				MobiScout.Tab.UI.PeriodView.AddDateToList(date, d2, driverid, tsnetto, holiday, name);
	        });
	        MobiScout.Tab.UI.PeriodView.UpdateView();
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetPeriodView: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
	    }
	});
};

MobiScout.Tab.Data.getRealtimeHours = function (vehicleid, isRefresh) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getRealtimeHours", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getRealtimeHours: not logged on");
    	return;
    }
    var msgsn;
    var tsstatus;
    var driverid;
    var vehicleid;
    var activityid;
    var plate;
    var name;
    var caogroup;
    var caodescr;
    var timestamp;
    var content;
    var location;
    var datetimemessage = MobiScout.Tab.GetCurrentDate();
    
    MobiScout.Tab.Data.checkSession();
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getRealtimeHours",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "vehicleID=" + vehicleid + "&dtMessage=" + datetimemessage.format('YmdHis') + "&translatePositions=" + translatePositions + "&convertMessages=false",
	    beforeSend: function (xhr, settings) {
	    },
	    success: function (xml) {
	        $(xml).find('row').each(function () {
	        	caogroup = 0;
	        	caodescr = "";
	        	timestamp = 0;
	            $(this).find('cell').each(function () {
	                var id = $(this).attr('column');
	                if (id == "MSSMESSAGES.MSGSN") msgsn = Number($(this).text());
	                else if (id == "MSSMESSAGES.VEHICLEID") vehicleid = Number($(this).text());
	                else if (id == "MSSMESSAGES.EMP_ID") driverid = Number($(this).text());
	                else if (id == "MSSMESSAGES.TSSTATUS") tsstatus = $(this).text();
	                else if (id == "MSSMESSAGES.MSGCONTENTS") content = $(this).text();
	                else if (id == "TIMESTAMP") timestamp = Number($(this).text());
	                else if (id == "MSSMESSAGES.ACTIVITYID") activityid = Number($(this).text());
	                else if (id == "VEHICLES.PLATE") plate = $(this).text();
	                else if (id == "EMPLOYEES.NAME") name = $(this).text();
	                else if (id == "Location") location = $(this).text();
	                else if (id == "ACT_TYPES.CAO_GROUP") {
	                	try{
	                		caogroup = Number($(this).text());
	                	}
	                	catch(Err){
	                	}
	                }
	                else if (id == "CAO_TYPES.DESCR") caodescr = $(this).text();
	                
	            });
	            
	            content = $('<p>' + content + '</p>').text(); // <GS-20170119> HTML formatted might cause breaking issues in UI
	            
	            var msg = new TabMessage();
				msg.MsgSN = msgsn;
				msg.VehicleID = vehicleid;
				msg.DriverID = driverid;
				msg.TSStatus = tsstatus;
				msg.ActivityID = activityid;
				msg.ActivityDescr = MobiScout.Tab.App.getActivityDescription(activityid);
				msg.Color = MobiScout.Tab.App.getActivityColor(activityid);
				msg.Plate = plate;
				msg.DriverName = name;
				msg.CaoGroupID = caogroup;
    			msg.CaoGroupDescr = caodescr;
    			msg.Location = location;
    			msg.MsgContent = $('<p>' + content + '</p>').text(); // <GS-20170119> HTML formatted might cause breaking issues in UI
    			
				try{
					var d = new Date(timestamp);
					var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
					msg.TimeStamp = d2;
				}
				catch(Err)
				{
					console.log(Err);
				}
				msg.MsgTypeID = 7; // altijd statusbericht
				MobiScout.Tab.App.DecodeMessage(msg);
				MobiScout.Tab.UI.RTHours.AddMessageToList(msg, isRefresh);
	        });
	        MobiScout.Tab.UI.RTHours.UpdateView();
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {

	    },
		complete: function(jqXHR, textStatus) {
			if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getRealtimeHours: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
	    }
	});
};

MobiScout.Tab.Data.StartUpdateWithWakeup = function(isAutoRefresh){

	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.StartUpdateWithWakeup", 5);
    $.ajax
    ({
        url: WebServiceURL + webServicePage + "/isLoggedOn",
        type: "POST",
        dataType: "xml",
        crossDomain: true,
        cache: false,
        headers: { "cache-control": "no-cache" },
        timeout: 5000,
        data: "",
        success: function (xml) {
        	delete xml;
        },
        error: function (xhr, ajaxOptions, thrownError) {
        },
        complete: function(jqXHR, textStatus) {
	    	if(textStatus == "success"){
	        	MobiScout.Tab.Data.getTrackAndTrace(isAutoRefresh, false);
	    	}
	    	else {
  	        	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.StartUpdateWithWakeup: " + textStatus + " code " + jqXHR.status);
	    		MobiScout.Tab.Data.getTrackAndTrace(isAutoRefresh, true);
	    	}
   		}
    });
};


MobiScout.Tab.Data.getTrackAndTrace = function (isAutoUpdate, checkSession) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getTrackAndTrace", 5);
	
    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrackAndTrace: not logged on");
    	return;
    }
    if (getTrackAndTraceRunning == true) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrackAndTrace: already running");
    	return;
    }
    MobiScout.Tab.SetDataIconMenu('recycle');
    
    var vehicleid;
    var lastkeepalive;
    var tsactivity;
    var tsactivitychange;
    var plate;
    var name;
    var activityid;
    var driverid;
    var numberUnreadMessages;
    var location;
    var xref;
    var yref;
    var trailerid;
    var speed;
    var destination;
    var expectedduration = -1;
    var actualiteit = -1;
    var numberAlerts;
    var restminutes = 0;
    var subdrivinghours = 0;
    var totdrivinghours = 0;
    var waitminutes = 0;
    var workminutes = 0;
    var tenallowed = 0;
    var workweek = 0;
    var departmentid = 0;
    var protocolid = 6;
    var tslka = 0;
    var tsact = 0;
    var tsactchange = 0;
    var liters = -1;
    var afstand = -1;
    var verbruik = -1;
    var marssnelheid = -1;
    var vehiclephonenumber = "";
    var employeephonenumber = "";
    var stopstotal = 0;
    var stopsdone = 0;
    
    var tslastdownload = 0;
    var tslastsuccess = 0;
    var dtcostatus = 0;
    var dtcolastresult = 0;
    var dtcolastdownload = "";
    var dtcolastsuccess = "";
	var sensor1;
	var sensor2;
	var sensor3;
	var sensor4;
	var sensor5;
	var sensor6;
	var sensor7;
	var sensor8;
	var sensor1alert;
	var sensor2alert;
	var sensor3alert;
	var sensor4alert;
	var sensor5alert;
	var sensor6alert;
	var sensor7alert;
	var sensor8alert;
    
    if(checkSession == true){
    	MobiScout.Tab.Data.checkSession();
    }
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getTrackAndTrace",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "selectMethod=" + vehicleSelectMethod + "&translatePositions=" + translatePositions + "&addFuelInformation=" + UseCanbus + "&addTripInformation=" + showTripInformation + "&addTemperatureInformation=" + showTemperatureInformation,
	    beforeSend: function (xhr, settings) {
	       getTrackAndTraceRunning = true; // <GS-27112014> even niet doen
	    },
	    success: function (xml) {
	        getTrackAndTraceRunning = false;
	        try{
		        MobiScout.Tab.App.markVehiclesNotUpdated();
		        var forceUpdate = false;
		        $(xml).find('row').each(function () {
		        	try{
		        	
		        		actualiteit = -1;
		        		restminutes = 0;
		        		subdrivinghours = 0;
		        		totdrivinghours = 0;
		        		waitminutes = 0;
		        		tenallowed = 0;
		        		workweek = 0;
		        		departmentid = 0;
		        		tslka = 0;
		        		tsact = 0;
		        		tsactchange = 0;
		        		liters = -1;
	    				afstand = -1;
	    				verbruik = -1;
	    				marssnelheid = -1;
	    				vehiclephonenumber = "";
	    				employeephonenumber = "";
		        		protocolid = 6;
		        		stopstotal = 0;
	    				stopsdone = 0;
	    				tslastdownload = 0;
    					tslastsuccess = 0;
    					dtcostatus = 0;
    					dtcolastresult = 0;
    					dtcolastdownload = "";
    					dtcolastsuccess = "";
	    				
			            $(this).find('cell').each(function () {
			                var id = $(this).attr('column');
			                if (id == "MSSTRACKANDTRACE.VEHICLEID") vehicleid = Number($(this).text());
			                else if (id == "MSSTRACKANDTRACE.LASTKEEPALIVE") lastkeepalive = $(this).text();
			                else if (id == "MSSTRACKANDTRACE.ACTIVITYID") activityid = Number($(this).text());
			                else if (id == "MSSTRACKANDTRACE.NROFUNREADMESSAGES") numberUnreadMessages = Number($(this).text());
			                else if (id == "MSSTRACKANDTRACE.DRIVERID") driverid = Number($(this).text());
							else if (id == "MSSTRACKANDTRACE.TSACTIVITY") tsactivity = $(this).text();
							else if (id == "MSSTRACKANDTRACE.TSACTCHANGE") tsactivitychange = $(this).text();
			                else if (id == "MSSTRACKANDTRACE.XREF") xref = parseFloat($(this).text().replace(",", "."));
			                else if (id == "MSSTRACKANDTRACE.YREF") yref = parseFloat($(this).text().replace(",", "."));
			                else if (id == "VEHICLES.PLATE") plate = $(this).text();
			                else if (id == "VEHICLES.GSMID") vehiclephonenumber = $(this).text();
			                else if (id == "VEHICLES.PROTOCOLID") protocolid = $(this).text();
			                else if (id == "VEHICLES.DEPARTMENTID") {
			                	try{
			                		departmentid = Number($(this).text());
			                	}
			                	catch(Ex){
			                	}
			                	
			                }
			                else if (id == "EMPLOYEES.NAME") name = $(this).text();
			                else if (id == "EMPLOYEES.PHONE") employeephonenumber = $(this).text();
			                else if (id == "Location") location = $(this).text();
			                else if (id == "MSSTRACKANDTRACE.SPEED") speed = parseFloat($(this).text().replace(",", "."));
			                else if (id == "MSSTRACKANDTRACE.TRAILERID") trailerid = Number($(this).text());
			                else if (id == "MSSTRACKANDTRACE.DESTINATION") destination = $(this).text();
			                else if (id == "NumberAlerts") numberAlerts = Number($(this).text());
			                
			                else if (id == "TRACKTRACEDRIVER.RESTMINUTES") restminutes = Number($(this).text());
			                else if (id == "TRACKTRACEDRIVER.SUBDRIVINGHOURS") subdrivinghours = Number($(this).text());
			                else if (id == "TRACKTRACEDRIVER.TOTDRIVINGHOURS") totdrivinghours = Number($(this).text());
			                else if (id == "TRACKTRACEDRIVER.WAITMINUTES") waitminutes = Number($(this).text());
			                else if (id == "TRACKTRACEDRIVER.WORKMINUTES") workminutes = Number($(this).text());
			                else if (id == "TRACKTRACEDRIVER.TENALLOWED") tenallowed = Number($(this).text());
			                else if (id == "TRACKTRACEDRIVER.WORKWEEK") workweek = Number($(this).text());
			                else if (id == "TSLKA") tslka = Number($(this).text());
			                else if (id == "TSACT") tsact= Number($(this).text());
		                	else if (id == "MSSTRACKANDTRACE.ACTUALITEIT") try{ actualiteit = Number($(this).text()); }catch(Err){}
		                	else if (id == "MSSTRACKANDTRACE.EXPECTEDDURATION") try{ expectedduration = Number($(this).text()); }catch(Err){}
		                	else if (id == "Liters") liters = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "Afstand") afstand = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "Marssnelheid") marssnelheid = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "Verbruik") verbruik = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "StopsTotal") stopstotal = Number($(this).text());
		                	else if (id == "StopsDone") stopsdone = Number($(this).text());
		                	
		                	else if (id == "VEHICLES.DTCOSTATUS") dtcostatus = Number($(this).text());
		                	else if (id == "VEHICLES.DTCOLASTRESULT") dtcolastresult = Number($(this).text());
		                	else if (id == "VEHICLES.DTCOLASTDOWNLOAD") dtcolastdownload = $(this).text();
		                	else if (id == "VEHICLES.DTCOLASTSUCCESS") dtcolastsuccess = $(this).text();
		                	else if (id == "TSLASTDOWNLOAD") tslastdownload = Number($(this).text());
		                	else if (id == "TSLASTSUCCESS") tslastsuccess = Number($(this).text());
		                	else if (id == "TSACTCHANGE") tsactchange= Number($(this).text());
		                	
		                	
		                	else if (id == "SENSOR1") sensor1 = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "SENSOR2") sensor2 = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "SENSOR3") sensor3 = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "SENSOR4") sensor4 = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "SENSOR5") sensor5 = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "SENSOR6") sensor6 = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "SENSOR7") sensor7 = parseFloat($(this).text().replace(",", "."));
		                	else if (id == "SENSOR8") sensor8 = parseFloat($(this).text().replace(",", "."));
		                	
		                	else if (id == "SENSOR1ALERT") sensor1alert = Number($(this).text());
		                	else if (id == "SENSOR2ALERT") sensor2alert = Number($(this).text());
		                	else if (id == "SENSOR3ALERT") sensor3alert = Number($(this).text());
		                	else if (id == "SENSOR4ALERT") sensor4alert = Number($(this).text());
		                	else if (id == "SENSOR5ALERT") sensor5alert = Number($(this).text());
		                	else if (id == "SENSOR6ALERT") sensor6alert = Number($(this).text());
		                	else if (id == "SENSOR7ALERT") sensor7alert = Number($(this).text());
		                	else if (id == "SENSOR8ALERT") sensor8alert = Number($(this).text());
		                	
		                	
		                	
			            });
			            if(countAlertMessages == false) numberAlerts = 0;
			            if(driverid == 0) name = "";
			            
			            //TODO: employeephonenumber updaten in emp list
			            
						if(MobiScout.Tab.App.addVehicleToTrackAndTraceList(vehicleid, plate, name, yref, xref, activityid, tsactivity, MobiScout.Tab.App.getActivityColor(activityid), lastkeepalive, location, numberUnreadMessages, trailerid, speed, destination, numberAlerts, expectedduration, actualiteit, restminutes, subdrivinghours, totdrivinghours, waitminutes, workminutes,tenallowed, workweek, departmentid, tslka, tsact, liters, afstand, marssnelheid, verbruik, vehiclephonenumber, protocolid, driverid, stopstotal, stopsdone, dtcostatus, dtcolastresult, dtcolastdownload, dtcolastsuccess, tslastdownload, tslastsuccess, tsactivitychange, tsactchange, sensor1, sensor2, sensor3, sensor4, sensor5, sensor6, sensor7, sensor8, sensor1alert, sensor2alert, sensor3alert, sensor4alert, sensor5alert, sensor6alert, sensor7alert, sensor8alert) == true){		            
		                	forceUpdate = true;
		                }
		                if ($('.ui-page-active').attr('id') == 'map') {
		                	MobiScout.Tab.Mapping.setPosition(String(vehicleid), yref, xref, "images/truck.png", MobiScout.Tab.App.getActivityColor(activityid), plate, name, MobiScout.Tab.App.getActivityDescription(activityid), tsactivity, trailerid, expectedduration, destination, location);
		                }
		                if(driverid > 0 && isBlank(employeephonenumber) == false){
		                	MobiScout.Tab.App.SetPhoneNumberInDriverList(driverid, name, employeephonenumber);
		                
		                }
		                
			    	}
			    	catch(Err){
			    		console.log("Failed to handle TT record " + Err);
			    	}
		        });
		        if(MobiScout.Tab.App.clearTrackAndTraceList() == true) forceUpdate = true;
		        if(forceUpdate == true) MobiScout.Tab.App.sortTrackAndTraceList();
		        //MobiScout.Tab.LogToConsole("Update data done");
		        MobiScout.Tab.UI.Vehicle.BuildTrackAndTraceList(forceUpdate);
		        //MobiScout.Tab.LogToConsole("Update list done");
		        MobiScout.Tab.Mapping.CheckAllMarkersVisibility();
		        //MobiScout.Tab.LogToConsole("Update markers done");
		        MobiScout.Tab.Mapping.SetClusterer();
		        //MobiScout.Tab.LogToConsole("Update clusterer done");
		        restoreRefreshCounter = 0;
			}
			catch(e1){
				MobiScout.Tab.LogToConsole("Failed to update trackandtrace on success: " + e1);
			}
			delete xml;
			
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
	         getTrackAndTraceRunning = false;
	    },
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrackAndTrace: " + textStatus + " code " + jqXHR.status);
				MobiScout.Tab.checkAlertForDevelopment();
			}
		    getTrackAndTraceRunning = false;
		    MobiScout.Tab.Data.getUnreadMessages(isAutoUpdate);
		    if(textStatus == "success"){
		    }
		    else if(textStatus == "notmodified"){
		    }
		    else if(textStatus == "timeout"){
		    }
	    	else if (textStatus == "error"){
	    	}
	    	else if (textStatus == "abort"){
	    	}
	    	else if (textStatus == "parsererror"){
	    	}
	    }
	});
};


MobiScout.Tab.Data.getEmployees = function (isAutoUpdate, checkSession) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getEmployees", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getEmployees: not logged on");
    	return;
    }
    if (getEmployeesRunning == true) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getEmployees: already running");
    	return;
    }
    
    var vehicleid = 0;
    var lastkeepalive;
    var tsactivity;
    var plate = '';
    var name = '';
    var activityid =0;
    var driverid =0;
    var numberUnreadMessages = 0;
    var location = '';
    var xref;
    var yref;
    var trailerid;
    var speed;
    var destination = '';
    var expectedduration = -1;
    var actualiteit = -1;
    var numberAlerts;
    var restminutes = 0;
    var subdrivinghours = 0;
    var totdrivinghours = 0;
    var waitminutes = 0;
    var workminutes = 0;
    var tenallowed = 0;
    var workweek = 0;
    var departmentid = 0;
    var tslka = 0;
    var tsact = 0;
    var liters = -1;
    var afstand = -1;
    var verbruik = "";
    var marssnelheid = "";
    var phonenumber = "";
    
    if(checkSession == true){
    	MobiScout.Tab.Data.checkSession();
    }
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/getTrackTraceDriver",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "getExtraCanInfo=" + showGraphsInEmployeeList + "&selectMethod=" + driverSelectMethod,
	    beforeSend: function (xhr, settings) {
	       getEmployeesRunning = true; 
	    },
	    success: function (xml) {
	        getEmployeesRunning = false;
	        MobiScout.Tab.App.markEmployeesNotUpdated();
	        var forceUpdate = false;
	        $(xml).find('row').each(function () {
	        	try{
	        	
	        		actualiteit = -1;
	        		restminutes = 0;
	        		subdrivinghours = 0;
	        		totdrivinghours = 0;
	        		waitminutes = 0;
	        		tenallowed = 0;
	        		workweek = 0;
	        		departmentid = 0;
	        		tslka = 0;
	        		tsact = 0;
	        		liters = -1;
    				afstand = -1;
    				verbruik = "";
    				marssnelheid = "";
    				driverid = 0;
    				phonenumber = "";
	        		
		            $(this).find('cell').each(function () {
		                var id = $(this).attr('column');
		                if (id == "TRACKTRACEDRIVER.VEHICLEID") vehicleid = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.LASTKEEPALIVE") lastkeepalive = $(this).text();
		                else if (id == "TRACKTRACEDRIVER.ACTIVITYID") activityid = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.NROFUNREADMESSAGES") numberUnreadMessages = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.DRIVERID") driverid = Number($(this).text());
						else if (id == "TRACKTRACEDRIVER.TSACTIVITY") tsactivity = $(this).text();
		                else if (id == "TRACKTRACEDRIVER.XREF") xref = parseFloat($(this).text().replace(",", "."));
		                else if (id == "TRACKTRACEDRIVER.YREF") yref = parseFloat($(this).text().replace(",", "."));
		                else if (id == "VEHICLES.PLATE") plate = $(this).text();
		                else if (id == "EMPLOYEES.DEPARTMENTID") { try{ departmentid = Number($(this).text()); } catch(Ex){ } }
		                else if (id == "EMPLOYEES.NAME") name = $(this).text();
		                else if (id == "EMPLOYEES.PHONE") phonenumber = $(this).text();
		                else if (id == "Location") location = $(this).text();
		                else if (id == "TRACKTRACEDRIVER.SPEED") speed = parseFloat($(this).text().replace(",", "."));
		                else if (id == "TRACKTRACEDRIVER.TRAILERID") trailerid = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.DESTINATION") destination = $(this).text();
		                else if (id == "NumberAlerts") numberAlerts = Number($(this).text());
		                
		                else if (id == "TRACKTRACEDRIVER.RESTMINUTES") restminutes = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.SUBDRIVINGHOURS") subdrivinghours = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.TOTDRIVINGHOURS") totdrivinghours = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.WAITMINUTES") waitminutes = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.WORKMINUTES") workminutes = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.TENALLOWED") tenallowed = Number($(this).text());
		                else if (id == "TRACKTRACEDRIVER.WORKWEEK") workweek = Number($(this).text());
		                else if (id == "TSLKA") tslka = Number($(this).text());
		                else if (id == "TSACT") tsact= Number($(this).text());
	                	else if (id == "TRACKTRACEDRIVER.ACTUALITEIT") try{ actualiteit = Number($(this).text()); }catch(Err){}
	                	else if (id == "TRACKTRACEDRIVER.EXPECTEDDURATION") try{ expectedduration = Number($(this).text()); }catch(Err){}
	                	else if (id == "Liters") liters = parseFloat($(this).text().replace(",", "."));
	                	else if (id == "Afstand") afstand = parseFloat($(this).text().replace(",", "."));
	                	else if (id == "MARSSNELHEID") marssnelheid = $(this).text();
	                	else if (id == "CONSUMPTION") verbruik = $(this).text();
		            });
		            if(countAlertMessages == false) numberAlerts = 0;
		            if(driverid == 0) name = "";
		            
	                if(driverid > 0){
		                var newTTD = new TabEmployee();
			            newTTD.ID = driverid;
			            newTTD.ActivityID = activityid;
			            newTTD.LastKeepAlive = lastkeepalive;
			            newTTD.TSActivity = tsactivity;
			            newTTD.ActivityDescription = MobiScout.Tab.App.getActivityDescription(activityid);
			            newTTD.Latitude = yref;
			            newTTD.Longitude = xref;
			            newTTD.Color = MobiScout.Tab.App.getActivityColor(activityid);
			            newTTD.Plate = plate;
			            newTTD.Name = name;
			            newTTD.Location = location;
			            newTTD.NumberOfUnreadMessages = numberUnreadMessages;
			            newTTD.TrailerID = trailerid;
			            newTTD.Speed = speed;
			            newTTD.Destination = destination;
			            newTTD.ExpectedDuration = expectedduration;
			            newTTD.Updated = true;
			            newTTD.NumberOfAlerts = numberAlerts;
			            newTTD.Actualiteit = actualiteit;
			            newTTD.Restminutes = restminutes;
			            newTTD.Subdrivinghours = subdrivinghours;
			            newTTD.Totdrivinghours = totdrivinghours;
			            newTTD.Waitminutes = waitminutes;
			            newTTD.Workminutes = workminutes;
			            newTTD.Tenallowed = tenallowed;
			            newTTD.Workweek = workweek;
			            newTTD.DepartmentID = departmentid;
			            newTTD.Liters = liters;
			            newTTD.Distance = afstand;
			            
			            if(!isBlank(marssnelheid)) marssnelheid = marssnelheid.substring(0, marssnelheid.length-1);
			            if(!isBlank(verbruik)) verbruik = verbruik.substring(0, verbruik.length-1);
			            
			            newTTD.MarchingSpeed = marssnelheid;
			            newTTD.Consumption = verbruik;
			            newTTD.PhoneNumber = phonenumber;
			            
						try{
							var d = new Date(tslka);
							var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
							newTTD.TSLKA = d2;
						}
						catch(Err)
						{
							console.log(Err);
						}
			            try{
							var d = new Date(tsact);
							var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
							newTTD.TSACT = d2;
						}
						catch(Err)
						{
							console.log(Err);
						}
						
		                if(MobiScout.Tab.App.addEmployeeToTrackAndTraceDriverListV2(newTTD) == true){
		                	forceUpdate = true;
		                }
		            }
	                
		    	}
		    	catch(Err){
		    		console.log("Failed to handle DTT record " + Err);
		    	}
	        });
	        if(MobiScout.Tab.App.clearTrackAndTraceDriverList() == true){
	        	forceUpdate = true;
	        }
	        if(forceUpdate == true) MobiScout.Tab.App.sortTrackAndTraceDriverList();
	        MobiScout.Tab.UI.Employee.BuildEmployeeList(forceUpdate);
	        restoreRefreshCounter = 0;
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
	         getEmployeesRunning = false;
	    },
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getEmployees: " + textStatus + " code " + jqXHR.status);
				MobiScout.Tab.checkAlertForDevelopment();
			}
		    getEmployeesRunning = false;
	    }
	});
};


MobiScout.Tab.Data.getGeofences = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getGeofences", 5);
    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false){ 
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getGeofences: not logged on");
    	return;
    }

    var description = "";
    var xref = "0";
    var yref = "0";
    var poiid = 0;
    var geoactive = 0;
    var geotype = 0;
    var geoentry = 0;
    var geoexit = 0;
    var isnavdest = 0;
    MobiScout.Tab.Data.checkSession();
        $.ajax
		({
			
		    url: WebServiceURL + webServicePage + "/getPlannerGeofences",
		    crossDomain: true,
		    cache: false,
		    headers: { "cache-control": "no-cache" },
		    type: "POST",
		    dataType: "xml",
		    data: "",
		    beforeSend: function(xhr, settings){
			},		    
		    success: function (xml) {
		    	//MobiScout.Tab.Mapping.ClearMap(); // niet nodig.. alleen bij opstarten...
		        $(xml).find('row').each(function () {
		            $(this).find('cell').each(function () {
		                var id = $(this).attr('column');
		                if (id == "POI_ID") poiid = parseInt($(this).text(), 10);
		                if (id == "DESCR") description = $(this).text();
		                if (id == "XREF") xref = $(this).text();
		                if (id == "YREF") yref = $(this).text();
		                if (id == "GEOFENCEACTIVE") geoactive = parseInt($(this).text(), 10);
		                if (id == "GEOFENCETYPE") geotype = parseInt($(this).text(), 10);
		                if (id == "GEOFENCEBEAMENTRY") geoentry = parseInt($(this).text(), 10);
		                if (id == "GEOFENCEBEAMEXIT") geoexit = parseInt($(this).text(), 10);
		                if (id == "ISNAVDEST") isnavdest = parseInt($(this).text(), 10);
		            });
	                if(xref != "" && xref != "0" && yref != "" && yref != "0"){
	                    MobiScout.Tab.App.AddNewGeofence(description, yref, xref, geoentry, geoexit, geotype, false, MobiScout.Tab.GetCurrentDate(), true, geoactive, isnavdest, poiid);
	                }
		            
		        });
		        delete xml;
		    },
		    error: function (xhr, ajaxOptions, thrownError) {
		    	
		    },
		    complete: function(jqXHR, textStatus) {
		    	if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getGeofences: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
	      		MobiScout.Tab.Data.getVehicleList();
	      		MobiScout.Tab.Data.getTrailerList(false); // test
		    	MobiScout.Tab.Mapping.checkGeofenceDisplay();
		    	if(textStatus == "success"){
		    	}
		    	else if(textStatus == "notmodified"){
		    	}
		    	else if(textStatus == "timeout"){
		    	}
		    	else if (textStatus == "error"){
		    	}
		    	else if (textStatus == "abort"){
		    	}
		    	else if (textStatus == "parsererror"){
		    	}
		    }
		});
};




MobiScout.Tab.Data.GetVersion = function() {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.GetVersion", 5);

    if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetVersion: not logged on");
    	return;
    }
        $.ajax
		({
        url: WebServiceURL + webServicePage + "/getDataServiceVersion",
		    type: "POST",
		    dataType: "text",
		    crossDomain: true,
		    cache: false,
		    headers: { "cache-control": "no-cache" },
		    data: "",

		    success: function(msg) {
		        MobiScout.Tab.appendMessage("Verbonden met data webservice versie: " + msg);
		    },
		    error: function(xhr, ajaxOptions, thrownError) {
		        MobiScout.Tab.appendMessage("error GetVersion");

		    },
		    complete: function(jqXHR, textStatus) {
		    	if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.GetVersion: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
			}
		});
}



MobiScout.Tab.Data.getVehicleList = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getVehicleList", 5);
	
	 if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getVehicleList: not logged on");
	 	return;
	 }

        if (getVehicleListRunning == true) {
        	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getVehicleList: already running");
        	return;
        }
        $.ajax
		({
		    url: WebServiceURL + webServicePage + "/getCompleteVehicleListForPlanner",
		    crossDomain: true,
		    cache: false,
		    headers: { "cache-control": "no-cache" },
		    type: "POST",
		    dataType: "xml",
		    data: "",
			beforeSend: function (xhr, settings) {
	       		getVehicleListRunning = true; // <GS-27112014> even niet doen
	    	},		    
		    success: function (xml) {
		        getVehicleListRunning = false;
		        //MobiScout.Tab.App.ClearVehicleList(); // we got a new list, clear the old one
		        $(xml).find('row').each(function () {
		            var newvehicle = new TabVehicle();

		            $(this).find('cell').each(function () {
		                var id = $(this).attr('column');
		                if (id == "VEH_ID") newvehicle.ID = Number($(this).text());
		                else if (id == "PLATE") newvehicle.Plate = $(this).text();
		                else if (id == "PROTOCOLID") newvehicle.ProtocolID = Number($(this).text());
		                else if (id == "GSMID") newvehicle.PhoneNumber = Number($(this).text());

		                else if (id == "MAKE") newvehicle.Make = $(this).text();
		                else if (id == "PASSWORD") newvehicle.Password = $(this).text();
		                else if (id == "MODEL") newvehicle.Model = $(this).text();
		                else if (id == "HASTACHOGRAPH") newvehicle.HasTachograph = Number($(this).text());
		                else if (id == "DTCOUSERSTATUS") newvehicle.DTCOUserStatus = Number($(this).text());
		                else if (id == "DTCOSTATUS") newvehicle.DTCOStatus = Number($(this).text());
		                else if (id == "DTCOFAILCOUNT") newvehicle.DTCOFailCount = Number($(this).text());
		                else if (id == "DTCOLASTRESULT") newvehicle.DTCOLastResult = Number($(this).text());
		                else if (id == "DTCOLASTDOWNLOAD") newvehicle.DTCOLastDownload = $(this).text();
		                else if (id == "DTCOLASTSUCCESS") newvehicle.DTCOLastSuccess = $(this).text();
		                else if (id == "TSLASTDOWNLOAD") {
		                	try{
								var d = new Date(Number($(this).text()));
								var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
								newvehicle.TSDTCOLastDownload = d2;
							}
							catch(Err)
							{
								console.log(Err);
							}
		                }
		                else if (id == "TSLASTSUCCESS") {
							try{
								var d = new Date(Number($(this).text()));
								var d2 = new Date(d.getTime() + (d.getTimezoneOffset()*60000));
								newvehicle.TSDTCOLastSuccess = d2;
							}
							catch(Err)
							{
								console.log(Err);
							}
						}
		            });
		            MobiScout.Tab.App.VehicleList.push(newvehicle);
		        });
		        MobiScout.Tab.BuildVehicleList();
		        if(isDevelopmentDevice == true) MobiScout.Tab.BuildVehicleListNFC();
		        delete xml;
		    },
		    error: function (xhr, ajaxOptions, thrownError) {
		        getVehicleListRunning = false;
		    },
		    complete: function(jqXHR, textStatus) {
		    	if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getVehicleList: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
		    	getVehicleListRunning = false;
		    	
		    	MobiScout.Tab.Data.getTrackAndTrace(false, false);
		    	
		    	if(textStatus == "success"){
		    	}
		    	else if(textStatus == "notmodified"){
		    	}
		    	else if(textStatus == "timeout"){
		    		
		    	}
		    	else if (textStatus == "error"){
		    		
		    	}
		    	else if (textStatus == "abort"){
		    		
		    	}
		    	else if (textStatus == "parsererror"){
		    		
		    	}
		    }
		});
   
};


var getUserListRunning = false;

MobiScout.Tab.Data.getUserList = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getUserList", 5);
	
	 if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getUserList: not logged on");
	 	return;
	 }
	 var user_id = "";
	 var name = "";
	 var password = "";

        if (getUserListRunning == true) {
        	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getUserList: already running");
        	return;
        }
        $.ajax
		({
		    url: WebServiceURL + webServicePage + "/getUserList",
		    crossDomain: true,
		    cache: false,
		    headers: { "cache-control": "no-cache" },
		    type: "POST",
		    dataType: "xml",
		    data: "",
			beforeSend: function (xhr, settings) {
	       		getUserListRunning = true; 
	    	},		    
		    success: function (xml) {
		        getUserListRunning = false;
		        
		        MobiScout.Tab.App.UserList.splice(0, MobiScout.Tab.App.UserList.length);
		        
		        $(xml).find('row').each(function () {
		            
		            $(this).find('cell').each(function () {
		                var id = $(this).attr('column');
		                if (id == "USER_ID") userid = $(this).text();
		                else if (id == "NAME") name = $(this).text();
		                else if (id == "USERPASSWORD") password = $(this).text();
		            });
		            if(!isBlank(userid) && !isBlank(name) && !isBlank(password)){
			            MobiScout.Tab.App.UserList.push({
		                    UserID: userid,
		                    Name: name,
		                    Password: password
		                });
	                }
		        });
		        MobiScout.Tab.BuildUserList();
		        delete xml;
		    },
		    error: function (xhr, ajaxOptions, thrownError) {
		        getUserListRunning = false;
		    },
		    complete: function(jqXHR, textStatus) {
		    	if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getUserList: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
		    	getUserListRunning = false;
		    	
		    	if(textStatus == "success"){
		    	}
		    	else if(textStatus == "notmodified"){
		    	}
		    	else if(textStatus == "timeout"){
		    		
		    	}
		    	else if (textStatus == "error"){
		    		
		    	}
		    	else if (textStatus == "abort"){
		    		
		    	}
		    	else if (textStatus == "parsererror"){
		    		
		    	}
		    }
		});
   
};

MobiScout.Tab.Data.getDriverList = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getDriverList", 5);
	
	 if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getDriverList: not logged on");
	 	return;
	 }

        if (getDriverListRunning == true) {
        	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getDriverList: already running");
        	return;
        }
        $.ajax
		({
		    url: WebServiceURL + webServicePage + "/getCompleteDriverList",
		    crossDomain: true,
		    cache: false,
		    headers: { "cache-control": "no-cache" },
		    type: "POST",
		    dataType: "xml",
		    data: "",
			beforeSend: function (xhr, settings) {
	       		getDriverListRunning = true; 
	    	},		    
		    success: function (xml) {
		        getDriverListRunning = false;
		        
		        MobiScout.Tab.App.DriverList.splice(0, MobiScout.Tab.App.DriverList.length);
		        
		        $(xml).find('row').each(function () {
		            var newdriver = new TabEmployee();
		            $(this).find('cell').each(function () {
		                var id = $(this).attr('column');
		                if (id == "EMP_ID") newdriver.ID = Number($(this).text());
		                else if (id == "NAME") newdriver.Name = $(this).text();
		                else if (id == "USER_ID") newdriver.UserID = $(this).text();
		                else if (id == "PASSWORD") newdriver.Password = $(this).text();
		            });
		            MobiScout.Tab.App.DriverList.push(newdriver);
		        });
		        MobiScout.Tab.BuildDriverList();
		        delete xml;
		    },
		    error: function (xhr, ajaxOptions, thrownError) {
		        getDriverListRunning = false;
		    },
		    complete: function(jqXHR, textStatus) {
		    	if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getDriverList: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
		    	getDriverListRunning = false;
		    	
		    	if(textStatus == "success"){
		    	}
		    	else if(textStatus == "notmodified"){
		    	}
		    	else if(textStatus == "timeout"){
		    		
		    	}
		    	else if (textStatus == "error"){
		    		
		    	}
		    	else if (textStatus == "abort"){
		    		
		    	}
		    	else if (textStatus == "parsererror"){
		    		
		    	}
		    }
		});
   
};


MobiScout.Tab.Data.getTrailerList = function (rebuildTrailerNFClist) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.getTrailerList", 5);
	 if (MobiScout.Tab.App.CurrentPlanner.isLoggedOn == false) {
		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrailerList: not logged on");
	 	return;
	 }

        if (getTrailerListRunning == true) {
        	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrailerList: already running");
        	return;
        }
        $.ajax
		({
		    url: WebServiceURL + webServicePage + "/getTrailerList",
		    crossDomain: true,
		    cache: false,
		    headers: { "cache-control": "no-cache" },
		    type: "POST",
		    dataType: "xml",
		    data: "",
			beforeSend: function (xhr, settings) {
	       		getTrailerListRunning = true; 
	    	},		    
		    success: function (xml) {
		        getTrailerListRunning = false;
		        $(xml).find('row').each(function () {
		            var newTrailer = new TabTrailer();
		            $(this).find('cell').each(function () {
		                var id = $(this).attr('column');
		                if (id == "TRAILER_ID") newTrailer.ID = Number($(this).text());
		                if (id == "PLATE") newTrailer.Plate = $(this).text();
		            });
		            MobiScout.Tab.App.TrailerList.push(newTrailer);
		        });
		    },
		    error: function (xhr, ajaxOptions, thrownError) {
		        getTrailerListRunning = false;
		    },
		    complete: function(jqXHR, textStatus) {
		    	if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.getTrailerList: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
		    	getTrailerListRunning = false;
		    	if(rebuildTrailerNFClist == true){
		    		MobiScout.Tab.BuildTrailerListNFC();
		    	}
		    }
		});
   
};



MobiScout.Tab.Data.checkSession = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.checkSession", 5);
	
            if (checkSessionRunning == true) {
            	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.checkSession: already running");
            	return;
            }
            $.ajax
	        ({
	            url: WebServiceURL + webServicePage + "/isLoggedOn",
	            type: "POST",
	            dataType: "xml",
	            crossDomain: true,
	            cache: false,
	            headers: { "cache-control": "no-cache" },
	            data: "",
	            beforeSend: function (xhr, settings) {
	       			checkSessionRunning = true;
	    		},
	            success: function (xml) {
	                $(xml).find('int').each(function () {
	                    checkSessionRunning = false;
	                    if ($(this).text() == "0") {
	                        if (MobiScout.Tab.Data.LoadLocalData("PlannerNaam") && MobiScout.Tab.Data.LoadLocalData("PlannerWachtwoord")) {
	                            MobiScout.Tab.Data.RestoreSession(MobiScout.Tab.Data.LoadLocalData("PlannerNaam"), MobiScout.Tab.Data.LoadLocalData("PlannerWachtwoord"));
	                            MobiScout.Tab.LogToConsole("restoring session");
	                        }
	                    }
	                });

	            },
	            error: function (xhr, ajaxOptions, thrownError) {
	                checkSessionRunning = false;
	            },
	            complete: function(jqXHR, textStatus) {
	            	if(textStatus != "success"){
	            		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.checkSession: " + textStatus + " text: " + jqXHR.responseText + " code " + jqXHR.status);
	            		MobiScout.Tab.checkAlertForDevelopment();
	            	}
		    		checkSessionRunning = false;
		   		}
	        });
};


MobiScout.Tab.Data.SendTextMessage = function(vehicleid, textmessage){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.SendTextMessage", 5);
	textmessage = $('<p>' + textmessage + '</p>').text();
    var requestConfirmation = confirmMessages;
    if (requestConfirmation == undefined) requestConfirmation = true;
    if (textmessage == "$PSTAT*00") requestConfirmation = false;
	$.ajax
	({
	    //omschrijven naar sendMessageToVehicles vehicleIDs message requestDeliveryConfirmation requestReadConfirmation
	    url: WebServiceURL + webServicePage + "/sendMessageToVehicles",
		//url: WebServiceURL + webServicePage + "/sendMessageToVehicle",
	    type: "POST",
	    dataType: "xml",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    //data: "vehicleID=" + vehicleid + "&message=" + textmessage,
	    data: "vehicleIDs=" + vehicleid + "&message=" + textmessage + "&requestDeliveryConfirmation=" + requestConfirmation + "&requestReadConfirmation=" + requestConfirmation + "&isPriority=false",
	    success: function (xml) {
		    $(xml).find('boolean').each(function () {
	            if ($(this).text() == "true") {
	            	// remove from TxList
	            	if(textmessage == "$PSTAT*00") MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.StatusAanvraagVerzonden);
	            	else MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.BerichtVerzonden);
				}
		    });
	    },
		error: function (xhr, ajaxOptions, thrownError) {
	    	
	    },
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
	    		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.SendTextMessage: " + textStatus);
	    		MobiScout.Tab.checkAlertForDevelopment();
	    	}
	    
		    if(textStatus == "success"){ }
		    else if(textStatus == "notmodified"){ }
		    else if(textStatus == "timeout"){
		    	// toon bericht dat het niet gelukt is
		    	MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.BerichtVerzendenMislukt);
		    }
		    else if (textStatus == "error"){
		    	// toon bericht dat het niet gelukt is
		    	MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.BerichtVerzendenMislukt);
		    }
		    else if (textStatus == "abort"){ 
		    	// toon bericht dat het niet gelukt is
		    	MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.BerichtVerzendenMislukt);
		    }
			else if (textStatus == "parsererror"){ 
				// toon bericht dat het niet gelukt is
		    	MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.BerichtVerzendenMislukt);
			}
		}
	});
};

MobiScout.Tab.Data.postVersionMessage = function(){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.postVersionMessage", 5);
	var versionInfo = applicationVersion;
	var platform = '';
	try{
		if(window.MobiScoutApp) versionInfo += ' app';
		else versionInfo += ' web';
		// if available post the webview/browser info too. navigator.userAgent of navigator.platform
		//if(navigator.platform) versionInfo += ' ' + navigator.platform;
		if(navigator.userAgent){
			if(navigator.userAgent.match(/Android/i)) versionInfo += ' Android';
			else if(navigator.userAgent.match(/BlackBerry/i)) versionInfo += ' BlackBerry';
			else if(navigator.userAgent.match(/iPhone|iPad|iPod/i)) versionInfo += ' iOS';
			else if(navigator.userAgent.match(/IEMobile/i)) versionInfo += ' Windows Phone';
			else if(navigator.userAgent.match(/Opera Mini/i)) versionInfo += ' Opera';
			else if(navigator.userAgent.match(/Windows/i)) versionInfo += ' Windows';
			else if(navigator.userAgent.match(/Macintosh/i)) versionInfo += ' MacOS';
		}
		if(window.MobiScoutApp) platform = window.MobiScoutApp.GetPlatformInfo() ;//+ " " + device.version; 
	}
	catch(Err){}
	$.ajax
	({
		url: WebServiceURL + webServicePage + "/postMobiScoutAppVersion",
	    type: "POST",
	    dataType: "xml",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    data: "version=" + versionInfo + "&date=" + applicationBuildDate + "&user=" + $('<p>' + MobiScout.Tab.App.CurrentPlanner.Name + '</p>').text() + "&deviceid=" + platform,
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
	    		MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.postVersionMessage: " + textStatus);
	    		MobiScout.Tab.checkAlertForDevelopment();
	    	}
		    if(textStatus == "success"){ }
		    else if(textStatus == "notmodified"){ }
		    else if(textStatus == "timeout"){
		    }
		    else if (textStatus == "error"){
		    }
		    else if (textStatus == "abort"){ 
		    }
			else if (textStatus == "parsererror"){ 
			}
		}
	});
};

MobiScout.Tab.Data.MarkAlertRead = function(alertsn){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.MarkAlertRead", 5);

	$.ajax
	({
		url: WebServiceURL + webServicePage + "/MarkAlertRead",
	    type: "POST",
	    dataType: "xml",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    data: "alertsn=" + alertsn,
	    success: function (xml) {
		    $(xml).find('boolean').each(function () {
	            if ($(this).text() == "true") {
	            	MobiScout.Tab.App.removeAlertMessage(alertsn);
				}
		    });
	    },
		error: function (xhr, ajaxOptions, thrownError) {
	    },
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.MarkAlertRead: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
	    	MobiScout.Tab.UpdateMessageBadgeCount(MobiScout.Tab.App.Messages.length);
        	MobiScout.Tab.UI.Alert.BuildAlertList();
        	MobiScout.Tab.UI.Vehicle.BuildTrackAndTraceList(false);
	    }
	});
};

MobiScout.Tab.Data.MarkMessageRead = function(msgsn){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.MarkMessageRead", 5);
    $.ajax
	({
		url: WebServiceURL + webServicePage + "/MarkMessageRead",
	    type: "POST",
	    dataType: "xml",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    data: "msgsn=" + msgsn,
	    success: function (xml) {
		    $(xml).find('boolean').each(function () {
	            if ($(this).text() == "true") {
	            	MobiScout.Tab.App.removeUnreadMessage(msgsn);
	            	MobiScout.Tab.App.CurrentMsgSN = 0;
        			// herbepaal ongelezen berichten
        			MobiScout.Tab.UpdateMessageBadgeCount(MobiScout.Tab.App.Messages.length);
        			MobiScout.Tab.UI.Message.BuildMessagesList(true);
        			// direct verversen?
        			MobiScout.Tab.Data.getTrackAndTrace(false, false);
				}
		    });
	    },
		error: function (xhr, ajaxOptions, thrownError) {
	    	
	    },
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.MarkMessageRead: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
		}
	});
};

MobiScout.Tab.Data.SaveLocalData = function (name, value) {
	if(localStorage) {
	    MobiScout.Tab.Data.RemoveLocalData(name);
	    localStorage.setItem(name, value);
	}
}

MobiScout.Tab.Data.LoadLocalData = function (name) {
    if(localStorage){
	    return localStorage[name];
	}
}

MobiScout.Tab.Data.RemoveLocalData = function (name) {
	if(localStorage){
		localStorage.removeItem(name);
	}
}

MobiScout.Tab.Data.ClearLocalData = function () {
	if(localStorage){
		localStorage.clear();
	}
}

MobiScout.Tab.Data.ClearAutorisations = function(){
	MobiScout.Tab.Data.RemoveLocalData("1050");
	MobiScout.Tab.Data.RemoveLocalData("1100");
	MobiScout.Tab.Data.RemoveLocalData("1150");
	MobiScout.Tab.Data.RemoveLocalData("1200");
	MobiScout.Tab.Data.RemoveLocalData("1250");
	MobiScout.Tab.Data.RemoveLocalData("1300");
	MobiScout.Tab.Data.RemoveLocalData("1350");
	MobiScout.Tab.Data.RemoveLocalData("1400");
	MobiScout.Tab.Data.RemoveLocalData("1450");
	MobiScout.Tab.Data.RemoveLocalData("1600");
	MobiScout.Tab.Data.RemoveLocalData("1650");
	MobiScout.Tab.Data.RemoveLocalData("1700");
	MobiScout.Tab.Data.RemoveLocalData("1750");
	MobiScout.Tab.Data.RemoveLocalData("1800");
	MobiScout.Tab.Data.RemoveLocalData("1851");
	MobiScout.Tab.Data.RemoveLocalData("1853");
	MobiScout.Tab.Data.RemoveLocalData("1854");
}

MobiScout.Tab.Data.RestoreSession = function (plannerName, plannerPassword) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.RestoreSession", 1);
    if (restoreSessionRunning == true) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.RestoreSession: already running");
    	return;
    }
        $.ajax
	    ({
	        url: WebServiceURL + webServicePage + "/logonPlanner",
	        type: "POST",
	        dataType: "xml",
	        crossDomain: true,
	        cache: false,
	        headers: { "cache-control": "no-cache" },
	        data: "plannerID=" + plannerName + "&password=" + plannerPassword,
  			beforeSend: function (xhr, settings) {
	       		restoreSessionRunning = true;
	    	},	        
	        success: function (xml) {
	            restoreSessionRunning = false;
	            $(xml).find('boolean').each(function () {
	                if ($(this).text() == "true") {
	                    MobiScout.Tab.appendMessage("Restored als " + plannerName);

	                    MobiScout.Tab.App.CurrentPlanner.Name = plannerName;
	                    MobiScout.Tab.App.CurrentPlanner.Password = plannerPassword;
	                    MobiScout.Tab.App.CurrentPlanner.isLoggedOn = true;
	                    // save the data 
	                    if(window.MobiScoutApp)
	                    {
	                    	window.MobiScoutApp.startShift();
	                    	//window.MobiScoutApp.SetMobiScoutInfo(WebServiceURL, plannerName, plannerPassword, Number(refreshInterval) * 60);
	                    }
	                    // and refresh directly.
	                    if(restoreRefreshCounter < 5){
	                    	restoreRefreshCounter ++;
	                    	MobiScout.Tab.Update(false);
	                    }
	                }
	            });
				delete xml;

	        },
	        error: function (xhr, ajaxOptions, thrownError) {
	            restoreSessionRunning = false;
	        },
	        complete: function(jqXHR, textStatus) {
	        	if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.RestoreSession: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
		    	restoreSessionRunning = false;
		    	if(textStatus == "success"){
		    	}
		    	else if(textStatus == "notmodified"){
		    	}
		    	else if(textStatus == "timeout"){
		    		
		    	}
		    	else if (textStatus == "error"){
		    		
		    	}
		    	else if (textStatus == "abort"){
		    		
		    	}
		    	else if (textStatus == "parsererror"){
		    		
		    	}
		    }
	    });
    /*}*/
}


MobiScout.Tab.Data.LogonPlanner = function (plannerName, plannerPassword) {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.LogonPlanner", 1);
    if (logonPlannerRunning == true) {
    	MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.LogonPlanner: already running");
    	return;
    }
    
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/logonPlanner",
	    type: "POST",
	    dataType: "xml",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    data: "plannerID=" + plannerName + "&password=" + plannerPassword,
	    beforeSend: function (xhr, settings) {
	       	logonPlannerRunning = true;
	    },	
	    success: function (xml) {
	        logonPlannerRunning = false;

	        $(xml).find('boolean').each(function () {
	            if ($(this).text() == "true") {
	                MobiScout.Tab.appendMessage("Ingelogd als " + plannerName);
	                MobiScout.Tab.App.CurrentPlanner.Name = plannerName;
	                MobiScout.Tab.App.CurrentPlanner.Password = plannerPassword;
	                MobiScout.Tab.App.CurrentPlanner.isLoggedOn = true;
	                
	                MobiScout.Tab.Data.getConfiguration();
	                MobiScout.Tab.UI.refreshScreen();
	                MobiScout.Tab.Data.postVersionMessage();
	                // start workers
	                MobiScout.Tab.App.startworkers();
	                if(window.MobiScoutApp)
	                {
	                   	window.MobiScoutApp.startShift();
	                   	//window.MobiScoutApp.SetMobiScoutInfo(WebServiceURL, plannerName, plannerPassword, Number(refreshInterval) * 60);
	                   	
	                }
	                // alleen als eerste keer?
	                navigator.notification.activityStart("", MobiScout.Tab.Translations.Synchroniseren);
	                
	            }
	            else{
		    		MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.AanmeldenMisluktInstellingen);
	            }
	        });
			delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
	        logonPlannerRunning = false;
	    },
	    complete: function(jqXHR, textStatus) {
	    		if(textStatus != "success"){
					MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.LogonPlanner: " + textStatus);
					MobiScout.Tab.checkAlertForDevelopment();
				}
		    	logonPlannerRunning = false;
		    	if(textStatus == "success"){
		    		MobiScout.Tab.App.LogonRetries = 5;
		    	}
		    	else if(textStatus == "notmodified"){
		    	}
		    	else if(textStatus == "timeout"){
		    		if(MobiScout.Tab.App.LogonRetries > 0){
		    			setTimeout(MobiScout.Tab.App.LogonPlanner, 2000);
		    		}
		    		else{
		    			navigator.notification.activityStop();
		    			MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.AanmeldenMisluktVerbinding);
		    		}
		    	}
		    	else if (textStatus == "error"){
					if(MobiScout.Tab.App.LogonRetries > 0){
		    			setTimeout(MobiScout.Tab.App.LogonPlanner, 1000);
		    		}
		    		else{
		    			navigator.notification.activityStop();
						MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.AanmeldenMisluktVerbinding);
		    		}

		    	}
		    	else if (textStatus == "abort"){
					if(MobiScout.Tab.App.LogonRetries > 0){
		    			setTimeout(MobiScout.Tab.App.LogonPlanner, 1000);
		    		}
		    		else{
		    			navigator.notification.activityStop();
						MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.AanmeldenMisluktVerbinding + " (abort)!");
		    		}
		    	}
		    	else if (textStatus == "parsererror"){
					if(MobiScout.Tab.App.LogonRetries > 0){
		    			setTimeout(MobiScout.Tab.App.LogonPlanner, 1000);
		    		}
		    		else{
		    			navigator.notification.activityStop();
						MobiScout.Tab.ShowAlert(MobiScout.Tab.Translations.LetOp, MobiScout.Tab.Translations.AanmeldenMisluktVerbinding + " (parse)!");
		    		}
		    		
		    	}
		    }
	});
}


MobiScout.Tab.Data.LogOffPlanner = function () {
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.Data.LogOffPlanner", 1);
    $.ajax
	({
	    url: WebServiceURL + webServicePage + "/logoffPlanner",
	    crossDomain: true,
	    cache: false,
	    headers: { "cache-control": "no-cache" },
	    type: "POST",
	    dataType: "xml",
	    data: "",
	    success: function (xml) {
	        MobiScout.Tab.appendMessage("Uitgelogd!");
	        MobiScout.Tab.App.CurrentPlanner.Name = "";
	        MobiScout.Tab.App.CurrentPlanner.Password = "";
	        MobiScout.Tab.App.CurrentPlanner.isLoggedOn = false;
	        MobiScout.Tab.App.stopworkers();
	        MobiScout.Tab.UI.refreshScreen();
	        //TODO: clear all stuff (lists, map etc)
	        delete xml;
	    },
	    error: function (xhr, ajaxOptions, thrownError) {
	        MobiScout.Tab.appendMessage("Fout bij uitloggen");

	    },
	    complete: function(jqXHR, textStatus) {
	    	if(textStatus != "success"){
				MobiScout.Tab.LogToConsole("MobiScout.Tab.Data.LogOffPlanner: " + textStatus);
				MobiScout.Tab.checkAlertForDevelopment();
			}
		}
	});
}
