MobiScout.Tab.UI.Message.SelectedDate = MobiScout.Tab.GetCurrentDate();
MobiScout.Tab.UI.Message.DateChanged = false;


// build messages list
MobiScout.Tab.UI.Message.BuildMessagesList = function (forceRefresh, count) {
        if(forceRefresh == true || count == 0) {
        	$("#MessagesList").empty();
        }
       	if ($("#MessagesList").html() == '') {
       		var newList = [];
            newList.push('<li data-role="list-divider">' + MobiScout.Tab.App.Messages.length + ' ' + MobiScout.Tab.Translations.OngelezenBerichten + '</li>');
            if(count == 0) newList.push('<li data-icon="false"><a>' + MobiScout.Tab.Translations.GeenBerichten + '</a></li>');
            
            for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
                newList.push(MobiScout.Tab.UI.Message.GenerateMessageItem(MobiScout.Tab.App.Messages[i], false));
            }
            $("#MessagesList").append(newList.join(''));
            
        }
        else {
            for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
                MobiScout.Tab.UI.Message.UpdateMessageItem(MobiScout.Tab.App.Messages[i]);
            }
        }
        $("#MessagesList").listview("refresh");
    };

MobiScout.Tab.UI.Message.setMessageDialogLoading = function(){
		$("#MessageDialogList").html('<li data-role="list-divider">' + MobiScout.Tab.Translations.OphalenBerichtenVan + ' ' + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.LastSelectedVehicleID) + '</li><li data-icon="false"><a>' + MobiScout.Tab.Translations.Laden + '</a></li>').listview("refresh");
}

MobiScout.Tab.UI.Message.ClearDialogList = function(){
		$("#MessageDialogList").empty(); 
}
	
MobiScout.Tab.UI.Message.BuildMessagesDialogList = function(forceClear){
		//$("#MessageDialogList").html('');
		if(forceClear == true)
		{ 
			$("#MessageDialogList").empty();
			var totalList = [];
	       	if(MobiScout.Tab.App.MessageDialog.length == 0){
	       		totalList.push('<li id="msgdlgheaderitem" data-role="list-divider">' + MobiScout.Tab.Translations.GeenBerichtenVan + ' ' + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.LastSelectedVehicleID) + '</li><li data-icon="false"><a>' + MobiScout.Tab.Translations.GeenBerichten + '</a></li>');
	       	}
	       	else{
		        totalList.push('<li id="msgdlgheaderitem" data-role="list-divider">' + MobiScout.Tab.App.MessageDialog.length + ' '+MobiScout.Tab.Translations.BerichtenVan+' ' + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.LastSelectedVehicleID) + '</li>');
		        for (var i = 0; i < MobiScout.Tab.App.MessageDialog.length; i++) {
		        	totalList.push(MobiScout.Tab.UI.Message.GenerateMessageDialogItem(MobiScout.Tab.App.MessageDialog[i]));
				}
			}
			$("#MessageDialogList").html(totalList.join(''));
		}
		else{
			// lijst bijwerken adv huidige lijst en MobiScout.Tab.App.MessageDialog array
			if(MobiScout.Tab.App.MessageDialog.length == 0){
				$("#MessageDialogList").empty();
				var totalList = [];
	       		totalList.push('<li id="msgdlgheaderitem" data-role="list-divider">' + MobiScout.Tab.Translations.GeenBerichtenVan + ' ' + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.LastSelectedVehicleID) + '</li><li data-icon="false"><a>' + MobiScout.Tab.Translations.GeenBerichten + '</a></li>');
	       		$("#MessageDialogList").html(totalList.join(''));
			}
			else{
				// dan alle berichten nalopen
				for (var i = 0; i < MobiScout.Tab.App.MessageDialog.length; i++) {
					if(isBlank($('#msgdlgsn' + MobiScout.Tab.App.MessageDialog[i].MsgSN).html()) == false){
						// bestaat al 
						//console.log("message already in list: " + MobiScout.Tab.App.MessageDialog[i].MsgSN + " " + $('#msgdlgsn' + MobiScout.Tab.App.MessageDialog[i].MsgSN).html());
					}
					else{
						//console.log("new message, prepending: " + MobiScout.Tab.App.MessageDialog[i].MsgSN);
						$('#MessageDialogList').prepend(MobiScout.Tab.UI.Message.GenerateMessageDialogItem(MobiScout.Tab.App.MessageDialog[i]));
					}
				}
				$("#msgdlgheaderitem").text(MobiScout.Tab.App.MessageDialog.length + ' '+MobiScout.Tab.Translations.BerichtenVan+' ' + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.LastSelectedVehicleID));
				
			}
			
		}
		$("#MessageDialogList").listview("refresh")
	};
	
	
MobiScout.Tab.UI.Message.GenerateIconTable = function(message){
	var iconTable = '<table class="messageIconTable" >';
	
	iconTable += '<tr>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '</tr>';
	
	var imageNew = "";
	var imageInbound = "images/folder_outbox.png";
	var imageRead = "";
	var imageUrgent = "";
	
	if(message.StatusID == 40 && isBlank(message.TSRead) == true && message.MsgTypeID == 1) imageNew = 'images/star.png';
	else if(message.StatusID == 40 && message.MsgTypeID == 1) {
		imageRead = 'images/true.png';
	}
	if(message.StatusID == 40) imageInbound = 'images/folder_inbox.png'; 
	if(message.Prio == "1") imageUrgent = 'images/exclamation-mark.png';
	
	var imageMessage = "images/r1_mail.png";
	if(message.MsgTypeID == 7) {
		if(message.StatusID == 30) imageMessage = "images/Settings_64.png"; // instellingen
		else imageMessage = "images/r1_calendar.png"; // statusbericht
	}
	else if(message.MsgTypeID == 19) imageMessage = "images/thermometer.png"; // temperatuur alarm
	else{
		if(startsWith(message.MsgContent, "#") || startsWith(message.MsgContent, "$")){ 
			imageMessage = "images/Settings_64.png"; // systeem bericht
		}
	}
	iconTable += '<tr> <td colspan="4" ><center><img class="vehicleIcon" src="' + imageMessage + '"/></center></td></tr>';
	iconTable += '<tr>';
	if(!isBlank(imageNew)) iconTable += '<td><img class="messageListImage" src="' + imageNew + '"/></td>';
	else iconTable += '<td><img class="messageListImage"/></td>';
	if(!isBlank(imageInbound)) iconTable += '<td><img class="messageListImage" src="' + imageInbound + '"/></td>';
	else iconTable += '<td><img class="messageListImage"/></td>';
	if(!isBlank(imageRead)) iconTable += '<td><img class="messageListImage" src="' + imageRead + '"/></td>';
	else iconTable += '<td><img class="messageListImage"/></td>';
	if(!isBlank(imageUrgent)) iconTable += '<td><img class="messageListImage" src="' + imageUrgent + '"/></td>';
	else iconTable += '<td><img class="messageListImage"/></td>';
	iconTable += '</tr>';
	iconTable += '<tr> <td></td><td></td><td></td><td></td></tr>'; 
	iconTable += '</table>';
	return iconTable;
};
	
MobiScout.Tab.UI.Message.GenerateDetailTable = function(message, isInbox){
	var detailTable = '<table class="vehicleDetailTable">';
	
	detailTable += '<tr>';
	detailTable += '<td class="vehicleIconColumn"></td>';
	detailTable += '<td></td>';
	detailTable += '</tr>';
	
	var messageDescription = message.MsgContent;
	var locationDescription = message.Location;
	var locationImage = '<td></td>';
	var messageInGeofence = MobiScout.Tab.App.IsMessageInGeofence(message);
	if(startsWith(message.Location, "POI:")){
	    if(messageInGeofence != undefined){
	    	locationImage = '<td><img class="vehicleDetailImage" src="images/star.png"/></td>';
	    	locationDescription = message.Location.substring(4, message.Location.length).trim();
	    }
	    else{
	    	locationImage = '<td><img class="vehicleDetailImage" src="images/flag_green.png"/></td>';
	    	locationDescription = message.Location.substring(4, message.Location.length).trim();
	    } 
    }
    else if(startsWith(message.Location, "ADR:")){
    	if(messageInGeofence != undefined){
        	locationImage = '<td><img class="vehicleDetailImage" src="images/star.png"/></td>';
	    	locationDescription = message.Location.substring(4, message.Location.length).trim();
       	}
        else{
        	locationImage = '<td><img class="vehicleDetailImage" src="images/user.png"/></td>';
	    	locationDescription = message.Location.substring(4, message.Location.length).trim();
        } 
    }
    else if(startsWith(message.Location, "POLY:")){
    	if(messageInGeofence != undefined){
        	locationImage = '<td><img class="vehicleDetailImage" src="images/star.png"/></td>';
	    	locationDescription = message.Location.substring(5, message.Location.length).trim();
       	}
        else{
        	locationImage = '<td><img class="vehicleDetailImage" src="images/flag_red.png"/></td>';
	    	locationDescription = message.Location.substring(5, message.Location.length).trim();
        } 
    }
    else{
    	if(!isBlank(locationDescription)){
    		locationImage = '<td><img class="vehicleDetailImage" src="images/map-pin.png"/></td>';
    	}
    }
    
    var htmlColor = 'gray';
	var activityColorBall = '';
	
	if(message.MsgTypeID == 7) {
		if(message.StatusID == 30){
			activityColorBall = '&#10137;';
			messageDescription = '<h3 style="color: gray;white-space:normal;" >Instellingen bericht</h3>';
		}
		else{
			htmlColor = MobiScout.Tab.App.toRGB(message.Color);
			activityColorBall = '<div style="background-color: ' + htmlColor + ';width:10px;height:10px;-moz-border-radius: 5px/5px;-webkit-border-radius: 5px 5px;border-radius: 5px/5px;float: left;"></div>';
			// tekstkleur naar grijs met een bolletje ervoor
			//messageDescription = '<h3 style="color: '+htmlColor+';white-space:normal;" >' + message.ActivityDescr + '</h3>';
			messageDescription = '<h3 style="color: gray;white-space:normal;" >' + message.ActivityDescr + '</h3>';
		}
	}
	else if(message.MsgTypeID == 19){
		// temperatuur alarm
		messageDescription = '<h3 style="color: orange; font-style:italic;white-space:normal;" >Temperatuur alarm</h3>';
	}
	else{
		if(isInbox == true){
			messageDescription = '<h3 style="color: red;white-space:normal;" >' + message.MsgContent + '</h3>';	
		}
		else{
			if(message.StatusID == 40 && isBlank(message.TSRead)) messageDescription = '<h3 style="color: red;white-space:normal;" >' + message.MsgContent + '</h3>';
			else if(message.StatusID == 40) messageDescription = '<h3 style="color: blue;white-space:normal;" >' + message.MsgContent + '</h3>';
			else messageDescription = '<h3 style="color: gray;white-space:normal;" >' + message.MsgContent + '</h3>';
		}
	}
	// voertuig/chauffeurnaam?
	if(isInbox == true){
		if(showVehiclePlate == true) detailTable += '<tr><td><img class="vehicleDetailImage" src="images/truck.png"/></td><td>' + message.Plate + '</td></tr>';
		else detailTable += '<tr><td><img class="vehicleDetailImage" src="images/truck.png"/></td><td>' + message.VehicleID + '</td></tr>';
	}
	if(!isBlank(message.DriverName) && message.DriverID > 0) detailTable += '<tr><td><img class="vehicleDetailImage" src="images/user.png"/></td><td>' + message.DriverName + '</td></tr>';
    // voeg de omschrijving/tekst toe
	detailTable += '<tr><td>' + activityColorBall + '</td><td>' + messageDescription + '</td></tr>';
    // voeg de tijd toe
	detailTable += '<tr><td><img class="vehicleDetailImage" src="images/accessories-clock.png"/></td><td>' + message.TSStatus  + '</td></tr>';
	// voeg evt. de detail toe
	if(message.Temperature1 != -1000 || message.Temperature2 != -1000 || message.Temperature3 != -1000 || message.Temperature4 != -1000 || message.Temperature5 != -1000 || message.Temperature6 != -1000 || message.Temperature7 != -1000 || message.Temperature8 != -1000){
		var msgDetails = '<table style="font-size: 8px;text-align:center;border-collapse: collapse; border-spacing: 0; cellspacing:0; cellpadding:0; width:100%;">';
		msgDetails += '<tr>';
		msgDetails += '<td style="width: 12.5%;">T1</td><td style="width: 12.5%;">T2</td><td style="width: 12.5%;">T3</td><td style="width: 12.5%;">T4</td><td style="width: 12.5%;">T5</td><td style="width: 12.5%;">T6</td><td style="width: 12.5%;">T7</td><td style="width: 12.5%;">T8</td>';
		msgDetails += '</tr>';
		msgDetails += '<tr>';
		if(message.Temperature1 != -1000) msgDetails += "<td>" + message.Temperature1 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		if(message.Temperature2 != -1000) msgDetails += "<td>" + message.Temperature2 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		if(message.Temperature3 != -1000) msgDetails += "<td>" + message.Temperature3 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		if(message.Temperature4 != -1000) msgDetails += "<td>" + message.Temperature4 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		if(message.Temperature5 != -1000) msgDetails += "<td>" + message.Temperature5 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		if(message.Temperature6 != -1000) msgDetails += "<td>" + message.Temperature6 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		if(message.Temperature7 != -1000) msgDetails += "<td>" + message.Temperature7 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		if(message.Temperature8 != -1000) msgDetails += "<td>" + message.Temperature8 + " &#176;C</td>";
		else msgDetails += "<td>--</td>";
		msgDetails += '</tr>';
		msgDetails += '</table>';
		detailTable += '<tr><td><img class="vehicleDetailImage" src="images/thermometer.png"/></td><td>' + msgDetails + '</td></tr>';
	}
	
	if(message.IO1 == true || message.IO2 == true || message.IO3 == true){
		var IODetails = '<table style="font-size: 8px;text-align:center;border-collapse: collapse; border-spacing: 0; cellspacing:0; cellpadding:0; width:100%;">';
		IODetails += '<tr><td style="width: 33.3%;">I/O 1</td><td style="width: 33.3%;">I/O 2</td><td style="width: 33.3%;">I/O 3</td></tr>';
		IODetails += '<tr>';
		if(message.IO1 == true) IODetails += '<td><bold>Aan</bold></td>';
		else IODetails += '<td>Uit</td>';
		if(message.IO2 == true) IODetails += '<td><bold>Aan</bold></td>';
		else IODetails += '<td>Uit</td>';
		if(message.IO3 == true) IODetails += '<td><bold>Aan</bold></td>';
		else IODetails += '<td>Uit</td>';
		IODetails += '</tr>';
		IODetails += '</table>';
		detailTable += '<tr><td><img class="vehicleDetailImage" src="images/IO.png"/></td><td>' + IODetails + '</td></tr>';
	}
	// voeg de locatie optioneel toe
	if(!isBlank(locationDescription)) detailTable += '<tr>' + locationImage + '<td>' + locationDescription + '</td></tr>';
	
	detailTable += '</table>';
	
	return detailTable;
	
};

MobiScout.Tab.UI.Message.GenerateMessageDialogItem = function(message){
	var item = '<table class="messageTable" >';
	item += '<tr>';
	item += '<td class="tabMessageIcons"></td>';
	item += '<td class="tabMessageDetails" ></td>'; 
	item += '</tr>';
	item += '<tr>';
	item += '<td class="tabMessageIcons">' + MobiScout.Tab.UI.Message.GenerateIconTable(message) + '</td>';
	item += '<td class="tabMessageDetails">' + MobiScout.Tab.UI.Message.GenerateDetailTable(message, false) + '</td>';
	item += '</tr>';
	item += '</table>';
	item = '<li data-icon="false"><a id="msgdlgsn' + message.MsgSN + '">' + item + '</a><a onclick="MobiScout.Tab.Mapping.ShowMessageOnMap('+ message.MsgSN +')"></a></li>';
	return item;
};
	
MobiScout.Tab.UI.Message.GenerateMessageItem = function(message, isupdate){

	var item = '<table class="messageTable" >';
	item += '<tr>';
	item += '<td class="tabMessageIcons"></td>';
	item += '<td class="tabMessageDetails" ></td>'; 
	item += '</tr>';
	item += '<tr>';
	item += '<td class="tabMessageIcons">' + MobiScout.Tab.UI.Message.GenerateIconTable(message) + '</td>';
	item += '<td class="tabMessageDetails">' + MobiScout.Tab.UI.Message.GenerateDetailTable(message, true) + '</td>';
	item += '</tr>';
	item += '</table>';
	if(isupdate) {
		item = '<a id="msgsn' + message.MsgSN + '">' + item + '</a><a onclick="MobiScout.Tab.Mapping.ShowMessageOnMap('+ message.MsgSN +')"></a>';
	}
	else{
		item = '<li data-icon="false"><a id="msgsn' + message.MsgSN + '">' + item + '</a><a onclick="MobiScout.Tab.Mapping.ShowMessageOnMap('+ message.MsgSN +')"></a></li>';
	}
	return item;
};
	
MobiScout.Tab.UI.Message.UpdateMessageItem = function (message){
		$("#msgsn" + message.MsgSN).html(MobiScout.Tab.UI.Message.GenerateMessageItem(message, true));
    };    
	