MobiScout.Tab.UI.BuildContextMenu = function(pageid){
	// first, always clean the context menu
	$('#contextmenulist').empty();
	
	var contextMenuList = [];
	
	// altijd een 'sluiten' optie toevoegen om het menu te kunnen sluiten
  	contextMenuList.push('<li data-icon="back" id="btncontext_close"><a class="jqm-list-item" data-ajax="false">' + MobiScout.Tab.Translations.Terug + '</a></li>');
	// always add an option to send a text message
	contextMenuList.push('<li data-icon="edit" id="btncontext_newmail"><a class="jqm-list-item" data-ajax="false">nieuw bericht</a></li>');
  	if(pageid == "home"){ }
  	else if(pageid == "realtimeHours"){ }
  	else if(pageid == "periodView"){
  		// optie om te berekenen
  		if(authorisationForCAO == true){
			contextMenuList.push('<li data-icon="clock" id="btncontext_berekencao"><a class="jqm-list-item" data-ajax="false">berekenen</a></li>');
			// optie om datum te selecteren? 
  			// optie om gegevens te normeren?
  			// optie voor CAO specifieke instellingen?
  			// optie voor loonbijlage?
		}
  	}
  	else if(pageid == "driverCard"){
  		// optie voor canbus rapportage
  	}
  	else if(pageid == "employees"){ }
  	else if(pageid == "dateselection"){ }
  	else if(pageid == "help"){ }
  	else if(pageid == "messages"){
  		contextMenuList.push('<li data-icon="check" id="btncontext_markallmessagesread"><a class="jqm-list-item" data-ajax="false">alles gelezen</a></li>');
  	}
  	else if(pageid == "alerts"){
  		contextMenuList.push('<li data-icon="check" id="btncontext_markallalertsread"><a class="jqm-list-item" data-ajax="false">alles gelezen</a></li>');
  	}
  	else if(pageid == "messagedialog"){ 
  		// datum selectie toevoegen AP6352
  		contextMenuList.push('<li data-icon="calendar" id="btncontext_selectdate_msgs"><a class="jqm-list-item" data-ajax="false">datum</a></li>');
  		
  	}
  	else if(pageid == "trips"){ }
  	else if(pageid == "tripstops"){ }
  	else if(pageid == "map"){
  		contextMenuList.push('<li data-icon="delete" id="btncontext_clearmap"><a class="jqm-list-item" data-ajax="false">wis kaart</a></li>');
  		contextMenuList.push('<li data-icon="plus" id="btncontext_zoomin"><a class="jqm-list-item" data-ajax="false">zoom in</a></li>');
  		contextMenuList.push('<li data-icon="minus" id="btncontext_zoomout"><a class="jqm-list-item" data-ajax="false">zoom uit</a></li>');
  		contextMenuList.push('<li data-icon="eye" id="btncontext_zoomtotal"><a class="jqm-list-item" data-ajax="false">zoom totaal</a></li>');
  	}
  	else if(pageid == "settings"){
  		// optie om instellingen op te slaan?
  		// optie alles te wissen?
  	}
  	else if(pageid == "messagedetail"){ }
  	else if(pageid == "stopdetails"){ }
  	else if(pageid == "newmessage"){ }
  	else if(pageid == "temperature"){
  		contextMenuList.push('<li data-icon="calendar" id="btncontext_selectdate"><a class="jqm-list-item" data-ajax="false">datum</a></li>');
  		contextMenuList.push('<li data-icon="bars" id="btncontext_toggletemperatureview"><a class="jqm-list-item" data-ajax="false">grafiek/tabel</a></li>');
  	}
  	
  	if(isDevelopmentDevice == true){
  		contextMenuList.push('<li data-icon="tag" id="btncontext_programvehicletag"><a class="jqm-list-item" data-ajax="false">voertuig tag</a></li>');
  		contextMenuList.push('<li data-icon="tag" id="btncontext_programtrailertag"><a class="jqm-list-item" data-ajax="false">trailer tag</a></li>');
  		contextMenuList.push('<li data-icon="tag" id="btncontext_programdrivertag"><a class="jqm-list-item" data-ajax="false">chauffeur tag</a></li>');
  		contextMenuList.push('<li data-icon="tag" id="btncontext_programusertag"><a class="jqm-list-item" data-ajax="false">gebruiker tag</a></li>');
  	}
  	
  	$("#contextmenulist").append(contextMenuList.join('')).listview('refresh');
  	
  	// wire all events please
  	$('#btncontext_berekencao').bind('click', function(event, ui){
		if(MobiScout.Tab.UOCalculationManager.CalculationList.length == 0){
			for(var i = 0; i < MobiScout.Tab.UI.PeriodView.DateEntryList.length; i ++){
				MobiScout.Tab.UOCalculationManager.AddDriverToCalculationList(MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID, new Date(MobiScout.Tab.UI.PeriodView.CurrentStartDate));
			}
			MobiScout.Tab.UOCalculationManager.Run(true);
		}
	});
  	
  	$("#btncontext_newmail").bind('click', function(event, ui) {
		MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
    	MobiScout.Tab.App.SendNewMessage();
    });
  	$("#btncontext_close").bind('click', function(event, ui) {
		MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
    });
    
  	$("#btncontext_markallmessagesread").bind('click', function(event, ui) {
  		MobiScout.Tab.App.MarkAllMessagesRead();	
    });
  	$("#btncontext_markallalertsread").bind('click', function(event, ui) {
  		MobiScout.Tab.App.MarkAllAlertsRead();	
    });
    
    $("#btncontext_clearmap").bind('click', function(event, ui) {
  		MobiScout.Tab.Mapping.ClearMap();
    });
    $("#btncontext_zoomin").bind('click', function(event, ui) {
  		MobiScout.Tab.Mapping.ZoomIn();
    });
    $("#btncontext_zoomout").bind('click', function(event, ui) {
  		MobiScout.Tab.Mapping.ZoomOut();
    });
    $("#btncontext_zoomtotal").bind('click', function(event, ui) {
  		MobiScout.Tab.Mapping.ZoomToVehicles();
    });
    
    $("#btncontext_toggletemperatureview").bind('click', function(event, ui) {
  		MobiScout.Tab.UI.Temperature.ToggleView();
    });
    
    $("#btncontext_selectdate").bind('click', function(event, ui) {
  		$("#popupdatepicker").prop("readonly", true).datepicker(
		{
			onSelect: function(dateText) {
				MobiScout.Tab.PlayTick();
				MobiScout.Tab.LogToConsole("selected date: " + $("#popupdatepicker").datepicker( "getDate" ));
				MobiScout.Tab.UI.Temperature.SelectedDate = $("#popupdatepicker").datepicker( "getDate" );
				MobiScout.Tab.ChangePage("temperature");
			},
			dateFormat: "dd/mm/yy",
			monthNames: [ "Januari", "Februari", "Maart", "April", "Mei", "Juni", "Juli", "Augustus", "September", "Oktober", "November", "December" ],
			monthNamesShort: [ "Jan", "Feb", "Mar", "Apr", "Mei", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec" ],
			dayNames: [ "Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag" ],
			dayNamesMin: [ "Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za" ],
			dayNamesShort: [ "Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za" ],
			showWeek: true,
			autoSize: true,
			firstDay : 1,
			weekHeader: "W"
		});
		$("#popupdatepicker" ).datepicker( "setDate", MobiScout.Tab.UI.Temperature.SelectedDate );
		$.mobile.changePage($("#datepickerdialog")); 
    });
    
    $("#btncontext_selectdate_msgs").bind('click', function(event, ui) {
  		$("#popupdatepicker").prop("readonly", true).datepicker(
		{
			onSelect: function(dateText) {
				MobiScout.Tab.PlayTick();
				MobiScout.Tab.LogToConsole("selected date: " + $("#popupdatepicker").datepicker( "getDate" ));
				MobiScout.Tab.UI.Message.SelectedDate = $("#popupdatepicker").datepicker( "getDate" );
				MobiScout.Tab.UI.Message.DateChanged = true;
				MobiScout.Tab.ChangePage("messagedialog");
			},
			dateFormat: "dd/mm/yy",
			monthNames: [ "Januari", "Februari", "Maart", "April", "Mei", "Juni", "Juli", "Augustus", "September", "Oktober", "November", "December" ],
			monthNamesShort: [ "Jan", "Feb", "Mar", "Apr", "Mei", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec" ],
			dayNames: [ "Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag" ],
			dayNamesMin: [ "Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za" ],
			dayNamesShort: [ "Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za" ],
			showWeek: true,
			autoSize: true,
			firstDay : 1,
			weekHeader: "W"
		});
		$("#popupdatepicker" ).datepicker( "setDate", MobiScout.Tab.UI.Message.SelectedDate );
		$.mobile.changePage($("#datepickerdialog")); 
    });
    
    
    $('#btncontext_programvehicletag').bind('click', function(event, ui){
    	$.mobile.changePage($("#programvehiclenfc"));
    });
    
     $('#btncontext_programtrailertag').bind('click', function(event, ui){
    	$.mobile.changePage($("#programtrailernfc"));
    });
    
    $('#btncontext_programdrivertag').bind('click', function(event, ui){
    	$.mobile.changePage($("#programdrivernfc"));
    });
    $('#btncontext_programusertag').bind('click', function(event, ui){
    	$.mobile.changePage($("#programusernfc"));
    });
    
}


MobiScout.Tab.UI.DeviceAllowsAnimation = function(){
	if(window.requestAnimationFrame == undefined) return false;
	if(pageTransition == 'none') return false;
	return true;
}

MobiScout.Tab.UI.FormatMessageForDisplay = function(message, duration){
	var textMessage = message.MsgContent;
	var j = 0;
	
	var isImage = false;
    var imageSN = 0;

    if (startsWith(message.MsgContent, "Er is een foto ontvangen [") /*|| startsWith(message.MsgContent, "Er is een document ontvangen [")*/) {
        isImage = true;
        var matches = message.MsgContent.match(/\[(.*?)\]/);
        if (matches) {
            imageSN = Number(matches[1]);
        }
    }
    
	while (textMessage.indexOf("\x20\x20") >= 0 && j < 255) {
		textMessage = textMessage.replace("\x20\x20", "<br>");
		j++;
	}
	var messageToDisplay = '';
	var senderID = '';
	if(isBlank(message.Plate) == false && isBlank(message.DriverName) == false && message.DriverID > 0) {
		if(showVehiclePlate == true) senderID = message.Plate + ", " + message.DriverName;
		else senderID = message.VehicleID + ", " + message.DriverName;
	}
	else if(isBlank(message.Plate) == false) {
		if(showVehiclePlate == true) senderID = message.Plate;
		else senderID = message.VehicleID;
	}
	else if(isBlank(message.DriverName) == false  && message.DriverID > 0) senderID = message.DriverName;
	messageToDisplay = '<fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">' + MobiScout.Tab.Translations.BerichtDetails + '</legend>';
	messageToDisplay += '<div style="margin:10px;">';
	
	messageToDisplay += '<p style="font-style: italic; font-weight: bold;"><img src="images/user.png" width="16" height="16"/>&nbsp;&nbsp;' + senderID + '</p>';
	
	messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/accessories-date.png" width="16" height="16"/>&nbsp;&nbsp;' + message.TSStatus + '</p>';

	if(duration) {
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/accessories-clock.png" width="16" height="16"/>&nbsp;&nbsp;' + duration + '</p>';
	}


	if(startsWith(message.Location, "POI:")){
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/flag_green.png" width="16" height="16"/>&nbsp;&nbsp;' + message.Location.substring(4, message.Location.length).trim() + '</p>';
	}
	else if(startsWith(message.Location, "ADR:")){
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/user.png" width="16" height="16"/>&nbsp;&nbsp;' + message.Location.substring(4, message.Location.length).trim() + '</p>';
	}
	else if(startsWith(message.Location, "POLY:")){
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/flag_red.png" width="16" height="16"/>&nbsp;&nbsp;' + message.Location.substring(5, message.Location.length).trim() + '</p>';
	}
	else if(isBlank(message.Location) == false){
		messageToDisplay += '<p style="color: gray;white-space:normal" >' + message.Location.trim() + '</p>';
	}
	messageToDisplay += '</div></fieldset>';
	messageToDisplay += '<br>';
	var messageType = MobiScout.Tab.Translations.OntvangenTekstBericht;
	if(message.StatusID == 30) messageType = MobiScout.Tab.Translations.VerzondenTekstBericht;
	if(message.MsgTypeID == 7) messageType = MobiScout.Tab.Translations.StatusBericht;
	else if(message.MsgTypeID == 19) messageType = MobiScout.Tab.Translations.TemperatuurBericht;
	
	messageToDisplay += '<fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">' + messageType + '</legend>';
	messageToDisplay += '<div style="margin:10px;">';
	
    //messageToDisplay += '<br><p style="font-style: italic;font-size:0.75em !important; color: gray">' + messageType + '</p><hr>';
    
	if (message.MsgTypeID == 7) {
		// bij een statusbericht de status netjes toevoegen
		var htmlColor = MobiScout.Tab.App.toRGB(message.Color);
		//messageToDisplay += '<h3 style="color: '+htmlColor+'" >' + message.ActivityDescr + '</h3>';
		messageToDisplay += '<a style="background-color: '+htmlColor+';color:black;border-radius:3px;padding:3px;font-weight:bold;" >' + message.ActivityDescr + '</a>';
		textMessage = '';
		if(message.Temperature1 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 1 " + message.Temperature1 + " &#176;C<br>";
		if(message.Temperature2 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 2 " + message.Temperature2 + " &#176;C<br>";
		if(message.Temperature3 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 3 " + message.Temperature3 + " &#176;C<br>";
		if(message.Temperature4 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 4 " + message.Temperature4 + " &#176;C<br>";
		if(message.Temperature5 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 5 " + message.Temperature5 + " &#176;C<br>";
		if(message.Temperature6 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 6 " + message.Temperature6 + " &#176;C<br>";
		if(message.Temperature7 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 7 " + message.Temperature7 + " &#176;C<br>";
		if(message.Temperature8 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 8 " + message.Temperature8 + " &#176;C<br>";
		
		if(message.IO1 == true) textMessage += "IO 1 " + MobiScout.Tab.Translations.Aangeschakeld + "<br>";
		if(message.IO2 == true) textMessage += "IO 2 " + MobiScout.Tab.Translations.Aangeschakeld + "<br>";
		if(message.IO3 == true) textMessage += "IO 3 " + MobiScout.Tab.Translations.Aangeschakeld + "<br>";
		if(message.Speed > 0) textMessage += MobiScout.Tab.Translations.Snelheid + " " + message.Speed + "<br>";;
		if(message.Heading > 0) textMessage += MobiScout.Tab.Translations.Richting + " " + message.Heading + "<br>";;
		
		if(message.Odometer > 0) textMessage += MobiScout.Tab.Translations.KmStand + " " + message.Odometer + "<br>";
		if(message.TrailerID > 0) textMessage += MobiScout.Tab.Translations.Oplegger + " 1 " + message.TrailerID + "<br>";
		if(message.TrailerID2 > 0) textMessage += MobiScout.Tab.Translations.Oplegger + " 2 " + message.TrailerID2 + "<br>";
	}
	else if(message.MsgTypeID == 19){ 
		textMessage = '';
		if(message.Temperature1 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 1 " + message.Temperature1 + " &#176;C<br>";
		if(message.Temperature2 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 2 " + message.Temperature2 + " &#176;C<br>";
		if(message.Temperature3 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 3 " + message.Temperature3 + " &#176;C<br>";
		if(message.Temperature4 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 4 " + message.Temperature4 + " &#176;C<br>";
		if(message.Temperature5 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 5 " + message.Temperature5 + " &#176;C<br>";
		if(message.Temperature6 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 6 " + message.Temperature6 + " &#176;C<br>";
		if(message.Temperature7 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 7 " + message.Temperature7 + " &#176;C<br>";
		if(message.Temperature8 != -1000) textMessage += MobiScout.Tab.Translations.Temperatuur + " 8 " + message.Temperature8 + " &#176;C<br>";
		
		if(message.IO1 == true) textMessage += "IO 1 " + MobiScout.Tab.Translations.Aangeschakeld + "<br>";
		if(message.IO2 == true) textMessage += "IO 2 " + MobiScout.Tab.Translations.Aangeschakeld + "<br>";
		if(message.IO3 == true) textMessage += "IO 3 " + MobiScout.Tab.Translations.Aangeschakeld + "<br>";
	}
	if(!isBlank(textMessage)) messageToDisplay += '<p style="white-space:normal; color:gray;">' + textMessage + ' </p>';
	
	if (imageSN > 0) {
        var imageURL = WebServiceURL + webServicePage + '/getPicture?pictureSN=' + imageSN;
        // img tag toevoegen, simpel
        messageToDisplay += '<img style="border-radius: 5px;" width="100%" height="auto" src="' + imageURL + '">';
    }
	
	messageToDisplay += '</div></fieldset>';
	return messageToDisplay;
}

MobiScout.Tab.UI.GenerateVersionTable = function(appVersion, compName){
 	var versionTable = '<table style="width:100%; font-size: 10px;font-weight: bold;color:gray;">';
 	versionTable += '<tr>';
 	versionTable += '<td style="width:50%"></td>';
 	versionTable += '<td style="width:50%"></td>';
 	versionTable += '</tr>';
 	
 	versionTable += '<tr>';
 	versionTable += '<td style="width:50%">' + MobiScout.Tab.Translations.SoftwareVersie + '</td>';
 	versionTable += '<td style="width:50%">' + appVersion + '</td>';
 	versionTable += '</tr>';
 	versionTable += '<tr>';
 	versionTable += '<td style="width:50%">' + MobiScout.Tab.Translations.SoftwareDatum + '</td>';
 	versionTable += '<td style="width:50%">' + applicationBuildDate + '</td>';
 	versionTable += '</tr>';
 	if(!isBlank(availableVersion)){
	 	versionTable += '<tr>';
	 	versionTable += '<td style="width:50%">' + MobiScout.Tab.Translations.SoftwareAvailable + '</td>';
	 	versionTable += '<td style="width:50%">' + availableVersion + '</td>';
	 	versionTable += '</tr>';
 	}
 	if(!isBlank(WebServiceURL)){
	 	versionTable += '<tr>';
	 	versionTable += '<td style="width:50%">' + MobiScout.Tab.Translations.ServerAdres + '</td>';
	 	versionTable += '<td style="width:50%">' + WebServiceURL.replace("http://", "").replace("https://", "") + '</td>';
	 	versionTable += '</tr>';
 	}
 	if(!isBlank(compName)){
	 	versionTable += '<tr>';
	 	versionTable += '<td style="width:50%">' + MobiScout.Tab.Translations.Bedrijfsnaam + '</td>';
	 	versionTable += '<td style="width:50%">' + compName + '</td>';
	 	versionTable += '</tr>';
 	}
 	versionTable += '</table>';
 	return versionTable;
}

MobiScout.Tab.UI.ShowToast = function(text){
	try{
		if(window.MobiScoutApp){
			window.MobiScoutApp.ShowToast(text);
		}
	}catch(Err){
	}
}
	
MobiScout.Tab.UI.refreshScreen = function () {
       
    };	
    
MobiScout.Tab.UI.SwingElement = function(sender){
	$(sender).fadeOut(200).fadeIn(200);
	/*$(sender).animateRotate(360, { duration: 500, easing: 'linear', 
		complete: function () {
			//$(sender).animateRotate(180, { duration: 500, easing: 'linear' });
		}
	});*/    
};
	
MobiScout.Tab.UI.ShowGroupOnMap = function(departmentID){	
	// navigeer naar de kaart
	MobiScout.Tab.Mapping.VisibleDepartmentID = departmentID;
	MobiScout.Tab.ChangePage("map");
	//setTimeout(MobiScout.Tab.Mapping.ShowGroupOnMap(departmentID), 500);
};



MobiScout.Tab.UI.AnimateControl = function (element){
	$(element).fadeOut();
	$(element).fadeIn();
	//var x = $(element).css('backgroundColor');
	//$(element).animate({backgroundColor: '#FFBF80'}, 150);
	//$(element).animate({backgroundColor: x}, 50);
	//$(element).animate({borderWidth:'+2'});
	//$(element).animate({borderWidth:'-2'});
	
	
}

MobiScout.Tab.UI.GenerateTrailerDescription = function(trailerid){
	var trailerdescr = MobiScout.Tab.App.GetTrailerPlate(trailerid);
	trailerdescr = String(trailerdescr);
	if(TrimString(String(trailerid)) == TrimString(trailerdescr)){
		return trailerid;
	}
	return trailerdescr + " (" + trailerid + ")";
}
    
MobiScout.Tab.UI.ShowVehicleContextMenu = function(){
    	$('<div>').simpledialog2({
		    mode: 'button',
		    headerText: "Modules ...",
		    headerClose: false,
		    buttonPrompt: false,
		    transition: 'none',
		    //themeDialog: 'a',
		    animate: false,
		    
		    buttons : {
		    	'Kaart': {
		        click: function () { 
		          MobiScout.Tab.Mapping.CenterOnVehicleID(MobiScout.Tab.App.LastSelectedVehicleID);
		        },
		        icon: "location",
		        iconpos: "right"
		      },
		      'Alarm berichten': {
		        click: function () { 
		          MobiScout.Tab.ChangePage("alerts");
		        },
		        icon: "alert",
		        iconpos: "right"
		      },
		      'Berichten dialoog': {
		        click: function () { 
		          MobiScout.Tab.ChangePage("messagedialog");
		        },
		        icon: "bullets",
		        iconpos: "right"
		      },
		      'Ritten en stops': {
		        click: function () { 
		          //console.log("Naar ritten en stops!");
		          MobiScout.Tab.App.LoadTripsForVehicle(MobiScout.Tab.App.LastSelectedVehicleID);
		        },
		        icon: "calendar",
		        iconpos: "right"
		      },
		      'Route': {
		        click: function () { 
		          //MobiScout.Tab.Mapping.StartPlotVehicleRouteOnMap(MobiScout.Tab.App.LastSelectedVehicleID);
		          // set date
		          $( "#select-date" ).datepicker( "setDate", MobiScout.Tab.GetCurrentDate() );
		          MobiScout.Tab.App.ActionFromDateSelection = 1;
		          MobiScout.Tab.ChangePage("dateselection");
		        },
		        icon: "navigation",
		        iconpos: "right"
		      },
		      
		      
		      /*'Temperaturen': {
		        click: function () { 
		          //console.log("Naar temperaturen!");
		        },
		        icon: "eye",
		        iconpos: "right"
		        
		      },
		      'Aktiviteiten': {
		        click: function () { 
		          //console.log("Naar aktiviteiten!");
		        },
		        icon: "clock",
		        iconpos: "right"
		        
		      },*/
		      
		      'Annuleren': {
		        click: function () { 
		          
		        },
		        icon: "delete",
		        iconpos: "right",
		        theme: "c"
		      }
		    }
	  });
    };    
    
MobiScout.Tab.UI.SetPlaceHolderForListView = function(listname, newplaceholder){
	try{
		$("#" + listname).prev().find(".ui-input-search input").attr("placeholder", newplaceholder);
	}
	catch(Err){
		MobiScout.Tab.LogToConsole("Failed to set placeholder" + Err);
	}
	
};    