MobiScout.Tab.ChangePage = function(page){
	MobiScout.Tab.App.LastPageID = $('.ui-page-active').attr('id');
	if(MobiScout.Tab.App.PageTransistionsAlwaysNone == true){
		MobiScout.Tab.App.SetActivePageTransition('none');
		$.mobile.changePage("#" + page, {transition: 'none'});
		
	}
	else{
		$.mobile.changePage("#" + page, {transition: pageTransition});
	}
}

MobiScout.Tab.FilterVehicles = function(sender, e){
	try{
		$("#select-vehicles").empty();
	    var toggle = "";
	    var searchString = $(sender).val().toLowerCase();
	    var firstID = undefined;
	    if(!isBlank(searchString)){
		    for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
				if(MobiScout.Tab.App.VehicleList[i].Plate.toLowerCase().indexOf(searchString) != -1 || MobiScout.Tab.App.VehicleList[i].ID.toString().toLowerCase().indexOf(searchString) != -1 ){
		        	if(firstID == undefined) firstID = MobiScout.Tab.App.VehicleList[i].ID;
			    	toggle = $('<option value="' + MobiScout.Tab.App.VehicleList[i].ID + '">' + MobiScout.Tab.App.VehicleList[i].Plate + " (" + MobiScout.Tab.App.VehicleList[i].ID + ")" + '</option>');
			        $("#select-vehicles").append(toggle);
		        }
		    }
		    try {
		    	var el = $('#select-vehicles');
		    	el.val(firstID).attr('selected', true).siblings('option').removeAttr('selected');
		        el.selectmenu("refresh", true);
		    	// text updaten
		        MobiScout.Tab.App.VehicleToSendTo = parseInt($("#select-vehicles").val(), 10);
				$("#lblNewTextMsg").text(MobiScout.Tab.Translations.NaarVoertuig + " " + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.VehicleToSendTo) + " [" + MobiScout.Tab.App.VehicleToSendTo + "]");
		        
		   	}
		    catch(Err){
		    }
	    }
	    else{
	    	MobiScout.Tab.BuildVehicleList();
	    	// text updaten
	    	MobiScout.Tab.App.VehicleToSendTo = parseInt($("#select-vehicles").val(), 10);
			$("#lblNewTextMsg").text(MobiScout.Tab.Translations.NaarVoertuig + " " + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.VehicleToSendTo) + " [" + MobiScout.Tab.App.VehicleToSendTo + "]");
	    	
	    }
	    
	    $("#select-vehicles").trigger("refresh");
	}
	catch(ex){
	}
	return true;
}


MobiScout.Tab.FilterVehiclesNFC = function(sender, e){
	try{
		$("#select-vehicles-nfc").empty();
	    var toggle = "";
	    var searchString = $(sender).val().toLowerCase();
	    var firstID = undefined;
	    if(!isBlank(searchString)){
		    for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
				if(MobiScout.Tab.App.VehicleList[i].Plate.toLowerCase().indexOf(searchString) != -1 || MobiScout.Tab.App.VehicleList[i].ID.toString().toLowerCase().indexOf(searchString) != -1 ){
		        	if(firstID == undefined) firstID = MobiScout.Tab.App.VehicleList[i].ID;
			    	toggle = $('<option value="' + MobiScout.Tab.App.VehicleList[i].ID + '">' + MobiScout.Tab.App.VehicleList[i].Plate + " (" + MobiScout.Tab.App.VehicleList[i].ID + ")" + '</option>');
			        $("#select-vehicles-nfc").append(toggle);
		        }
		    }
		    try {
		    	var el = $('#select-vehicles-nfc');
		    	el.val(firstID).attr('selected', true).siblings('option').removeAttr('selected');
		        el.selectmenu("refresh", true);
		   	}
		    catch(Err){
		    }
	    }
	    else{
	    	MobiScout.Tab.BuildVehicleListNFC();
	    }
	    
	    $("#select-vehicles-nfc").trigger("refresh");
	}
	catch(ex){
	}
	return true;
}

MobiScout.Tab.FilterTrailersNFC = function(sender, e){
	try{
		$("#select-trailers-nfc").empty();
	    var toggle = "";
	    var searchString = $(sender).val().toLowerCase();
	    var firstID = undefined;
	    if(!isBlank(searchString)){
		    for (var i = 0; i < MobiScout.Tab.App.TrailerList.length; i++) {
				if(MobiScout.Tab.App.TrailerList[i].Plate.toLowerCase().indexOf(searchString) != -1 || MobiScout.Tab.App.TrailerList[i].ID.toString().toLowerCase().indexOf(searchString) != -1 ){
		        	if(firstID == undefined) firstID = MobiScout.Tab.App.TrailerList[i].ID;
			    	toggle = $('<option value="' + MobiScout.Tab.App.TrailerList[i].ID + '">' + MobiScout.Tab.App.TrailerList[i].Plate + " (" + MobiScout.Tab.App.TrailerList[i].ID + ")" + '</option>');
			        $("#select-trailers-nfc").append(toggle);
		        }
		    }
		    try {
		    	var el = $('#select-trailers-nfc');
		    	el.val(firstID).attr('selected', true).siblings('option').removeAttr('selected');
		        el.selectmenu("refresh", true);
		   	}
		    catch(Err){
		    }
	    }
	    else{
	    	MobiScout.Tab.BuildTrailerListNFC();
	    }
	    
	    $("#select-trailers-nfc").trigger("refresh");
	}
	catch(ex){
	}
	return true;
}

MobiScout.Tab.FilterDriversNFC = function(sender, e){
	try{
		$("#select-drivers-nfc").empty();
	    var toggle = "";
	    var searchString = $(sender).val().toLowerCase();
	    var firstID = undefined;
	    if(!isBlank(searchString)){
		    for (var i = 0; i < MobiScout.Tab.App.DriverList.length; i++) {
				if(MobiScout.Tab.App.DriverList[i].Name.toLowerCase().indexOf(searchString) != -1 || MobiScout.Tab.App.DriverList[i].ID.toString().toLowerCase().indexOf(searchString) != -1 ){
		        	if(firstID == undefined) firstID = MobiScout.Tab.App.DriverList[i].ID;
			    	toggle = $('<option value="' + MobiScout.Tab.App.DriverList[i].ID + '">' + MobiScout.Tab.App.DriverList[i].Name + " (" + MobiScout.Tab.App.DriverList[i].ID + ")" + '</option>');
			        $("#select-drivers-nfc").append(toggle);
		        }
		    }
		    try {
		    	var el = $('#select-drivers-nfc');
		    	el.val(firstID).attr('selected', true).siblings('option').removeAttr('selected');
		        el.selectmenu("refresh", true);
		   	}
		    catch(Err){
		    }
	    }
	    else{
	    	MobiScout.Tab.BuildDriverList();
	    }
	    
	    $("#select-drivers-nfc").trigger("refresh");
	}
	catch(ex){
	}
	return true;
}

MobiScout.Tab.FilterUsersNFC = function(sender, e){
	try{
		$("#select-users-nfc").empty();
	    var toggle = "";
	    var searchString = $(sender).val().toLowerCase();
	    var firstID = undefined;
	    if(!isBlank(searchString)){
		    for (var i = 0; i < MobiScout.Tab.App.UserList.length; i++) {
				if(MobiScout.Tab.App.UserList[i].Name.toLowerCase().indexOf(searchString) != -1 || MobiScout.Tab.App.UserList[i].UserID.toString().toLowerCase().indexOf(searchString) != -1 ){
		        	if(firstID == undefined) firstID = MobiScout.Tab.App.UserList[i].UserID;
			    	toggle = $('<option value="' + MobiScout.Tab.App.UserList[i].UserID + '">' + MobiScout.Tab.App.UserList[i].Name + '</option>');
			        $("#select-users-nfc").append(toggle);
		        }
		    }
		    try {
		    	var el = $('#select-users-nfc');
		    	el.val(firstID).attr('selected', true).siblings('option').removeAttr('selected');
		        el.selectmenu("refresh", true);
		   	}
		    catch(Err){
		    }
	    }
	    else{
	    	MobiScout.Tab.BuildUserList();
	    }
	    
	    $("#select-users-nfc").trigger("refresh");
	}
	catch(ex){
	}
	return true;
}

MobiScout.Tab.HandleNFCTag = function(nfcEvent){
	console.log("MobiScout.Tab.HandleNFCTag event type: " + nfcEvent.type)
	console.log("MobiScout.Tab.HandleNFCTag event tag: " + nfcEvent.tag)
}

MobiScout.Tab.PreventCanvasGhosting = function(){
	// set canvas overflow to prevent ghosting
	$("canvas").parents("*").css("overflow", "visible");
}

MobiScout.Tab.ConvertMinutesToTimeSpan = function(inmin){
	if(inmin < 0) inmin = 0;
  	var hours = Math.floor( inmin / 60);          
    var minutes = inmin % 60;
    return (hours < 10 ? "0" + hours : hours) + ":" + (minutes < 10 ? "0" + minutes : minutes) ;
}

MobiScout.Tab.ConvertMinutesToTimeSpanReadable = function(inmin){
  	var hours = Math.floor( inmin / 60);          
    var minutes = inmin % 60;
    return (hours < 10 ? "0" + hours : hours) + " u " + (minutes < 10 ? "0" + minutes : minutes) + " m";
}

MobiScout.Tab.GetCurrentDate = function () {
    var now = new Date();
    now.setTime(now.getTime());
    return now;
}

MobiScout.Tab.AutoLogonPlanner = function(){
	if (!MobiScout.Tab.Data.LoadLocalData("PlannerNaam") || !MobiScout.Tab.Data.LoadLocalData("PlannerWachtwoord")) {
    	MobiScout.Tab.ChangePage("settings");
    	MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.VulGegevensIn); 
  	}
    else {
        MobiScout.Tab.App.LogonPlanner();
    } 
};

MobiScout.Tab.decodeBase64 = function(input) {
	return Base64.decode(input);
};

MobiScout.Tab.encodeBase64 = function(input){
	return Base64.encode(input);
};


MobiScout.Tab.ClearAutorisations = function(){
	authorisationForMap = false; 
	authorisationForVehicles = false;
	authorisationForEmployees = false;
	authorisationForTrailers = false;
	authorisationForTrips = false;
	authorisationForHours = false;
	authorisationForMessages = false;
	authorisationForMessageDialog = false;
	authorisationForRoute = false;
	authorisationForPeriodView = false;
	authorisationForCAO = false;
	authorisationForRealtimeHours = false;
	authorisationForAlerts = false;
	authorisationForTemperature = false;
	authorisationForDrivingTimes = false;
	authorisationForCanbus = false;
	authorisationForFuelUsage = false; 
	MobiScout.Tab.Data.ClearAutorisations();
}

MobiScout.Tab.SaveSettings = function(){

        var reconnectAfterSave = false;
        // indien de service URL veranderd is, dan moeten we ook opnieuw aanmelden + config ophalen
		// kijk of de gebruiker gewijzigd is... dan autorisaties verwijderen en straks config opnieuw laden
		if(MobiScout.Tab.Data.LoadLocalData("PlannerNaam")){
			MobiScout.Tab.LogToConsole(MobiScout.Tab.Data.LoadLocalData("PlannerNaam") + " vs " + plannernaam.value); 
			if(MobiScout.Tab.Data.LoadLocalData("PlannerNaam") != plannernaam.value){
				MobiScout.Tab.ClearAutorisations();
				MobiScout.Tab.Data.ClearLocalData(); // alles weggooien, dat is beter
				reconnectAfterSave = true;
			}
		}
		
		

        MobiScout.Tab.Data.SaveLocalData("PlannerNaam", plannernaam.value);
        MobiScout.Tab.Data.SaveLocalData("PlannerWachtwoord", MobiScout.Tab.encodeBase64(plannerwachtwoord.value));
        
        if (MobiScout.Tab.Data.LoadLocalData("SecureConnection") == 'true' || MobiScout.Tab.Data.LoadLocalData("SecureConnection") == true) {
        	if(!checkSecureConnection.checked) reconnectAfterSave = true;
        }
        else if (MobiScout.Tab.Data.LoadLocalData("SecureConnection") == 'false' || MobiScout.Tab.Data.LoadLocalData("SecureConnection") == false) {
        	if(checkSecureConnection.checked) reconnectAfterSave = true;
        }
        
        
        MobiScout.Tab.Data.SaveLocalData("SecureConnection", checkSecureConnection.checked);
		if (MobiScout.Tab.Data.LoadLocalData("SecureConnection") == 'true' || MobiScout.Tab.Data.LoadLocalData("SecureConnection") == true) {
			SecureConnection = true;
		}
		else{
			SecureConnection = false;
		}
        
        var correctstrURL = serviceurl.value;
        correctstrURL = correctstrURL.replace(/\s+/g, '');
        correctstrURL = correctstrURL.trim();
		if (endsWith(correctstrURL, ".")){
			correctstrURL = correctstrURL.substring(0, correctstrURL.length - 1);
		}
		correctstrURL = correctstrURL.trim();
        serviceurl.value = correctstrURL;
        
        try
        {
        	var strURL = MobiScout.Tab.Data.LoadLocalData("ServiceURL");
        	if(strURL != serviceurl.value){
    			reconnectAfterSave = true;
    			MobiScout.Tab.Data.RemoveLocalData("availableVersion");
    			MobiScout.Tab.Data.RemoveLocalData("availableURL");
    			availableVersion = "";
    			availableURL = "";
        	}
        }
        catch(Err){}
        
        MobiScout.Tab.Data.SaveLocalData("ServiceURL", serviceurl.value);
        refreshInterval = Number(refreshinterval.value);
        MobiScout.Tab.Data.SaveLocalData("RefreshInterval", refreshInterval);
        //messageReminderInterval = Number(messagereminderinterval.value);
        //MobiScout.Tab.Data.SaveLocalData("MessageReminderInterval", messageReminderInterval);
        try{
	        if(window.MobiScoutApp){
	         	window.MobiScoutApp.SetRefreshInterval(refreshInterval);
	        }
        }catch(Err){}
        
        try{
	        vehicleSelectMethod = parseInt($('#vehiclemethod').val(), 10);
	        if(vehicleSelectMethod < 1 && vehicleSelectMethod > 8) vehicleSelectMethod = 1;
	        MobiScout.Tab.Data.SaveLocalData("VehicleSelectMethod", vehicleSelectMethod);
        }
        catch(Err){
        }
        try{
	        driverSelectMethod = parseInt($('#drivermethod').val(), 10);
	        if(driverSelectMethod < 1 && driverSelectMethod > 2) driverSelectMethod = 1;
	        MobiScout.Tab.Data.SaveLocalData("DriverSelectMethod", driverSelectMethod);
        }
        catch(Err){
        }
        try{
	        var newLanguageID = parseInt($('#languageselect').val(), 10);
	        MobiScout.Tab.Data.SaveLocalData("LanguageID", newLanguageID);
	        if(newLanguageID != LanguageID) {
	        	LanguageID = newLanguageID;
	        	reconnectAfterSave = true;
	        	MobiScout.Tab.Translations.switchLanguage();
	        }
	        LanguageID = newLanguageID;
	         
	        
        }
        catch(Err){
        }
        
        
        
        
        try{
	        notificationSound = parseInt($('#notificationsound').val(), 10);
	        if(notificationSound < 1 && notificationSound > 6) notificationSound = 1;
	        MobiScout.Tab.Data.SaveLocalData("NotificationSound", notificationSound);
        }
        catch(Err){
        }
        try{
        	if($("#toggletranslatepositions").val() == "on"){
        		translatePositions = true;
        	}
        	else{
        		translatePositions = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("TranslatePositions", translatePositions);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save TranslatePositions: "+ Err);
        }

        try{
        	if($("#togglemessagereminder").val() == "on"){
        		reminderMessages = true;
        	}
        	else{
        		reminderMessages = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("ReminderMessages", reminderMessages);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save ReminderMessages: "+ Err);
        }
        
        try {
	         if ($("#togglemessagedelivery").val() == "on") {
	             confirmMessages = true;
	         }
	         else {
	             confirmMessages = false;
	         }
	         MobiScout.Tab.Data.SaveLocalData("ConfirmMessages", confirmMessages);
	     }
	     catch (Err) {
	         MobiScout.Tab.LogToConsole("failed to save ConfirmMessages: " + Err);
	     }
	     
        try{
        	if($("#toggleuseserverimages").val() == "on"){
        		UseServerImages = true;
        	}
        	else{
        		UseServerImages = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseServerImages", UseServerImages);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseServerImages: "+ Err);
        }
        try{
        	if($("#toggleuseserverimagesinlist").val() == "on"){
        		UseServerImagesInList = true;
        	}
        	else{
        		UseServerImagesInList = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseServerImagesInList", UseServerImagesInList);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseServerImagesInList: "+ Err);
        }
        
        try{
        	if($("#toggleuseactchange").val() == "on"){
        		useLastActChange = true;
        	}
        	else{
        		useLastActChange = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("useLastActChange", useLastActChange);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save useLastActChange: "+ Err);
        }
        
        
        try{
        	if($("#toggleshowgraphsinlist").val() == "on"){
        		showGraphsInEmployeeList = true;
        	}
        	else{
        		showGraphsInEmployeeList = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("showGraphsInEmployeeList", showGraphsInEmployeeList);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save showGraphsInEmployeeList: "+ Err);
        }
        
        try{
        	if($("#toggleusedepartments").val() == "on"){
        		UseDepartments = true;
        	}
        	else{
        		UseDepartments = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseDepartments", UseDepartments);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseDepartments: "+ Err);
        }

		try{
        	if($("#toggleuseclustering").val() == "on"){
        		UseClustering = true;
        	}
        	else{
        		UseClustering = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseClustering", UseClustering);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseClustering: "+ Err);
        }
        
        try{
        	if($("#toggleusetrafficinfo").val() == "on"){
        		UseTrafficInfo = true;
        	}
        	else{
        		UseTrafficInfo = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseTrafficInfo", UseTrafficInfo);
        	
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseTrafficInfo: "+ Err);
        }
        
        
        try{
        	if($("#togglecountalertmessages").val() == "on"){
        		if(countAlertMessages == false) reconnectAfterSave = true;
        		countAlertMessages = true;
        		$('#btnmenu_alerts').css('display','block');
        		
        	}
        	else{
        		if(countAlertMessages == true) reconnectAfterSave = true;
        		countAlertMessages = false;
        		$('#btnmenu_alerts').css('display','none');
        	}
        	MobiScout.Tab.Data.SaveLocalData("CountAlertMessages", countAlertMessages);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save CountAlertMessages: "+ Err);
        }
        
        try{
        	if($("#toggletouchsound").val() == "on"){
        		UseTickSound = true;
        	}
        	else{
        		UseTickSound = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseTickSound", UseTickSound);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseTickSound: "+ Err);
        }
        
        try{
        	if($("#toggletouchhaptic").val() == "on"){
        		UseHapticFeedback = true;
        	}
        	else{
        		UseHapticFeedback = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseHapticFeedback", UseHapticFeedback);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseHapticFeedback: "+ Err);
        }
        
        
        try{
        	if($("#togglepageanimation").val() == "on"){
        		if(pageTransition == 'none') reconnectAfterSave = true;
        		pageTransition = pageTransitionIfActive;
        	}
        	else{
        		if(pageTransition != 'none') reconnectAfterSave = true;
        		pageTransition = 'none';
        	}
        	MobiScout.Tab.Data.SaveLocalData("pageTransition", pageTransition);
        	MobiScout.Tab.App.SetActivePageTransition();
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save pageTransition: "+ Err);
        }

        try{
        	if($("#togglecanbus").val() == "on"){
        		if(UseCanbus == false) reconnectAfterSave = true;
        		UseCanbus = true;
        	}
        	else{
        		if(UseCanbus == true) reconnectAfterSave = true;
        		UseCanbus = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("UseCanbus", UseCanbus);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save UseCanbus: "+ Err);
        }
        
        try{
        	if($("#toggletrips").val() == "on"){
        		if(showTripInformation == false) reconnectAfterSave = true;
        		showTripInformation = true;
        		$('#btnmenu_trips').css('display','block');
        	}
        	else{
        		if(showTripInformation == true) reconnectAfterSave = true;
        		showTripInformation = false;
        		$('#btnmenu_trips').css('display','none');
        	}
        	MobiScout.Tab.Data.SaveLocalData("showTripInformation", showTripInformation);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save showTripInformation: "+ Err);
        }
        try{
        	if($("#toggleshowvehicleplate").val() == "on") showVehiclePlate = true;
        	else showVehiclePlate = false;
        	MobiScout.Tab.Data.SaveLocalData("showVehiclePlate", showVehiclePlate);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save showVehiclePlate: "+ Err);
        }
        try{
        	if($("#toggleshowtrailerplate").val() == "on") showTrailerPlate = true;
        	else showTrailerPlate = false;
        	MobiScout.Tab.Data.SaveLocalData("showTrailerPlate", showTrailerPlate);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save showTrailerPlate: "+ Err);
        }
        
        
        try{
        	if($("#toggletemperature").val() == "on"){
        		if(showTemperatureInformation == false) reconnectAfterSave = true;
        		showTemperatureInformation = true;
        	}
        	else{
        		if(showTemperatureInformation == true) reconnectAfterSave = true;
        		showTemperatureInformation = false;
        	}
        	MobiScout.Tab.Data.SaveLocalData("showTemperatureInformation", showTemperatureInformation);
        }
        catch(Err){
        	MobiScout.Tab.LogToConsole("failed to save showTemperatureInformation: "+ Err);
        }

        
        if (MobiScout.Tab.Data.LoadLocalData("ServiceURL")) {
            var strURL = MobiScout.Tab.Data.LoadLocalData("ServiceURL");
            if (strURL != "") {
                if (startsWith(strURL, "http")) {
                	if(!endsWith(strURL,"/")){
                		strURL += "/";
                	}
                    WebServiceURL = strURL;
                }
                else {
                	if(SecureConnection == true){
                		WebServiceURL = "https://" + strURL + "/";
                	}
                	else{
                    	WebServiceURL = "http://" + strURL + "/";
                    }
                }
            }
        }
        // controleer of de URL gewijzigd is, indien ja:
        if(reconnectAfterSave == true){ 
        	MobiScout.Tab.App.ClearData();
        }
        
        if(UseTrafficInfo == true) MobiScout.Tab.Mapping.InitializeTraffic();
        else MobiScout.Tab.Mapping.RemoveTrafficLayer();
        if(UseClustering == true) MobiScout.Tab.Mapping.SetClusterer();
        else MobiScout.Tab.Mapping.RemoveClusterer();
        
        MobiScout.Tab.UI.Vehicle.GenerateCircularMenu(true);
        
        MobiScout.Tab.ChangePage("home");
}

MobiScout.Tab.FillSettingsScreen = function(){
	 try {
		if (MobiScout.Tab.Data.LoadLocalData("PlannerNaam")) plannernaam.value = MobiScout.Tab.Data.LoadLocalData("PlannerNaam");
	    if (MobiScout.Tab.Data.LoadLocalData("PlannerWachtwoord")) plannerwachtwoord.value = MobiScout.Tab.decodeBase64(MobiScout.Tab.Data.LoadLocalData("PlannerWachtwoord"));
	    if (MobiScout.Tab.Data.LoadLocalData("RefreshInterval")) {
	    	refreshinterval.value = Number(MobiScout.Tab.Data.LoadLocalData("RefreshInterval"));
	    	$("#refreshinterval").slider('refresh'); 
	    }
	    
	    if (MobiScout.Tab.Data.LoadLocalData("SecureConnection")) {

            if (MobiScout.Tab.Data.LoadLocalData("SecureConnection") == 'true' || MobiScout.Tab.Data.LoadLocalData("SecureConnection") == true) {
            	SecureConnection = true;
                $("#checkSecureConnection").attr("checked", true).checkboxradio('refresh');
            }
            else {
            	SecureConnection = false;
                $("#checkSecureConnection").attr("checked", false).checkboxradio('refresh');
            }
        }
	    
	    //if (MobiScout.Tab.Data.LoadLocalData("MessageReminderInterval")) {
	    //	messagereminderinterval.value = Number(MobiScout.Tab.Data.LoadLocalData("MessageReminderInterval"));
	    //	$("#messagereminderinterval").slider('refresh'); 
	    //}
	    if (MobiScout.Tab.Data.LoadLocalData("VehicleSelectMethod")) {
	    	vehiclemethod.value = Number(MobiScout.Tab.Data.LoadLocalData("VehicleSelectMethod"));
	    	$("#vehiclemethod").selectmenu('refresh'); 
	    }
	    if (MobiScout.Tab.Data.LoadLocalData("DriverSelectMethod")) {
	    	drivermethod.value = Number(MobiScout.Tab.Data.LoadLocalData("DriverSelectMethod"));
	    	$("#drivermethod").selectmenu('refresh'); 
	    }
	    
	    if (MobiScout.Tab.Data.LoadLocalData("LanguageID")) {
	    	languageselect.value = Number(MobiScout.Tab.Data.LoadLocalData("LanguageID"));
	    	$("#languageselect").selectmenu('refresh'); 
	    }
	    
	    if (MobiScout.Tab.Data.LoadLocalData("NotificationSound")) {
	    	notificationsound.value = Number(MobiScout.Tab.Data.LoadLocalData("NotificationSound"));
	    	$("#notificationsound").selectmenu('refresh'); 
	    }
	    else {
	    	notificationsound.value = Number(notificationSound);
	    	$("#notificationsound").selectmenu('refresh'); 
	    }
	    if (MobiScout.Tab.Data.LoadLocalData("TranslatePositions")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("TranslatePositions");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		translatePositions = true;
        	}
        	else{
        		translatePositions = false;
        	}
	    }
	    if(translatePositions == true) $("#toggletranslatepositions").val('on').slider('refresh');
	    else $("#toggletranslatepositions").val('off').slider('refresh');
	    
	    
	    if (MobiScout.Tab.Data.LoadLocalData("UseServerImages")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("UseServerImages");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		UseServerImages = true;
        	}
        	else{
        		UseServerImages = false;
        	}
	    }
	    
	    if(UseServerImages == true) $("#toggleuseserverimages").val('on').slider('refresh');
	    else $("#toggleuseserverimages").val('off').slider('refresh');
	    
	    
    	if (MobiScout.Tab.Data.LoadLocalData("UseServerImagesInList")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("UseServerImagesInList");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		UseServerImagesInList = true;
        	}
        	else{
        		UseServerImagesInList = false;
        	}
	    }
	    
	    if(UseServerImagesInList == true) $("#toggleuseserverimagesinlist").val('on').slider('refresh');
	    else $("#toggleuseserverimagesinlist").val('off').slider('refresh');
	    

    	if (MobiScout.Tab.Data.LoadLocalData("useLastActChange")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("useLastActChange");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		useLastActChange = true;
        	}
        	else{
        		useLastActChange = false;
        	}
	    }
	    
	    if(useLastActChange == true) $("#toggleuseactchange").val('on').slider('refresh');
	    else $("#toggleuseactchange").val('off').slider('refresh');


	    
	    if (MobiScout.Tab.Data.LoadLocalData("showGraphsInEmployeeList")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("showGraphsInEmployeeList");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		showGraphsInEmployeeList = true;
        	}
        	else{
        		showGraphsInEmployeeList = false;
        	}
	    }
	    
	    if(showGraphsInEmployeeList == true) $("#toggleshowgraphsinlist").val('on').slider('refresh');
	    else $("#toggleshowgraphsinlist").val('off').slider('refresh');
	    
	    
	    if (MobiScout.Tab.Data.LoadLocalData("UseDepartments")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("UseDepartments");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		UseDepartments = true;
        	}
        	else{
        		UseDepartments = false;
        	}
	    }
	    if(UseDepartments == true) $("#toggleusedepartments").val('on').slider('refresh');
	    else $("#toggleusedepartments").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("UseClustering")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("UseClustering");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		UseClustering = true;
        	}
        	else{
        		UseClustering = false;
        	}
	    }
	    if(UseClustering == true) $("#toggleuseclustering").val('on').slider('refresh');
	    else $("#toggleuseclustering").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("UseTrafficInfo")) {
	    	var tp = MobiScout.Tab.Data.LoadLocalData("UseTrafficInfo");
	    	if(tp == true || tp == 'true' || tp.toUpperCase() == 'TRUE'){
        		UseTrafficInfo = true;
        	}
        	else{
        		UseTrafficInfo = false;
        	}
	    }
	    
	    if(UseTrafficInfo == true) $("#toggleusetrafficinfo").val('on').slider('refresh');
	    else $("#toggleusetrafficinfo").val('off').slider('refresh');
	    
	    
	    if (MobiScout.Tab.Data.LoadLocalData("ReminderMessages")) {
	    	var mr = MobiScout.Tab.Data.LoadLocalData("ReminderMessages");
	    	if(mr == true || mr == 'true' || mr.toUpperCase() == 'TRUE'){
        		reminderMessages = true;
        	}
        	else{
        		reminderMessages = false;
        	}
	    }
	    
	    if(reminderMessages == true) $("#togglemessagereminder").val('on').slider('refresh');
	    else $("#togglemessagereminder").val('off').slider('refresh');
	    
	    
	    if (MobiScout.Tab.Data.LoadLocalData("ConfirmMessages")) {
            var cr = MobiScout.Tab.Data.LoadLocalData("ConfirmMessages");
            if (cr == true || cr == 'true' || cr.toUpperCase() == 'TRUE') {
                confirmMessages = true;
            }
            else {
                confirmMessages = false;
            }
        }

        if (confirmMessages == true) $("#togglemessagedelivery").val('on').slider('refresh');
        else $("#togglemessagedelivery").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("CountAlertMessages")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("CountAlertMessages");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		countAlertMessages = true;
        	}
        	else{
        		countAlertMessages = false;
        	}
	    }
	    if(countAlertMessages == true) $("#togglecountalertmessages").val('on').slider('refresh');
	    else $("#togglecountalertmessages").val('off').slider('refresh');
	    
		if (MobiScout.Tab.Data.LoadLocalData("UseTickSound")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("UseTickSound");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		UseTickSound = true;
        	}
        	else{
        		UseTickSound = false;
        	}
	    }
	    if(UseTickSound == true) $("#toggletouchsound").val('on').slider('refresh');
	    else $("#toggletouchsound").val('off').slider('refresh');
	    	    
	    if (MobiScout.Tab.Data.LoadLocalData("UseHapticFeedback")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("UseHapticFeedback");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		UseHapticFeedback = true;
        	}
        	else{
        		UseHapticFeedback = false;
        	}
	    }
	    if(UseHapticFeedback == true) $("#toggletouchhaptic").val('on').slider('refresh');
	    else $("#toggletouchhaptic").val('off').slider('refresh');
	    
	    
	    if (MobiScout.Tab.Data.LoadLocalData("pageTransition")) {
	    	pageTransition = MobiScout.Tab.Data.LoadLocalData("pageTransition");
	    }
	    if(pageTransition != pageTransitionIfActive) pageTransition = 'none';
	    if(pageTransition == pageTransitionIfActive) $("#togglepageanimation").val('on').slider('refresh');
	    else $("#togglepageanimation").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("UseCanbus")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("UseCanbus");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		UseCanbus = true;
        	}
        	else{
        		UseCanbus = false;
        	}
	    }
	    if(UseCanbus == true) $("#togglecanbus").val('on').slider('refresh');
	    else $("#togglecanbus").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("showTripInformation")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("showTripInformation");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		showTripInformation = true;
        	}
        	else{
        		showTripInformation = false;
        	}
	    }
	    if(showTripInformation == true) $("#toggletrips").val('on').slider('refresh');
	    else $("#toggletrips").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("showVehiclePlate")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("showVehiclePlate");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		showVehiclePlate = true;
        	}
        	else{
        		showVehiclePlate = false;
        	}
	    }
	    if(showVehiclePlate == true) $("#toggleshowvehicleplate").val('on').slider('refresh');
	    else $("#toggleshowvehicleplate").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("showTrailerPlate")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("showTrailerPlate");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		showTrailerPlate = true;
        	}
        	else{
        		showTrailerPlate = false;
        	}
	    }
	    if(showTrailerPlate == true) $("#toggleshowtrailerplate").val('on').slider('refresh');
	    else $("#toggleshowtrailerplate").val('off').slider('refresh');
	    
	    
	    if (MobiScout.Tab.Data.LoadLocalData("showTemperatureInformation")) {
	    	var ca = MobiScout.Tab.Data.LoadLocalData("showTemperatureInformation");
	    	if(ca == true || ca == 'true' || ca.toUpperCase() == 'TRUE'){
        		showTemperatureInformation = true;
        	}
        	else{
        		showTemperatureInformation = false;
        	}
	    }
	    if(showTemperatureInformation == true) $("#toggletemperature").val('on').slider('refresh');
	    else $("#toggletemperature").val('off').slider('refresh');
	    
	    if (MobiScout.Tab.Data.LoadLocalData("ServiceURL")) {
	        serviceurl.value = MobiScout.Tab.Data.LoadLocalData("ServiceURL");
	    }
	    else {
	        if (WebServiceURL == "") {
	            serviceurl.value = location.host;
	        }
	        else {
	            serviceurl.value = WebServiceURL;
	            $("#serviceurl").textinput("disable");
	        }
	    }
	    
	    
	    
    } catch (Error) {
    	
    }
    //TODO: de sliders staan niet altijd op de juiste positie na de eerste keer openen van het scherm.
    $("#toggletouchhaptic").slider('refresh');
    $("#toggletranslatepositions").slider('refresh');
	$("#toggleuseserverimages").slider('refresh');
	$("#toggleuseserverimagesinlist").slider('refresh');
	$("#toggleshowgraphsinlist").slider('refresh');
	$("#toggleusedepartments").slider('refresh');
	$("#toggleuseclustering").slider('refresh');
	$("#toggleusetrafficinfo").slider('refresh');
	$("#togglemessagereminder").slider('refresh');
	$("#togglemessagedelivery").slider('refresh');
	$("#togglecountalertmessages").slider('refresh');
	$("#toggletouchsound").slider('refresh');
	$("#toggleuseactchange").slider('refresh');
    $("#toggletrips").slider('refresh');
    $("#toggletemperature").slider('refresh');
    $("#togglecanbus").slider('refresh');
    $("#togglepageanimation").slider('refresh');
	$("#settings").page();
}

MobiScout.Tab.ShowUnreadMessages = function(){
	// vanuit de notificatiebalk geklikt op Nieuwe berichten...
	// schakel naar het ongelezen berichtenscherm
	//MobiScout.Tab.App.MessageDetailOrigin = MessageOrigin.UNREADMESSAGES;
	MobiScout.Tab.ChangePage("messages");
}

MobiScout.Tab.AndroidNotification = function(title, message, type)
{
	try 
	{
		if (isPhoneGap == true || window.Cordova) {
			if(window.plugins){
				
				window.plugins.statusBarNotification.notify(title, message, type);
			}
		}
	}
	catch(Err)
	{
	   MobiScout.Tab.appendMessage("MobiScout.Tab.AndroidNotification: " + Err);
	}
};

MobiScout.Tab.SelectVehicleInList = function(vehicleid){
	if (vehicleid > 0) {
            var el = $('#select-vehicles');
            el.val(vehicleid).attr('selected', true).siblings('option').removeAttr('selected');
            el.selectmenu("refresh", true);
    }
};

MobiScout.Tab.BuildDriverList = function(){
	try {
        $("#select-drivers-nfc").empty();
        var toggle;
        for (var i = 0; i < MobiScout.Tab.App.DriverList.length; i++) {
           	toggle = $('<option value="' + MobiScout.Tab.App.DriverList[i].ID + '">' + MobiScout.Tab.App.DriverList[i].Name + " (" + MobiScout.Tab.App.DriverList[i].ID + ")" + '</option>');
            $("#select-drivers-nfc").append(toggle);
        }
        $("#select-drivers-nfc").selectmenu('refresh');
    }
    catch (Err) {

    }
}

MobiScout.Tab.BuildUserList = function(){
	try {
        $("#select-users-nfc").empty();
        var toggle;
        for (var i = 0; i < MobiScout.Tab.App.UserList.length; i++) {
           	toggle = $('<option value="' + MobiScout.Tab.App.UserList[i].UserID + '">' + MobiScout.Tab.App.UserList[i].Name + '</option>');
            $("#select-users-nfc").append(toggle);
        }
        $("#select-users-nfc").selectmenu('refresh');
    }
    catch (Err) {

    }
}

MobiScout.Tab.BuildVehicleList = function(){
	// lijstje maken voor naar welke auto we iets sturen
	try {
        $("#select-vehicles").empty();
        var toggle;

        for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
        	if(showVehiclePlate == true){
            	toggle = $('<option value="' + MobiScout.Tab.App.VehicleList[i].ID + '">' + MobiScout.Tab.App.VehicleList[i].Plate + " (" + MobiScout.Tab.App.VehicleList[i].ID + ")" + '</option>');
            }
            else{
            	toggle = $('<option value="' + MobiScout.Tab.App.VehicleList[i].ID + '">' + MobiScout.Tab.App.VehicleList[i].ID + '</option>');
            }
            $("#select-vehicles").append(toggle);
        }
        $("#select-vehicles").selectmenu('refresh');
    }
    catch (Err) {

    }
};

MobiScout.Tab.BuildVehicleListNFC = function(){
	try {
        
        $("#select-vehicles-nfc").empty();
        var nfctoggle;
        for (var i = 0; i < MobiScout.Tab.App.VehicleList.length; i++) {
        	if(showVehiclePlate == true){
            	nfctoggle = $('<option value="' + MobiScout.Tab.App.VehicleList[i].ID + '">' + MobiScout.Tab.App.VehicleList[i].Plate + " (" + MobiScout.Tab.App.VehicleList[i].ID + ")" + '</option>');
            }
            else{
            	nfctoggle = $('<option value="' + MobiScout.Tab.App.VehicleList[i].ID + '">' + MobiScout.Tab.App.VehicleList[i].ID + '</option>');
            }
            $("#select-vehicles-nfc").append(nfctoggle);
        }
        $("#select-vehicles-nfc").selectmenu('refresh');
    }
    catch (Err) {

    }
};

MobiScout.Tab.BuildTrailerListNFC = function(){
	try {
        
        $("#select-trailers-nfc").empty();
        var nfctoggle;
        for (var i = 0; i < MobiScout.Tab.App.TrailerList.length; i++) {
           	nfctoggle = $('<option value="' + MobiScout.Tab.App.TrailerList[i].ID + '">' + MobiScout.Tab.App.TrailerList[i].Plate + " (" + MobiScout.Tab.App.TrailerList[i].ID + ")" + '</option>');
            $("#select-trailers-nfc").append(nfctoggle);
        }
        $("#select-trailers-nfc").selectmenu('refresh');
    }
    catch (Err) {

    }
};



MobiScout.Tab.ClearAndroidNotification = function(){
	try 
	{
		MobiScout.Tab.App.ReminderActive = false;
		if (isPhoneGap == true || window.Cordova) {
			if(window.plugins){
				window.plugins.statusBarNotification.clear(1);
			}
		}
	}
	catch(Err)
	{
	   MobiScout.Tab.appendMessage("MobiScout.Tab.ClearAndroidNotification: " + Err);
	}
}

MobiScout.Tab.AlertDismissed = function(){
}

MobiScout.Tab.ShowAlert = function(title, message){
	navigator.notification.alert(
	    message,  // message
	    MobiScout.Tab.AlertDismissed,         
	    title,            
	    'Ok'            
	);
}

MobiScout.Tab.postNewTextMessage = function(vehicleid, textmessage){
	MobiScout.Tab.LogToConsole("postNewTextMessage: " + vehicleid + " " + textmessage);
   	if(vehicleid > 0){
   		//TODO: eerst proberen direct te verzenden, als dat niet lukt, opslaan en herproberen
   		/*var newMsg = new TabMessage(); 
   		newMsg.VehicleID = vehicleid;
   		newMsg.MsgContent = textmessage;
   		MobiScout.Tab.App.TxMessages.push(newMsg);*/
   		MobiScout.Tab.Data.SendTextMessage(vehicleid, textmessage);
   	}
}; 

MobiScout.Tab.setMessageDetails = function(msgsn){
     for (var i = 0; i < MobiScout.Tab.App.Messages.length; i++) {
	     if (MobiScout.Tab.App.Messages[i].MsgSN == msgsn) {
	     
	     	var messageToDisplay = MobiScout.Tab.UI.FormatMessageForDisplay(MobiScout.Tab.App.Messages[i]);
	     	var state = document.getElementById("divMsgDetails");
		    state.innerHTML = messageToDisplay;
		    break;
	    }
    }
};

MobiScout.Tab.GetMessageDetails = function(message){
	var textMessage = message.MsgContent;
	var j = 0;
	while (textMessage.indexOf("\x20\x20") >= 0 && j < 255) {
		textMessage = textMessage.replace("\x20\x20", "<br>");
		j++;
	}
	var messageToDisplay = "<h4>Van: " + message.Plate + "  " + message.DriverName + "<br>" + textMessage + " </h4>";
	
	if(showVehiclePlate == false) messageToDisplay = "<h4>Van: " + message.VehicleID + "  " + message.DriverName + "<br>" + textMessage + " </h4>";
	
	if (message.MsgTypeID == 7) {
		var htmlColor = MobiScout.Tab.App.toRGB(message.Color);
		messageToDisplay = '<h4>Van: ' + message.Plate + ' ' + message.DriverName + '</h4><h3 style="color: '+htmlColor+'" >' + message.ActivityDescr + '</h3><p>' + textMessage + '</p>';
		if(showVehiclePlate == false) messageToDisplay = '<h4>Van: ' + message.VehicleID + ' ' + message.DriverName + '</h4><h3 style="color: '+htmlColor+'" >' + message.ActivityDescr + '</h3><p>' + textMessage + '</p>';
	}
	if(isBlank(message.Location) == false) messageToDisplay += '<p>' + message.Location + '</p>';
	return messageToDisplay;
}

MobiScout.Tab.setMessageDetailsFromDialog = function(msgsn){
     for (var i = 0; i < MobiScout.Tab.App.MessageDialog.length; i++) {
	     if (MobiScout.Tab.App.MessageDialog[i].MsgSN == msgsn) {
	     
	     	var messageToDisplay = MobiScout.Tab.UI.FormatMessageForDisplay(MobiScout.Tab.App.MessageDialog[i]);
		    var state = document.getElementById("divMsgDetails");
		    state.innerHTML = messageToDisplay;
		    if(MobiScout.Tab.App.MessageDialog[i].StopSN > 0 && authorisationForTrips == true){
		    	// get stop details
		    	MobiScout.Tab.App.CurrentMessageStopSN = MobiScout.Tab.App.MessageDialog[i].StopSN; 
		    	MobiScout.Tab.Data.GetDetailsForStop(MobiScout.Tab.App.MessageDialog[i].StopSN);
		    }
		    break;
	    }
    }
};



MobiScout.Tab.HapticFeedback = function(){
	if(UseHapticFeedback == true){
		if (isPhoneGap == true || window.Cordova) {
	        try {
	            navigator.notification.vibrate(50);
	        }
	        catch(Ex)
	        {}
		}
	}
};

MobiScout.Tab.LogToConsoleWithLevel = function(textmessage, loglevel){
	try
	{
		if(logLevel >= loglevel){
			if(isPhoneGap == true){
				if(window.MobiScoutApp){ // straks weer uit
					window.MobiScoutApp.WriteToLog(textmessage);
				}
			}
			else if (console) {
				if(console.log){
					console.log(textmessage);
				}
			}
		}
	}
	catch(Exc){}
};
MobiScout.Tab.LogToConsole = function(textmessage){
	MobiScout.Tab.LogToConsoleWithLevel(textmessage, 1);
	
};

MobiScout.Tab.StartUpdateSequence = function(buttonIndex){
	if(isPhoneGap == true){
		if(window.MobiScoutApp){
			if(buttonIndex == 1 || buttonIndex == undefined){
				MobiScout.Tab.LogToConsole("User accepted update");
				// dan zetten we snel wat parameters om?
				window.MobiScoutApp.Update(availableURL, MobiScout.Tab.App.allowUserCancel);
			}
			else{
				MobiScout.Tab.LogToConsole("User declined update to " + availableVersion);
			}
		}
	}
};

MobiScout.Tab.PlayAttentionSound = function () {
    if (isPhoneGap == true || window.Cordova) {
        try {
       		if(MobiScout.Tab.App.playingSound == false){
	        	MobiScout.Tab.App.playingSound = true;
            	var geluidje = new Media("/android_asset/www/audio/attn.wav", onmp3ok, onmp3err); 
            	geluidje.play();
            }
            //TODO: anders.. dan blijven we de wakelock dus gewoon houden ... dat moeten niet.
        }
        catch (Err) {
        }
    }
};

MobiScout.Tab.CheckUpdateAvailable = function(){
	// alleen indien we 3G of beter hebben
	MobiScout.Tab.LogToConsole("MobiScout.Tab.CheckUpdateAvailable " + isPhoneGap);
	if (isPhoneGap == true) {
       	if(availableVersion != applicationVersion){
      		if(availableURL != ""){
       			MobiScout.Tab.LogToConsole("Prompting user for upgrade to " + availableVersion + " on " + availableURL);
       			MobiScout.Tab.App.allowUserCancel = true;
       			MobiScout.Tab.PlayAttentionSound();
       			navigator.notification.confirm(
       					MobiScout.Tab.Translations.NieuweVersieOphalen, 
       		            MobiScout.Tab.StartUpdateSequence,       
       		            MobiScout.Tab.Translations.UpdateBeschikbaar,           
       		            MobiScout.Tab.Translations.JaNee                  
       		        );
       		}
        }
	}
};

MobiScout.Tab.MaybeExitApplication = function(buttonIndex)
{	
	if(buttonIndex == 1){
		MobiScout.Tab.ExitApplication();
	}
};

MobiScout.Tab.ExitApplication = function () {
	MobiScout.Tab.LogToConsole("Exit");
	MobiScout.Tab.App.stopworkers();
	MobiScout.Tab.AllowSleep();
    if (isPhoneGap == true || window.Cordova) {
    	if(window.MobiScoutApp) window.MobiScoutApp.ExitClicked();
    	navigator.app.exitApp();
    }
    else {
        window.opener = 'x';
        window.close();
    }

};

MobiScout.Tab.appendMessage = function(text){
	MobiScout.Tab.LogToConsole(text);
}


MobiScout.Tab.UpdateAlertBadgeCount = function(){
	var count = 0;
	for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
		count += MobiScout.Tab.App.TrackAndTraceList[i].NumberOfAlerts;
	}
	if(count == 0){
		$('#badge-alerts').html(count).fadeOut();
	}
	else{
		$('#badge-alerts').html(count).fadeIn();
	}
	return count;
}

MobiScout.Tab.UpdateMessageBadgeCount = function(count){
	var totalCount = count + MobiScout.Tab.UpdateAlertBadgeCount();
	if(count == 0){
		$('#badge-unreadmessages').html(count).fadeOut();
	}
	else{
		
		$('#badge-unreadmessages').html(count).fadeIn();
	}
	if(totalCount == 0){
		$('#badge-total').html(totalCount).fadeOut();
	}
	else{
		if(totalCount > 99){
			$("#btnMenu").width('50px');
			$("#btnMenu").css('text-align', 'right');
			$('#badge-total').css('left', Math.floor($("#btnMenu").width())-46 + 'px');
			$('#badge-total').css('top', Math.floor($("#btnMenu").height()-11) + 'px');
		}
		else if(totalCount > 9){
			$("#btnMenu").width('45px');
			$("#btnMenu").css('text-align', 'right');
			$('#badge-total').css('left', Math.floor($("#btnMenu").width())-41 + 'px');
			$('#badge-total').css('top', Math.floor($("#btnMenu").height()-11) + 'px');
		}
		else{
			$("#btnMenu").width('40px');
			$("#btnMenu").css('text-align', 'center');
			$('#badge-total').css('left', Math.floor($("#btnMenu").width())-36 + 'px');
			$('#badge-total').css('top', Math.floor($("#btnMenu").height()-11) + 'px');
		}
		$('#badge-total').html(totalCount).fadeIn();
	}
};

MobiScout.Tab.UpdateStops = function (tripsn){
	if(tripsn > 0){
		MobiScout.Tab.App.ClearStops();
		
		MobiScout.Tab.Data.getStops(MobiScout.Tab.App.LastSelectedTripSN);
	}
};

MobiScout.Tab.UpdateTrips = function(vehicleid){
	MobiScout.Tab.LogToConsole("MobiScout.Tab.UpdateTrips: " + vehicleid);
	MobiScout.Tab.Data.getTripList(vehicleid);
}

MobiScout.Tab.UpdateMessageDialog = function(forceclear){
	if(MobiScout.Tab.App.LastSelectedVehicleID == 0)
	{
		// dan moeten we de eerste uit de TrackAndTrace lijst maar nemen
		if(MobiScout.Tab.App.TrackAndTraceList.length>0){
			MobiScout.Tab.App.LastSelectedVehicleID = MobiScout.Tab.App.TrackAndTraceList[0].ID;
			forceclear = true; 
		}
	}
	if(MobiScout.Tab.App.LastSelectedVehicleID > 0){
			if(forceclear == true){
				MobiScout.Tab.App.ClearMessageDialog();
				MobiScout.Tab.UI.Message.setMessageDialogLoading();
			}
			MobiScout.Tab.Data.getMessageDialog(MobiScout.Tab.App.LastSelectedVehicleID, MobiScout.Tab.UI.Message.SelectedDate, forceclear);
	}
}

MobiScout.Tab.DumpPageSizes = function(){
	MobiScout.Tab.LogToConsoleWithLevel("page_body nodes: " + $('#page_body *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page home nodes: " + $('#home *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page realtimeHours nodes: " + $('#realtimeHours *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page periodView nodes: " + $('#periodView *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page temperature nodes: " + $('#temperature *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page driverCard nodes: " + $('#driverCard *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page employees nodes: " + $('#employees *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page dateselection nodes: " + $('#dateselection *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page help nodes: " + $('#help *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page messages nodes: " + $('#messages *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page alerts nodes: " + $('#alerts *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page messagedialog nodes: " + $('#messagedialog *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page trips nodes: " + $('#trips *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page tripstops nodes: " + $('#tripstops *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page map nodes: " + $('#map *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page settings nodes: " + $('#settings *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page messagedetail nodes: " + $('#messagedetail *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page stopdetails nodes: " + $('#stopdetails *').size(), 3);
	MobiScout.Tab.LogToConsoleWithLevel("page newmessage nodes: " + $('#newmessage *').size(), 3);
	
}

MobiScout.Tab.Update = function(isAutoRefresh){
	// aangeroepen vanuit Java code.. niet wijzigen
	MobiScout.Tab.LogToConsoleWithLevel("Connection type: " + MobiScout.Tab.GetNetworkConnectionType(), 3);
	
	//MobiScout.Tab.DumpPageSizes();
	
	//if(isAutoRefresh == true && MobiScout.Tab.GetNetworkConnectionType() == Connection.WIFI){
	//	setTimeout("MobiScout.Tab.Data.StartUpdateWithWakeup(" + isAutoRefresh + ")", 1000); // 1 second delay
	//}
	//else{
		MobiScout.Tab.Data.getTrackAndTrace(isAutoRefresh, true);
	//}
	
	// indien we in het berichten/status dialoog zitten, dan moeten we die ook bijwerken
	if ($('.ui-page-active').attr('id') == 'messagedialog') {
		// maar alleen indien de gebruiker niet met de app bezig is.
		// we moeten dit slim doen, of updaten zonder dat de gebruiker hier iets van merkt.
		MobiScout.Tab.UpdateMessageDialog(false);
	}
};

MobiScout.Tab.SetDataIconMenu = function(newIcon){
  	$("#btnMenu").buttonMarkup({ icon: newIcon });
}

MobiScout.Tab.AllowSleep = function(){
	MobiScout.Tab.LogToConsoleWithLevel("MobiScout.Tab.AllowSleep", 3);
	MobiScout.Tab.SetDataIconMenu('bars');
	if(window.MobiScoutApp && isPhoneGap == true){
		try{
			window.MobiScoutApp.AllowApplicationSleep();
		}catch(Err){}
	}
};

MobiScout.Tab.checkAlertForDevelopment = function(){
	//MobiScout.Tab.LogToConsole("CheckAlertForDevelopment");
	// er is iets misgegaan, indien isDevelopmentDevice == true dan een geluidje spelen
	if(isDevelopmentDevice == true){
		MobiScout.Tab.PlayNotification(false, 3);
	}
}

MobiScout.Tab.PlayNotification = function (vibrate, soundType) {
    if (isPhoneGap == true || window.Cordova) {
        try {
       		if(MobiScout.Tab.App.playingSound == false){
	        	 MobiScout.Tab.App.playingSound = true;
	        	 if(soundType == undefined) soundType = notificationSound;
		         var geluidje;
		         if(soundType == 1) geluidje = new Media("/android_asset/www/audio/sonar.wav", onmp3ok, onmp3err); 
		         if(soundType == 2) geluidje = new Media("/android_asset/www/audio/attn.wav", onmp3ok, onmp3err);
		         if(soundType == 3) geluidje = new Media("/android_asset/www/audio/error.wav", onmp3ok, onmp3err);
		         if(soundType == 4) geluidje = new Media("/android_asset/www/audio/notify.wav", onmp3ok, onmp3err);
		         if(soundType == 5) geluidje = new Media("/android_asset/www/audio/ns.wav", onmp3ok, onmp3err);
		         if(soundType == 6) geluidje = new Media("/android_asset/www/audio/beep111.wav", onmp3ok, onmp3err);
		         if(geluidje){
		         	geluidje.play();
		         }
		         
		         if(vibrate == true){
		         	navigator.notification.vibrate(500);
		         }
		 	}
        }
        catch (Err) {
        }
    }
};



MobiScout.Tab.PlayTick = function () {
	if(UseTickSound == true){
	    if (isPhoneGap == true || window.Cordova) {
	        try {
	        	if(MobiScout.Tab.App.playingSound == false){
		        	//MobiScout.Tab.App.playingSound = true;
		        	if(MobiScout.Tab.App.MediaPlayer == undefined) {
		        		MobiScout.Tab.App.MediaPlayer = new Media("/android_asset/www/audio/Effect_Tick.wav", readyNoRelease, failNoRelease); 
		        	}
		            MobiScout.Tab.App.MediaPlayer.play();
	            }
	        }
	        catch (Err) {
	        }
	    }
    }
	MobiScout.Tab.HapticFeedback();    
};

function readyNoRelease() {
	MobiScout.Tab.App.playingSound = false;
};

function failNoRelease(err) {
	MobiScout.Tab.App.playingSound = false;
};


MobiScout.Tab.PlayLongNotification = function () {
    if (isPhoneGap == true || window.Cordova) {
        try {
        	if(MobiScout.Tab.App.playingSound == false){
	        	MobiScout.Tab.App.playingSound = true;
		        var geluidje = new Media("/android_asset/www/audio/ns.wav", onmp3ok, onmp3err); 
	            geluidje.play();
	            navigator.notification.vibrate(500);
            }
        }
        catch (Err) {
        }
    }
};

function onmp3ok() {
	try{
		this.release();
	}
	catch(Err){
		console.log(Err);
	}
	MobiScout.Tab.App.playingSound = false;
	MobiScout.Tab.AllowSleep();
};

function onmp3err(err) {
	try{
		this.release();
	}
	catch(Err){
		console.log(Err);
	}
	MobiScout.Tab.App.playingSound = false;
	MobiScout.Tab.AllowSleep();
};


MobiScout.Tab.IsNetworkConnectionFast = function(){
	var networkType = MobiScout.Tab.GetNetworkConnectionType();
	if (networkType == Connection.ETHERNET || navigator.connection.type == Connection.WIFI || navigator.connection.type == Connection.CELL_3G || navigator.connection.type == Connection.CELL_4G) {
		return true;
	}
	return false;
}

MobiScout.Tab.IsNetworkHighSpeedPaid = function(){
	var networkType = MobiScout.Tab.GetNetworkConnectionType();
	if (navigator.connection.type == Connection.CELL_3G || navigator.connection.type == Connection.CELL_4G) {
		return true;
	}
	return false;
}

MobiScout.Tab.IsNetworkHighSpeedFree = function(){
	var networkType = MobiScout.Tab.GetNetworkConnectionType();
	if (navigator.connection.type == Connection.ETHERNET || navigator.connection.type == Connection.WIFI) {
		return true;
	}
	return false;
}

MobiScout.Tab.GetNetworkConnectionType = function(){
	// bepaal de netwerksnelheid hier
	var connectionType = navigator.connection.type;
	if(isPhoneGap == true){
		if(window.MobiScoutApp){
		    	connectionType = window.MobiScoutApp.GetNetworkInfoType(navigator.connection.type);
		}
	}
	return connectionType;
}

MobiScout.Tab.TranslateGeofenceType = function(id){
	if(id == undefined) return "";
	if(id == 0) return "";
	else if(id == 1) return MobiScout.Tab.Translations.GeofenceBetreden;
	else if(id == 2) return MobiScout.Tab.Translations.GeofenceVerlaten;
	else if(id == 3) return MobiScout.Tab.Translations.GeofenceBetredenVerlaten;
	else if(id == 10) return MobiScout.Tab.Translations.GeofenceRouteVerlaten;
}
