
	
MobiScout.Tab.UI.Alert.BuildAlertList = function(){
		//$("#AlertList").html('');
		$("#AlertList").empty();
		var htmlList = '';
       	for (var i = 0; i < MobiScout.Tab.App.AlertList.length; i++) {
       		htmlList += MobiScout.Tab.UI.Alert.GenerateAlertItem(MobiScout.Tab.App.AlertList[i]);
		}
		$("#AlertList").append(htmlList).listview("refresh");
	};
	
MobiScout.Tab.UI.Alert.GenerateAlertIconTable = function(alert){
	var iconTable = '<table class="messageIconTable" >';
	iconTable += '<tr>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '</tr>';
	var imageNew = "";
	var imageInbound = "";
	var imageRead = "";
	var imageUrgent = "";
	var imageMessage = "images/geofence_64.png";
	if(alert.AlertTypeID == 1){
		// geofence
		if(alert.GeofenceTypeID == 1) { imageMessage = "images/geofence_64.png";} // betreden
		else if(alert.GeofenceTypeID == 2) { imageMessage = "images/geofence_2_64.png";} // verlaten
		else if(alert.GeofenceTypeID == 3) { imageMessage = "images/geofence_3_64.png";} // verlaten/betreden
		else if(alert.GeofenceTypeID == 10) { imageMessage = "images/geofence_route_64.png";} // route verlaten
	}
	else if(alert.AlertTypeID == 2){
		// temperatuur
		imageMessage = "images/temperature_64.png";
	}
	else if(alert.AlertTypeID == 3){ // noodknop
	}
	else if(alert.AlertTypeID == 4){ // hygro
	}
	else if(alert.AlertTypeID == 5){ // I/O
		imageMessage = "IO_Alert_64.png";
	}
	iconTable += '<tr> <td colspan="4" ><center><img class="vehicleIcon" src="' + imageMessage + '"/></center></td></tr>';
	iconTable += '<tr> <td></td><td></td><td></td><td></td></tr>'; 
	iconTable += '</table>';
	return iconTable;
}

MobiScout.Tab.UI.Alert.GenerateAlertDetailTable = function(alert){
	var detailTable = '<table class="tripDetailTable">';
	detailTable += '<tr>';
	detailTable += '<td class="vehicleIconColumn"></td>';
	detailTable += '<td></td>';
	detailTable += '</tr>';
	if(alert.AlertTypeID == 1){ // geofence
		if(showVehiclePlate == true) detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/truck.png"/></td><td style="font-size:1em;">' + alert.Plate + '</td></tr>';
		else  detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/truck.png"/></td><td style="font-size:1em;">' + alert.VehicleID + '</td></tr>';
		detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + alert.GeofenceTypeDescription + " " + alert.Description + '</td></tr>';
		detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/accessories-clock.png"/></td><td style="font-size:1em;">' + alert.TSAlert + '</td></tr>';
	}
	if(alert.AlertTypeID == 2){ // temperatuur
		if(showVehiclePlate == true) detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/truck.png"/></td><td style="font-size:1em;">' + alert.Plate + '</td></tr>';
		else detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/truck.png"/></td><td style="font-size:1em;">' + alert.VehicleID + '</td></tr>';
		if(alert.Temperature1 && alert.Temperature1 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 1 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(0)) + ' ' + alert.Temperature1 + ' &#176;C</td></tr>';
		if(alert.Temperature2 && alert.Temperature2 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 2 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(1)) + ' ' + alert.Temperature2 + ' &#176;C</td></tr>';
		if(alert.Temperature3 && alert.Temperature3 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 3 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(2)) + ' ' + alert.Temperature3 + ' &#176;C</td></tr>';
		if(alert.Temperature4 && alert.Temperature4 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 4 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(3)) + ' ' + alert.Temperature4 + ' &#176;C</td></tr>';
		if(alert.Temperature5 && alert.Temperature5 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 5 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(4)) + ' ' + alert.Temperature5 + ' &#176;C</td></tr>';
		if(alert.Temperature6 && alert.Temperature6 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 6 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(5)) + ' ' + alert.Temperature6 + ' &#176;C</td></tr>';
		if(alert.Temperature7 && alert.Temperature7 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 7 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(6)) + ' ' + alert.Temperature7 + ' &#176;C</td></tr>';
		if(alert.Temperature8 && alert.Temperature8 != -1000)  detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + MobiScout.Tab.Translations.Temperatuur + ' 8 ' + MobiScout.Tab.App.GetTempDescr(alert.Description.charAt(7)) + ' ' + alert.Temperature8 + ' &#176;C</td></tr>';
		detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/accessories-clock.png"/></td><td style="font-size:1em;">' + alert.TSAlert + '</td></tr>';
	}
	if(alert.AlertTypeID == 3){ // noodknop
	}
	if(alert.AlertTypeID == 4){ // hygro
	}
	if(alert.AlertTypeID == 5){ // I/O
		if(showVehiclePlate == true) detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/truck.png"/></td><td style="font-size:1em;">' + alert.Plate + '</td></tr>';
		else detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/truck.png"/></td><td style="font-size:1em;">' + alert.VehicleID + '</td></tr>';
		detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + alert.Description + " " + alert.Description + '</td></tr>';
		detailTable += '<tr><td class="vehicleDetailImage"><img class="vehicleDetailImage" src="images/accessories-clock.png"/></td><td style="font-size:1em;">' + alert.TSAlert + '</td></tr>';
	}
	detailTable += '</table>';
	return detailTable;
}
	
MobiScout.Tab.UI.Alert.GenerateAlertItem = function(alert){
	// omschrijven naar tabel structuur
	var item = '<table class="messageTable" >';
	item += '<tr>';
	item += '<td class="tabMessageIcons"></td>';
	item += '<td class="tabMessageDetails" ></td>'; 
	item += '</tr>';
	item += '<tr>';
	item += '<td class="tabMessageIcons">' + MobiScout.Tab.UI.Alert.GenerateAlertIconTable(alert) + '</td>';
	item += '<td class="tabMessageDetails">' + MobiScout.Tab.UI.Alert.GenerateAlertDetailTable(alert) + '</td>';
	item += '</tr>';
	item += '</table>';
	item = '<li data-icon="false"><a id="alertsn' + alert.AlertSN + '">' + item + '</a></li>';
	return item;
};
	