// build employee list
MobiScout.Tab.UI.Employee.BuildEmployeeList = function (forceUpdate) {
	// first release all resource for the current graphs
	//MobiScout.Tab.App.DumpMemUsage("build employee list start, before clear");
	for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
   		MobiScout.Tab.UI.Employee.ReleaseResourcesForEmployeeChart(MobiScout.Tab.App.TrackAndTraceDriverList[i].ID);
   	}
   	MobiScout.Tab.App.EmployeeCharts = null;
   	MobiScout.Tab.App.EmployeeCharts = new Array();
	//MobiScout.Tab.App.DumpMemUsage("build employee list start, after clear");
	if(showGraphsInEmployeeList == true) navigator.notification.activityStart("", MobiScout.Tab.Translations.SamenstellenOverzicht);
    if(forceUpdate == true) $("#TrackAndTraceDriverList").empty();
    if ($("#TrackAndTraceDriverList").html() == '') {
       	var newList = [];
       	if(UseDepartments == false) newList.push('<li data-role="list-divider">' + MobiScout.Tab.App.TrackAndTraceDriverList.length + ' Chauffeurs </li>');
        if(MobiScout.Tab.App.TrackAndTraceDriverList.length == 0) {
        	newList.push('<li data-role="list-divider" >Geen chauffeurs<a>geen chauffeurs gevonden</a></li>');
        }
        else{
        	var groupName = "";
	        for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
	        	if(UseDepartments == true){
			        var currDepartment = MobiScout.Tab.App.getDepartment( MobiScout.Tab.App.TrackAndTraceDriverList[i].DepartmentID );
			        if(groupName != currDepartment && !isBlank(currDepartment)){
						newList.push('<li data-role="list-divider" ><p class="departmentHeader">' + currDepartment + '</p></li>');
						groupName = currDepartment;
			        }
		     	}
				newList.push(MobiScout.Tab.UI.Employee.GenerateEmployeeItemNew(MobiScout.Tab.App.TrackAndTraceDriverList[i], false));
           }
	   }
	   $("#TrackAndTraceDriverList").append(newList.join(''));
   	}
   	else {
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
        	MobiScout.Tab.UI.Employee.UpdateEmployeeItem(MobiScout.Tab.App.TrackAndTraceDriverList[i]);
        }
   	}
    $("#TrackAndTraceDriverList").listview('refresh');
    for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
		MobiScout.Tab.UI.Employee.UpdateBadgeForEmployee(MobiScout.Tab.App.TrackAndTraceDriverList[i].ID, MobiScout.Tab.App.TrackAndTraceDriverList[i].NumberOfUnreadMessages);
	    MobiScout.Tab.UI.Employee.UpdateAlertBadgeForEmployee(MobiScout.Tab.App.TrackAndTraceDriverList[i].ID, MobiScout.Tab.App.TrackAndTraceDriverList[i].NumberOfAlerts);
	    if ($('.ui-page-active').attr('id') == 'employees') {
	    	if(MobiScout.Tab.App.isAppPaused == false){
            	if(MobiScout.Tab.App.TrackAndTraceDriverList[i].ActivityChanged == true){
               		MobiScout.Tab.App.TrackAndTraceDriverList[i].TimestampChanged = false;
               		MobiScout.Tab.UI.AnimateControl("#ttemp" + MobiScout.Tab.App.TrackAndTraceDriverList[i].ID);
               	}
               	if(MobiScout.Tab.App.TrackAndTraceDriverList[i].TimestampChanged == true){
               		MobiScout.Tab.UI.AnimateControl("#timestampemp" + MobiScout.Tab.App.TrackAndTraceDriverList[i].ID);
               	}
            }
       	}
        MobiScout.Tab.App.TrackAndTraceDriverList[i].TimestampChanged = false;
        MobiScout.Tab.App.TrackAndTraceDriverList[i].ActivityChanged = false;
    }
	if(showGraphsInEmployeeList == true) navigator.notification.activityStart("", MobiScout.Tab.Translations.SamenstellenGrafieken);
    $("#TrackAndTraceDriverList").listview('refresh');
    MobiScout.Tab.UI.Employee.ActivateCanbusGraphs();
    try{
        ShowHideAsides();
    }catch(Err)
    {
    }
    navigator.notification.activityStop();
    //MobiScout.Tab.App.DumpMemUsage("build employee list finished");
};	

MobiScout.Tab.UI.Employee.ActivateCanbusGraphs = function(){
	if(showGraphsInEmployeeList == true){
		for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceDriverList.length; i++) {
	    	MobiScout.Tab.UI.Employee.ActivateCanbusGraph(MobiScout.Tab.App.TrackAndTraceDriverList[i]);
	    }
		$("#TrackAndTraceDriverList").listview('refresh');
		MobiScout.Tab.PreventCanvasGhosting();
	}
}

MobiScout.Tab.UI.Employee.SetTablesVisible = function(){
	/*$(".ui-li-aside").css("display" ,"none"); // altijd uit
	
	if(screen.width >= 720){
		// rijtijden tabel aan
		$("#tabEmployeeTimes").css("display" ,"block");
		$("#tabEmployeeTimes").width('27%');
		$("#tableEmployeeTimes").css("display" ,"block");
		$("#tabEmployeeIcons").width('14%');
		$("#tabEmployeeIndicators").width('4%');
		$("#tabEmployeeDetails").width('55%');
	}
	else{
		$("#tabEmployeeTimes").css("display" ,"none");
		$("#tabEmployeeTimes").width('0%');
		$("#tableEmployeeTimes").css("display" ,"none");
		$("#tabEmployeeIcons").width('28%');
		$("#tabEmployeeIndicators").width('8%');
		$("#tabEmployeeDetails").width('64%');
		
	}*/
};

MobiScout.Tab.UI.Employee.GenerateEmployeeItemNew = function (employee, isupdate) {
	
	var mainTable = '<table class="employeeTable" >';
	mainTable += '<tr>';
	mainTable += '<td class="tabEmployeeIcons"></td>';
	mainTable += '<td class="tabEmployeeDetails" ></td>'; 
	mainTable += '<td class="tabEmployeeTimes" ></td>'; 
	mainTable += '</tr>';
	
	mainTable += '<tr>';
	mainTable += '<td class="tabEmployeeIcons">' + MobiScout.Tab.UI.Employee.GenerateIconTable(employee) + '</td>';
	mainTable += '<td class="tabEmployeeDetails">' + MobiScout.Tab.UI.Employee.GenerateDetailTable(employee) + '</td>';
	mainTable += '<td class="tabEmployeeTimes">' + MobiScout.Tab.UI.Employee.GenerateDrivingTimesTable(employee) + '</td>';
	mainTable += '</tr>';
	mainTable += '</table>';
	var item = mainTable;
	if(isupdate == false || isupdate == undefined){
		item = '<li data-icon="false" class="ui-badge-container"><span id="badgeemp' + employee.ID + '" class="badge badgemessages"></span><span id="badgealertsemp' + employee.ID + '" class="badge badgealerts"></span><a id="ttemp' + employee.ID + '">' + item + '</a></li>';
	}
	return item;
};

MobiScout.Tab.UI.Employee.GenerateDrivingTimesTable = function(employee){
	var timeTable = '';
	if(!isBlank(employee.Name) && MobiScout.Tab.UI.Employee.DrivingTimesActual(employee) == true){
		var resterendBlok = 270 - employee.Subdrivinghours;
		if(resterendBlok < 0) resterendBlok = 0;
		var resterendBlokInfo = '<td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</td>';
		if (resterendBlok < 15 && resterendBlok > 0)  resterendBlokInfo = '<td class="colDriveTimeValue"><font color="orange">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</font></td>';
		else if (resterendBlok == 0)  resterendBlokInfo = '<td class="colDriveTimeValue"><font color="red">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</font></td>';
		var resterendVandaag = 540 - employee.Totdrivinghours;
		if(resterendVandaag < 0) resterendVandaag = 0;
		if(employee.Tenallowed > 0)  resterendVandaag = 600 - employee.Totdrivinghours;
		var resterendVandaagInfo = '<td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</td>';
		if (resterendVandaag < 30 && resterendVandaag > 0)  resterendVandaagInfo = '<td class="colDriveTimeValue"><font color="orange">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</font></td>';
		else if (resterendVandaag == 0)  resterendVandaagInfo = '<td class="colDriveTimeValue"><font color="red">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</font></td>';
		timeTable = '<table class="tableEmployeeTimes">';
		timeTable += '<tr>';
		timeTable += '<td class="colDriveTimeDescr"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '</tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="employeeListImageRight" src="images/rijden_transparent.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(employee.Subdrivinghours) + '</td><td class="colDriveTimeValue">&nbsp;' + resterendBlokInfo + '</td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="employeeListImageRight" src="images/10964-sum-sign.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(employee.Totdrivinghours) + '</td><td class="colDriveTimeValue">&nbsp;' + resterendVandaagInfo + '</td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="employeeListImageRight" src="images/rusten_transparent.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(employee.Restminutes) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="employeeListImageRight" src="images/wachten_transparent.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(employee.Waitminutes) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="employeeListImageRight" src="images/werken_transparent.png"/></td><td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(employee.Workminutes) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="employeeListImageRight" src="images/blackwhite/Planner.png"/></td><td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(employee.Workweek) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '</table>';
	}
	else{
		timeTable = '<table class="tableEmployeeTimes">';
		timeTable += '<tr>';
		timeTable += '<td class="colDriveTimeDescr"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '</tr>';
		timeTable += '</table>';
	}
	return timeTable;
};

MobiScout.Tab.UI.Employee.DrivingTimesActual = function(employee){
	if(employee.Subdrivinghours == 0 && employee.Totdrivinghours == 0 && employee.Restminutes == 0 && employee.Waitminutes == 0 && employee.Workminutes == 0 && employee.Workweek == 0) return false;
	return true;
};

MobiScout.Tab.UI.Employee.GenerateDetailTable = function(employee){
	
	var detailTable = '<table class="employeeDetailTable">';
	
	detailTable += '<tr>';
	detailTable += '<td class="employeeIconColumn"></td>';
	detailTable += '<td></td>';
	detailTable += '</tr>';
	try{
		
	    var htmlColor = MobiScout.Tab.App.toRGB(employee.Color);
		var actDescr = employee.ActivityDescription;
		if(employee.Speed > 3) actDescr += " " + employee.Speed + " km/u";
		
		if(employee.TSACT){
			var msdiffminutes = (MobiScout.Tab.GetCurrentDate().getTime() - employee.TSACT.getTime()) / 60000;
			msdiffminutes = msdiffminutes.toFixed(0);
			if(msdiffminutes < 0) msdiffminutes = 0;
			if(msdiffminutes < 1){ // minder dan 1 minuut, geen tijd indicatie geven, dit is actueel
				actDescr += '<em> - ' + MobiScout.Tab.Translations.Zojuist + '</em>';
			}
			else if(msdiffminutes < 15){ // minder dan 15 minuten, toon minuten
				actDescr += '<em> - ' + msdiffminutes + ' ' + MobiScout.Tab.Translations.MinutenGeleden + '</em>';
			}
			else if(msdiffminutes < 1440){ // minder dan 1 dag geleden, toon alleen de tijd (HH:mm)
				actDescr += '<em> - ' + MobiScout.Tab.Translations.Sinds + ' ' + employee.TSACT.format('H:i') + '</em>';
			}
			else { // meer dan 1 dag geleden, toon datum en tijd (d/m HH:mm)
				actDescr += '<em> - ' + MobiScout.Tab.Translations.Sinds + ' ' + employee.TSACT.format('d/m H:i') + '</em>';
			}
		}
		
		var vehicleDescription = employee.Name;
		
		var activityColorBall = '<div id="timestampemp' + employee.ID + '" style="background-color: ' + htmlColor + ';width:10px;height:10px;-moz-border-radius: 5px/5px;-webkit-border-radius: 5px 5px;border-radius: 5px/5px;float: left;"></div>';
		
		var connectedImage = '';
		if(employee.TSLKA){
			// determine validity
			var msdiff = MobiScout.Tab.GetCurrentDate().getTime() - employee.TSLKA.getTime();
			if(msdiff < 300000){
			 	connectedImage = '<img class="employeeDetailImage" src="images/lightning_bolt_16_h.gif"/>';
			}
			else if(msdiff < 600000){
			 	connectedImage = '<img class="employeeDetailImage" src="images/flag-green.png"/>';
			}
			else if(msdiff < 900000){
			 	connectedImage = '<img class="employeeDetailImage" src="images/flag-yellow.png"/>';
			}
			else{
				//connectedImage = '<img class="employeeDetailImage" src="images/disconnected_n.png"/>';
			}
		}
		if(!isBlank(employee.Plate) && employee.Plate.length > 1) vehicleDescription += ',&nbsp;' + employee.Plate;
		detailTable += '<tr><td>' + connectedImage + '</td><td><strong>&nbsp;' + vehicleDescription + '</strong></td></tr>';
		detailTable += '<tr><td>' + activityColorBall + '</td><td>&nbsp;' + actDescr + '</td></tr>';
		//if(!isBlank(locationDescription)) detailTable += '<tr>' + locationImage + '<td>&nbsp;' + locationDescription + '</td></tr>';
		//if(!isBlank(destinationDescription)) detailTable += '<tr><td></td><td>&nbsp;' + destinationDescription + '</td></tr>';
		// invoegen van een extra tabel met 2 kolommen
		detailTable += '<tr><td></td><td>' + MobiScout.Tab.UI.Employee.GenerateCanbusTable(employee) + '</td></tr>';
		
		
	}
	catch(Err)
	{
	}
	
	detailTable += '</table>';
	return detailTable;
};

MobiScout.Tab.UI.Employee.ActivateCanbusGraph = function(employee){
	try{
		var usagedata = new Array();
		var items = employee.Consumption.split(";");
		//for(var i = 0; i < items.length; i ++) usagedata.push(KMPerLiterToLiterPer100KM(StringToFloat(items[i])));
		
		var speeddata = new Array();
		var labeldata = new Array();
		var itemsspeed = employee.MarchingSpeed.split(";");
		for(var i = 0; i < itemsspeed.length; i ++) {
			if(StringToFloat(itemsspeed[i]) > 1){
				usagedata.push(KMPerLiterToLiterPer100KM(StringToFloat(items[i])));
				speeddata.push(StringToFloat(itemsspeed[i]));
				labeldata.push("");
			}
		}
		
		
		
		var lineChartData = {
				labels : labeldata, 
				datasets : [
					{
						label: "Verbruik",
						fillColor : "rgba(220,220,220,0.2)",
						strokeColor : "rgba(220,220,220,1)",
						pointColor : "rgba(220,220,220,1)",
						pointStrokeColor : "#fff",
						pointHighlightFill : "#fff",
						pointHighlightStroke : "rgba(220,220,220,1)",
						data : usagedata
					},
					{
						label: "Marssnelheid",
						fillColor : "rgba(151,187,205,0.2)",
						strokeColor : "rgba(151,187,205,1)",
						pointColor : "rgba(151,187,205,1)",
						pointStrokeColor : "#fff",
						pointHighlightFill : "#fff",
						pointHighlightStroke : "rgba(151,187,205,1)",
						data : speeddata 
					}
				]
	
			}
		
		MobiScout.Tab.UI.Employee.ReleaseResourcesForEmployeeChart(employee.ID);
			
		
		var element = document.getElementById("canvasCB" + employee.ID );	
		if(element){
			var ctx = element.getContext("2d");
			
			if(ctx){
				
				//var doAnimation = MobiScout.Tab.UI.DeviceAllowsAnimation();
				MobiScout.Tab.UI.Employee.SetChartForEmployee(employee.ID, new Chart(ctx).Line(lineChartData, { maintainAspectRatio: false, responsive: true, animation: false, scaleShowLabels: false, showScale: false, scaleBeginAtZero: true,showTooltips: false }), speeddata, usagedata, labeldata);
			}
			else{
				//console.log("ctx is null");
			}
			
		}
		else{
			//console.log("element is null");
		}
	}
	catch(Err){
		MobiScout.Tab.LogToConsole("MobiScout.Tab.UI.Employee.ActivateCanbusGraph: " + Err);
	}
}

MobiScout.Tab.UI.Employee.ReleaseResourcesForEmployeeChart = function(ID){
	for(var i = 0; i < MobiScout.Tab.App.EmployeeCharts.length; i ++){
		if(MobiScout.Tab.App.EmployeeCharts[i].ID == ID){
			//console.log("Release chart data " + ID);
			//MobiScout.Tab.App.EmployeeCharts[i].Chart.clear();
			MobiScout.Tab.App.EmployeeCharts[i].Chart.destroy();
			MobiScout.Tab.App.EmployeeCharts[i].Chart = null;
			MobiScout.Tab.App.EmployeeCharts[i] = null;
			MobiScout.Tab.App.EmployeeCharts.splice(i, 1);
			//console.log("Chart data released for " + ID);
		}
	}			
}

MobiScout.Tab.UI.Employee.SetChartForEmployee = function (empid, chart, speedvalues, consumptionvalues, labelvalues){
	var found = false;
	try{
		for(var i = 0; i < MobiScout.Tab.App.EmployeeCharts.length; i ++){
			if(empid == MobiScout.Tab.App.EmployeeCharts[i].ID){
				// update the values... ?
				found = true;
				//console.log("found chart");
				// set values
				//while(MobiScout.Tab.App.EmployeeCharts[i].Chart.datasets[1].points.length > 0) MobiScout.Tab.App.EmployeeCharts[i].Chart.removeData();
				//MobiScout.Tab.App.EmployeeCharts[i].Chart.clear();
				
				MobiScout.Tab.App.EmployeeCharts[i].SpeedValues = speedvalues;
				MobiScout.Tab.App.EmployeeCharts[i].ConsumptionValues = consumptionvalues;
				MobiScout.Tab.App.EmployeeCharts[i].LabelValues = labelvalues;
				
				for(var j = 0; j < speedvalues.length; j ++){
					MobiScout.Tab.App.EmployeeCharts[i].Chart.datasets[1].points[j].value = speedvalues[j];
					MobiScout.Tab.App.EmployeeCharts[i].Chart.datasets[0].points[j].value = consumptionvalues[j];
				}
				MobiScout.Tab.App.EmployeeCharts[i].Chart.update();
			}
		}
		if(found == false){
			// create new one
			var newChart = new TabEmployeeChart();
			newChart.ID = empid;
			newChart.Chart = chart;
			newChart.SpeedValues = speedvalues;
			newChart.ConsumptionValues = consumptionvalues;
			newChart.LabelValues = labelvalues;
			MobiScout.Tab.App.EmployeeCharts.push(newChart);
		}
	}catch(Err)
	{
		MobiScout.Tab.LogToConsole("SetChartForEmployee: " + Err);
	}
}

MobiScout.Tab.UI.Employee.GenerateCanbusTable = function(employee){
	if(showGraphsInEmployeeList == true) return '<canvas class="canbusgraph" id="canvasCB' + employee.ID +  '"></canvas>';
	return '<a>&nbsp;</a>'; 
};

MobiScout.Tab.UI.Employee.GetAverageMarchingSpeed = function(employee){
 	var retval= new SplitFloat();
 	retval.Wholes = '';
 	retval.Fraction = '';
	retval.Wholes = MobiScout.Tab.UI.Employee.GetAverageMarchingSpeedWhole(employee);
	if(!isBlank(retval.Wholes)){ 	
		retval.Fraction = MobiScout.Tab.UI.Employee.GetAverageMarchingSpeedFraction(employee);
	}
	else{
		retval.Wholes = '--'; 
	}
	return retval;
}

MobiScout.Tab.UI.Employee.GetAverageMarchingSpeedWhole = function(employee){
	var avg = 0;
	
	if(!isBlank(employee.MarchingSpeed)){
		var items = employee.MarchingSpeed.split(";");
		if(items.length > 0){
			for(var i = 0; i < items.length; i ++) avg += StringToFloat(items[i]);
			avg /= items.length; 
		}
	}
	if(avg > 0 && avg < 100) return avg.toFixed(0);
	return "";
}

MobiScout.Tab.UI.Employee.GetAverageMarchingSpeedFraction = function(employee){
	var avg = 0;
	
	if(!isBlank(employee.MarchingSpeed)){
		var items = employee.MarchingSpeed.split(";");
		if(items.length > 0){
			for(var i = 0; i < items.length; i ++) avg += StringToFloat(items[i]);
			avg /= items.length; 
		}
	}
	avg = avg % 1;
	avg *= 10;
	if(avg > 0) return "." + avg.toFixed(0);
	return "";
}

MobiScout.Tab.UI.Employee.GetAverageUsage = function(employee){
 	var retval= new SplitFloat();
 	retval.Wholes = '';
 	retval.Fraction = '';
	retval.Wholes = MobiScout.Tab.UI.Employee.GetAverageUsageWhole(employee);
	if(!isBlank(retval.Wholes)){ 	
		retval.Fraction = MobiScout.Tab.UI.Employee.GetAverageUsageFraction(employee);
	}
	else{
		retval.Wholes = '--'; 
	}
	return retval;
}

MobiScout.Tab.UI.Employee.GetAverageUsageWhole = function(employee){
	var avg = 0;
	
	if(!isBlank(employee.Consumption)){
		var items = employee.Consumption.split(";");
		if(items.length > 0){
			for(var i = 0; i < items.length; i ++) avg += KMPerLiterToLiterPer100KM(StringToFloat(items[i]));
			avg /= items.length; 
		}
	}
	if(avg > 0 && avg < 500) return avg.toFixed(0);
	return "";
}

MobiScout.Tab.UI.Employee.GetAverageUsageFraction = function(employee){
	var avg = 0;
	
	if(!isBlank(employee.Consumption)){
		var items = employee.Consumption.split(";");
		if(items.length > 0){
			for(var i = 0; i < items.length; i ++) avg += KMPerLiterToLiterPer100KM(StringToFloat(items[i]));
			avg /= items.length; 
		}
	}
	avg = avg % 1;
	avg *= 10;
	if(avg > 0) return "." + avg.toFixed(0);
	return "";
}

MobiScout.Tab.UI.Employee.GenerateIndicatorTable = function(employee){
	var indicatorTable = '<table class="employeeIndicatorTable">';
	indicatorTable += '<tr><td align="center" style="width:100%"></td></tr>';
	indicatorTable += '<tr><td><img class="employeeListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="employeeListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="employeeListImage" src="images/user.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="employeeListImage" src="images/activities.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="employeeListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="employeeListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '</table>';
	return indicatorTable;
};

MobiScout.Tab.UI.Employee.GenerateIconTable = function(employee){
	
	var iconTable = '<table class="employeeIconTable" >';
	
	iconTable += '<tr>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '</tr>';
	var atbType = MobiScout.Tab.App.getActivityType(employee.ActivityID);
	var imageDrive = "images/rijden_transparent_disabled.png";
	var imageRest = "images/rusten_transparent_disabled.png";
	var imageWork = "images/werken_transparent_disabled.png";
	var imageWait = "images/wachten_transparent_disabled.png";
	if(atbType == 1){ // werken
		imageWork = "images/werken_transparent.png";
	}
	else if(atbType == 2){ // rusten
		imageRest = "images/rusten_transparent.png";
	}
	else if(atbType == 3){ // rijden
		imageDrive = "images/rijden_transparent.png";
	}
	else if(atbType == 4){ // wachten
		imageWait = "images/wachten_transparent.png";
	}

	iconTable += '<tr> <td colspan="4" ><center><img class="employeeIcon" src="images/chauffeur.png"/></center></td></tr>';
	iconTable += '<tr><td><img class="employeeListImage" src="' + imageDrive + '"/></td>';
		iconTable += '<td><img class="employeeListImage" src="' + imageRest + '"/></td>';
		iconTable += '<td><img class="employeeListImage" src="' + imageWork + '"/></td>';
		iconTable += '<td><img class="employeeListImage" src="' + imageWait + '"/></td></tr>';
	iconTable += '<tr> <td></td><td></td><td></td><td></td></tr>';
	
	var averageFuelUsage = MobiScout.Tab.UI.Employee.GetAverageUsage(employee);
	var averageMarchingSpeed = MobiScout.Tab.UI.Employee.GetAverageMarchingSpeed(employee);
	
	if(!isBlank(employee.MarchingSpeed)) iconTable += '<tr><td><img class="employeeListImage" src="images/81-dashboard.png" /></td><td colspan="3"><center>' + averageMarchingSpeed.Wholes +  averageMarchingSpeed.Fraction + '</center></td></tr>';
	if(!isBlank(employee.Consumption)) iconTable += '<tr><td><img class="employeeListImage" src="images/47-fuel.png" /></td><td colspan="3"><center>' + averageFuelUsage.Wholes + averageFuelUsage.Fraction + '</center></td></tr>';

	iconTable += '</table>';
	return iconTable;
};


MobiScout.Tab.UI.Employee.UpdateEmployeeItem = function (employee) {
	$("#ttemp" + employee.ID).empty();
    $("#ttemp" + employee.ID).html(MobiScout.Tab.UI.Employee.GenerateEmployeeItemNew(employee, true));
	MobiScout.Tab.UI.Employee.UpdateBadgeForEmployee(employee.ID, employee.NumberOfUnreadMessages);
	MobiScout.Tab.UI.Employee.UpdateAlertBadgeForEmployee(employee.ID, employee.NumberOfAlerts);
};    
    

MobiScout.Tab.UI.Employee.UpdateBadgeForEmployee = function(empid, numberofunreadmessages){
	if(numberofunreadmessages > 0) $('#badgeemp' + empid).html(numberofunreadmessages).fadeIn();
    else $('#badgeemp' + empid).html(numberofunreadmessages).fadeOut();
};
	
MobiScout.Tab.UI.Employee.UpdateAlertBadgeForEmployee = function(empid, numberofalerts){
	if(numberofalerts > 0) $('#badgealertsemp' + empid).html(numberofalerts).fadeIn();
    else $('#badgealertsemp' + empid).html(numberofalerts).fadeOut();
};
        