/* todo

*/

function TabActivity() {
    this.ActSN = 0;
    this.VehicleID = 0;
    this.DriverID = 0;
    this.Plate = "";
    this.DriverName = "";
    this.TSStart = "";
    this.TSStop = "";
    this.ActivityID = 0;
    this.ActivityDescr = "";
    this.Color;
    this.Latitude = 0;
    this.Longitude = 0;
    this.Location = "";
    this.Odometer = 0;
    this.CaoGroupID = 0;
    this.CaoGroupDescr = "";
    this.TimeStampStart = 0;
    this.TimeStampStop = 0;
    this.StopSN = 0;
    this.KMSStart = 0;
    this.KMSStop = 0;
    this.Rem = "";
    this.Remarks = "";
}
function TabPeriodDate() {
    this.DriverID = 0;
    this.DriverName = "";
    this.TSDate = "";
    this.Date = "";
    this.TSNetto = 0;
    this.Holiday = 0;
}


MobiScout.Tab.UI.PeriodView.DateEntryList = new Array();
MobiScout.Tab.UI.PeriodView.CurrentStartDate = getMonday(MobiScout.Tab.GetCurrentDate());
MobiScout.Tab.UI.PeriodView.SelectedDate;
MobiScout.Tab.UI.PeriodView.timeline = null;
MobiScout.Tab.UI.PeriodView.ActivityList = new Array();
MobiScout.Tab.UI.PeriodView.Data;
MobiScout.Tab.UI.PeriodView.CurrentDriverInView = 0;

MobiScout.Tab.UI.PeriodView.GetDriverName = function(driverid)
{
	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.DateEntryList.length; i ++){
		if(Number(MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID) == Number(driverid))
		{
			 return MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverName;
		}
	}
	return driverid;
}

MobiScout.Tab.UI.PeriodView.ShowProgress = function(driverid){
	if(driverid == undefined){
		$('#btncontext_berekencao').removeClass('ui-disabled');
		if(window.MobiScoutApp){
			window.MobiScoutApp.ReportProgress(100, "", "");
		}
		else{
			$('#caoCalculationProgress').empty();
		}
	}
	else{
		//	voortgang in nieuw element weergeven
		if(window.MobiScoutApp){
			var percentageDone = MobiScout.Tab.UOCalculationManager.GetPercentageDone();
			if(window.MobiScoutApp.ReportProgress(Number(percentageDone), MobiScout.Tab.UI.PeriodView.GetDriverName(driverid), "Berekenen uren...") == true){
				MobiScout.Tab.UOCalculationManager.Stop();
				return; 
			}
		}
		else{
			$('#caoCalculationProgress').html('<img align="left" src="images/spinner.gif" width="16" height="16"/>&nbsp;&nbsp;' + MobiScout.Tab.UI.PeriodView.GetDriverName(driverid));
		}
 		$('#btncontext_berekencao').addClass('ui-disabled');
 	}
}

MobiScout.Tab.UI.PeriodView.PreviousWeek = function(){
	$('#periodTableContainer').fadeOut();
	MobiScout.Tab.UI.PeriodView.CurrentStartDate = MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, -7);
	MobiScout.Tab.UI.PeriodView.ShowPeriodView(MobiScout.Tab.UI.PeriodView.CurrentStartDate);
}

MobiScout.Tab.UI.PeriodView.NextWeek = function(){
	$('#periodTableContainer').fadeOut();
	MobiScout.Tab.UI.PeriodView.CurrentStartDate = MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 7);
	MobiScout.Tab.UI.PeriodView.ShowPeriodView(MobiScout.Tab.UI.PeriodView.CurrentStartDate);
}

MobiScout.Tab.UI.PeriodView.ActivityInList = function(activity){
	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.ActivityList.length; i ++){
			if(activity.ActSN == MobiScout.Tab.UI.PeriodView.ActivityList[i].ActSN) return true;
	}
	return false;
}

MobiScout.Tab.UI.PeriodView.AddActivityToList = function(activity){
	if(isBlank(activity.CaoGroupDescr)) activity.CaoGroupDescr = 'Geen';
	// alleen toevoegen als ie nog niet bestaat (ACT_SN)
	if(!MobiScout.Tab.UI.PeriodView.ActivityInList(activity)) {
		MobiScout.Tab.UI.PeriodView.ActivityList.push(activity);
		return true;
	}
	return false;
}

MobiScout.Tab.UI.PeriodView.HideTimeline = function(){
	$('#timelinehours').hide();
}

MobiScout.Tab.UI.PeriodView.ShowTimeline = function(){
	if(MobiScout.Tab.UI.PeriodView.ActivityList.length > 0) $('#timelinehours').show(); 
}

MobiScout.Tab.UI.PeriodView.ReshowTimeline = function(){
	if(MobiScout.Tab.UI.PeriodView.timeline != null) MobiScout.Tab.UI.PeriodView.timeline.checkResize();
	MobiScout.Tab.UI.PeriodView.UpdateActivityView(false);
	MobiScout.Tab.UI.PeriodView.ShowTimeline();
}

MobiScout.Tab.UI.PeriodView.RefreshActivityView = function(){
	// redraw, don't change timeline
	MobiScout.Tab.UI.PeriodView.drawVisualization(false);
}

MobiScout.Tab.UI.PeriodView.UpdateActivityView = function(redraw){
	MobiScout.Tab.UI.PeriodView.ShowTimeline();
	MobiScout.Tab.UI.PeriodView.drawVisualization(redraw);
}
MobiScout.Tab.UI.PeriodView.getSelectedRow = function() {
	var row = undefined;
	if(MobiScout.Tab.UI.PeriodView.timeline != null){
	    var sel = MobiScout.Tab.UI.PeriodView.timeline.getSelection();
	    if (sel.length) {
	    	if (sel[0].row != undefined) {
	        	row = sel[0].row;
	        }
	   	}
   	}
   	return row;
};

MobiScout.Tab.UI.PeriodView.GetDurationForActivity = function(i){
	var dateStart = new Date(MobiScout.Tab.UI.PeriodView.ActivityList[i].TimeStampStart);
	var dateStop  = new Date(MobiScout.Tab.UI.PeriodView.ActivityList[i].TimeStampStop);
	var msdiffminutes = (dateStop.getTime() - dateStart.getTime()) / 60000;
	msdiffminutes = Math.round(msdiffminutes);
	return MobiScout.Tab.ConvertMinutesToTimeSpan(msdiffminutes);
}

MobiScout.Tab.UI.PeriodView.FormatActivityForDisplay = function(activity, duration){
	var textMessage = "";
	var messageToDisplay = '';
	var senderID = '';
	if(isBlank(activity.Plate) == false && isBlank(activity.DriverName) == false && activity.DriverID > 0) 
	{
		if(showVehiclePlate == true) senderID = activity.Plate + ", " + activity.DriverName;
		else  senderID = activity.VehicleID + ", " + activity.DriverName;
		
	}
	else if(isBlank(activity.Plate) == false) {
		if(showVehiclePlate == true) senderID = activity.Plate;
		senderID = activity.VehicleID;
	}
	else if(isBlank(activity.DriverName) == false  && activity.DriverID > 0) senderID = activity.DriverName;
	messageToDisplay = '<fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">Details</legend>';
	messageToDisplay += '<div style="margin:10px;">';
	messageToDisplay += '<p style="font-style: italic; font-weight: bold;"><img src="images/user.png" width="16" height="16"/>&nbsp;&nbsp;' + senderID + '</p>';
	messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/accessories-date.png" width="16" height="16"/>&nbsp;&nbsp;' + activity.TSStart + ' - ' + activity.TSStop + '</p>';
	if(duration) {
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/accessories-clock.png" width="16" height="16"/>&nbsp;&nbsp;' + duration + '</p>';
	}
	if(startsWith(activity.Location, "POI:")){
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/flag_green.png" width="16" height="16"/>&nbsp;&nbsp;' + activity.Location.substring(4, activity.Location.length).trim() + '</p>';
	}
	else if(startsWith(activity.Location, "ADR:")){
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/user.png" width="16" height="16"/>&nbsp;&nbsp;' + activity.Location.substring(4, activity.Location.length).trim() + '</p>';
	}
	else if(startsWith(activity.Location, "POLY:")){
		messageToDisplay += '<p style="color: gray;white-space:normal"><img src="images/flag_red.png" width="16" height="16"/>&nbsp;&nbsp;' + activity.Location.substring(5, activity.Location.length).trim() + '</p>';
	}
	else if(isBlank(activity.Location) == false){
		messageToDisplay += '<p style="color: gray;white-space:normal" >' + activity.Location.trim() + '</p>';
	}
	messageToDisplay += '</div></fieldset>';
	messageToDisplay += '<br>';
	var messageType = "Activiteit";
	messageToDisplay += '<fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">' + messageType + '</legend>';
	messageToDisplay += '<div style="margin:10px;">';
	var htmlColor = MobiScout.Tab.App.toRGB(activity.Color);
	messageToDisplay += '<a style="background-color: '+htmlColor+';color:black;border-radius:3px;padding:3px;font-weight:bold;" >' + activity.ActivityDescr + '</a>';
	textMessage = '';
	if(activity.KMSStart > 0) textMessage += MobiScout.Tab.Translations.KmStand + " " + activity.KMSStart + " - " + activity.KMSStop + "<br>";
	if(!isBlank(activity.Rem)) textMessage += activity.Rem + "<br>";
	if(!isBlank(activity.Remarks)) textMessage += activity.Remarks + "<br>";
	if(!isBlank(textMessage)) messageToDisplay += '<p style="white-space:normal; color:gray;">' + textMessage + ' </p>';
	messageToDisplay += '</div></fieldset>';
	return messageToDisplay;
};

MobiScout.Tab.UI.PeriodView.ItemSelect = function (event) {
	MobiScout.Tab.PlayTick();
	var row = MobiScout.Tab.UI.PeriodView.getSelectedRow();
	MobiScout.Tab.UI.PeriodView.CheckHourTotalsVisibility();
	if (row != undefined) {
	    var duration = MobiScout.Tab.UI.PeriodView.GetDurationForActivity(row);
	    var activityinfo = MobiScout.Tab.UI.PeriodView.FormatActivityForDisplay(MobiScout.Tab.UI.PeriodView.ActivityList[row], duration);
	    $('#hoursinfo').html(activityinfo);
	    if(MobiScout.Tab.UI.PeriodView.ActivityList[row].StopSN > 0 && authorisationForTrips == true){
			MobiScout.Tab.App.CurrentMessageStopSN = MobiScout.Tab.UI.PeriodView.ActivityList[row].StopSN; 
		    MobiScout.Tab.Data.GetDetailsForStop(MobiScout.Tab.UI.PeriodView.ActivityList[row].StopSN);
		}
    }
	else {
    	$('#hoursinfo').html(MobiScout.Tab.UI.PeriodView.GetTotalsPerCaoGroup());
    }
}

MobiScout.Tab.UI.PeriodView.Redraw = function(redraw){
	MobiScout.Tab.UI.PeriodView.ShowTimeline();
	if(redraw){
		if(MobiScout.Tab.UI.PeriodView.timeline != null){
			var viewDate = MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.SelectedDate, -1);	
		   	var start = viewDate;
			start.setHours(0,0,0,0);
			var end = viewDate;
			end.setHours(23,59,59,999);
		   	MobiScout.Tab.UI.PeriodView.timeline.applyRange(start, end);
			MobiScout.Tab.UI.PeriodView.timeline.redraw();
		}
		$('#hoursinfo').html(MobiScout.Tab.UI.PeriodView.GetTotalsPerCaoGroup());
	}
	MobiScout.Tab.UI.PeriodView.CheckHourTotalsVisibility();
}

MobiScout.Tab.UI.PeriodView.CheckHourTotalsVisibility = function(){
	if($('#timelinehours').is(":visible")) $('#hoursinfo').show();
	else  $('#hoursinfo').hide();
}

MobiScout.Tab.UI.PeriodView.GetTotalsPerCaoGroup = function(){
	var retval = '<table style="font-size: 12px;border-collapse: collapse;border-spacing: 0;font: bold  12px arial ;color: #103E9C;">';
	retval += '<tr><td></td><td></td></tr>';
	for(var i = 0; i < MobiScout.Tab.App.CaoTypes.length; i ++){
		if(MobiScout.Tab.App.CaoTypes[i].CaoID > 0){
				var colorAddition = '';
				if(MobiScout.Tab.App.CaoTypes[i].Paid == 0) colorAddition = 'color: gray;';
				retval += '<tr>';
				retval += '<td style="' + colorAddition + 'padding-left: 10px;padding-right: 10px;padding-top:5px;">' + MobiScout.Tab.App.CaoTypes[i].Description + '</td>';
				retval += '<td style="' + colorAddition + 'padding-left: 10px;padding-right: 10px;padding-top:5px;">' + MobiScout.Tab.UI.PeriodView.GetTotalTimeForGroup(MobiScout.Tab.App.CaoTypes[i].CaoID) + '</td>';
				retval += '</tr>';
		}
	}
	// totaal tijd ook weergeven
	retval += '<tr style="border-top: 1px solid #000000;">';
	retval += '<td style="padding-left: 10px;padding-right: 10px;padding-top:5px;"><img style="min-width:14px;max-width:14px; height:auto; width:100%; float: left; margin-right: 8px;" src="images/10964-sum-sign.png"/></td>';
	retval += '<td style="padding-left: 10px;padding-right: 10px;padding-top:5px; color:black;">' + MobiScout.Tab.UI.PeriodView.GetTotalTime() + '</td>';
	retval += '</tr>';
	retval += '</table>';
	return retval;
}

MobiScout.Tab.UI.PeriodView.GetMSDurationForActivity = function(i){
	// hier mogen we de tijd die NIET in de geselecteerde dag valt niet meetellen
	// controleren tegen MobiScout.Tab.UI.PeriodView.SelectedDate
	var dateStart = new Date(MobiScout.Tab.UI.PeriodView.ActivityList[i].TimeStampStart);
	var dateStop =  new Date(MobiScout.Tab.UI.PeriodView.ActivityList[i].TimeStampStop);
	if(!dateStart.isSameDateAs(MobiScout.Tab.UI.PeriodView.SelectedDate)){
		// dan nemen we het begin van de huidige dag
		dateStart = MobiScout.Tab.UI.PeriodView.SelectedDate;
		dateStart.setHours(0);
		dateStart.setMinutes(0);
		dateStart.setSeconds(0);
		dateStart.setMilliseconds(0);
	}
	if(!dateStop.isSameDateAs(MobiScout.Tab.UI.PeriodView.SelectedDate)){
		// dan nemen we het einde van de huidige dag
		dateStop = MobiScout.Tab.UI.PeriodView.SelectedDate;
		dateStop.setHours(23);
		dateStop.setMinutes(59);
		dateStop.setSeconds(59);
		dateStop.setMilliseconds(999);
	}
	return dateStop.getTime() - dateStart.getTime();
}

MobiScout.Tab.UI.PeriodView.GetTotalTime = function(){
	var totalmilliseconds = 0
	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.ActivityList.length; i ++){
			totalmilliseconds += MobiScout.Tab.UI.PeriodView.GetMSDurationForActivity(i);
	}
	totalmilliseconds /= 60000; // naar minuten
	totalmilliseconds = Math.round(totalmilliseconds);
	
	return MobiScout.Tab.ConvertMinutesToTimeSpan(totalmilliseconds);
}

MobiScout.Tab.UI.PeriodView.GetTotalTimeForGroup = function(caoid){
	var totalmilliseconds = 0
	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.ActivityList.length; i ++){
		if(MobiScout.Tab.UI.PeriodView.ActivityList[i].CaoGroupID == caoid){
			totalmilliseconds += MobiScout.Tab.UI.PeriodView.GetMSDurationForActivity(i);
		}
	}
	totalmilliseconds /= 60000; // naar minuten
	totalmilliseconds = Math.round(totalmilliseconds);
	
	return MobiScout.Tab.ConvertMinutesToTimeSpan(totalmilliseconds);
}

MobiScout.Tab.UI.PeriodView.UserChangedRange = function(event){
	MobiScout.Tab.LogToConsole("changed: " + event.start + " " + event.end);
	// dan de bijbehorende data ophalen en invoegen
	if(MobiScout.Tab.UI.PeriodView.CurrentDriverInView > 0){
		MobiScout.Tab.Data.GetActivitiesForDriver(MobiScout.Tab.UI.PeriodView.CurrentDriverInView, event.start, true);
	}
}

MobiScout.Tab.UI.PeriodView.drawVisualization = function(redraw) {

	MobiScout.Tab.UI.PeriodView.Data = [];
	for (var i = 0; i < MobiScout.Tab.UI.PeriodView.ActivityList.length; i++) {
		var dateStart = new Date(MobiScout.Tab.UI.PeriodView.ActivityList[i].TimeStampStart);
		var dateStop = new Date(MobiScout.Tab.UI.PeriodView.ActivityList[i].TimeStampStop);
		var htmlcolor = MobiScout.Tab.App.toRGB(MobiScout.Tab.UI.PeriodView.ActivityList[i].Color);
		if(!isBlank(MobiScout.Tab.UI.PeriodView.ActivityList[i].CaoGroupDescr)){
			MobiScout.Tab.UI.PeriodView.Data.push({ 'start': dateStart, 'end': dateStop,'content': '<div class="order" style="background-color:' + htmlcolor + ' !important;">' + MobiScout.Tab.UI.PeriodView.ActivityList[i].ActivityDescr + '</div>','group': MobiScout.Tab.UI.PeriodView.ActivityList[i].CaoGroupDescr });
		}
	}
	
	if(MobiScout.Tab.UI.PeriodView.timeline == null){
	    var options = {
	    	width:  "100%",
	        height: "auto",
	        layout: "box",
	        editable: false,
	        selectable: true,
	        eventMargin: 0,  // minimal margin between events
	        eventMarginAxis: 10, // minimal margin beteen events and the axis
	        showMajorLabels: false,
	        axisOnTop: true,
	        groupsChangeable : false,
	        groupsOnRight: false,
	        groupsOrder: MobiScout.Tab.UI.PeriodView.OrderCAOGroups
	    };
	    MobiScout.Tab.UI.PeriodView.timeline = new links.Timeline(document.getElementById('timelinehours'), options);
	    links.events.addListener(MobiScout.Tab.UI.PeriodView.timeline, 'select', MobiScout.Tab.UI.PeriodView.ItemSelect);
	    //links.events.addListener(MobiScout.Tab.UI.PeriodView.timeline, 'rangechanged', MobiScout.Tab.UI.PeriodView.UserChangedRange);
	}
	for(var i = 0; i < MobiScout.Tab.App.CaoTypes.length; i ++){
		if(MobiScout.Tab.App.CaoTypes[i].CaoID > 0){
			MobiScout.Tab.UI.PeriodView.timeline.getGroup(MobiScout.Tab.App.CaoTypes[i].Description);
			if(MobiScout.Tab.UI.PeriodView.ActivityList.length > 0){
			 	// dummy toevoegen zodat alle groepen getoond worden.
				//MobiScout.Tab.UI.PeriodView.Data.push({ 'start': new Date(MobiScout.Tab.UI.PeriodView.ActivityList[0].TimeStampStart), 'end': new Date(MobiScout.Tab.UI.PeriodView.ActivityList[0].TimeStampStart),'content': '<div class="order" style="background-color:0 !important;">&nbsp;</div>','group': MobiScout.Tab.App.CaoTypes[i].Description });
				MobiScout.Tab.UI.PeriodView.Data.push({ 'start': MobiScout.Tab.UI.PeriodView.SelectedDate, 'end': MobiScout.Tab.UI.PeriodView.SelectedDate,'content': '<div class="order" style="display:none; background-color:0 !important;">&nbsp;</div>','group': MobiScout.Tab.App.CaoTypes[i].Description });
		    }
		    else{
				MobiScout.Tab.UI.PeriodView.Data.push({ 'start': MobiScout.Tab.UI.PeriodView.SelectedDate, 'end': MobiScout.Tab.UI.PeriodView.SelectedDate,'content': '<div class="order" style="background-color:0 !important;">&nbsp;</div>','group': MobiScout.Tab.App.CaoTypes[i].Description });
		    }
		}
	}   
    MobiScout.Tab.UI.PeriodView.timeline.draw(MobiScout.Tab.UI.PeriodView.Data);
    MobiScout.Tab.UI.PeriodView.Redraw(redraw);
    if(redraw == true){
	    if($('#timelinehours').inView() == false){
	    	$('html:not(:animated), body:not(:animated)').animate({
	            scrollTop: $("#timelinehours").offset().top
	        }, 500);
		}
	}
    
    
    
};

MobiScout.Tab.UI.PeriodView.OrderCAOGroups = function(a, b){
	if(MobiScout.Tab.App.GetCaoIDForGroupName(a.content) > MobiScout.Tab.App.GetCaoIDForGroupName(b.content)) return 1;
	return 0; 
}


MobiScout.Tab.UI.PeriodView.AddDateToList = function(date, d2, driverid, tsnetto, holiday, name){
	var newdateentry = new TabPeriodDate();
	newdateentry.DriverID = driverid;
	newdateentry.DriverName = name;
	newdateentry.TSDate = d2;
	newdateentry.Date = date;
	if(!isBlank(tsnetto)) newdateentry.TSNetto = Number(tsnetto);
	newdateentry.Holiday = holiday;
	MobiScout.Tab.UI.PeriodView.DateEntryList.push(newdateentry);
}

MobiScout.Tab.UI.PeriodView.ShowPeriodView = function(fromDate){
	// maak de lijst eerst leeg
	MobiScout.Tab.UI.PeriodView.CurrentDriverInView = 0;
	if(fromDate == undefined) fromDate = MobiScout.Tab.GetCurrentDate();
	MobiScout.Tab.UI.PeriodView.CurrentStartDate = getMonday(fromDate);
	//MobiScout.Tab.UI.ShowToast("Laden periode " + new Date(MobiScout.Tab.UI.PeriodView.CurrentStartDate).format('d/m/Y')); 
	MobiScout.Tab.UI.PeriodView.DateEntryList.splice(0,MobiScout.Tab.UI.PeriodView.DateEntryList.length);
	//$("#periodTableContainer").empty();
	$("#timelinehoursdriver").empty();  //??
	if(MobiScout.Tab.UI.PeriodView.timeline != null){
		MobiScout.Tab.UI.PeriodView.timeline.deleteAllItems();
		$("#timelinehours").hide();  
	}
	MobiScout.Tab.UI.PeriodView.ActivityList.splice(0, MobiScout.Tab.UI.PeriodView.ActivityList.length);
	$("#hoursinfo").empty();  
	
	
	// haal een nieuwe lijst op
	MobiScout.Tab.Data.GetPeriodView(new Date(MobiScout.Tab.UI.PeriodView.CurrentStartDate));
	
	
	
};

MobiScout.Tab.UI.PeriodView.getDay = function(indate, offset){
	var date = new Date(indate);
	date.setDate(date.getDate()+offset);
	
    return date;
}

MobiScout.Tab.UI.PeriodView.GetTotalNettoHoursForDriver = function(driverid){
	var nettominuten = 0;
	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.DateEntryList.length; i ++){
		if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID == driverid){
			nettominuten += MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto;
		}
	}
	return MobiScout.Tab.ConvertMinutesToTimeSpan(nettominuten);
}

MobiScout.Tab.UI.PeriodView.UpdateView = function(){
	$('#periodTableContainer').fadeIn();
	
	//MobiScout.Tab.LogToConsole("MobiScout.Tab.UI.PeriodView.UpdateView: " + $(document).width());
	//var pertab = '<table class="periodTableLayout" style="width:'+$(document).width()+' !important">';
	var pertab = '<table id="periodTable" class="periodTableLayout">';
	pertab += '<tr>'
    pertab += '<th width="99%">chauffeur</th>'
    pertab += '<th class="perhead">ma<br><sub>' + MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 0).format('d/m') + '</sub></th>'
    pertab += '<th class="perhead">di<br><sub>' + MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 1).format('d/m') + '</sub></th>'
    pertab += '<th class="perhead">wo<br><sub>' + MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 2).format('d/m') + '</sub></th>'
    pertab += '<th class="perhead">do<br><sub>' + MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 3).format('d/m') + '</sub></th>'
    pertab += '<th class="perhead">vr<br><sub>' + MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 4).format('d/m') + '</sub></th>'
    pertab += '<th class="perhead">za<br><sub>' + MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 5).format('d/m') + '</sub></th>'
    pertab += '<th class="perhead">zo<br><sub>' + MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, 6).format('d/m') + '</sub></th>'
    pertab += '<th class="perhead">uren</th>'
  	pertab += '</tr>'
  	
  	// iedere dag van de week voor iedere chauffeur doorlopen
  	var prevEmpName = "";
  	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.DateEntryList.length; i ++){
  		if(prevEmpName != MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverName){
  			// create a record
  			pertab += '<tr>';
  			pertab += '<td width="99%" class="percelldriver">' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverName + '</td>';
  			pertab += '<td class="percell" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_ma"></td>'
  			pertab += '<td class="percell" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_di"></td>'
  			pertab += '<td class="percell" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_wo"></td>'
  			pertab += '<td class="percell" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_do"></td>'
  			pertab += '<td class="percell" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_vr"></td>'
  			pertab += '<td class="percell weekend" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_za"></td>'
  			pertab += '<td class="percell weekend" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_zo"></td>'
  			pertab += '<td class="percell peruren" id="pertab_' + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID +'_uren"></td>'
  			pertab += '</tr>';
  			prevEmpName = MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverName;
  		}
  	}
  	
  	pertab += '</table>';
	$("#periodTableContainer").html(pertab);
	
	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.DateEntryList.length; i ++){
  		var day = MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSDate.getDay();
  		var daystr = "";
  		if(day == 0){ daystr = "zo"; }
  		else if(day == 1){ daystr = "ma"; }
  		else if(day == 2){ daystr = "di"; }
  		else if(day == 3){ daystr = "wo"; }
  		else if(day == 4){ daystr = "do"; }
  		else if(day == 5){ daystr = "vr"; }
  		else if(day == 6){ daystr = "za"; }
  		var cellid = "#pertab_" + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID + "_" + daystr;
  		
  		if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].Holiday == 9){  
  			// ATV
  			// kleur lichtblauw
  			$(cellid).addClass("dayoff").removeClass("weekend");
  			$(cellid).html('<small>A</small>');
  		}
  		else if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].Holiday == 10){  
  			// Ziek
  			// kleur lichtblauw
  			$(cellid).addClass("dayoff").removeClass("weekend");
  			$(cellid).html('<small>Z</small>');
  		}
  		else if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].Holiday == 11){  
  			// TvT opname
  			// kleur lichtblauw
  			$(cellid).addClass("dayoff").removeClass("weekend");
  			$(cellid).html('<small>T</small>');
  		}
  		else if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].Holiday == 12){  
  			// Vakantie opname
  			// kleur lichtblauw
  			$(cellid).addClass("dayoff").removeClass("weekend");
  			
			$(cellid).html('<small>V</small>');
 			
  		}
  		else if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].Holiday == 13){  
  			// Vakantie opname
  			// kleur lichtblauw
  			$(cellid).addClass("dayoff").removeClass("weekend");
  			$(cellid).html('<small>G</small>');
  		}
  		else if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].Holiday == 14){
  			// feestdag / doorbetaalde rustdag
  			// kleur oranje
  			$(cellid).addClass("holiday").removeClass("weekend");
  			//$(cellid).html('<small>H</small>');
  			if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto > 0 && MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto != 480){
  				$(cellid).text(MobiScout.Tab.ConvertMinutesToTimeSpan(MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto));
  			}
  			
  		}
  		else{
  			// onbekend, handel maar af als 0
  			$(cellid).addClass("worked").removeClass("weekend");
  			if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto > 0){
  				$(cellid).text(MobiScout.Tab.ConvertMinutesToTimeSpan(MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto));
  			}
  		}
  		/*if(MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto > 0){
  			// evt tijd vullen
  			//$(cellid).text(MobiScout.Tab.ConvertMinutesToTimeSpan(MobiScout.Tab.UI.PeriodView.DateEntryList[i].TSNetto));
  		}*/
  	}
  	prevEmpName = "";
  	for(var i = 0; i < MobiScout.Tab.UI.PeriodView.DateEntryList.length; i ++){
  		if(prevEmpName != MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverName){
  			$("#pertab_" + MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID + "_uren").text(MobiScout.Tab.UI.PeriodView.GetTotalNettoHoursForDriver(MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverID));
  			prevEmpName = MobiScout.Tab.UI.PeriodView.DateEntryList[i].DriverName;
  		}
  	}
  	
	$('#periodTable tr td').click(function(){
	    var cid = $(this).attr('id');
	    if(cid != undefined){
	    	if(authorisationForHours == true){
		    	var column_num = parseInt( $(this).index() ) + 1;
	        	var row_num = parseInt( $(this).parent().index() )+1;
		    	var items = cid.split('_');
		    	if(items.length > 1 && row_num > 1){
		    		MobiScout.Tab.PlayTick();
		    		
		    		$("#hoursinfo").empty();
		    		
		    		var driverid = Number(items[1]);
		    		var date = MobiScout.Tab.UI.PeriodView.getDay(MobiScout.Tab.UI.PeriodView.CurrentStartDate, column_num - 2);
		    		$('#timelinehoursdriver').html('<img src="images/user.png" width="16" height="16"/>&nbsp;&nbsp;<a style="font: bold 12px arial;color: #103E9C;">' + MobiScout.Tab.UI.PeriodView.GetDriverName(driverid) + '&nbsp;@&nbsp;' + date.format('d/m/Y') + '</a>');
		    		MobiScout.Tab.UI.PeriodView.SelectedDate = date;
		    		if(MobiScout.Tab.UI.PeriodView.timeline != null){
						MobiScout.Tab.UI.PeriodView.timeline.deleteAllItems();
					}
					MobiScout.Tab.UI.PeriodView.ActivityList.splice(0, MobiScout.Tab.UI.PeriodView.ActivityList.length);
		    		// moeten we hier de control laten zien?
		    		MobiScout.Tab.UI.PeriodView.CurrentDriverInView = driverid;
		    		MobiScout.Tab.Data.GetActivitiesForDriver(driverid, date, false);
		    		
		    		
		    	}
		    }
	    }
	    
	});
	
	
	$("#period-select-date").prop("readonly", true).datepicker(
		{
			onSelect: function(dateText) {
				MobiScout.Tab.PlayTick();
				MobiScout.Tab.UI.PeriodView.ShowPeriodView($("#period-select-date").datepicker( "getDate" ));
			},
			beforeShow : function(el, instance ){
				MobiScout.Tab.PlayTick();
			},
			dateFormat: "dd/mm/yy",
			monthNames: [ "Januari", "Februari", "Maart", "April", "Mei", "Juni", "Juli", "Augustus", "September", "Oktober", "November", "December" ],
			monthNamesShort: [ "Jan", "Feb", "Mar", "Apr", "Mei", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec" ],
			dayNames: [ "Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag" ],
			dayNamesMin: [ "Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za" ],
			dayNamesShort: [ "Zo", "Ma", "Di", "Wo", "Do", "Vr", "Za" ],
			showWeek: true,
			autoSize: true,
			firstDay : 1,
			weekHeader: "W"
		});
	$("#period-select-date" ).datepicker( "setDate", new Date(MobiScout.Tab.UI.PeriodView.CurrentStartDate) );	
	
}
