function TabTemperature() {
    this.SensorSN = 0;
    this.ActSN = 0;
    this.VehicleID = 0;
    this.TrailerID = 0;
    this.TSAction = "";
    this.TimeStampAction = "";
    this.Sensor1 = -1000;
    this.Sensor1Alert = 0;
    this.Sensor2 = -1000;
    this.Sensor2Alert = 0;
    this.Sensor3 = -1000;
    this.Sensor3Alert = 0;
    this.Sensor4 = -1000;
    this.Sensor4Alert = 0;
    this.Sensor5 = -1000;
    this.Sensor5Alert = 0;
    this.Sensor6 = -1000;
    this.Sensor6Alert = 0;
    this.Sensor7 = -1000;
    this.Sensor7Alert = 0;
    this.Sensor8 = -1000;
    this.Sensor8Alert = 0;
}



MobiScout.Tab.UI.Temperature.SensorList = new Array();
MobiScout.Tab.UI.Temperature.temperatureChart;
MobiScout.Tab.UI.Temperature.SelectedDate = MobiScout.Tab.GetCurrentDate();


MobiScout.Tab.UI.Temperature.SetLoadingMessage = function(){
	var tempDescr = '';
	tempDescr = '<fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">Even geduld a.u.b.</legend>';
	tempDescr += '<div style="margin:10px;">';
	tempDescr += '<p style="color: gray;white-space:normal"><center>Laden van temperatuur data...</center></p>';
	tempDescr += '</div></fieldset>';
	$("#temperatureDescription").html(tempDescr);
	
	document.getElementById("temperatureChart").style.display = 'none';
	document.getElementById("temperatureTable").style.display = 'none';
	
	$("#temperaturelegendDiv").html('');
};

MobiScout.Tab.UI.Temperature.ClearChart = function(){
	if(MobiScout.Tab.UI.Temperature.temperatureChart) MobiScout.Tab.UI.Temperature.temperatureChart.clear();
	if(MobiScout.Tab.UI.Temperature.temperatureChart) MobiScout.Tab.UI.Temperature.temperatureChart.destroy();
};

MobiScout.Tab.UI.Temperature.IsDifferent = function(i){
	if(i == 0 || i == MobiScout.Tab.UI.Temperature.SensorList.length - 1) return true;
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor1 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor1) return true; 
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor2 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor2) return true; 
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor3 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor3) return true; 
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor4 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor4) return true; 
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor5 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor5) return true; 
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor6 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor6) return true; 
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor7 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor7) return true; 
	if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor8 != MobiScout.Tab.UI.Temperature.SensorList[i-1].Sensor8) return true;
	return false; 
}

MobiScout.Tab.UI.Temperature.currentView = 0;

MobiScout.Tab.UI.Temperature.ToggleView = function(){
	if(MobiScout.Tab.UI.Temperature.currentView == 0){
		MobiScout.Tab.UI.Temperature.ShowTable();
	}
	else
	{
		MobiScout.Tab.UI.Temperature.ShowChart();
	}
}

MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay = function(temp){
	if(temp != -1000) return temp.toFixed(1) + '&deg;C';
	return '';
}

MobiScout.Tab.UI.Temperature.ShowTable = function(){
	try{
		MobiScout.Tab.UI.Temperature.currentView = 1;
		var tempDescr = '';
		tempDescr = '<fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">Temperatuur gegevens</legend>';
		tempDescr += '<div style="margin:10px;">';
		tempDescr += '<p style="color: gray;white-space:normal"><img src="images/truck.png" width="16" height="9"/>&nbsp;&nbsp;' + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.LastSelectedVehicleID) + '&nbsp;(' + MobiScout.Tab.App.LastSelectedVehicleID + ')</p>';
		tempDescr += '<p style="color: gray;white-space:normal"><img src="images/accessories-date.png" width="16" height="16"/>&nbsp;&nbsp;' + MobiScout.Tab.UI.Temperature.SelectedDate.format('d/m/Y') + '</p>';
		tempDescr += '<p style="color: gray;white-space:normal"><img src="images/temperature_64.png" width="16" height="16"/>&nbsp;&nbsp;' + MobiScout.Tab.UI.Temperature.SensorList.length + '&nbsp;metingen</p>';
		tempDescr += '</div></fieldset>';
		$("#temperatureDescription").html(tempDescr);
		// grafiek onzichtbaar maken
		var element = document.getElementById("temperatureChart");
		element.style.display = 'none';
		// nu de tabel vullen
		element = document.getElementById("temperatureTable");
		element.style.display = 'block';
		var table = '<br><table class="temperatureTable">';
		table += '<caption>temperatuur tabel</caption>';
		table += '<tr><th>tijd</th><th>t1</th><th>t2</th><th>t3</th><th>t4</th><th>t5</th><th>t6</th><th>t7</th><th>t8</th></tr>';
		
		for(var i = 0; i < MobiScout.Tab.UI.Temperature.SensorList.length; i ++) {
			table += '<tr><td>' + new Date(MobiScout.Tab.UI.Temperature.SensorList[i].TimeStampAction).format("d/m/Y H:i") + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor1) + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor2) + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor3) + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor4) + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor5) + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor6) + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor7) + '</td>';
			table += '<td>' + MobiScout.Tab.UI.Temperature.ConvertTemperatureForDisplay(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor8) + '</td>';
			table += '</tr>';
		}
		
		table += '</table>';
		element.innerHTML = table;
		$("#temperaturelegendDiv").empty();
	}
	catch(Err){
	
	}
}
	

MobiScout.Tab.UI.Temperature.ShowChart = function(){
	try{
		MobiScout.Tab.UI.Temperature.currentView = 0;
		var s1 = "Blue";
		var s2 = "Orange";
		var s3 = "Green";
		var s4 = "Purple";
		var s5 = "Black";
		var s6 = "Fuchsia";
		var s7 = "Maroon";
		var s8 = "Olive";
		var tempDescr = '';
		tempDescr = '<fieldset style="border:gray 1px solid;border-radius: 5px;"><legend style="margin-left:20px;color:gray; font-style:italic;font-size:0.75em;border-radius: 5px;">Temperatuur gegevens</legend>';
		tempDescr += '<div style="margin:10px;">';
		tempDescr += '<p style="color: gray;white-space:normal"><img src="images/truck.png" width="16" height="9"/>&nbsp;&nbsp;' + MobiScout.Tab.App.GetVehiclePlate(MobiScout.Tab.App.LastSelectedVehicleID) + '&nbsp;(' + MobiScout.Tab.App.LastSelectedVehicleID + ')</p>';
		tempDescr += '<p style="color: gray;white-space:normal"><img src="images/accessories-date.png" width="16" height="16"/>&nbsp;&nbsp;' + MobiScout.Tab.UI.Temperature.SelectedDate.format('d/m/Y') + '</p>';
		tempDescr += '<p style="color: gray;white-space:normal"><img src="images/temperature_64.png" width="16" height="16"/>&nbsp;&nbsp;' + MobiScout.Tab.UI.Temperature.SensorList.length + '&nbsp;metingen</p>';
		tempDescr += '</div></fieldset>';
		$("#temperatureDescription").html(tempDescr);
		
		var element = document.getElementById("temperatureTable");
		element.style.display = 'none';
		element = document.getElementById("temperatureChart");
		element.style.display = 'block';
		
		var element = document.getElementById("temperatureChart");	
		if(element){
			var ctx = element.getContext("2d");
			if(ctx){
				ctx.canvas.width = 300;
                ctx.canvas.height = 300;
				var s1data = new Array();
				var s2data = new Array();
				var s3data = new Array();
				var s4data = new Array();
				var s5data = new Array();
				var s6data = new Array();
				var s7data = new Array();
				var s8data = new Array();
				var labeldata = new Array();
				var forceLabel = false;
				
				// wat is het bereik dat we laten zien?
				var startdate = new Date(MobiScout.Tab.UI.Temperature.SensorList[0].TimeStampAction);
				var enddate = new Date(MobiScout.Tab.UI.Temperature.SensorList[MobiScout.Tab.UI.Temperature.SensorList.length - 1].TimeStampAction);
				var msdiff = enddate.getTime() - startdate.getTime();
				
				
				for(var i = 0; i < MobiScout.Tab.UI.Temperature.SensorList.length; i ++) {
					
					var timeOffset = new Date(MobiScout.Tab.UI.Temperature.SensorList[i].TimeStampAction).getTime() - startdate.getTime();
					// 10% van het tijd-bereik als uitgangpunt nemen
					if(timeOffset >= (msdiff/10)){
						forceLabel = true;
						startdate = new Date(MobiScout.Tab.UI.Temperature.SensorList[i].TimeStampAction);
					}
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor1 != -1000) s1data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor1.toFixed(1));
					else s1data.push(null);
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor2 != -1000) s2data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor2.toFixed(1));
					else s2data.push(null);
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor3 != -1000) s3data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor3.toFixed(1));
					else s3data.push(null);
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor4 != -1000) s4data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor4.toFixed(1));
					else s4data.push(null);
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor5 != -1000) s5data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor5.toFixed(1));
					else s5data.push(null);
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor6 != -1000) s6data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor6.toFixed(1));
					else s6data.push(null);
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor7 != -1000) s7data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor7.toFixed(1));
					else s7data.push(null);
					if(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor8 != -1000) s8data.push(MobiScout.Tab.UI.Temperature.SensorList[i].Sensor8.toFixed(1));
					else s8data.push(null);
					var date = new Date(MobiScout.Tab.UI.Temperature.SensorList[i].TimeStampAction);
					if(forceLabel == true || i == 0 || i == MobiScout.Tab.UI.Temperature.SensorList.length - 1){
						labeldata.push(date.format('H:i'));
					}
					else{
						labeldata.push('');
					}
					forceLabel = false;
				}
				var lineChartData = {
						labels : labeldata, 
						datasets : [
							{
								label: "S1",
								strokeColor : s1,
								pointColor : s1,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s1,
								data : s1data
							},
							{
								label: "S2",
								strokeColor : s2,
								pointColor : s2,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s2,
								data : s2data
							},
							{
								label: "S3",
								strokeColor : s3,
								pointColor : s3,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s3,
								data : s3data 
							},
							{
								label: "S4",
								strokeColor : s4,
								pointColor : s4,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s4,
								data : s4data 
							},
							{
								label: "S5",
								strokeColor : s5,
								pointColor : s5,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s5,
								data : s5data 
							},
							{
								label: "S6",
								strokeColor : s6,
								pointColor : s6,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s6,
								data : s6data 
							},
							{
								label: "S7",
								strokeColor : s7,
								pointColor : s7,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s7,
								data : s7data 
							},
							{
								label: "S8",
								strokeColor : s8,
								pointColor : s8,
								fillColor: "rgba(255,255,255,0)",
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : s8,
								data : s8data 
							}
						]
				}
				
				MobiScout.Tab.UI.Temperature.temperatureChart = new Chart(ctx).Line(lineChartData, { maintainAspectRatio: true, responsive: true, animation: false, scaleShowLabels: true, showScale: true, scaleBeginAtZero: true, showTooltips: true });
				var legend = '<center>';
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s1data) > 0) legend += '<a style="color:' + s1 + ' ; font-size:0.8em;font-style:italic">sensor 1</a>&nbsp;';
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s2data) > 0) legend += '<a style="color:' + s2 + '; font-size:0.8em;font-style:italic">sensor 2</a>&nbsp;';
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s3data) > 0) legend += '<a style="color:' + s3 + '; font-size:0.8em;font-style:italic">sensor 3</a>&nbsp;';
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s4data) > 0) legend += '<a style="color:' + s4 + '; font-size:0.8em;font-style:italic">sensor 4</a>&nbsp;';
				legend += '<br/>'; // break tussen voertuig en oplegger aub
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s5data) > 0) legend += '<a style="color:' + s5 + '; font-size:0.8em;font-style:italic">sensor 5</a>&nbsp;';
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s6data) > 0) legend += '<a style="color:' + s6 + '; font-size:0.8em;font-style:italic">sensor 6</a>&nbsp;';
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s7data) > 0) legend += '<a style="color:' + s7 + '; font-size:0.8em;font-style:italic">sensor 7</a>&nbsp;';
				if(MobiScout.Tab.UI.Temperature.ValidTemperatures(s8data) > 0) legend += '<a style="color:' + s8 + '; font-size:0.8em;font-style:italic">sensor 8</a>&nbsp;';
				legend += '</center>';
				$("#temperaturelegendDiv").html(legend);
			}
		}
	}
	catch(Err){
		MobiScout.Tab.LogToConsole("temperature chart failed: " + Err);
	}
};

MobiScout.Tab.UI.Temperature.ValidTemperatures = function(data_arr){
	var j = 0;
	for(var i = 0; i < data_arr.length; i ++) {
		if(data_arr[i] != null && data_arr[i] != -1000) j++;
	}
	return j;
};

MobiScout.Tab.UI.Temperature.ShowTemperatureForVehicle = function(vehicleid, date){
		MobiScout.Tab.UI.Temperature.SensorList.splice(0,MobiScout.Tab.UI.Temperature.SensorList.length);
		MobiScout.Tab.UI.Temperature.ClearChart();
		MobiScout.Tab.UI.Temperature.SetLoadingMessage();
		MobiScout.Tab.Data.GetTemperatures(vehicleid, date);
		
};


MobiScout.Tab.UI.Temperature.TemperatureInList = function(sensorentry){
	for(var i = 0; i < MobiScout.Tab.UI.Temperature.SensorList.length; i ++){
			if(sensorentry.SensorSN == MobiScout.Tab.UI.Temperature.SensorList[i].SensorSN) return true;
	}
	return false;
}

MobiScout.Tab.UI.Temperature.AddSensorEntryToList = function(sensorentry){
	if(!MobiScout.Tab.UI.Temperature.TemperatureInList(sensorentry)) {
		MobiScout.Tab.UI.Temperature.SensorList.push(sensorentry);
		return true;
	}
	return false;
}
