MobiScout.Tab.UI.Trip.BuildTripList = function(){
	//$("#TripsList").html('');
	$("#TripsList").empty();
		var totalList = '';
		var currentPlate = '';
       	if(MobiScout.Tab.App.Trips.length == 0){
       		totalList += '<li data-role="list-divider">Geen ritten</li><li data-icon="false"><a>geen ritten gevonden</a></li>';
       	}
       	else{
	        totalList+='<li data-role="list-divider">' + MobiScout.Tab.App.Trips.length + ' Ritten</li>';
	        for (var i = 0; i < MobiScout.Tab.App.Trips.length; i++) {
	        	if(showVehiclePlate == true){
		        	if(currentPlate != MobiScout.Tab.App.Trips[i].Plate){
		        		// insert divider
		        		
		        		totalList += '<li data-icon="false" data-role="list-divider">' + MobiScout.Tab.App.Trips[i].Plate + '</li>';
		        		currentPlate = MobiScout.Tab.App.Trips[i].Plate;
		        	}
		        }
		        else{
		        	if(currentPlate != MobiScout.Tab.App.Trips[i].VehicleID){
		        		// insert divider
		        		totalList += '<li data-icon="false" data-role="list-divider">' + MobiScout.Tab.App.Trips[i].VehicleID + '</li>';
		        		currentPlate = MobiScout.Tab.App.Trips[i].VehicleID;
		        	}
		        
		        }
	        	totalList += MobiScout.Tab.UI.Trip.GenerateTripItem(MobiScout.Tab.App.Trips[i]);
			}
		}
		$("#TripsList").html(totalList);
		$("#TripsList").listview("refresh")
};

MobiScout.Tab.UI.Trip.GenerateTripIconTable = function(trip){
	var iconTable = '<table class="messageIconTable" >';
	iconTable += '<tr>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '</tr>';
	var imageNew = "";
	var imageInbound = "";
	var imageRead = "";
	var imageUrgent = "";
	var imageMessage = "images/planned_trip.png";
	iconTable += '<tr> <td colspan="4" ><center><img class="vehicleIcon" src="' + imageMessage + '"/></center></td></tr>';
	iconTable += '<tr> <td></td><td></td><td></td><td></td></tr>'; 
	iconTable += '</table>';
	return iconTable;
}

MobiScout.Tab.UI.Trip.GenerateTripDetailTable = function(trip){
	var detailTable = '<table class="tripDetailTable">';
	detailTable += '<tr>';
	detailTable += '<td class="vehicleIconColumn"></td>';
	detailTable += '<td></td>';
	detailTable += '</tr>';
	// per info item een record maken
	if(showVehiclePlate == true) detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + trip.Plate + ' ' + trip.Name + '</td></tr>';
	else detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;">' + trip.VehicleID + ' ' + trip.Name + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: ' + MobiScout.Tab.App.GetStatusColor(trip.StatusID) + ';">' + MobiScout.Tab.App.TranslateStatus(trip.StatusID) + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;font-weight:bold;" >' + trip.Descr + ' ' + trip.ExternalRef + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;" >' + trip.Remarks + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;" >' + trip.LocFrom + ' - '+  trip.LocTo + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;" >' + trip.TSStartPlanned + ' - ' + trip.TSStopPlanned + '</tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;" >'+ MobiScout.Tab.Translations.AantalOpenStops + ': ' + trip.StopCount + '</tr>';
	
	if(trip.StopCount > 0 && trip.StopsTotal > 0) {
		var percentageDone = (trip.StopsDone * 100) / trip.StopsTotal; // aantal stops totaal eigenlijk
		detailTable += '<tr><td><img class="vehicleDetailImage" src="images/accessories-date.png"/></td><td class="meter gray nostripes"><span style="width: ' + percentageDone + '%"></span><div class="meterpercent">&nbsp;' + Math.round(percentageDone) + ' %&nbsp;</div></td></tr>';
	} 
	
	detailTable += '</table>';
	return detailTable;
	
}

MobiScout.Tab.UI.Trip.GenerateTripItem = function(trip){
	// TODO: omschrijven naar tabel structuur
	var item = '<table class="messageTable" >';
	item += '<tr>';
	item += '<td class="tabMessageIcons"></td>';
	item += '<td class="tabMessageDetails" ></td>'; 
	item += '</tr>';
	item += '<tr>';
	item += '<td class="tabMessageIcons">' + MobiScout.Tab.UI.Trip.GenerateTripIconTable(trip) + '</td>';
	item += '<td class="tabMessageDetails">' + MobiScout.Tab.UI.Trip.GenerateTripDetailTable(trip) + '</td>';
	item += '</tr>';
	item += '</table>';
	item = '<li data-icon="false"><a id="tripitem' + trip.TripSN + '">' + item + '</a></li>';
	return item;
};

MobiScout.Tab.UI.Trip.ClearStopList = function(){
	$("#StopsList").empty();
	$("#StopsList").listview("refresh");
}

MobiScout.Tab.UI.Trip.BuildStopList = function(){
		//$("#StopsList").html('');
		$("#StopsList").empty();
		var totalList = '';
       	if(MobiScout.Tab.App.Stops.length == 0){
       		totalList += '<li data-role="list-divider">Geen stops</li><li data-icon="false"><a>geen stops gevonden</a></li>';
       	}
       	else{
	        totalList+='<li data-role="list-divider">' + MobiScout.Tab.App.Stops.length + ' Stops</li>';
	        for (var i = 0; i < MobiScout.Tab.App.Stops.length; i++) {
	        	totalList += MobiScout.Tab.UI.Trip.GenerateStopItem(MobiScout.Tab.App.Stops[i]);
			}
		}
		$("#StopsList").html(totalList);
		$("#StopsList").listview("refresh");
	};
	
MobiScout.Tab.UI.Trip.GenerateStopIconTable = function(stop){
	var iconTable = '<table class="messageIconTable" >';
	iconTable += '<tr>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '</tr>';
	var imageNew = "";
	var imageInbound = "";
	var imageRead = "";
	var imageUrgent = "";
	var imageStop = "images/awaiting.png";
	if(stop.StatusID == 30 || stop.StatusID == 35) imageStop = 'images/maintenance-time.png';
	else if(stop.StatusID == 40) imageStop = 'images/done_48.png';
	else if(stop.StatusID == 99) imageStop = 'images/temporarily-not-available-clock.png'; // verwijderd
	if(stop.Afwijkingen > 0) imageStop = 'images/important.png';
	iconTable += '<tr> <td colspan="4" ><center><img class="vehicleIcon" src="' + imageStop + '"/></center></td></tr>';
	iconTable += '<tr> <td></td><td></td><td></td><td></td></tr>'; 
	iconTable += '</table>';
	return iconTable;
}	

MobiScout.Tab.UI.Trip.GenerateStopDetailTable = function(stop){
	var detailTable = '<table class="tripDetailTable">';
	detailTable += '<tr>';
	detailTable += '<td class="vehicleIconColumn"></td>';
	detailTable += '<td></td>';
	detailTable += '</tr>';
	// per info item een record maken
	var activityTypeID = Number(stop.ActionTypeID);
	if(activityTypeID == 1) activityTypeID = 200;
	else if(activityTypeID == 2) activityTypeID = 201;
	
	var htmlColor = 'gray';
	var activityColorBall = '';
	var statusColorBall = '';
	htmlColor = MobiScout.Tab.App.toRGB(MobiScout.Tab.App.getActivityColor(activityTypeID));
	activityColorBall = '<div style="background-color: ' + htmlColor + ';width:10px;height:10px;-moz-border-radius: 5px/5px;-webkit-border-radius: 5px 5px;border-radius: 5px/5px;float: left;"></div>';
	htmlColor = MobiScout.Tab.App.GetStatusColor(stop.StatusID);
	statusColorBall = '<div style="background-color: ' + htmlColor + ';width:10px;height:10px;-moz-border-radius: 5px/5px;-webkit-border-radius: 5px 5px;border-radius: 5px/5px;float: left;"></div>';
	detailTable += '<tr><td class="vehicleDetailImage">' + statusColorBall + '</td><td style="font-size:1.2em;font-weight:bold;">' + MobiScout.Tab.App.TranslateStatus(stop.StatusID) + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage">' + activityColorBall + '</td><td style="font-size:1em;font-weight:bold;" >' +  stop.Action  + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;font-weight:bold;" >' +  stop.CustomerName + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;" >' + stop.Address + ' ' + stop.AddressNo + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;" >' + stop.Postcode + ' '+  stop.City + '</td></tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;white-space:normal;word-break: break-word;word-wrap:break-word;display: inline-block;" >' +  stop.ExternalRef  + '</tr>';
	detailTable += '<tr><td class="vehicleDetailImage"></td><td style="font-size:1em;color: black;" >' + stop.TSStartPlanned + ' - ' + stop.TSStopPlanned + '</tr>';
	detailTable += '</table>';
	return detailTable;
	
}
MobiScout.Tab.UI.Trip.GenerateStopItem = function(stop){
	// TODO: omschrijven naar tabel structuur
	var item = '<table class="messageTable" >';
	item += '<tr>';
	item += '<td class="tabMessageIcons"></td>';
	item += '<td class="tabMessageDetails" ></td>'; 
	item += '</tr>';
	item += '<tr>';
	item += '<td class="tabMessageIcons">' + MobiScout.Tab.UI.Trip.GenerateStopIconTable(stop) + '</td>';
	item += '<td class="tabMessageDetails">' + MobiScout.Tab.UI.Trip.GenerateStopDetailTable(stop) + '</td>';
	item += '</tr>';
	item += '</table>';
	item = '<li data-icon="false"><a id="stopitem' + stop.StopSN + '">' + item + '</a></li>';
	return item;
/*	var img = 'images/activities.png';
		if(stop.StatusID == 40) img = 'images/258-checkmark.png';
		//TODO: De actie omschrijving hier ook toevoegen stop.Action
		
        var item = '<li data-icon="false"><a id="stopitem' + stop.StopSN + '"><p class="mobiscout_activities_icon_wrapper"><img src="'+img+'" width="25" height="25"/></p><h3 style="color: ' + MobiScout.Tab.App.GetStatusColor(stop.StatusID) + '">' + MobiScout.Tab.App.TranslateStatus(stop.StatusID) + '</h3><p style="color: gray" ><strong>' + stop.Action + '&nbsp;' + stop.CustomerName + '</strong></p><p style="color: black" >' + stop.Address + ' ' + stop.AddressNo + '<br>' + stop.Postcode + ' '+  stop.City + '<br>' + stop.ExternalRef + '</p><p style="color: black" >' + stop.TSStartPlanned + ' - ' + stop.TSStopPlanned + '</p></a></li>';
        return item;*/
};