// build vehicle list
MobiScout.Tab.UI.Vehicle.BuildTrackAndTraceList = function (forceUpdate) {
        // updaten indien mogelijk
        //MobiScout.Tab.App.DumpMemUsage("build vehiclelist list start");
        //if(forceUpdate == true) $("#TrackAndTraceList").html('');
        if(forceUpdate == true) $("#TrackAndTraceList").empty();
        var needsEventWiring = false;
        if ($("#TrackAndTraceList").html() == '') {
        	needsEventWiring = true;
        	var newList = [];
        	if(UseDepartments == false){
            	newList.push('<li data-role="list-divider">' + MobiScout.Tab.App.TrackAndTraceList.length + ' ' + MobiScout.Tab.Translations.Voertuigen + '</li>');
            }
            if(MobiScout.Tab.App.TrackAndTraceList.length == 0){
            	newList.push('<li data-role="list-divider" >0 ' + + MobiScout.Tab.Translations.Voertuigen + '<a>' + MobiScout.Tab.Translations.GeenVoertuigenGevonden + '</a></li>');
            }
            else{
            	var groupName = "";
	            for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
	            	if(UseDepartments == true){
		            	var currDepartment = MobiScout.Tab.App.getDepartment( MobiScout.Tab.App.TrackAndTraceList[i].DepartmentID );
		            	if(groupName != currDepartment && !isBlank(currDepartment)){
							var numberOfVehiclesInDepartment = MobiScout.Tab.App.getVehicleCountForDepartment(MobiScout.Tab.App.TrackAndTraceList[i].DepartmentID);
							if(numberOfVehiclesInDepartment == 1) numberOfVehiclesInDepartment += ' ' + MobiScout.Tab.Translations.Voertuig;
							else numberOfVehiclesInDepartment += ' ' + MobiScout.Tab.Translations.Voertuigen;
							newList.push('<li style="max-height:24px !important;" id="' + MobiScout.Tab.App.TrackAndTraceList[i].DepartmentID + '" data-role="list-divider" ><p class="departmentHeader">' + currDepartment + ' - ' + numberOfVehiclesInDepartment + '<img onclick="MobiScout.Tab.UI.Vehicle.ShowGroupOnMap(this, ' + MobiScout.Tab.App.TrackAndTraceList[i].DepartmentID + ')" src="images/map-pin.png" style="float:right; height: 16px; width: auto;"/></p></li>');
							groupName = currDepartment;
		            	}
		            }
		            if(UseNewVehicleLayout == true){ 
	                	//$("#TrackAndTraceList").append(MobiScout.Tab.UI.Vehicle.GenerateVehicleItemNew(MobiScout.Tab.App.TrackAndTraceList[i], false));
	                	newList.push(MobiScout.Tab.UI.Vehicle.GenerateVehicleItemNew(MobiScout.Tab.App.TrackAndTraceList[i], false));
	                }
	                else{
	                	//$("#TrackAndTraceList").append(MobiScout.Tab.UI.Vehicle.GenerateVehicleItem(MobiScout.Tab.App.TrackAndTraceList[i], false));
	                	newList.push(MobiScout.Tab.UI.Vehicle.GenerateVehicleItem(MobiScout.Tab.App.TrackAndTraceList[i], false));;
	                }
	            }
            }
            $("#TrackAndTraceList").append(newList.join(''));
        }
        else {
            for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
                MobiScout.Tab.UI.Vehicle.UpdateVehicleItem(MobiScout.Tab.App.TrackAndTraceList[i]);
            }
        }
        //MobiScout.Tab.LogToConsole("All items updated");
        $("#TrackAndTraceList").listview('refresh');
        //MobiScout.Tab.LogToConsole("ListView refreshed");
        if(needsEventWiring == true) MobiScout.Tab.UI.Vehicle.WireVehicleListEvents();
        
        for (var i = 0; i < MobiScout.Tab.App.TrackAndTraceList.length; i++) {
        	
        	MobiScout.Tab.UI.Vehicle.UpdateBadgeForVehicle(MobiScout.Tab.App.TrackAndTraceList[i]);
        	
	        MobiScout.Tab.UI.Vehicle.UpdateAlertBadgeForVehicle(MobiScout.Tab.App.TrackAndTraceList[i]);
	        
	        if ($('.ui-page-active').attr('id') == 'home') {
	        	if(MobiScout.Tab.App.isAppPaused == false){
					if(UseNewVehicleLayout == true){
			        	if(MobiScout.Tab.App.TrackAndTraceList[i].ActivityChanged == true){
			            	MobiScout.Tab.App.TrackAndTraceList[i].TimestampChanged = false;
			                MobiScout.Tab.UI.AnimateControl("#ttveh" + MobiScout.Tab.App.TrackAndTraceList[i].ID);
			            }
			            if(MobiScout.Tab.App.TrackAndTraceList[i].TimestampChanged == true){
			            	MobiScout.Tab.UI.AnimateControl("#timestampveh" + MobiScout.Tab.App.TrackAndTraceList[i].ID);
			            }
		            }
		            else{
			        	if(MobiScout.Tab.App.TrackAndTraceList[i].TimestampChanged == true){
			            	MobiScout.Tab.UI.AnimateControl("#ttveh" + MobiScout.Tab.App.TrackAndTraceList[i].ID);
			        	}
	            	}
	        	}
	    	}
	        MobiScout.Tab.App.TrackAndTraceList[i].TimestampChanged = false;
	        MobiScout.Tab.App.TrackAndTraceList[i].ActivityChanged = false;
	        
	    }
        //MobiScout.Tab.LogToConsole("Items animated");
        
        try{
        	ShowHideAsides();
        }catch(Err)
        {
        }
        //MobiScout.Tab.App.DumpMemUsage("build vehiclelist list finish");
        MobiScout.Tab.UI.Vehicle.GetVehicleIconTableWidth();
    };	

MobiScout.Tab.UI.Vehicle.SetTablesVisible = function(){
	/*$(".ui-li-aside").css("display" ,"none"); // altijd uit
	
	if(screen.width >= 720){
		// rijtijden tabel aan
		$("#tabVehicleTimes").css("display" ,"block");
		$("#tabVehicleTimes").width('27%');
		$("#tableVehicleTimes").css("display" ,"block");
		$("#tabVehicleIcons").width('14%');
		$("#tabVehicleIndicators").width('4%');
		$("#tabVehicleDetails").width('55%');
	}
	else{
		$("#tabVehicleTimes").css("display" ,"none");
		$("#tabVehicleTimes").width('0%');
		$("#tableVehicleTimes").css("display" ,"none");
		$("#tabVehicleIcons").width('28%');
		$("#tabVehicleIndicators").width('8%');
		$("#tabVehicleDetails").width('64%');
		
	}*/
};

MobiScout.Tab.UI.Vehicle.GenerateVehicleItemNew = function (vehicle, isupdate) {
	// genereer alle delen afzonderlijk van elkaar en pas deze in elkaar
	// het item moet een tabelstructuur worden, met geneste tabellen in de cellen
	var mainTable = '<table class="vehicleTable" >';
	mainTable += '<tr>';
	mainTable += '<td class="tabVehicleIcons"></td>';
	//mainTable += '<td class="tabVehicleIndicators" ></td>'; 
	mainTable += '<td class="tabVehicleDetails" ></td>'; 
	mainTable += '<td class="tabVehicleTimes" ></td>'; 
	mainTable += '</tr>';
	
	mainTable += '<tr>';
	mainTable += '<td class="tabVehicleIcons">' + MobiScout.Tab.UI.Vehicle.GenerateIconTable(vehicle) + '</td>';
	mainTable += '<td class="tabVehicleDetails">' + MobiScout.Tab.UI.Vehicle.GenerateDetailTable(vehicle) + '</td>';
	mainTable += '<td class="tabVehicleTimes">' + MobiScout.Tab.UI.Vehicle.GenerateDrivingTimesTable(vehicle) + '</td>';
	mainTable += '</tr>';
	mainTable += '</table>';
	
	var item = mainTable;

	
		
	var badgeMessageClass = MobiScout.Tab.UI.Vehicle.GetMessageBadgeClassForVehicle(vehicle);
	var badgeAlertClass = MobiScout.Tab.UI.Vehicle.GetAlertBadgeClassForVehicle(vehicle);
	
	
	
	if(isupdate == false || isupdate == undefined){
		if(MobiScout.Tab.UI.DeviceAllowsAnimation() == false){
			item = '<li data-rel="inline" data-icon="false" class="ui-badge-container"><span id="badgeveh' + vehicle.ID + '" class="'+badgeMessageClass+'"></span><span id="badgealertsveh' + vehicle.ID + '" class="'+badgeAlertClass+'"></span><a href="#inlinemenu' + vehicle.ID + '" id="ttveh' + vehicle.ID + '">' + item + '</a></li>';
			item += '<li id="inlinemenu' + vehicle.ID + '" class="ui-li ui-li-static ui-btn-up-c InlineMenuListItem" style="display: none;">';
			item += '<div class="li-hor-menu">';
			if(useColoredImagesInMenu == true){
				if(authorisationForMap == true) item += '<img class="InlineMenuImage" src="images/pin_1_64.png" onclick="MobiScout.Tab.UI.Vehicle.CenterOnVehicleID(this, ' + vehicle.ID + ')"/>';
				if(authorisationForMessageDialog == true) item += '<img class="InlineMenuImage" src="images/MessageStack_64.png" onclick="MobiScout.Tab.UI.Vehicle.LoadMessageDialog(this, ' + vehicle.ID + ')"/>';
				if(authorisationForRealtimeHours == true) item += '<img class="InlineMenuImage" src="images/timeline_5_64.png" onclick="MobiScout.Tab.UI.Vehicle.LoadRealtimeHours(this, ' + vehicle.ID + ')"/>';
				if(authorisationForTemperature == true) item += '<img class="InlineMenuImage" src="images/temperature_64.png" onclick="MobiScout.Tab.UI.Vehicle.LoadTemperatures(this, ' + vehicle.ID + ')"/>';
				if(authorisationForRoute == true) item += '<img class="InlineMenuImage" src="images/geofence_route_64.png" onclick="MobiScout.Tab.UI.Vehicle.LoadRoute(this, ' + vehicle.ID + ', false)"/>';
				if(authorisationForTrips == true) item += '<img class="InlineMenuImage" src="images/planned_trip.png" onclick="MobiScout.Tab.UI.Vehicle.LoadTrips(this, ' + vehicle.ID + ')"/>';
				if(authorisationForCanbus == true) item += '<img class="InlineMenuImage" src="images/leaf_green_3_64.png" onclick="MobiScout.Tab.UI.Vehicle.ShowVehicleCanbusInfo(this, ' + vehicle.ID + ')"/>';
				if(authorisationForAlerts == true) item += '<img class="InlineMenuImage" src="images/General_alert_64.png" onclick="MobiScout.Tab.UI.Vehicle.LoadAlerts(this, ' + vehicle.ID + ')"/>';
				item += '<img class="InlineMenuImage" src="images/email-add-icon.png" onclick="MobiScout.Tab.UI.Vehicle.SendNewMessage(this, ' + vehicle.ID + ')"/>';
				item += '<img class="InlineMenuImage" src="images/r1_phone.png" onclick="MobiScout.Tab.UI.Vehicle.CallVehicle(this, ' + vehicle.ID + ')">&nbsp;</img>';
			}
			else{
				if(authorisationForMap == true) item += '<img class="InlineMenuImage" src="images/blackwhite/Marker.png" onclick="MobiScout.Tab.UI.Vehicle.CenterOnVehicleID(this, ' + vehicle.ID + ')"/>';
				if(authorisationForMessageDialog == true) item += '<img class="InlineMenuImage" src="images/blackwhite/Delivery.png" onclick="MobiScout.Tab.UI.Vehicle.LoadMessageDialog(this, ' + vehicle.ID + ')"/>';
				if(authorisationForRoute == true) item += '<img class="InlineMenuImage" src="images/blackwhite/Polyline.png" onclick="MobiScout.Tab.UI.Vehicle.LoadRoute(this, ' + vehicle.ID + ', false)"/>';
				if(authorisationForTrips == true) item += '<img class="InlineMenuImage" src="images/blackwhite/Planner.png" onclick="MobiScout.Tab.UI.Vehicle.LoadTrips(this, ' + vehicle.ID + ')"/>';
				if(authorisationForCanbus == true) item += '<img class="InlineMenuImage" src="images/leaf.png" onclick="MobiScout.Tab.UI.Vehicle.ShowVehicleCanbusInfo(this, ' + vehicle.ID + ')"/>';
				if(authorisationForAlerts == true) item += '<img class="InlineMenuImage" src="images/blackwhite/Warning_Shield.png" onclick="MobiScout.Tab.UI.Vehicle.LoadAlerts(this, ' + vehicle.ID + ')"/>';
				item += '<img class="InlineMenuImage" src="images/blackwhite/Message_Outline.png" onclick="MobiScout.Tab.UI.Vehicle.SendNewMessage(this, ' + vehicle.ID + ')"/>';
				item += '<img class="InlineMenuImage" src="images/blackwhite/Phone-Open.png" onclick="MobiScout.Tab.UI.Vehicle.CallVehicle(this, ' + vehicle.ID + ')">&nbsp;</img>';
			}
			item += '</div>';
			item += '</li>';
		}
		else{
			item = '<li id="vehicleMenu' + vehicle.ID + '" data-rel="circularMenu" data-icon="false" class="ui-badge-container ui-li-static"><span id="badgeveh' + vehicle.ID + '" class="'+badgeMessageClass+'"></span><span id="badgealertsveh' + vehicle.ID + '" class="'+badgeAlertClass+'"></span><a id="ttveh' + vehicle.ID + '">' + item + '</a></li>';
		}
	}
	return item;
};

MobiScout.Tab.UI.Vehicle.ShowVehicleCanbusInfo = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();

	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.UI.Scoring.ShowVehicleCanbusInfo(id);
}

MobiScout.Tab.UI.Vehicle.ShowGroupOnMap = function(sender, id){
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.ShowGroupOnMap(id);
}

MobiScout.Tab.UI.Vehicle.SendNewMessage = function(sender, id){
	MobiScout.Tab.LogToConsole("MobiScout.Tab.UI.Vehicle.SendNewMessage");
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();

	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.SendNewMessage(id);
}

MobiScout.Tab.UI.Vehicle.SendPositionRequest = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;

	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.postNewTextMessage(id, '$PSTAT*00');
}

MobiScout.Tab.UI.Vehicle.AllowedToBlockClick = function(){
	if(MobiScout.Tab.UI.DeviceAllowsAnimation() == true && $('#menu-vehicles').hasClass('wcircle-animating')== true){
		MobiScout.Tab.LogToConsole("AllowedToBlockClick: True");
	 	return true;
	}
	return false;
}

MobiScout.Tab.UI.Vehicle.CenterOnVehicleID = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.App.MapCentered = true; // try to fix bug AP6154
	MobiScout.Tab.Mapping.CenterOnVehicleID(id);
}

MobiScout.Tab.UI.Vehicle.CallVehicle = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();
	
	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	var protocolID = MobiScout.Tab.App.GetVehicleProtocolID(id);
	if(protocolID == 6){
		// we moeten het voertuig bellen
		var phoneNumber = MobiScout.Tab.App.GetVehiclePhonenumber(id);
		if(isBlank(phoneNumber) == false){
			MobiScout.Tab.App.CallPhoneNumber(phoneNumber);
		}
		else{
			var driverid = MobiScout.Tab.App.GetDriverOnVehicle(id);
			if(driverid > 0){
				phoneNumber = MobiScout.Tab.App.GetDriverPhonenumber(driverid);
				if(isBlank(phoneNumber) == false){
					MobiScout.Tab.App.CallPhoneNumber(phoneNumber);
				}
				else{
					MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.GeenNummer);
				}
			}
			else{
				MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.GeenNummer);
			}
		}
	}
	else if(protocolID == 7 || protocolID == 8 || protocolID == 14){
		// we moeten de chauffeur bellen indien het nummer bekend, anders de auto
		
		var driverid = MobiScout.Tab.App.GetDriverOnVehicle(id);
		var phoneNumber = "";
		if(driverid > 0){
			phoneNumber = MobiScout.Tab.App.GetDriverPhonenumber(driverid);
			if(isBlank(phoneNumber) == false){
				MobiScout.Tab.App.CallPhoneNumber(phoneNumber);
			}
			else{
				// dan voertuig proberen
				phoneNumber = MobiScout.Tab.App.GetVehiclePhonenumber(id);
				if(isBlank(phoneNumber) == false){
					MobiScout.Tab.App.CallPhoneNumber(phoneNumber);
				}
				else{
					MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.GeenNummer);
				}				
			}
		}
		else{
			phoneNumber = MobiScout.Tab.App.GetVehiclePhonenumber(id);
			if(isBlank(phoneNumber) == false){
				MobiScout.Tab.App.CallPhoneNumber(phoneNumber);
			}
			else{
				MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.GeenNummerVoertuig + " "  + id);
			}
		}
	}
	else if(protocolID == 99){
		// we moeten de chauffeur bellen
		var driverid = MobiScout.Tab.App.GetDriverOnVehicle(id);
		if(driverid > 0){
			phoneNumber = MobiScout.Tab.App.GetDriverPhonenumber(driverid);
			if(isBlank(phoneNumber) == false){
				MobiScout.Tab.App.CallPhoneNumber(phoneNumber);
			}
			else{
				MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.GeenNummerChauffeur + " "  + driverid);
			}			
		}
		else{
			MobiScout.Tab.UI.ShowToast(MobiScout.Tab.Translations.GeenChauffeur + " " + id);
		}
	}
}

MobiScout.Tab.UI.Vehicle.LoadAlerts = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();

	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.LastSelectedVehicleID = id;
	MobiScout.Tab.ChangePage("alerts");
}

MobiScout.Tab.UI.Vehicle.LoadRoute = function(sender, id, autoPlotToday){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();

	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.LastSelectedVehicleID = id;
	if(autoPlotToday == true){
		MobiScout.Tab.Mapping.StartPlotVehicleRouteOnMap(MobiScout.Tab.App.LastSelectedVehicleID, MobiScout.Tab.GetCurrentDate());
	}
	else{
		$( "#select-date" ).datepicker( "setDate", MobiScout.Tab.GetCurrentDate() );
		MobiScout.Tab.App.ActionFromDateSelection = 1;
		MobiScout.Tab.ChangePage("dateselection");
	}
}

MobiScout.Tab.UI.Vehicle.LoadTrips = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();

	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.LastSelectedVehicleID = id;
	MobiScout.Tab.App.LoadTripsForVehicle(MobiScout.Tab.App.LastSelectedVehicleID);
}


MobiScout.Tab.UI.Vehicle.LoadTemperatures = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.LastSelectedVehicleID = id;
	MobiScout.Tab.ChangePage("temperature")
}

MobiScout.Tab.UI.Vehicle.LoadPeriodView = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.LastSelectedVehicleID = id;
	MobiScout.Tab.ChangePage("periodView")
}

MobiScout.Tab.UI.Vehicle.LoadRealtimeHours = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.LastSelectedVehicleID = id;
	MobiScout.Tab.ChangePage("realtimeHours")
}


MobiScout.Tab.UI.Vehicle.LoadMessageDialog = function(sender, id){
	if(id == undefined) id = MobiScout.Tab.App.LastSelectedVehicleID;
	if(MobiScout.Tab.UI.Vehicle.AllowedToBlockClick() == true) return;
	//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();
	if(sender) MobiScout.Tab.UI.SwingElement(sender);
	MobiScout.Tab.PlayTick();
	MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu();
	MobiScout.Tab.App.LastSelectedVehicleID = id;
	if(MobiScout.Tab.App.LastVehicleInMessageDialog != MobiScout.Tab.App.LastSelectedVehicleID){
		MobiScout.Tab.UI.Message.ClearDialogList();
	}
	MobiScout.Tab.ChangePage("messagedialog")
}

MobiScout.Tab.UI.Vehicle.GetVehicleIconTableWidth = function(){
	
	var div = $('<div>').addClass('tabVehicleIcons').hide();
	$('body').append(div);
	try{
		MobiScout.Tab.App.VehicleIconTableWidth = Number(div.css('width').replace("px", ""));
	}catch(Err){
		MobiScout.Tab.LogToConsole("failed to set VehicleIconTableWidth: " + Err);	
	}
	div.remove();
}

MobiScout.Tab.UI.Vehicle.GenerateCircularMenu = function(forceClear){
	if(forceClear == true) $('#menu-vehicles-div').empty();
	if(isBlank($('#menu-vehicles-div').html())){
		var menucontent = [];
		MobiScout.Tab.App.VehicleMenuItemCount = 0;
		if(authorisationForMap == true){
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border-radius:50%;border: 1px solid #333;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.CenterOnVehicleID()"><center><img style="width:24px;height:auto;" src="images/pin_1_64.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Kaart + '</span></center></div>');
			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		if(authorisationForMessageDialog == true){ 
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border: 1px solid #333;border-radius:50%;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.LoadMessageDialog()"><center><img style="width:24px;height:auto;" src="images/MessageStack_64.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Dialoog + '</span></center></div>');
			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		// realtime uren
		if(authorisationForRealtimeHours == true){
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border: 1px solid #333;border-radius:50%;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.LoadRealtimeHours()"><center><img style="width:24px;height:auto;" src="images/timeline_5_64.png"/><span style="display:none;font-size:0.6em;">realtime</span></center></div>');
			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		// temperaturen
		if(authorisationForTemperature == true) {
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border: 1px solid #333;border-radius:50%;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.LoadTemperatures()"><center><img style="width:24px;height:auto;" src="images/temperature_64.png"/><span style="display:none;font-size:0.6em;">temperatuur</span></center></div>');
			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		if(authorisationForRoute == true){		
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border: 1px solid #333;border-radius:50%;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.LoadRoute()"><center><img style="width:24px;height:auto;" src="images/geofence_route_64.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Route + '</span></center></div>');
			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		if(authorisationForTrips == true) {
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border: 1px solid #333;border-radius:50%;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.LoadTrips()"><center><img style="width:24px;height:auto;" src="images/planned_trip.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Ritten + '</span></center></div>');
			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		if(authorisationForCanbus == true) {
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border-radius:50%;border: 1px solid #333;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.ShowVehicleCanbusInfo()"><center><img style="width:24px;height:auto;" src="images/leaf_green_3_64.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Canbus + '</span></center></div>');
 			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		if(authorisationForAlerts == true){
			menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border-radius:50%;border: 1px solid #333;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.LoadAlerts()"><center><img style="width:24px;height:auto;" src="images/General_alert_64.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Alarmen + '</span></center></div>');
 			MobiScout.Tab.App.VehicleMenuItemCount ++;
		}
		menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border-radius:50%;border: 1px solid #333;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.SendNewMessage()"><center><img style="width:24px;height:auto;" src="images/email-add-icon.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Bericht + '</span></center></div>');
		MobiScout.Tab.App.VehicleMenuItemCount ++;
		menucontent.push('<div class="wcircle-menu-item" style="background-color:rgba(255, 255, 255, 1.0);border-radius:50%;border: 1px solid #333;padding:8px;width:24px;height:24px;" onclick="MobiScout.Tab.UI.Vehicle.CallVehicle()"><center><img style="width:24px;height:auto;" src="images/r1_phone.png"/><span style="display:none;font-size:0.6em;">' + MobiScout.Tab.Translations.Bellen + '</span></center></div>');
		MobiScout.Tab.App.VehicleMenuItemCount ++;
		$('#menu-vehicles-div').html(menucontent.join(''));
		$('#menu-vehicles').WCircleMenu({angle_start : -Math.PI/2,delay: 25,distance: 110,angle_interval: Math.PI/(MobiScout.Tab.App.VehicleMenuItemCount-1),easingFuncShow:"easeOutBack",easingFuncHide:"easeInBack",step:15,openCallback:MobiScout.Tab.UI.Vehicle.VehicleMenuOpened,closeCallback:MobiScout.Tab.UI.Vehicle.VehicleMenuClosed,itemRotation:360,iconRotation:180});
	}
	
}

MobiScout.Tab.UI.Vehicle.WireVehicleListEvents = function(){
 	var $list = $("#TrackAndTraceList");
 	
 	MobiScout.Tab.UI.Vehicle.GenerateCircularMenu(false);
 	
 	if(MobiScout.Tab.UI.DeviceAllowsAnimation() == false){
 	
	 	$list.find(':jqmData(rel="inline")').each(function (idx, element) {
	     	var linkli = $(element),
	        inlineli = $(linkli.find('a').prop('hash'));
	        
	        //hide the element and set state to closed
	        inlineli.hide();
	        linkli.prop('data-inlinestate', 'closed');
	        //on click, hide or show the div under the menu item
	        linkli.off('vclick').on('vclick', function (e) {
	        	
	        	e.preventDefault();
	            e.stopImmediatePropagation();
	            // no focus on filter box anymore!
	            $('input').blur();
	            MobiScout.Tab.App.LastSelectedVehicleID = Number(inlineli.prop('id').replace("inlinemenu", ""));
	            
	            // close others
	        	$list.find(':jqmData(rel="inline")').not(this).each(function (idx, element) {
	        		var linklio = $(element);
	        		var inlinelio = $(linklio.find('a').prop('hash'));
	        		linklio.prop('data-inlinestate', 'closed');
	        		inlinelio.slideUp(100, function() { inlinelio.hide(); });
	        	});
	            if (e) {
		            if (e.clientX) {
		                if (e.clientX > MobiScout.Tab.App.VehicleIconTableWidth) {
				            // indien er ongelezen berichten zijn, dan gaan we daar heen
				            if(MobiScout.Tab.App.UnreadMessageCountForVehicle(MobiScout.Tab.App.LastSelectedVehicleID) > 0){
				            	MobiScout.Tab.ChangePage("messages");
				            	return;
				        	}
				        }
		           	}
		        }
	            
	            if (linkli.prop('data-inlinestate') === 'closed') {
	            	
	            	linkli.prop('data-inlinestate', 'open');
	                inlineli.slideDown(350);
	        		
	                var $menuinstance = $('#' + inlineli.prop('id')).find('.li-hor-menu');
	                
					if( ($menuinstance.height() < $menuinstance.prop('scrollHeight')) || ($menuinstance.width() < $menuinstance.prop('scrollWidth'))){
					   // your element have overflow
					   // $menuinstance.css('background-color','yellow');
					   // SHOW the indicators
					  
					}
					else{
					  //your element don't have overflow
					 // $menuinstance.css('background-color','orange');
					  // HIDE the indicators
					}
	                
	            } 
	            else {
	            	linkli.prop('data-inlinestate', 'closed');
	                inlineli.slideUp(350, function() { inlineli.hide(); });
	            }
	     	});
     	});
	}
	
	else{
		$list.find(':jqmData(rel="circularMenu")').each(function (idx, element) {
	     	var linkli = $(element);
	        linkli.off('click').on('click', function (e) {
	        	// wacht totdat animatie gedaan is.
	        	//e.preventDefault();
	            //e.stopImmediatePropagation();
	        	
	        	if($('#menu-vehicles').hasClass('wcircle-animating') == true) {
	        		return;
	        	}
	        	//MobiScout.Tab.App.topVehicleListCoordinate =  $(this).offset().top;
	        	// als het menu al open is, gewoon dicht doen dan
	        	if($('#menu-vehicles').hasClass('wcircle-open')) {
					//$('#menu-vehicles').trigger('WCircleMenuClose');
					$('#menu-vehicles').WCircleMenu('close');
					//MobiScout.Tab.UI.Vehicle.FadeVehiclesIn();
		            return;
		        }
	        	MobiScout.Tab.App.LastSelectedVehicleID = Number(linkli.prop('id').replace("vehicleMenu", ""));
	        	// als er niet in het linker deel geklikt wordt en er zijn ongelezen berichten.. dan open de inbox maar meteen
				MobiScout.Tab.PlayTick();
				
				
	            if (e) {
		            if (e.clientX) {
		                if (e.clientX > MobiScout.Tab.App.VehicleIconTableWidth && $('#menu-vehicles').hasClass('wcircle-open') == false) {
				            // indien er ongelezen berichten zijn, dan gaan we daar heen
				            if(MobiScout.Tab.App.UnreadMessageCountForVehicle(MobiScout.Tab.App.LastSelectedVehicleID) > 0){
				            	MobiScout.Tab.ChangePage("messages");
				            	return;
				        	}
				        }
		           	}
		        }
		        
		        
		        
	            var left;
	            var top;
	            try{
		            // controleer de locatie en de omvang van het menu
		            MobiScout.Tab.App.isVehicleMenuCircular = false;
 					if(e.clientY < MobiScout.Tab.UI.CalculateMinDistanceForMenu() + $('#msheader').height()) {
		            	// dan altijd in het midden van het scherm
		            	MobiScout.Tab.App.isVehicleMenuCircular = true;
		            	
		            	left = window.innerWidth /2;
		            	top = e.pageY + 12; //Number($('#menu-vehicles').css("height").replace("px", ""))/2;
		            	$('#menu-vehicles').trigger('WCircleMenuDistance', MobiScout.Tab.UI.CalculateCircularMenuRadius(false));
			        	$('#menu-vehicles').trigger('WCircleMenuAngle', Math.PI);
			            $('#menu-vehicles').trigger('WCircleMenuAngleInterval', -Math.PI/(MobiScout.Tab.App.VehicleMenuItemCount-1));
		            }
		            else if(e.clientY > window.innerHeight - MobiScout.Tab.UI.CalculateMinDistanceForMenu()) {
		            	// dan altijd in het midden van het scherm
		            	MobiScout.Tab.App.isVehicleMenuCircular = true;
		            	
		            	left = window.innerWidth /2;
		            	top = e.pageY - 24;//Number($('#menu-vehicles').css("height").replace("px", "")) / 2;
		            	
		            	$('#menu-vehicles').trigger('WCircleMenuDistance', MobiScout.Tab.UI.CalculateCircularMenuRadius(false));
			        	$('#menu-vehicles').trigger('WCircleMenuAngle', Math.PI);
			            $('#menu-vehicles').trigger('WCircleMenuAngleInterval', Math.PI/(MobiScout.Tab.App.VehicleMenuItemCount-1));
		            }
		            else if(e.clientX < window.innerWidth - MobiScout.Tab.UI.CalculateMinDistanceForMenu() && e.clientX > MobiScout.Tab.UI.CalculateMinDistanceForMenu()) {
		            	// circlulair maken
		            	//TODO: pas ook de diameter aan
		            	$('#menu-vehicles').trigger('WCircleMenuAngle', 0);
			            $('#menu-vehicles').trigger('WCircleMenuAngleInterval', - (2 * Math.PI)/(MobiScout.Tab.App.VehicleMenuItemCount));
			            $('#menu-vehicles').trigger('WCircleMenuDistance', MobiScout.Tab.UI.CalculateCircularMenuRadius(true));
			            left = e.pageX - 12;//Number($('#menu-vehicles').css("width").replace("px", ""))/2;
			            top = e.pageY  - 12;//Number($('#menu-vehicles').css("height").replace("px", ""))/2;
			            MobiScout.Tab.App.isVehicleMenuCircular = true;
		            }
		            else if(e.clientX >= window.innerWidth - MobiScout.Tab.UI.CalculateMinDistanceForMenu()) {
		            	$('#menu-vehicles').trigger('WCircleMenuDistance', MobiScout.Tab.UI.CalculateCircularMenuRadius(false));
			        	$('#menu-vehicles').trigger('WCircleMenuAngle', -Math.PI/2);
			            $('#menu-vehicles').trigger('WCircleMenuAngleInterval', -Math.PI/(MobiScout.Tab.App.VehicleMenuItemCount-1));
			            left = e.pageX - 0;//Number($('#menu-vehicles').css("width").replace("px", ""))/2;
			            top = e.pageY  - 12;//Number($('#menu-vehicles').css("height").replace("px", ""))/2;
			        }
			        else {
		            	$('#menu-vehicles').trigger('WCircleMenuDistance', MobiScout.Tab.UI.CalculateCircularMenuRadius(false));
			        	$('#menu-vehicles').trigger('WCircleMenuAngle', -Math.PI/2);
			            $('#menu-vehicles').trigger('WCircleMenuAngleInterval', Math.PI/(MobiScout.Tab.App.VehicleMenuItemCount-1));
			            left = e.pageX - 0;//Number($('#menu-vehicles').css("width").replace("px", ""))/2;
			            top = e.pageY  - 12;//Number($('#menu-vehicles').css("height").replace("px", ""))/2;
			        }
		        	if(left > window.innerWidth - 50) {
		        		left = window.innerWidth - 50;
		        	} 
		        	if(top > $(document).height() - 50){
		        		 top = $(document).height() - 50;
		        		 //console.log("set top to: " + top);
		        	}
			        $('#menu-vehicles').css("left", left);
			        $('#menu-vehicles').css("top", top);
			        $("#TrackAndTraceList li").not(linkli).css( "opacity" , 0.25 );
			        MobiScout.Tab.App.vehicleMenuInfoIndex = 0;
    				$( "#menu-vehicles .wcircle-menu-item" ).each(function( index, element ) {
    					$(element).css("background-color", "rgba(255, 255, 255, 1.0)");
					});
					MobiScout.Tab.App.numberOfVehicleMenuTransitions = 0;
			        $('#menu-vehicles').WCircleMenu('open');
		        }
		        catch(Err){
		        	MobiScout.Tab.LogToConsole("Failed to open circluar menu: " + Err);
		        }
	        });
        });
	}
}

MobiScout.Tab.UI.CalculateMinDistanceForMenu = function(isCircular){
 	return Number(MobiScout.Tab.App.VehicleMenuItemCount * 12);
}

MobiScout.Tab.UI.CalculateCircularMenuRadius = function(isCircular){
	// circulair: 80
	// halfrond: 100
	if(isCircular) return Number(MobiScout.Tab.App.VehicleMenuItemCount * 10);
	else return Number(MobiScout.Tab.App.VehicleMenuItemCount * 13);
}

MobiScout.Tab.UI.Vehicle.VehicleMenuOpened = function(){
	
    if(MobiScout.Tab.App.vehicleMenuTimerID) clearTimeout(MobiScout.Tab.App.vehicleMenuTimerID);
    MobiScout.Tab.App.vehicleMenuTimerID = setTimeout(MobiScout.Tab.UI.Vehicle.ShowMenuAdditionalInfo, 7500);
}

MobiScout.Tab.UI.Vehicle.ShowInfoWindow = function(x, y, info){
	// TODO: positie altijd JUIST bepalen
	
	$("#menuInfoWindow").text(info);
	var width = $("#menuInfoWindow").width();
	if(MobiScout.Tab.App.isVehicleMenuCircular == true){
		// dan moeten we corrigeren met de helft van de breedte
		x = x - (width/2) + 12;
	}
	if(x < 10) x = 10;
	if(x > window.innerWidth - width - 20) x = window.innerWidth - width - 20;
//	console.log("innerWidth: " + window.innerWidth + " x: " + x + " width: " + width + " screen: " + screen.width); 
	$("#menuInfoWindow").css("left", x);
    $("#menuInfoWindow").css("top", y);
    
    $('.menuinfobox').fadeIn();
}

MobiScout.Tab.UI.Vehicle.HideInfoWindow = function(){
	$('.menuinfobox').fadeOut();
}



//TODO: hold index to which menu item we are explaining
// show information in seperate div 

MobiScout.Tab.UI.Vehicle.ShowMenuAdditionalInfo = function(){
    $( "#menu-vehicles .wcircle-menu-item" ).each(function( index, element ) {
		if(index == MobiScout.Tab.App.vehicleMenuInfoIndex){
        	$(element).css("background-color", "rgba(100, 100, 100, 0.5)");
            MobiScout.Tab.UI.Vehicle.ShowInfoWindow($('#menu-vehicles').offset().left, $('#menu-vehicles').offset().top, $(element).find( "span" ).text());
        }
        else{
        	//$(element).css("opacity", 0.3);
        	$(element).css("background-color", "rgba(255, 255, 255, 1.0)");
        }
		MobiScout.Tab.App.maxVehicleMenuInfoIndex = index;
	});
	MobiScout.Tab.App.vehicleMenuInfoIndex ++;
    if(MobiScout.Tab.App.vehicleMenuInfoIndex > MobiScout.Tab.App.maxVehicleMenuInfoIndex) MobiScout.Tab.App.vehicleMenuInfoIndex = 0;
    if(MobiScout.Tab.App.vehicleMenuTimerID) clearTimeout(MobiScout.Tab.App.vehicleMenuTimerID);
    MobiScout.Tab.App.vehicleMenuTimerID = setTimeout(MobiScout.Tab.UI.Vehicle.HideMenuAdditionalInfo, 1500);
}
            
MobiScout.Tab.UI.Vehicle.HideMenuAdditionalInfo = function(){
	MobiScout.Tab.UI.Vehicle.HideInfoWindow();
	
    $( "#menu-vehicles .wcircle-menu-item" ).each(function( index, element ) {
    	$(element).css("background-color", "rgba(255, 255, 255, 1.0)");
	});
    MobiScout.Tab.App.numberOfVehicleMenuTransitions ++;
    if(MobiScout.Tab.App.numberOfVehicleMenuTransitions < (MobiScout.Tab.App.maxVehicleMenuInfoIndex + 1)){
		if(MobiScout.Tab.App.vehicleMenuTimerID) clearTimeout(MobiScout.Tab.App.vehicleMenuTimerID);
		MobiScout.Tab.App.vehicleMenuTimerID = setTimeout(MobiScout.Tab.UI.Vehicle.ShowMenuAdditionalInfo, 400);
	}          	
}


MobiScout.Tab.UI.Vehicle.VehicleMenuClosed = function(){
	//$("#TrackAndTraceList li").fadeTo( "fast" , 1.0 );
	MobiScout.Tab.UI.Vehicle.HideInfoWindow();
	$("#TrackAndTraceList li").css( "opacity" , 1.0 );
	if(MobiScout.Tab.App.vehicleMenuTimerID) clearTimeout(MobiScout.Tab.App.vehicleMenuTimerID);
}

MobiScout.Tab.UI.Vehicle.FadeVehiclesIn = function(){
	//$("#TrackAndTraceList li").fadeTo( "fast" , 1.0 );
	$("#TrackAndTraceList li").css( "opacity" , 1.0 );
}

MobiScout.Tab.UI.Vehicle.TryToCloseCircularMenu = function(){
	var retval = false;
	try{
		if(MobiScout.Tab.UI.DeviceAllowsAnimation() == true){
			if($('#menu-vehicles').hasClass('wcircle-open')){
			 	retval = true;
				$('#menu-vehicles').WCircleMenu('close');
				$("#TrackAndTraceList li").css( "opacity" , 1.0 );
			}
		}
	}catch(err){}
	return retval;
}

MobiScout.Tab.UI.Vehicle.GetMessageBadgeClassForVehicle = function(vehicle){
	if(!isBlank(vehicle.Name)){
		return 'badge badgemessages';
	}
	return 'badge badgemessageshigh';
}
MobiScout.Tab.UI.Vehicle.GetAlertBadgeClassForVehicle = function(vehicle){
	if(!isBlank(vehicle.Name)){
		return 'badge badgealerts';
	}
	return 'badge badgealertshigh';
}

MobiScout.Tab.UI.Vehicle.GenerateDrivingTimesTable = function(vehicle){
	var timeTable = '';
	
	// alleen doen indien het rijtijden besluit daadwerkelijk gebruikt wordt
	if(!isBlank(vehicle.Name) && MobiScout.Tab.UI.Vehicle.DrivingTimesActual(vehicle) == true){
		var resterendBlok = 270 - vehicle.Subdrivinghours;
		if(resterendBlok < 0) resterendBlok = 0;
		var resterendBlokInfo = '<td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</td>';
		if (resterendBlok < 15 && resterendBlok > 0)  resterendBlokInfo = '<td class="colDriveTimeValue"><font color="orange">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</font></td>';
		else if (resterendBlok == 0)  resterendBlokInfo = '<td class="colDriveTimeValue"><font color="red">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</font></td>';
		var resterendVandaag = 540 - vehicle.Totdrivinghours;
		if(resterendVandaag < 0) resterendVandaag = 0;
		if(vehicle.Tenallowed > 0)  resterendVandaag = 600 - vehicle.Totdrivinghours;
		var resterendVandaagInfo = '<td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</td>';
		if (resterendVandaag < 30 && resterendVandaag > 0)  resterendVandaagInfo = '<td class="colDriveTimeValue"><font color="orange">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</font></td>';
		else if (resterendVandaag == 0)  resterendVandaagInfo = '<td class="colDriveTimeValue"><font color="red">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</font></td>';
		timeTable = '<table class="tableVehicleTimes">';
		timeTable += '<tr>';
		timeTable += '<td class="colDriveTimeDescr"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '</tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="vehicleListImageRight" src="images/rijden_transparent.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Subdrivinghours) + '</td><td class="colDriveTimeValue">&nbsp;' + resterendBlokInfo + '</td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="vehicleListImageRight" src="images/10964-sum-sign.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Totdrivinghours) + '</td><td class="colDriveTimeValue">&nbsp;' + resterendVandaagInfo + '</td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="vehicleListImageRight" src="images/rusten_transparent.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Restminutes) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="vehicleListImageRight" src="images/wachten_transparent.png"/></td><td class="colDriveTimeValue" >' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Waitminutes) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="vehicleListImageRight" src="images/werken_transparent.png"/></td><td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Workminutes) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '<tr><td class="colDriveTimeDescr"><img class="vehicleListImageRight" src="images/blackwhite/Planner.png"/></td><td class="colDriveTimeValue">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Workweek) + '</td><td class="colDriveTimeValue"></td></tr>';
		timeTable += '</table>';
	}
	else{
		timeTable = '<table class="tableVehicleTimes">';
		timeTable += '<tr>';
		timeTable += '<td class="colDriveTimeDescr"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '<td class="colDriveTimeValue"></td>';
		timeTable += '</tr>';
		timeTable += '</table>';
	}
	return timeTable;
};

MobiScout.Tab.UI.Vehicle.DrivingTimesActual = function(vehicle){
	if(vehicle.Subdrivinghours == 0 && vehicle.Totdrivinghours == 0 && vehicle.Restminutes == 0 && vehicle.Waitminutes == 0 && vehicle.Workminutes == 0 && vehicle.Workweek == 0) return false;
	return true;
};

MobiScout.Tab.UI.Vehicle.GenerateDetailTable = function(vehicle){
	var detailTable = '<table class="vehicleDetailTable">';
	
	detailTable += '<tr>';
	detailTable += '<td class="vehicleIconColumn"></td>';
	detailTable += '<td></td>';
	detailTable += '</tr>';
	
	var locationDescription = vehicle.Location;
	var locationImage = '<td></td>';
	var vehicleInGeofence = MobiScout.Tab.App.IsVehicleInGeofence(vehicle);
	if(startsWith(vehicle.Location, "POI:")){
	    if(vehicleInGeofence != undefined){
	    	locationImage = '<td><img class="vehicleDetailImage" src="images/star.png"/></td>';
	    	locationDescription = vehicle.Location.substring(4, vehicle.Location.length).trim();
	    }
	    else{
	    	locationImage = '<td><img class="vehicleDetailImage" src="images/flag_green.png"/></td>';
	    	locationDescription = vehicle.Location.substring(4, vehicle.Location.length).trim();
	    } 
    }
    else if(startsWith(vehicle.Location, "ADR:")){
    	if(vehicleInGeofence != undefined){
        	locationImage = '<td><img class="vehicleDetailImage" src="images/star.png"/></td>';
	    	locationDescription = vehicle.Location.substring(4, vehicle.Location.length).trim();
       	}
        else{
        	locationImage = '<td><img class="vehicleDetailImage" src="images/user.png"/></td>';
	    	locationDescription = vehicle.Location.substring(4, vehicle.Location.length).trim();
        } 
    }
    else if(startsWith(vehicle.Location, "POLY:")){
    	if(vehicleInGeofence != undefined){
        	locationImage = '<td><img class="vehicleDetailImage" src="images/star.png"/></td>';
	    	locationDescription = vehicle.Location.substring(5, vehicle.Location.length).trim();
       	}
        else{
        	locationImage = '<td><img class="vehicleDetailImage" src="images/flag_red.png"/></td>';
	    	locationDescription = vehicle.Location.substring(5, vehicle.Location.length).trim();
        } 
    }
    else{
    	if(!isBlank(locationDescription)){
    		locationImage = '<td><img class="vehicleDetailImage" src="images/map-pin.png"/></td>';
    	}
    }
    
    var htmlColor = MobiScout.Tab.App.toRGB(vehicle.Color);
	var actDescr = vehicle.ActivityDescription;
	if(vehicle.Speed > 3) actDescr += " " + vehicle.Speed + " km/u";
	
	//console.log("vehicle: " + vehicle.ID + " vehicle.TSACTCHANGE = " + vehicle.TSACTCHANGE + " vehicle.TSACT = " + vehicle.TSACT);
	
	if(vehicle.TSACT > 0 && useLastActChange == false /* && vehicle.ProtocolID != 15*/){
		// determine validity
		var minutesInCurrentDay = MobiScout.Tab.GetCurrentDate().getHours() * 60 + MobiScout.Tab.GetCurrentDate().getMinutes();
		var msdiffminutes = (MobiScout.Tab.GetCurrentDate().getTime() - vehicle.TSACT.getTime()) / 60000;
		msdiffminutes = msdiffminutes.toFixed(0);
		if(msdiffminutes < 0) msdiffminutes = 0;
		if(msdiffminutes < 1){ // minder dan 1 minuut, geen tijd indicatie geven, dit is actueel
			actDescr += '<em> - ' + MobiScout.Tab.Translations.Zojuist + '</em>';
		}
		else if(msdiffminutes < 15){ // minder dan 15 minuten, toon minuten
			actDescr += '<em> - ' + msdiffminutes + ' ' + MobiScout.Tab.Translations.MinutenGeleden +'</em>';
		}
		else if(msdiffminutes <= /*1440*/ minutesInCurrentDay + 1){ // minder dan 1 dag geleden, toon alleen de tijd (HH:mm)
			actDescr += '<em> - ' + MobiScout.Tab.Translations.Sinds + ' ' + vehicle.TSACT.format('H:i') + '</em>';
		}
		else { // meer dan 1 dag geleden, toon datum en tijd (d/m HH:mm)
			actDescr += '<em> - ' + MobiScout.Tab.Translations.Sinds + ' ' + vehicle.TSACT.format('d/m H:i') + '</em>';
		}
	}
	else if(vehicle.TSACTCHANGE > 0){
		var minutesInCurrentDay = MobiScout.Tab.GetCurrentDate().getHours() * 60 + MobiScout.Tab.GetCurrentDate().getMinutes();
		var msdiffminutes = (MobiScout.Tab.GetCurrentDate().getTime() - vehicle.TSACTCHANGE.getTime()) / 60000;
		msdiffminutes = msdiffminutes.toFixed(0);
		if(msdiffminutes < 0) msdiffminutes = 0;
		if(msdiffminutes < 1){ // minder dan 1 minuut, geen tijd indicatie geven, dit is actueel
			actDescr += '<em> - ' + MobiScout.Tab.Translations.Zojuist + '</em>';
		}
		else if(msdiffminutes < 15){ // minder dan 15 minuten, toon minuten
			actDescr += '<em> - ' + msdiffminutes + ' ' + MobiScout.Tab.Translations.MinutenGeleden +'</em>';
		}
		else if(msdiffminutes <= /*1440*/ minutesInCurrentDay + 1){ // minder dan 1 dag geleden, toon alleen de tijd (HH:mm)
			actDescr += '<em> - ' + MobiScout.Tab.Translations.Sinds + ' ' + vehicle.TSACTCHANGE.format('H:i') + '</em>';
		}
		else { // meer dan 1 dag geleden, toon datum en tijd (d/m HH:mm)
			actDescr += '<em> - ' + MobiScout.Tab.Translations.Sinds + ' ' + vehicle.TSACTCHANGE.format('d/m H:i') + '</em>';
		} 
	}
	var destinationDescription = vehicle.Destination;
	if(vehicle.ExpectedDuration > 0 && !isBlank(vehicle.Destination))
	{ 
	    destinationDescription = MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration) + "&nbsp;en&nbsp;" + vehicle.Destination;
	}
	else if(vehicle.ExpectedDuration > 0)
	{
		destinationDescription = MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration);
	}
	else if(!isBlank(vehicle.Destination))
	{ 
		destinationDescription = vehicle.Destination;
	}
	var destinationImage = '';
	if(destinationDescription.toLowerCase().indexOf('karren') > -1 && !startsWith(destinationDescription,"0 ")){
		destinationImage = '<img class="vehicleDetailImage" src="images/318-pushcart.png"/>';
	}
	else if(isBlank(destinationImage) == false){
		destinationImage = '<img class="vehicleDetailImage" src="images/blackwhite/Define_Location.png"/>';
	}
	
	var vehicleDescription = vehicle.Plate;
	if(showVehiclePlate == false) vehicleDescription = vehicle.ID; 
	
	var activityColorBall = '<div id="timestampveh' + vehicle.ID + '" style="background-color: ' + htmlColor + ';width:10px;height:10px;-moz-border-radius: 5px/5px;-webkit-border-radius: 5px 5px;border-radius: 5px/5px;float: left;"></div>';
	
	
	
	var connectedImage = '';
	if(vehicle.TSLKA && MobiScout.Tab.App.GetVehicleProtocolID(vehicle.ID) != 15){ // navtracker uitsluiten
		// determine validity
		var msdiff = MobiScout.Tab.GetCurrentDate().getTime() - vehicle.TSLKA.getTime();
		if(msdiff < 300000){
		 	connectedImage = '<img class="vehicleDetailImage" src="images/lightning_bolt_16_h.gif"/>';
		}
		else if(msdiff < 600000){
		 	connectedImage = '<img class="vehicleDetailImage" src="images/flag-green.png"/>';
		}
		else if(msdiff < 900000){
		 	connectedImage = '<img class="vehicleDetailImage" src="images/flag-yellow.png"/>';
		}
		else{
			connectedImage = '<img class="vehicleDetailImage" src="images/disconnected_n.png"/>';
		}
	}
	
	if(!isBlank(vehicle.Name)) vehicleDescription += ',&nbsp;' + vehicle.Name;
	detailTable += '<tr><td>' + connectedImage + '</td><td><strong>' + vehicleDescription + '</strong></td></tr>';
	
	// controleer de duur van de activiteit, indien deze overschrijdend is (duur > maxtime) dan kleuren
	// we het balletje met een andere kleur!
	var actduration = (MobiScout.Tab.GetCurrentDate().getTime() - vehicle.TSACTCHANGE.getTime()) / 60000;
	var maxTime = MobiScout.Tab.App.getActivityMaxTime(vehicle.ActivityID);
	var activityRecord = '<tr><td>' + activityColorBall + '</td><td >' + actDescr + '</td></tr>'; 
	if(maxTime > 0){
		if(actduration >= maxTime){
			// TODO: misschien mooier om er dan altijd een rode rand omheen te maken? 
			activityRecord = '<tr><td><img class="vehicleDetailImage" src="images/IO_Alert_64.png"/></td><td>' + actDescr + '</td></tr>';
		}
	}
	detailTable += activityRecord;
	if(!isBlank(locationDescription)) detailTable += '<tr>' + locationImage + '<td>' + locationDescription + '</td></tr>';
	if(!isBlank(destinationDescription)) detailTable += '<tr><td>' + destinationImage +  '</td><td>' + destinationDescription + '</td></tr>';
	if(vehicle.TrailerID > 0){
		detailTable += '<tr><td><img class="vehicleDetailImage" src="images/trailer.png"/></td><td>' + MobiScout.Tab.UI.GenerateTrailerDescription(vehicle.TrailerID) + '</td></tr>';
	}
	//else{
	//	detailTable += '<tr><td></td><td></td></tr>';
	//}
	var actualiteitDescription = '';
	var actualiteitImage = '';
	if(vehicle.Actualiteit > 0 && showTripInformation == true && authorisationForTrips == true){
		// 1 = groen = vroeg
	    // 2 = geel = op tijd
	    // 3 = rood = laat
	    if(vehicle.Actualiteit == 1){
	    	 actualiteitImage = '<img class="vehicleDetailImage" src="images/flag-green-clock.png"/>';
	    	 actualiteitDescription = MobiScout.Tab.Translations.VoorOpPlanning;
	    } 
	    else if(vehicle.Actualiteit == 2) {
	    	 actualiteitImage = '<img class="vehicleDetailImage" src="images/flag-yellow-clock.png"/>';
	    	 actualiteitDescription = MobiScout.Tab.Translations.OpPlanning;
	    }
	    else if(vehicle.Actualiteit == 3) {
	    	 actualiteitImage = '<img class="vehicleDetailImage" src="images/flag-red-clock.png"/>';
	    	 actualiteitDescription = MobiScout.Tab.Translations.AchterOpPlanning;
	    }
	    detailTable += '<tr><td>' + actualiteitImage + '</td><td>' + actualiteitDescription + '</td></tr>';
	}
	if(vehicle.StopsTotal > 0 && showTripInformation == true && authorisationForTrips == true) {
		var percentageDone = (vehicle.StopsDone * 100) / vehicle.StopsTotal;
		detailTable += '<tr><td><img class="vehicleDetailImage" src="images/accessories-date.png"/></td><td class="meter gray nostripes"><span style="width: ' + percentageDone + '%"></span><div class="meterpercent">&nbsp;' + Math.round(percentageDone) + ' %&nbsp;</div></td></tr>';
	} 
	if(showTemperatureInformation == true && authorisationForTemperature == true){
		var sensorInfo = '';
		
		
		if(vehicle.Sensor1 != -1000 || vehicle.Sensor2 != -1000 || vehicle.Sensor3 != -1000 || vehicle.Sensor4 != -1000){
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor1, vehicle.Sensor1Alert); 
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor2, vehicle.Sensor2Alert); 
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor3, vehicle.Sensor3Alert); 
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor4, vehicle.Sensor4Alert); 
			if(!isBlank(sensorInfo)){
				detailTable += '<tr><td><img class="vehicleDetailImage" src="images/temperature_64.png"/></td><td>' + sensorInfo + '</td></tr>';	
			}
		}
		
		if(vehicle.Sensor5 != -1000 || vehicle.Sensor6 != -1000 || vehicle.Sensor7 != -1000 || vehicle.Sensor8 != -1000){
			sensorInfo = '';
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor5, vehicle.Sensor5Alert); 
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor6, vehicle.Sensor6Alert); 
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor7, vehicle.Sensor7Alert); 
			sensorInfo += MobiScout.Tab.UI.Vehicle.PrepSensorInfo('', vehicle.Sensor8, vehicle.Sensor8Alert); 
			if(!isBlank(sensorInfo)){
				detailTable += '<tr><td><img class="vehicleDetailImage" src="images/temperature_trailer_64.png"/></td><td>' + sensorInfo + '</td></tr>';	
			}
		}
	}
	detailTable += '</table>';
	return detailTable;
};

MobiScout.Tab.UI.Vehicle.PrepSensorInfo = function(name, sensorvalue, sensoralert){
	if(sensorvalue){
		var anchor = '<a style="font-weight:normal;color:gray;">';
		if(sensoralert == 1) anchor = '<a style="font-weight:bold;color:blue;">';
		else if(sensoralert == 2) anchor = '<a style="font-weight:bold;color:red;">'; 
		if(sensorvalue != -1000) return anchor + name + '&nbsp;' + sensorvalue.toFixed(1) + '&deg;&nbsp;&nbsp;</a>';
		return anchor + name + '&nbsp;---&nbsp;&nbsp;</a>';
	}
	return '';
}

MobiScout.Tab.UI.Vehicle.GenerateIndicatorTable = function(vehicle){
	var indicatorTable = '<table class="vehicleIndicatorTable">';
	indicatorTable += '<tr><td align="center" style="width:100%"></td></tr>';
	indicatorTable += '<tr><td><img class="vehicleListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="vehicleListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="vehicleListImage" src="images/user.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="vehicleListImage" src="images/activities.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="vehicleListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '<tr><td><img class="vehicleListImage" src="images/star.png"/></td></tr>';
	indicatorTable += '</table>';
	return indicatorTable;
};

MobiScout.Tab.UI.Vehicle.FormatDaysForDownload = function(numberOfDays){
	if(numberOfDays < 0) numberOfDays = 0;
	if(numberOfDays > 365) {
		return Math.floor(numberOfDays/365) + '<small>j&nbsp;</small>' + Math.floor(numberOfDays%365) + '<small>d</small>';
	}  
	return numberOfDays + '<small>d</small>';  
}

MobiScout.Tab.UI.Vehicle.GenerateIconTable = function(vehicle){
	var iconTable = '<table class="vehicleIconTable" >';
	
	iconTable += '<tr>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '<td align="center" style="width:25%"></td>';
	iconTable += '</tr>';
	var atbType = MobiScout.Tab.App.getActivityType(vehicle.ActivityID);
	var imageDrive = "images/rijden_transparent_disabled.png";
	var imageRest = "images/rusten_transparent_disabled.png";
	var imageWork = "images/werken_transparent_disabled.png";
	var imageWait = "images/wachten_transparent_disabled.png";
	if(atbType == 1){ // werken
		imageWork = "images/werken_transparent.png";
	}
	else if(atbType == 2){ // rusten
		imageRest = "images/rusten_transparent.png";
	}
	else if(atbType == 3){ // rijden
		imageDrive = "images/rijden_transparent.png";
	}
	else if(atbType == 4){ // wachten
		imageWait = "images/wachten_transparent.png";
	}

	//var strURL = 'images/truck.png';
	if(vehicle.ProtocolID == 15) iconTable += '<tr> <td colspan="4" ><center><img class="vehicleIcon" src="images/trailer.png"/></center></td></tr>';
	else if(UseServerImagesInList == true) iconTable += '<tr> <td colspan="4" ><center><img class="vehicleServerIcon" src="' + WebServiceURL + webServicePage + '/getMapIcon?vehicleID=' + vehicle.ID + '&plate=&trailerplate=&color=' + vehicle.Color + '"/></center></td></tr>';
	else iconTable += '<tr> <td colspan="4" ><center><img class="vehicleIcon" src="images/truck.png"/></center></td></tr>';

	if(vehicle.ProtocolID != 15){
		//iconTable += '<tr> <td colspan="4" ><center><img class="vehicleIcon" src="'+ strURL +'"/></center></td></tr>';
		iconTable += '<tr><td><img class="vehicleListImage" src="' + imageDrive + '"/></td>';
			iconTable += '<td><img class="vehicleListImage" src="' + imageRest + '"/></td>';
			iconTable += '<td><img class="vehicleListImage" src="' + imageWork + '"/></td>';
			iconTable += '<td><img class="vehicleListImage" src="' + imageWait + '"/></td></tr>';
	//	iconTable += '<tr> <td><center>R</center></td><td><center>P</center></td><td><center>W</center></td><td><center>B</center></td></tr>';
		iconTable += '<tr> <td></td><td></td><td></td><td></td></tr>';
		//iconTable += '<tr><td><img class="vehicleListImage" src="images/messages.png"  /></td><td colspan="3"><center>#msg</center></td></tr>';
		//iconTable += '<tr><td><img class="vehicleListImage" src="images/telefoon.png" /></td><td colspan="3"><center>#call</center></td></tr>';
		if(UseCanbus == true && authorisationForCanbus == true){
			if(vehicle.MarchingSpeed > 0) iconTable += '<tr><td><img class="vehicleListImage" src="images/81-dashboard.png" /></td><td colspan="3"><center>' + vehicle.MarchingSpeed.toFixed(1) + '</center></td></tr>';
			if(vehicle.Consumption > 0) iconTable += '<tr><td><img class="vehicleListImage" src="images/47-fuel.png" /></td><td colspan="3"><center>' + vehicle.Consumption.toFixed(1) + '</center></td></tr>';
		}
		if(vehicle.TSDTCOLastDownload.getTime() > 0 && MobiScout.Tab.App.GetVehicleTachoGraph(vehicle.ID) == true && UseCanbus == true && authorisationForCanbus == true)
		{
			var maxDownloadDays = 90;
			// controleer of het een groen, oranje of rood icoon moet zijn!
			var msdiff = MobiScout.Tab.GetCurrentDate().getTime() - vehicle.TSDTCOLastSuccess.getTime();
			var numberOfDays = Math.round((msdiff/86400000));
			//var dtco_column = '<td colspan="3" style="color:red;"><center>' + MobiScout.Tab.UI.Vehicle.FormatDaysForDownload(numberOfDays) + '</center></td>';
			if(vehicle.TSDTCOLastSuccess.getTime() > 0){
				msdiff = MobiScout.Tab.GetCurrentDate().getTime() - vehicle.TSDTCOLastSuccess.getTime();
				numberOfDays = Math.round((msdiff/86400000));
				//< 60 dagen -> groen
				//< 90 dagen -> oranje
				//>= 90 dagen rood
				/*if(numberOfDays < 60) dtco_column = '<td colspan="3" style="color:gray;"><center>' + MobiScout.Tab.UI.Vehicle.FormatDaysForDownload(numberOfDays) + '</center></td>';
				else if(numberOfDays < 90) dtco_column = '<td colspan="3" style="color:orange;"><center>' + MobiScout.Tab.UI.Vehicle.FormatDaysForDownload(numberOfDays) + '</center></td>';
				else  dtco_column = '<td colspan="3" style="color:red;"><center>' + MobiScout.Tab.UI.Vehicle.FormatDaysForDownload(numberOfDays) + '</center></td>';*/
				
			}
			
				var percentageDone = (numberOfDays * 100) / maxDownloadDays;
				if(percentageDone > 100) percentageDone = 100;
				if(percentageDone < 0) percentageDone = 0;
				//MobiScout.Tab.LogToConsole("veh: " + vehicle.ID + " percentage: " + percentageDone);
				var dtco_column = '';
				if(percentageDone > 0){ 
					dtco_column = '<td  colspan="3" class="meter orange nostripes"><span style="width: ' + percentageDone + '%"></span><div class="meterpercentsmall">&nbsp;' + Math.round(percentageDone) + '%&nbsp;</div></td>';
				}
				var img = 'images/123-id-card.png';
				//var img = 'images/228-nescontroller.png';
				
				//var img = 'images/291-idcard.png';
				//var img = 'images/274-router.png';
				
				
				if((vehicle.DTCOStatus & 0x0F) > 0x00){
					// voertuig onderhanden
					img = 'images/download_running.png';
					if(numberOfDays > 3000 ){
						dtco_column = '';
					}
				}
				else if(numberOfDays > 3000 || percentageDone > 95){
					// nog nooit goed uitgelezen!
					dtco_column = '<td  colspan="3"><center><img class="vehicleListImage" src="images/IO_Alert_64.png" /></center></td>';
				}
				iconTable += '<tr><td><img class="vehicleListImage" src="' + img + '" /></td>' + dtco_column + '</tr>';
		}
	}

	//iconTable += '<tr><td><img class="vehicleListImage" src="images/important.png"/></td><td colspan="3"><center>#alm</center></td></tr>';
	iconTable += '</table>';
	return iconTable;
};


MobiScout.Tab.UI.Vehicle.GenerateVehicleItem = function (vehicle, isupdate) {
        var item = '';
        try{
        	var vehicleInGeofence = MobiScout.Tab.App.IsVehicleInGeofence(vehicle);
        	
        	var addInfo = vehicle.Location;
        	/*var imageFile = 'images/truck.png';
        	if(vehicleInGeofence != undefined){
        		//MobiScout.Tab.LogToConsole("Vehicle " + vehicle.ID + " is in geofence: " + vehicleInGeofence);
        		imageFile = 'images/truckstar.png';
        	}*/
        	
        	
        	if(startsWith(vehicle.Location, "POI:")){
        		if(vehicleInGeofence != undefined){
        			addInfo = '<img src="images/star.png" width="10" height="10"/><strong>&nbsp;' + vehicle.Location.substring(4, vehicle.Location.length) + '</strong>';
        		}
        		else{
        			addInfo = '<img src="images/flag_green.png" width="10" height="10"/><strong>&nbsp;' + vehicle.Location.substring(4, vehicle.Location.length) + '</strong>';
        		} 
        	}
        	else if(startsWith(vehicle.Location, "ADR:")){
        		if(vehicleInGeofence != undefined){
        			addInfo = '<img src="images/star.png" width="10" height="10"/><strong>&nbsp;' + vehicle.Location.substring(4, vehicle.Location.length) + '</strong>';
        		}
        		else{
        			addInfo = '<img src="images/user.png" width="10" height="10"/><strong>&nbsp;' + vehicle.Location.substring(4, vehicle.Location.length) + '</strong>';
        		} 
        	}
        	else if(startsWith(vehicle.Location, "POLY:")){
        		if(vehicleInGeofence != undefined){
        			addInfo = '<img src="images/star.png" width="10" height="10"/><strong>&nbsp;' + vehicle.Location.substring(5, vehicle.Location.length) + '</strong>';
        		}
        		else{
        			addInfo = '<img src="images/flag_red.png" width="10" height="10"/><strong>&nbsp;' + vehicle.Location.substring(5, vehicle.Location.length) + '</strong>';
        		} 
        	}
	        var htmlColor = MobiScout.Tab.App.toRGB(vehicle.Color);
	        var actDescr = vehicle.ActivityDescription;
	        if(vehicle.Speed > 3) actDescr += " " + vehicle.Speed + " km/u";
	        
	        
	        if(vehicle.ExpectedDuration > 0 && !isBlank(vehicle.Destination))
	        { 
	        	if(isBlank(addInfo)) addInfo = MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration) + "&nbsp;en&nbsp;" + vehicle.Destination;
	        	else addInfo += "<br>" + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration) + "&nbsp;en&nbsp;" + vehicle.Destination;
	        }
	        else if(vehicle.ExpectedDuration > 0)
	        {
	        	if(isBlank(addInfo)) addInfo = MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration);
	        	else addInfo += "<br>" + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration);
	        }
	        else if(!isBlank(vehicle.Destination))
	        { 
	        	if(isBlank(addInfo)) addInfo = vehicle.Destination;
	        	else addInfo += "<br>" + vehicle.Destination;
	        }
	       
	        if(vehicle.TrailerID > 0){ 
	        	if(isBlank(addInfo)) addInfo = "Oplegger: " + MobiScout.Tab.UI.GenerateTrailerDescription(vehicle.TrailerID);
	        	else addInfo += "<br>Oplegger: " + MobiScout.Tab.UI.GenerateTrailerDescription(vehicle.TrailerID);
	        }
	        
	       
	        if(!isBlank(addInfo)){
				addInfo = '<p style="color: gray;white-space:normal;" >' + addInfo + '</p>';
	        }
	        if(vehicle.Actualiteit > 0){
	        	// 1 = groen = vroeg
	        	// 2 = geel = op tijd
	        	// 3 = rood = laat
	        	var tripInfo = '';
	        	if(vehicle.Actualiteit == 1) tripInfo = '<p style="white-space:normal;color: gray"><img src="images/flag-green-clock.png" width="24" height="24"/>&nbsp;&nbsp;Chauffeur loopt voor op de planning</p>'; 
	        	else if(vehicle.Actualiteit == 2) tripInfo = '<p style="white-space:normal;color: gray"><img src="images/flag-yellow-clock.png" width="24" height="24"/>&nbsp;&nbsp;Chauffeur loopt op schema</p>';
	        	else if(vehicle.Actualiteit == 3) tripInfo = '<p style="white-space:normal;color: gray"><img src="images/flag-red-clock.png" width="24" height="24"/>&nbsp;&nbsp;Chauffeur loopt achter op de planning</p>';
	        	addInfo += tripInfo;
	        }
	        var asideText = '';
	        if(!isBlank(vehicle.Name)){
		        //var asideText = '<p style="color: gray; display:none;" class="ui-li-aside">' + vehicle.LastKeepAlive + '</p>';
		        var resterendBlok = 270 - vehicle.Subdrivinghours;
		        if(resterendBlok < 0) resterendBlok = 0;
		        var resterendBlokInfo = '<td width="50" align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</td>';
		        if (resterendBlok < 15 && resterendBlok > 0)  resterendBlokInfo = '<td width="50" align="right"><font color="orange">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</font></td>';
		        else if (resterendBlok == 0)  resterendBlokInfo = '<td width="50" align="right"><font color="red">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendBlok) + '</font></td>';
	
		        var resterendVandaag = 540 - vehicle.Totdrivinghours;
		        if(resterendVandaag < 0) resterendVandaag = 0;
		        if(vehicle.Tenallowed > 0)  resterendVandaag = 600 - vehicle.Totdrivinghours;
		        var resterendVandaagInfo = '<td width="50" align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</td>';
		        if (resterendVandaag < 30 && resterendVandaag > 0)  resterendVandaagInfo = '<td width="50" align="right"><font color="orange">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</font></td>';
		        else if (resterendVandaag == 0)  resterendVandaagInfo = '<td width="50" align="right"><font color="red">' + MobiScout.Tab.ConvertMinutesToTimeSpan(resterendVandaag) + '</font></td>';
		        asideText = '<div style="color: gray; display:none;" class="ui-li-aside">';//<p>' + vehicle.LastKeepAlive + '</p>';
		        asideText += '<table style="font-size: 12px;border-collapse: collapse;border-spacing: 0;">';
		        asideText += '<tr><td width="100" align="left">Rijden blok</td><td align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Subdrivinghours) + '</td>' + resterendBlokInfo + '</tr>';
		        asideText += '<tr><td width="100" align="left">Rijden dag</td><td align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Totdrivinghours) + '</td>' + resterendVandaagInfo + '</tr>';
		        asideText += '<tr><td width="100" align="left">Rusten</td><td width="50" align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Restminutes) + '</td></tr>';
		        asideText += '<tr><td width="100" align="left">Wachten</td><td align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Waitminutes) + '</td></tr>';
		        asideText += '<tr><td width="100" align="left">Werken</td><td align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Workminutes) + '</td></tr>';
		        asideText += '<tr><td width="100" align="left">Week totaal</td><td align="right">' + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.Workweek) + '</td></tr>';
		        asideText += '</table></div>';
	        }
	        // in portrait -> not visible
	        // in landscape -> visible
	        //style="white-space:normal;
        	item = '<a id="ttveh' + vehicle.ID + '"><p class="mobiscout_vehicles_icon_wrapper_high"><img src="images/truck.png" width="34" height="19"/></p><h3 style="color: gray">' + vehicle.Plate + " " + vehicle.Name + '</h3><div style="background-color: ' + htmlColor + ';width:11px;height:11px;-moz-border-radius: 6px/6px;-webkit-border-radius: 6px 6px;border-radius: 6px/6px;float: left;"></div><p style="color: gray" ><strong>&nbsp;&nbsp;' + actDescr + '</strong></p><p style="color: gray" >' + vehicle.TSActivity + '</p>' + addInfo  + asideText + '</a>';
        	if(showVehiclePlate == false)  item = '<a id="ttveh' + vehicle.ID + '"><p class="mobiscout_vehicles_icon_wrapper_high"><img src="images/truck.png" width="34" height="19"/></p><h3 style="color: gray">' + vehicle.ID + " " + vehicle.Name + '</h3><div style="background-color: ' + htmlColor + ';width:11px;height:11px;-moz-border-radius: 6px/6px;-webkit-border-radius: 6px 6px;border-radius: 6px/6px;float: left;"></div><p style="color: gray" ><strong>&nbsp;&nbsp;' + actDescr + '</strong></p><p style="color: gray" >' + vehicle.TSActivity + '</p>' + addInfo  + asideText + '</a>';
        	
	        if(isupdate == false || isupdate == undefined){
	        	item = '<li data-icon="false" class="ui-badge-container"><span id="badgeveh' + vehicle.ID + '" class="badge badgemessages"></span><span id="badgealertsveh' + vehicle.ID + '" class="badge badgealerts"></span>' + item + '</li>';
	        }
	        // images toevoegen adhv status van het voertuig
	        // rijden
	        // verbonden
	        // telefoneren
	        // accu opladen
	        // app actief
	        // gps actief
	        // etc etc
	        //<img src="images/album-cover.jpg" class="ui-li-icon" />
	        
        }
        catch(Err){}
        return item;

    };

MobiScout.Tab.UI.Vehicle.UpdateVehicleItem = function (vehicle) {
		if(UseNewVehicleLayout == true){
			// clear the item first .. save memory
			$("#ttveh" + vehicle.ID).empty();
        	$("#ttveh" + vehicle.ID).html(MobiScout.Tab.UI.Vehicle.GenerateVehicleItemNew(vehicle, true));
        }
        else{
        	$("#ttveh" + vehicle.ID).empty();
        	$("#ttveh" + vehicle.ID).html(MobiScout.Tab.UI.Vehicle.GenerateVehicleItem(vehicle, true));
        }
    };    
    

MobiScout.Tab.UI.Vehicle.UpdateBadgeForVehicle = function(vehicle){
		var badgeMessageClass = MobiScout.Tab.UI.Vehicle.GetMessageBadgeClassForVehicle(vehicle);
		$('#badgeveh' + vehicle.ID).removeClass('badgemessages');
		$('#badgeveh' + vehicle.ID).removeClass('badgemessageshigh');
		$('#badgeveh' + vehicle.ID).removeClass('badge');
		$('#badgeveh' + vehicle.ID).addClass(badgeMessageClass);
		
	  	if(vehicle.NumberOfUnreadMessages > 0) $('#badgeveh' + vehicle.ID).html(vehicle.NumberOfUnreadMessages).fadeIn();
      	else $('#badgeveh' + vehicle.ID).html(vehicle.NumberOfUnreadMessages).fadeOut();
	};
	
MobiScout.Tab.UI.Vehicle.UpdateAlertBadgeForVehicle = function(vehicle){
		var badgeAlertClass = MobiScout.Tab.UI.Vehicle.GetAlertBadgeClassForVehicle(vehicle);
		
		$('#badgealertsveh' + vehicle.ID).removeClass('badgealerts');
		$('#badgealertsveh' + vehicle.ID).removeClass('badgealertshigh');
		$('#badgealertsveh' + vehicle.ID).removeClass('badge');
		$('#badgealertsveh' + vehicle.ID).addClass(badgeAlertClass);
		
	  	if(vehicle.NumberOfAlerts > 0) $('#badgealertsveh' + vehicle.ID).html(vehicle.NumberOfAlerts).fadeIn();
      	else $('#badgealertsveh' + vehicle.ID).html(vehicle.NumberOfAlerts).fadeOut();
	};
    
    
// ************************************ TEST FUNCTIES **************************************** 
   
MobiScout.Tab.UI.Vehicle.GenerateVehicleItemGrid = function (vehicle, isupdate) {
        var item = '';
        try{
	        var htmlColor = MobiScout.Tab.App.toRGB(vehicle.Color);
	        var actDescr = vehicle.ActivityDescription;
	        if(vehicle.Speed > 3) actDescr += " " + vehicle.Speed + " km/u";
	        var addInfo = vehicle.Location;
	        if(vehicle.ExpectedDuration > 0 && !isBlank(vehicle.Destination))
	        { 
	        	if(isBlank(addInfo)) addInfo = MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration) + "&nbsp;en&nbsp;" + vehicle.Destination;
	        	else addInfo += "<br>" + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration) + "&nbsp;en&nbsp;" + vehicle.Destination;
	        }
	        else if(vehicle.ExpectedDuration > 0)
	        {
	        	if(isBlank(addInfo)) addInfo = MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration);
	        	else addInfo += "<br>" + MobiScout.Tab.ConvertMinutesToTimeSpan(vehicle.ExpectedDuration);
	        }
	        else if(!isBlank(vehicle.Destination))
	        { 
	        	if(isBlank(addInfo)) addInfo = vehicle.Destination;
	        	else addInfo += "<br>" + vehicle.Destination;
	        }
	        if(vehicle.TrailerID > 0){ 
	        	if(isBlank(addInfo)) addInfo = "Oplegger: " + MobiScout.Tab.UI.GenerateTrailerDescription(vehicle.TrailerID);
	        	else addInfo += "<br>Oplegger: " + MobiScout.Tab.UI.GenerateTrailerDescription(vehicle.TrailerID);
	        }
	        if(!isBlank(addInfo)){
				addInfo = '<p style="color: gray" >' + addInfo + '</p>';
	        }
	        
	        var asideText = '<p  style="color: gray; display:none;" class="ui-li-aside">' + vehicle.LastKeepAlive + '<br><img src="images/sleutel.png" width="12" height="26"/></p>';
	        // in portrait -> not visible
	        // in landscape -> visible
	        
	        item = '<a id="ttveh' + vehicle.ID + '">';
	        item += '<div class="ui-grid-a">';
	        
	        var div1content = '<p class="mobiscout_vehicles_icon_wrapper_high"><img src="images/truck.png" width="34" height="19"/></p><h3 style="color: gray">' + vehicle.Plate + " " + vehicle.Name + '</h3><div style="background-color: ' + htmlColor + ';width:11px;height:11px;-moz-border-radius: 6px/6px;-webkit-border-radius: 6px 6px;border-radius: 6px/6px;float: left;"></div><p style="color: black" >&nbsp;&nbsp;' + actDescr + '</p><p style="color: black" >' + vehicle.TSActivity + '</p>';
	        if(showVehiclePlate == false) div1content = '<p class="mobiscout_vehicles_icon_wrapper_high"><img src="images/truck.png" width="34" height="19"/></p><h3 style="color: gray">' + vehicle.ID + " " + vehicle.Name + '</h3><div style="background-color: ' + htmlColor + ';width:11px;height:11px;-moz-border-radius: 6px/6px;-webkit-border-radius: 6px 6px;border-radius: 6px/6px;float: left;"></div><p style="color: black" >&nbsp;&nbsp;' + actDescr + '</p><p style="color: black" >' + vehicle.TSActivity + '</p>';
	        div1content += addInfo;
	        var div2content = asideText;
	        //div2content += '<img src="images/sleutel.png" width="12" height="26"/>';
	        item += '<div class="ui-block-a" style="width:80%">' + div1content + '</div>';
	        item += '<div class="ui-block-b" style="width:20%">' + div2content + '</div>';
	        item += '</div>';	// einde grid div
	        item += '</a>'; // einde anchor
	        if(isupdate == false){
	        	item = '<li data-icon="false" class="ui-badge-container"><span id="badgeveh' + vehicle.ID + '" class="badge badgemessages"></span><span id="badgealertsveh' + vehicle.ID + '" class="badge badgealerts"></span>' + item + '</li>';
	        }
	        // images toevoegen adhv status van het voertuig
	        // rijden
	        // verbonden
	        // telefoneren
	        // accu opladen
	        // app actief
	        // gps actief
	        // etc etc
	        //<img src="images/album-cover.jpg" class="ui-li-icon" />
	        
        }
        catch(Err){}
        return item;

    };    