function UOCalculationEntry() {
    this.DriverID = 0;
    this.DateToCalculate;
}

MobiScout.Tab.UOCalculationManager.CalculationList = new Array();
MobiScout.Tab.UOCalculationManager.NumberToCalculate = 0;

MobiScout.Tab.UOCalculationManager.EntryInList = function(entry){
	for(var i = 0; i < MobiScout.Tab.UOCalculationManager.CalculationList.length; i ++){
			if(entry.DriverID == MobiScout.Tab.UOCalculationManager.CalculationList[i].DriverID && entry.DateToCalculate.isSameDateAs(MobiScout.Tab.UOCalculationManager.CalculationList[i].DateToCalculate)) return true;
	}
	return false;
}


MobiScout.Tab.UOCalculationManager.AddDriverToCalculationList = function(driver, date){
	var newEntry = new UOCalculationEntry();
	newEntry.DriverID = driver;
	newEntry.DateToCalculate = date;
	if(!MobiScout.Tab.UOCalculationManager.EntryInList(newEntry)){
		MobiScout.Tab.UOCalculationManager.CalculationList.push(newEntry);
		MobiScout.Tab.LogToConsole("added driver: " + driver + " date: " + date);
	}
};


MobiScout.Tab.UOCalculationManager.RemoveDriverFromCalculationList = function(driver, date){
	MobiScout.Tab.LogToConsole("MobiScout.Tab.UOCalculationManager.RemoveDriverFromCalculationList: " + driver + " " + date);
	//MobiScout.Tab.UOCalculationManager.CalculationList.splice(0,MobiScout.Tab.UOCalculationManager.CalculationList.length);
	for(var i = 0; i < MobiScout.Tab.UOCalculationManager.CalculationList.length; i ++){
		if(driver == MobiScout.Tab.UOCalculationManager.CalculationList[i].DriverID && date == MobiScout.Tab.UOCalculationManager.CalculationList[i].DateToCalculate) 
		{
			MobiScout.Tab.UOCalculationManager.CalculationList.splice(i,1);
			return;
		}
	}
};


MobiScout.Tab.UOCalculationManager.ClearCalculationList = function(){
	MobiScout.Tab.UOCalculationManager.CalculationList.splice(0,MobiScout.Tab.UOCalculationManager.CalculationList.length);
};


MobiScout.Tab.UOCalculationManager.GetPercentageDone = function(){
	var done = MobiScout.Tab.UOCalculationManager.NumberToCalculate - MobiScout.Tab.UOCalculationManager.CalculationList.length;
	if(done < 0) done = 0;
	// percentage aub
	var percentageDone = (100 * done)/MobiScout.Tab.UOCalculationManager.NumberToCalculate;
	return percentageDone;
}

MobiScout.Tab.UOCalculationManager.Run = function(isStartSignal){
	if(isStartSignal == true){
		MobiScout.Tab.UOCalculationManager.NumberToCalculate = MobiScout.Tab.UOCalculationManager.CalculationList.length;
	}

	if(MobiScout.Tab.UOCalculationManager.CalculationList.length > 0){
		//MobiScout.Tab.UI.ShowToast("Bereken chauffeur " + MobiScout.Tab.UOCalculationManager.CalculationList[0].DriverID);
		MobiScout.Tab.UI.PeriodView.ShowProgress(MobiScout.Tab.UOCalculationManager.CalculationList[0].DriverID);
		MobiScout.Tab.Data.CalculateWeekForDriver(MobiScout.Tab.UOCalculationManager.CalculationList[0].DriverID,MobiScout.Tab.UOCalculationManager.CalculationList[0].DateToCalculate);
	}
	else{
		MobiScout.Tab.UOCalculationManager.Stop();
	}
};


MobiScout.Tab.UOCalculationManager.Stop = function(){
	MobiScout.Tab.UOCalculationManager.ClearCalculationList();
	MobiScout.Tab.UI.PeriodView.ShowProgress();
	$('#btncontext_berekencao').removeClass('ui-disabled');
	MobiScout.Tab.UI.ShowToast("Berekening gereed");
	// reload PeriodView
	MobiScout.Tab.UI.PeriodView.ShowPeriodView(new Date(MobiScout.Tab.UI.PeriodView.CurrentStartDate));
};
